// Package: haxe.Timer
var haxe_Log = require("../haxe/Log").Log;


// Class: haxe.Timer

var Timer = (function () {
var Timer = function(time_ms) {
	var me = this;
	this.id = setInterval(function() {
		me.run();
	},time_ms);
};
Timer.prototype = {
  id: null,
  run: function() {
	},
  stop: function() {
		if(this.id == null) {
			return;
		}
		clearInterval(this.id);
		this.id = null;
	},
 __class__: Timer
};
Timer.__name__ = "haxe.Timer";
Timer.measure = function(f,pos) {
	var t0 = window.performance.now() / 1000;
	var r = f();
	haxe_Log.trace(window.performance.now() / 1000 - t0 + "s",pos);
	return r;
};
Timer.delay = function(f,time_ms) {
	var t = new Timer(time_ms);
	t.run = function() {
		t.stop();
		f();
	};
	return t;
};
Timer.stamp = function() {
	return window.performance.now() / 1000;
};


return Timer;
}());
exports.default = exports.Timer = Timer;
