// Package: haxe.crypto.BaseCode
var haxe_io_Bytes = require("../../haxe/io/Bytes").Bytes;
var js__Boot_HaxeError = require("../../js/_Boot/HaxeError").HaxeError;


// Class: haxe.crypto.BaseCode

var BaseCode = (function () {
var BaseCode = function(base) {
	var len = base.length;
	var nbits = 1;
	while(len > 1 << nbits) ++nbits;
	if(nbits > 8 || len != 1 << nbits) {
		throw new js__Boot_HaxeError("BaseCode : base length must be a power of two.");
	}
	this.base = base;
	this.nbits = nbits;
};
BaseCode.prototype = {
  base: null,
  encodeBytes: function(b) {
		var nbits = this.nbits;
		var base = this.base;
		var size = b.length * 8 / nbits | 0;
		var out = new haxe_io_Bytes(new ArrayBuffer(size + (b.length * 8 % nbits == 0 ? 0 : 1)));
		var buf = 0;
		var curbits = 0;
		var mask = (1 << nbits) - 1;
		var pin = 0;
		var pout = 0;
		while(pout < size) {
			while(curbits < nbits) {
				curbits += 8;
				buf <<= 8;
				buf |= b.b[pin++];
			}
			curbits -= nbits;
			out.b[pout++] = base.b[buf >> curbits & mask] & 255;
		}
		if(curbits > 0) {
			out.b[pout++] = base.b[buf << nbits - curbits & mask] & 255;
		}
		return out;
	},
  nbits: null,
 __class__: BaseCode
};
BaseCode.__name__ = "haxe.crypto.BaseCode";


return BaseCode;
}());
exports.default = exports.BaseCode = BaseCode;
