// Package: haxe.ds.EnumValueMap
var haxe_IMap = require("../../haxe/IMap").IMap;
var $extend = require("../../extend_stub").extend_stub;
var Reflect = require("../../Reflect").Reflect;
var haxe_ds_BalancedTree = require("../../haxe/ds/BalancedTree").BalancedTree;


// Class: haxe.ds.EnumValueMap

var EnumValueMap = (function () {
var EnumValueMap = function() {
	haxe_ds_BalancedTree.call(this);
};
EnumValueMap.__interfaces__ = [haxe_IMap];
EnumValueMap.__super__ = haxe_ds_BalancedTree;
EnumValueMap.prototype = $extend(haxe_ds_BalancedTree.prototype, {
  compare: function(k1,k2) {
		var d = k1[1] - k2[1];
		if(d != 0) {
			return d;
		}
		var p1 = k1.slice(2);
		var p2 = k2.slice(2);
		if(p1.length == 0 && p2.length == 0) {
			return 0;
		}
		return this.compareArgs(p1,p2);
	},
  compareArgs: function(a1,a2) {
		var ld = a1.length - a2.length;
		if(ld != 0) {
			return ld;
		}
		var _g1 = 0;
		var _g = a1.length;
		while(_g1 < _g) {
			var i = _g1++;
			var d = this.compareArg(a1[i],a2[i]);
			if(d != 0) {
				return d;
			}
		}
		return 0;
	},
  compareArg: function(v1,v2) {
		if(Reflect.isEnumValue(v1) && Reflect.isEnumValue(v2)) {
			return this.compare(v1,v2);
		} else if((v1 instanceof Array) && v1.__enum__ == null && ((v2 instanceof Array) && v2.__enum__ == null)) {
			return this.compareArgs(v1,v2);
		} else {
			return Reflect.compare(v1,v2);
		}
	},
 __class__: EnumValueMap
});
EnumValueMap.__name__ = "haxe.ds.EnumValueMap";


return EnumValueMap;
}());
exports.default = exports.EnumValueMap = EnumValueMap;
