// Package: haxe.ds.ObjectMap
var HxOverrides = require("../../HxOverrides").HxOverrides;
var haxe_IMap = require("../../haxe/IMap").IMap;
var Std = require("../../Std").Std;


// Class: haxe.ds.ObjectMap

var ObjectMap = (function () {
var ObjectMap = function() {
	this.h = { __keys__ : { }};
};
ObjectMap.__interfaces__ = [haxe_IMap];
ObjectMap.prototype = {
  h: null,
  set: function(key,value) {
		var id = key.__id__ || (key.__id__ = ++ObjectMap.count);
		this.h[id] = value;
		this.h.__keys__[id] = key;
	},
  keys: function() {
		var a = [];
		for( var key in this.h.__keys__ ) {
		if(this.h.hasOwnProperty(key)) {
			a.push(this.h.__keys__[key]);
		}
		}
		return HxOverrides.iter(a);
	},
  iterator: function() {
		return { ref : this.h, it : this.keys(), hasNext : function() {
			return this.it.hasNext();
		}, next : function() {
			var i = this.it.next();
			return this.ref[i.__id__];
		}};
	},
  exists: function(key) {
		return this.h.__keys__[key.__id__] != null;
	},
  toString: function() {
		var s_b = "";
		s_b += "{";
		var it = this.keys();
		var i = it;
		while(i.hasNext()) {
			var i1 = i.next();
			s_b += Std.string(Std.string(i1));
			s_b += " => ";
			s_b += Std.string(Std.string(this.h[i1.__id__]));
			if(it.hasNext()) {
				s_b += ", ";
			}
		}
		s_b += "}";
		return s_b;
	},
  get: function(key) {
		return this.h[key.__id__];
	},
  remove: function(key) {
		var id = key.__id__;
		if(this.h.__keys__[id] == null) {
			return false;
		}
		delete(this.h[id]);
		delete(this.h.__keys__[id]);
		return true;
	},
 __class__: ObjectMap
};
ObjectMap.__name__ = "haxe.ds.ObjectMap";
ObjectMap.getId = function(obj) {
	return obj.__id__;
};
ObjectMap.count = 0;
ObjectMap.assignId = function(obj) {
	return obj.__id__ = ++ObjectMap.count;
};


return ObjectMap;
}());
exports.default = exports.ObjectMap = ObjectMap;
