// Package: haxe.ds.StringMap
var HxOverrides = require("../../HxOverrides").HxOverrides;
var haxe_IMap = require("../../haxe/IMap").IMap;
var Std = require("../../Std").Std;
var haxe_ds__StringMap_StringMapIterator = require("../../haxe/ds/_StringMap/StringMapIterator").StringMapIterator;


// Class: haxe.ds.StringMap

var StringMap = (function () {
var StringMap = function() {
	this.h = { };
};
StringMap.__interfaces__ = [haxe_IMap];
StringMap.prototype = {
  h: null,
  set: function(key,value) {
		if(__map_reserved[key] != null) {
			this.setReserved(key,value);
		} else {
			this.h[key] = value;
		}
	},
  keys: function() {
		return HxOverrides.iter(this.arrayKeys());
	},
  iterator: function() {
		return new haxe_ds__StringMap_StringMapIterator(this,this.arrayKeys());
	},
  exists: function(key) {
		if(__map_reserved[key] != null) {
			return this.existsReserved(key);
		}
		return this.h.hasOwnProperty(key);
	},
  arrayKeys: function() {
		var out = [];
		for( var key in this.h ) {
		if(this.h.hasOwnProperty(key)) {
			out.push(key);
		}
		}
		if(this.rh != null) {
			for( var key in this.rh ) {
			if(key.charCodeAt(0) == 36) {
				out.push(key.substr(1));
			}
			}
		}
		return out;
	},
  rh: null,
  toString: function() {
		var s_b = "";
		s_b += "{";
		var keys = this.arrayKeys();
		var _g1 = 0;
		var _g = keys.length;
		while(_g1 < _g) {
			var i = _g1++;
			var k = keys[i];
			s_b += k == null ? "null" : "" + k;
			s_b += " => ";
			s_b += Std.string(Std.string(__map_reserved[k] != null ? this.getReserved(k) : this.h[k]));
			if(i < keys.length - 1) {
				s_b += ", ";
			}
		}
		s_b += "}";
		return s_b;
	},
  get: function(key) {
		if(__map_reserved[key] != null) {
			return this.getReserved(key);
		}
		return this.h[key];
	},
  setReserved: function(key,value) {
		if(this.rh == null) {
			this.rh = { };
		}
		this.rh["$" + key] = value;
	},
  remove: function(key) {
		if(__map_reserved[key] != null) {
			key = "$" + key;
			if(this.rh == null || !this.rh.hasOwnProperty(key)) {
				return false;
			}
			delete(this.rh[key]);
			return true;
		} else {
			if(!this.h.hasOwnProperty(key)) {
				return false;
			}
			delete(this.h[key]);
			return true;
		}
	},
  getReserved: function(key) {
		if(this.rh == null) {
			return null;
		} else {
			return this.rh["$" + key];
		}
	},
  existsReserved: function(key) {
		if(this.rh == null) {
			return false;
		}
		return this.rh.hasOwnProperty("$" + key);
	},
 __class__: StringMap
};
StringMap.__name__ = "haxe.ds.StringMap";
var __map_reserved = {};

return StringMap;
}());
exports.default = exports.StringMap = StringMap;
