// Package: lime.app.Application
var HxOverrides = require("../../HxOverrides").HxOverrides;
var lime_ui_Window = require("../../lime/ui/Window").Window;
var lime__backend_html5_HTML5Application = require("../../lime/_backend/html5/HTML5Application").HTML5Application;
var lime_graphics_Renderer = require("../../lime/graphics/Renderer").Renderer;
var lime_app__Event_Int_Void = require("../../lime/app/_Event_Int_Void")._Event_Int_Void;
var lime_system_System = require("../../lime/system/System").System;
var $extend = require("../../extend_stub").extend_stub;
var lime_app_Module = require("../../lime/app/Module").Module;
var haxe_ds_IntMap = require("../../haxe/ds/IntMap").IntMap;


// Class: lime.app.Application

var Application = (function () {
var Application = function() {
	this.onUpdate = new lime_app__Event_Int_Void();
	lime_app_Module.call(this);
	if(Application.current == null) {
		Application.current = this;
	}
	this.modules = [];
	this.windowByID = new haxe_ds_IntMap();
	this.backend = new lime__backend_html5_HTML5Application(this);
	this.registerModule(this);
};
Application.__super__ = lime_app_Module;
Application.prototype = $extend(lime_app_Module.prototype, {
    "__properties__": {"get_frameRate":"get_frameRate","set_frameRate":"set_frameRate","get_preloader":"get_preloader","get_renderer":"get_renderer","get_renderers":"get_renderers","get_window":"get_window","get_windows":"get_windows"},
  onUpdate: null,
  get_renderers: function() {
		return this.__renderers;
	},
  config: null,
  modules: null,
  renderer: null,
  frameRate: null,
  set_frameRate: function(value) {
		return this.backend.setFrameRate(value);
	},
  window: null,
  create: function(config) {
		this.config = config;
		this.backend.create(config);
		if(config != null) {
			if(Object.prototype.hasOwnProperty.call(config,"fps")) {
				this.backend.setFrameRate(config.fps);
			}
			if(Object.prototype.hasOwnProperty.call(config,"windows")) {
				var _g = 0;
				var _g1 = config.windows;
				while(_g < _g1.length) {
					var windowConfig = _g1[_g];
					++_g;
					var $window = new lime_ui_Window(windowConfig);
					this.createWindow($window);
					break;
				}
			}
			if(this.__preloader == null || this.__preloader.complete) {
				this.setPreloader(this.__preloader);
				var _g2 = 0;
				var _g11 = this.modules;
				while(_g2 < _g11.length) {
					var module = _g11[_g2];
					++_g2;
					this.setPreloader(this.__preloader);
				}
			}
		}
	},
  onModuleExit: function(code) {
		this.backend.exit();
	},
  get_windows: function() {
		return this.__windows;
	},
  onWindowClose: function(window) {
		this.removeWindow(window);
	},
  setPreloader: function(preloader) {
		lime_app_Module.prototype.setPreloader.call(this,preloader);
		var _g = 0;
		var _g1 = this.modules;
		while(_g < _g1.length) {
			var module = _g1[_g];
			++_g;
			module.setPreloader(preloader);
		}
	},
  addModule: function(module) {
		module.registerModule(this);
		this.modules.push(module);
		if(this.__renderers.length > 0) {
			var _g = 0;
			var _g1 = this.__renderers;
			while(_g < _g1.length) {
				var renderer = _g1[_g];
				++_g;
				module.addRenderer(renderer);
			}
		}
		if(this.__windows.length > 0) {
			var _g2 = 0;
			var _g11 = this.__windows;
			while(_g2 < _g11.length) {
				var $window = _g11[_g2];
				++_g2;
				module.addWindow($window);
			}
		}
		module.setPreloader(this.__preloader);
	},
  get_preloader: function() {
		return this.__preloader;
	},
  windowByID: null,
  backend: null,
  createWindow: function(window) {
		lime_app_Module.prototype.addWindow.call(this,window);
		var _g = 0;
		var _g1 = this.modules;
		while(_g < _g1.length) {
			var module = _g1[_g];
			++_g;
			module.addWindow(window);
		}
		if(window.renderer == null) {
			var renderer = new lime_graphics_Renderer(window);
			this.addRenderer(renderer);
		}
		window.create(this);
		this.windowByID.h[window.id] = window;
		window.onCreate.dispatch();
	},
  preloader: null,
  removeWindow: function(window) {
		if(window != null && this.windowByID.h.hasOwnProperty(window.id)) {
			HxOverrides.remove(this.__windows,window);
			this.windowByID.remove(window.id);
			window.close();
			if(window.renderer != null) {
				this.removeRenderer(window.renderer);
			}
			if(this.__windows[0] == window) {
				this.window = null;
			}
			if(this.__windows.length == 0) {
				lime_system_System.exit(0);
			}
		}
	},
  get_frameRate: function() {
		return this.backend.getFrameRate();
	},
  get_renderer: function() {
		return this.__renderers[0];
	},
  addRenderer: function(renderer) {
		lime_app_Module.prototype.addRenderer.call(this,renderer);
		var _g = 0;
		var _g1 = this.modules;
		while(_g < _g1.length) {
			var module = _g1[_g];
			++_g;
			module.addRenderer(renderer);
		}
	},
  removeModule: function(module) {
		if(module != null) {
			module.unregisterModule(this);
			HxOverrides.remove(this.modules,module);
		}
	},
  get_window: function() {
		return this.__windows[0];
	},
  renderers: null,
  windows: null,
  exec: function() {
		Application.current = this;
		return this.backend.exec();
	},
 __class__: Application
});
Application.__name__ = "lime.app.Application";
Application.current = null;
Object.defineProperties(Application.prototype, {
	"renderer": { get: Application.prototype.get_renderer },
	"frameRate": { get: Application.prototype.get_frameRate, set: Application.prototype.set_frameRate },
	"window": { get: Application.prototype.get_window },
	"preloader": { get: Application.prototype.get_preloader },
	"renderers": { get: Application.prototype.get_renderers },
	"windows": { get: Application.prototype.get_windows },
});

var init = lime__backend_html5_HTML5Application

return Application;
}());
exports.default = exports.Application = Application;
