// Package: lime.app._Future.FutureWork
var lime_system_ThreadPool = require("../../../lime/system/ThreadPool").ThreadPool;
var js__Boot_HaxeError = require("../../../js/_Boot/HaxeError").HaxeError;


// Class: lime.app._Future.FutureWork

var FutureWork = (function () {
var FutureWork = function() {};
FutureWork.prototype = {
 __class__: FutureWork
};
FutureWork.__name__ = "lime.app._Future.FutureWork";
FutureWork.threadPool_doWork = function(state) {
	try {
		var result = state.work();
		FutureWork.threadPool.sendComplete({ promise : state.promise, result : result});
	} catch( e ) {
		if (e instanceof js__Boot_HaxeError) e = e.val;
		FutureWork.threadPool.sendError({ promise : state.promise, error : e});
	}
};
FutureWork.threadPool_onComplete = function(state) {
	state.promise.complete(state.result);
};
FutureWork.queue = function(state) {
	if(FutureWork.threadPool == null) {
		FutureWork.threadPool = new lime_system_ThreadPool();
		FutureWork.threadPool.doWork.add(FutureWork.threadPool_doWork);
		FutureWork.threadPool.onComplete.add(FutureWork.threadPool_onComplete);
		FutureWork.threadPool.onError.add(FutureWork.threadPool_onError);
	}
	FutureWork.threadPool.queue(state);
};
FutureWork.threadPool_onError = function(state) {
	state.promise.error(state.error);
};
FutureWork.threadPool = null;


return FutureWork;
}());
exports.default = exports.FutureWork = FutureWork;
