// Package: lime.graphics.format.JPEG
var HxOverrides = require("../../../HxOverrides").HxOverrides;
var lime_graphics_utils_ImageCanvasUtil = require("../../../lime/graphics/utils/ImageCanvasUtil").ImageCanvasUtil;
var haxe_io_Bytes = require("../../../haxe/io/Bytes").Bytes;


// Class: lime.graphics.format.JPEG

var JPEG = (function () {
var JPEG = function() {};
JPEG.prototype = {
 __class__: JPEG
};
JPEG.__name__ = "lime.graphics.format.JPEG";
JPEG.encode = function(image,quality) {
	if(image.get_premultiplied() || image.get_format() != 0) {
		image = image.clone();
		image.set_premultiplied(false);
		image.set_format(0);
	}
	lime_graphics_utils_ImageCanvasUtil.sync(image,false);
	if(image.buffer.__srcCanvas != null) {
		var data = image.buffer.__srcCanvas.toDataURL("image/jpeg",quality / 100);
		var buffer = window.atob(data.split(";base64,")[1]);
		var bytes = new haxe_io_Bytes(new ArrayBuffer(buffer.length));
		var _g1 = 0;
		var _g = buffer.length;
		while(_g1 < _g) {
			var i = _g1++;
			var v = HxOverrides.cca(buffer,i);
			bytes.b[i] = v & 255;
		}
		return bytes;
	}
	return null;
};
JPEG.decodeBytes = function(bytes,decodeData) {
	if(decodeData == null) {
		decodeData = true;
	}
	return null;
};
JPEG.decodeFile = function(path,decodeData) {
	if(decodeData == null) {
		decodeData = true;
	}
	return null;
};


return JPEG;
}());
exports.default = exports.JPEG = JPEG;
