// Package: lime.math.Vector2


// Class: lime.math.Vector2

var Vector2 = (function () {
var Vector2 = function(x,y) {
	if(y == null) {
		y = 0;
	}
	if(x == null) {
		x = 0;
	}
	this.x = x;
	this.y = y;
};
Vector2.prototype = {
    "__properties__": {"get_length":"get_length"},
  normalize: function(thickness) {
		if(this.x == 0 && this.y == 0) {
			return;
		} else {
			var norm = thickness / Math.sqrt(this.x * this.x + this.y * this.y);
			this.x *= norm;
			this.y *= norm;
		}
	},
  subtract: function(v) {
		return new Vector2(this.x - v.x,this.y - v.y);
	},
  setTo: function(xa,ya) {
		this.x = xa;
		this.y = ya;
	},
  add: function(v) {
		return new Vector2(v.x + this.x,v.y + this.y);
	},
  get_length: function() {
		return Math.sqrt(this.x * this.x + this.y * this.y);
	},
  __toFlashPoint: function() {
		return null;
	},
  offset: function(dx,dy) {
		this.x += dx;
		this.y += dy;
	},
  length: null,
  clone: function() {
		return new Vector2(this.x,this.y);
	},
  y: null,
  equals: function(toCompare) {
		if(toCompare != null && toCompare.x == this.x) {
			return toCompare.y == this.y;
		} else {
			return false;
		}
	},
  x: null,
 __class__: Vector2
};
Vector2.__name__ = "lime.math.Vector2";
Vector2.polar = function(len,angle) {
	return new Vector2(len * Math.cos(angle),len * Math.sin(angle));
};
Vector2.interpolate = function(pt1,pt2,f) {
	return new Vector2(pt2.x + f * (pt1.x - pt2.x),pt2.y + f * (pt1.y - pt2.y));
};
Vector2.distance = function(pt1,pt2) {
	var dx = pt1.x - pt2.x;
	var dy = pt1.y - pt2.y;
	return Math.sqrt(dx * dx + dy * dy);
};
Object.defineProperties(Vector2.prototype, {
	"length": { get: Vector2.prototype.get_length },
});



return Vector2;
}());
exports.default = exports.Vector2 = Vector2;
