// Package: lime.media.AudioBuffer
var lime_app_Promise = require("../../lime/app/Promise").Promise;
var lime_app_Future = require("../../lime/app/Future").Future;
var lime_utils_Log = require("../../lime/utils/Log").Log;


// Class: lime.media.AudioBuffer

var AudioBuffer = (function () {
var AudioBuffer = function() {
};
AudioBuffer.prototype = {
    "__properties__": {"get_src":"get_src","set_src":"set_src"},
  __srcFMODSound: null,
  __srcSound: null,
  get_src: function() {
		return this.__srcAudio;
	},
  __srcHowl: null,
  __srcVorbisFile: null,
  src: null,
  __srcAudio: null,
  __srcCustom: null,
  __srcBuffer: null,
  bitsPerSample: null,
  channels: null,
  data: null,
  dispose: function() {
	},
  sampleRate: null,
  set_src: function(value) {
		return this.__srcAudio = value;
	},
 __class__: AudioBuffer
};
AudioBuffer.__name__ = "lime.media.AudioBuffer";
AudioBuffer.fromVorbisFile = function(vorbisFile) {
	return null;
};
AudioBuffer.loadFromFiles = function(paths) {
	var promise = new lime_app_Promise();
	promise.completeWith(new lime_app_Future(function() {
		return AudioBuffer.fromFiles(paths);
	},true));
	return promise.future;
};
AudioBuffer.fromFiles = function(paths) {
	var buffer = null;
	var _g = 0;
	while(_g < paths.length) {
		var path = paths[_g];
		++_g;
		buffer = AudioBuffer.fromFile(path);
		if(buffer != null) {
			break;
		}
	}
	return buffer;
};
AudioBuffer.__getCodec = function(bytes) {
	var signature = bytes.getString(0,4);
	switch(signature) {
	case "OggS":
		return "audio/ogg";
	case "RIFF":
		if(bytes.getString(8,4) == "WAVE") {
			return "audio/wav";
		} else if(bytes.getString(0,3) == "ID3" || bytes.getString(0,2) == "ÿû") {
			return "audio/mp3";
		}
		break;
	case "fLaC":
		return "audio/flac";
	default:
		if(bytes.getString(0,3) == "ID3" || bytes.getString(0,2) == "ÿû") {
			return "audio/mp3";
		}
	}
	lime_utils_Log.error("Unsupported sound format",{ fileName : "AudioBuffer.hx", lineNumber : 480, className : "lime.media.AudioBuffer", methodName : "__getCodec"});
	return null;
};
AudioBuffer.loadFromFile = function(path) {
	var promise = new lime_app_Promise();
	var audioBuffer = AudioBuffer.fromFile(path);
	if(audioBuffer != null) {
		promise.complete(audioBuffer);
	} else {
		promise.error(null);
	}
	return promise.future;
};
AudioBuffer.fromBytes = function(bytes) {
	if(bytes == null) {
		return null;
	}
	return null;
};
AudioBuffer.fromFile = function(path) {
	if(path == null) {
		return null;
	}
	return null;
};
AudioBuffer.fromBase64 = function(base64String) {
	if(base64String == null) {
		return null;
	}
	return null;
};
Object.defineProperties(AudioBuffer.prototype, {
	"src": { get: AudioBuffer.prototype.get_src, set: AudioBuffer.prototype.set_src },
});



return AudioBuffer;
}());
exports.default = exports.AudioBuffer = AudioBuffer;
