// Package: lime.media.AudioManager
var lime_media_HTML5AudioContext = require("../../lime/media/HTML5AudioContext").HTML5AudioContext;
var lime_media_AudioContext = require("../../lime/media/AudioContext").AudioContext;


// Class: lime.media.AudioManager

var AudioManager = (function () {
var AudioManager = function() {};
AudioManager.prototype = {
 __class__: AudioManager
};
AudioManager.__name__ = "lime.media.AudioManager";
AudioManager.init = function(context) {
	if(AudioManager.context == null) {
		if(context == null) {
			try {
				window.AudioContext = window.AudioContext || window.webkitAudioContext;
				AudioManager.context = lime_media_AudioContext.WEB(new AudioContext ());
			} catch( e ) {
				AudioManager.context = lime_media_AudioContext.HTML5(new lime_media_HTML5AudioContext());
			}
		} else {
			AudioManager.context = context;
		}
	}
};
AudioManager.shutdown = function() {
	if(AudioManager.context != null) {
		var _g = AudioManager.context;
		if(_g[1] == 0) {
			var al = _g[3];
			var alc = _g[2];
			var currentContext = alc.getCurrentContext();
			if(currentContext != null) {
				var device = alc.getContextsDevice(currentContext);
				alc.makeContextCurrent(null);
				alc.destroyContext(currentContext);
				if(device != null) {
					alc.closeDevice(device);
				}
			}
		}
		AudioManager.context = null;
	}
};
AudioManager.context = null;
AudioManager.resume = function() {
	if(AudioManager.context != null) {
		var _g = AudioManager.context;
		if(_g[1] == 0) {
			var al = _g[3];
			var alc = _g[2];
			var currentContext = alc.getCurrentContext();
			if(currentContext != null) {
				var device = alc.getContextsDevice(currentContext);
				alc.resumeDevice(device);
				alc.processContext(currentContext);
			}
		}
	}
};
AudioManager.suspend = function() {
	if(AudioManager.context != null) {
		var _g = AudioManager.context;
		if(_g[1] == 0) {
			var al = _g[3];
			var alc = _g[2];
			var currentContext = alc.getCurrentContext();
			if(currentContext != null) {
				alc.suspendContext(currentContext);
				var device = alc.getContextsDevice(currentContext);
				alc.pauseDevice(device);
			}
		}
	}
};


return AudioManager;
}());
exports.default = exports.AudioManager = AudioManager;
