// Package: lime.system.System
var lime_system_Display = require("../../lime/system/Display").Display;
var haxe_ds_StringMap = require("../../haxe/ds/StringMap").StringMap;
var lime_system_CFFI = require("../../lime/system/CFFI").CFFI;
var StringTools = require("../../StringTools").StringTools;
var lime_math_Rectangle = require("../../lime/math/Rectangle").Rectangle;
var lime_system_Endian = require("../../lime/system/Endian").Endian;
var Reflect = require("../../Reflect").Reflect;
var Std = require("../../Std").Std;
var lime_system_DisplayMode = require("../../lime/system/DisplayMode").DisplayMode;
var haxe_ds_IntMap = require("../../haxe/ds/IntMap").IntMap;


// Class: lime.system.System

var System = (function () {
var System = function() {};
System.prototype = {
 __class__: System
};
System.__name__ = "lime.system.System";
System.get_endianness = function() {
	if(System.endianness == null) {
		var arrayBuffer = new ArrayBuffer(2);
		var this1;
		if(arrayBuffer != null) {
			this1 = new Uint8Array(arrayBuffer,0);
		} else {
			this1 = null;
		}
		var uint8Array = this1;
		var this2;
		if(arrayBuffer != null) {
			this2 = new Uint16Array(arrayBuffer,0);
		} else {
			this2 = null;
		}
		var uint16array = this2;
		uint8Array[0] = 170;
		uint8Array[1] = 187;
		if(uint16array[0] == 43707) {
			System.endianness = lime_system_Endian.BIG_ENDIAN;
		} else {
			System.endianness = lime_system_Endian.LITTLE_ENDIAN;
		}
	}
	return System.endianness;
};
System.userDirectory = null;
System.numDisplays = null;
System.__applicationConfig = null;
System.openFile = function(path) {
	if(path != null) {
		window.open(path,"_blank");
	}
};
System.get_desktopDirectory = function() {
	return System.__getDirectory(2);
};
System.getTimer = function() {
	return window.performance.now() | 0;
};
System.get_documentsDirectory = function() {
	return System.__getDirectory(3);
};
System.applicationDirectory = null;
System.fontsDirectory = null;
System.__applicationEntryPoint = null;
System.get_allowScreenTimeout = function() {
	return true;
};
System.applicationStorageDirectory = null;
System.__getDirectory = function(type) {
	return null;
};
System.get_applicationStorageDirectory = function() {
	return System.__getDirectory(1);
};
System.__copyMissingFields = function(target,source) {
	if(source == null || target == null) {
		return;
	}
	var _g = 0;
	var _g1 = Reflect.fields(source);
	while(_g < _g1.length) {
		var field = _g1[_g];
		++_g;
		if(!Object.prototype.hasOwnProperty.call(target,field)) {
			target[field] = Reflect.field(source,field);
		}
	}
};
System.embed = function(projectName,element,width,height,windowConfig) {
	if(System.__applicationEntryPoint == null || System.__applicationConfig == null) {
		return;
	}
	var _this = System.__applicationEntryPoint;
	if(__map_reserved[projectName] != null ? _this.existsReserved(projectName) : _this.h.hasOwnProperty(projectName)) {
		var htmlElement = null;
		if(typeof(element) == "string") {
			htmlElement = window.document.getElementById(element);
		} else if(element == null) {
			htmlElement = window.document.createElement("div");
		} else {
			htmlElement = element;
		}
		if(htmlElement == null) {
			window.console.log("[lime.embed] ERROR: Cannot find target element: " + Std.string(element));
			return;
		}
		if(width == null) {
			width = 0;
		}
		if(height == null) {
			height = 0;
		}
		var _this1 = System.__applicationConfig;
		var defaultConfig = __map_reserved[projectName] != null ? _this1.getReserved(projectName) : _this1.h[projectName];
		var config = { };
		System.__copyMissingFields(config,defaultConfig);
		if(windowConfig != null) {
			config.windows = [];
			if((windowConfig instanceof Array) && windowConfig.__enum__ == null) {
				config.windows = windowConfig;
			} else {
				config.windows[0] = windowConfig;
			}
			var _g1 = 0;
			var _g = config.windows.length;
			while(_g1 < _g) {
				var i = _g1++;
				if(i < defaultConfig.windows.length) {
					System.__copyMissingFields(config.windows[i],defaultConfig.windows[i]);
				}
				System.__copyMissingFields(config.windows[i].parameters,defaultConfig.windows[i].parameters);
				if(typeof(windowConfig.background) == "string") {
					var background = StringTools.replace(Std.string(windowConfig.background),"#","");
					if(background.indexOf("0x") > -1) {
						windowConfig.background = Std.parseInt(background);
					} else {
						windowConfig.background = Std.parseInt("0x" + background);
					}
				}
			}
		}
		if(Reflect.field(config.windows[0],"rootPath")) {
			config.rootPath = Reflect.field(config.windows[0],"rootPath");
			Reflect.deleteField(config.windows[0],"rootPath");
		}
		config.windows[0].element = htmlElement;
		config.windows[0].width = width;
		config.windows[0].height = height;
		var _this2 = System.__applicationEntryPoint;
		(__map_reserved[projectName] != null ? _this2.getReserved(projectName) : _this2.h[projectName])(config);
	}
};
System.get_applicationDirectory = function() {
	return System.__getDirectory(0);
};
System.__directories = new haxe_ds_IntMap();
System.load = function(library,method,args,lazy) {
	if(lazy == null) {
		lazy = false;
	}
	if(args == null) {
		args = 0;
	}
	return lime_system_CFFI.load(library,method,args,lazy);
};
System.openURL = function(url,target) {
	if(target == null) {
		target = "_blank";
	}
	if(url != null) {
		window.open(url,target);
	}
};
System.endianness = null;
System.exit = function(code) {
};
System.get_numDisplays = function() {
	return 1;
};
System.disableCFFI = null;
System.documentsDirectory = null;
System.allowScreenTimeout = null;
System.desktopDirectory = null;
System.get_userDirectory = function() {
	return System.__getDirectory(5);
};
System.__registerEntryPoint = function(projectName,entryPoint,config) {
	if(System.__applicationConfig == null) {
		System.__applicationConfig = new haxe_ds_StringMap();
	}
	if(System.__applicationEntryPoint == null) {
		System.__applicationEntryPoint = new haxe_ds_StringMap();
	}
	var _this = System.__applicationEntryPoint;
	if(__map_reserved[projectName] != null) {
		_this.setReserved(projectName,entryPoint);
	} else {
		_this.h[projectName] = entryPoint;
	}
	var _this1 = System.__applicationConfig;
	if(__map_reserved[projectName] != null) {
		_this1.setReserved(projectName,config);
	} else {
		_this1.h[projectName] = config;
	}
};
System.getDisplay = function(id) {
	if(id == 0) {
		var display = new lime_system_Display();
		display.id = 0;
		display.name = "Generic Display";
		display.dpi = 96 * window.devicePixelRatio;
		display.currentMode = new lime_system_DisplayMode(window.screen.width,window.screen.height,60,1);
		display.supportedModes = [display.currentMode];
		display.bounds = new lime_math_Rectangle(0,0,display.currentMode.width,display.currentMode.height);
		return display;
	}
	return null;
};
System.set_allowScreenTimeout = function(value) {
	return true;
};
System.get_fontsDirectory = function() {
	return System.__getDirectory(4);
};


return System;
}());
exports.default = exports.System = System;
