// Package: lime.ui.FileDialog
var lime_app__Event_Array_String__Void = require("../../lime/app/_Event_Array_String__Void")._Event_Array_String__Void;
var lime_ui_FileDialogType = require("../../lime/ui/FileDialogType").FileDialogType;
var lime_app__Event_Void_Void = require("../../lime/app/_Event_Void_Void")._Event_Void_Void;
var lime_app__Event_String_Void = require("../../lime/app/_Event_String_Void")._Event_String_Void;
var lime_graphics_Image = require("../../lime/graphics/Image").Image;
var lime_app__Event_lime_utils_Resource_Void = require("../../lime/app/_Event_lime_utils_Resource_Void")._Event_lime_utils_Resource_Void;
var haxe_io_Path = require("../../haxe/io/Path").Path;


// Class: lime.ui.FileDialog

var FileDialog = (function () {
var FileDialog = function() {
	this.onSelectMultiple = new lime_app__Event_Array_String__Void();
	this.onSelect = new lime_app__Event_String_Void();
	this.onSave = new lime_app__Event_String_Void();
	this.onOpen = new lime_app__Event_lime_utils_Resource_Void();
	this.onCancel = new lime_app__Event_Void_Void();
};
FileDialog.prototype = {
  onSave: null,
  save: function(data,filter,defaultPath,title) {
		if(data == null) {
			this.onCancel.dispatch();
			return false;
		}
		var type = "application/octet-stream";
		var defaultExtension = "";
		if(lime_graphics_Image.__isPNG(data)) {
			type = "image/png";
			defaultExtension = ".png";
		} else if(lime_graphics_Image.__isJPG(data)) {
			type = "image/jpeg";
			defaultExtension = ".jpg";
		} else if(lime_graphics_Image.__isGIF(data)) {
			type = "image/gif";
			defaultExtension = ".gif";
		} else if(lime_graphics_Image.__isWebP(data)) {
			type = "image/webp";
			defaultExtension = ".webp";
		}
		var path = defaultPath != null ? haxe_io_Path.withoutDirectory(defaultPath) : "download" + defaultExtension;
		var buffer = data.b.bufferValue;
		window.saveAs(new Blob([buffer],{ type : type}),path,true);
		this.onSave.dispatch(path);
		return true;
	},
  onSelectMultiple: null,
  onOpen: null,
  onCancel: null,
  browse: function(type,filter,defaultPath,title) {
		if(type == null) {
			type = lime_ui_FileDialogType.OPEN;
		}
		this.onCancel.dispatch();
		return false;
	},
  onSelect: null,
  open: function(filter,defaultPath,title) {
		this.onCancel.dispatch();
		return false;
	},
 __class__: FileDialog
};
FileDialog.__name__ = "lime.ui.FileDialog";


return FileDialog;
}());
exports.default = exports.FileDialog = FileDialog;
