// Package: lime.ui.Gamepad
var lime_app__Event_lime_ui_Gamepad_Void = require("../../lime/app/_Event_lime_ui_Gamepad_Void")._Event_lime_ui_Gamepad_Void;
var lime_app__Event_Void_Void = require("../../lime/app/_Event_Void_Void")._Event_Void_Void;
var lime_app__Event_lime_ui_GamepadAxis_Float_Void = require("../../lime/app/_Event_lime_ui_GamepadAxis_Float_Void")._Event_lime_ui_GamepadAxis_Float_Void;
var lime_ui_Joystick = require("../../lime/ui/Joystick").Joystick;
var lime_app__Event_lime_ui_GamepadButton_Void = require("../../lime/app/_Event_lime_ui_GamepadButton_Void")._Event_lime_ui_GamepadButton_Void;
var haxe_ds_IntMap = require("../../haxe/ds/IntMap").IntMap;


// Class: lime.ui.Gamepad

var Gamepad = (function () {
var Gamepad = function(id) {
	this.onDisconnect = new lime_app__Event_Void_Void();
	this.onButtonUp = new lime_app__Event_lime_ui_GamepadButton_Void();
	this.onButtonDown = new lime_app__Event_lime_ui_GamepadButton_Void();
	this.onAxisMove = new lime_app__Event_lime_ui_GamepadAxis_Float_Void();
	this.id = id;
	this.connected = true;
};
Gamepad.prototype = {
    "__properties__": {"get_guid":"get_guid","get_name":"get_name"},
  id: null,
  name: null,
  get_guid: function() {
		var devices = lime_ui_Joystick.__getDeviceData();
		return devices[this.id].id;
	},
  guid: null,
  get_name: function() {
		var devices = lime_ui_Joystick.__getDeviceData();
		return devices[this.id].id;
	},
  onButtonUp: null,
  onAxisMove: null,
  connected: null,
  onButtonDown: null,
  onDisconnect: null,
 __class__: Gamepad
};
Gamepad.__name__ = "lime.ui.Gamepad";
Gamepad.onConnect = new lime_app__Event_lime_ui_Gamepad_Void();
Gamepad.__connect = function(id) {
	if(!Gamepad.devices.h.hasOwnProperty(id)) {
		var gamepad = new Gamepad(id);
		Gamepad.devices.h[id] = gamepad;
		Gamepad.onConnect.dispatch(gamepad);
	}
};
Gamepad.__disconnect = function(id) {
	var gamepad = Gamepad.devices.h[id];
	if(gamepad != null) {
		gamepad.connected = false;
	}
	Gamepad.devices.remove(id);
	if(gamepad != null) {
		gamepad.onDisconnect.dispatch();
	}
};
Gamepad.addMappings = function(mappings) {
};
Gamepad.devices = new haxe_ds_IntMap();
Object.defineProperties(Gamepad.prototype, {
	"name": { get: Gamepad.prototype.get_name },
	"guid": { get: Gamepad.prototype.get_guid },
});



return Gamepad;
}());
exports.default = exports.Gamepad = Gamepad;
