// Package: lime.ui.Joystick
var lime_app__Event_Int_Float_Void = require("../../lime/app/_Event_Int_Float_Void")._Event_Int_Float_Void;
var lime_app__Event_Int_lime_ui_JoystickHatPosition_Void = require("../../lime/app/_Event_Int_lime_ui_JoystickHatPosition_Void")._Event_Int_lime_ui_JoystickHatPosition_Void;
var lime_app__Event_Int_Void = require("../../lime/app/_Event_Int_Void")._Event_Int_Void;
var lime_app__Event_Int_Float_Float_Void = require("../../lime/app/_Event_Int_Float_Float_Void")._Event_Int_Float_Float_Void;
var lime_app__Event_Void_Void = require("../../lime/app/_Event_Void_Void")._Event_Void_Void;
var lime_app__Event_lime_ui_Joystick_Void = require("../../lime/app/_Event_lime_ui_Joystick_Void")._Event_lime_ui_Joystick_Void;
var haxe_ds_IntMap = require("../../haxe/ds/IntMap").IntMap;


// Class: lime.ui.Joystick

var Joystick = (function () {
var Joystick = function(id) {
	this.onTrackballMove = new lime_app__Event_Int_Float_Float_Void();
	this.onHatMove = new lime_app__Event_Int_lime_ui_JoystickHatPosition_Void();
	this.onDisconnect = new lime_app__Event_Void_Void();
	this.onButtonUp = new lime_app__Event_Int_Void();
	this.onButtonDown = new lime_app__Event_Int_Void();
	this.onAxisMove = new lime_app__Event_Int_Float_Void();
	this.id = id;
	this.connected = true;
};
Joystick.prototype = {
    "__properties__": {"get_guid":"get_guid","get_name":"get_name","get_numAxes":"get_numAxes","get_numButtons":"get_numButtons","get_numHats":"get_numHats","get_numTrackballs":"get_numTrackballs"},
  get_numAxes: function() {
		var devices = Joystick.__getDeviceData();
		return devices[this.id].axes.length;
	},
  id: null,
  name: null,
  get_numHats: function() {
		return 0;
	},
  get_guid: function() {
		var devices = Joystick.__getDeviceData();
		return devices[this.id].id;
	},
  get_numButtons: function() {
		var devices = Joystick.__getDeviceData();
		return devices[this.id].buttons.length;
	},
  guid: null,
  get_name: function() {
		var devices = Joystick.__getDeviceData();
		return devices[this.id].id;
	},
  get_numTrackballs: function() {
		return 0;
	},
  onButtonUp: null,
  numAxes: null,
  numTrackballs: null,
  onAxisMove: null,
  numButtons: null,
  onHatMove: null,
  connected: null,
  onButtonDown: null,
  onDisconnect: null,
  onTrackballMove: null,
  numHats: null,
 __class__: Joystick
};
Joystick.__name__ = "lime.ui.Joystick";
Joystick.onConnect = new lime_app__Event_lime_ui_Joystick_Void();
Joystick.__connect = function(id) {
	if(!Joystick.devices.h.hasOwnProperty(id)) {
		var joystick = new Joystick(id);
		Joystick.devices.h[id] = joystick;
		Joystick.onConnect.dispatch(joystick);
	}
};
Joystick.__disconnect = function(id) {
	var joystick = Joystick.devices.h[id];
	if(joystick != null) {
		joystick.connected = false;
	}
	Joystick.devices.remove(id);
	if(joystick != null) {
		joystick.onDisconnect.dispatch();
	}
};
Joystick.__getDeviceData = function() {
	if(navigator.getGamepads) {
		return navigator.getGamepads();
	} else if(navigator.webkitGetGamepads) {
		return navigator.webkitGetGamepads();
	} else {
		return null;
	}
};
Joystick.devices = new haxe_ds_IntMap();
Object.defineProperties(Joystick.prototype, {
	"name": { get: Joystick.prototype.get_name },
	"guid": { get: Joystick.prototype.get_guid },
	"numAxes": { get: Joystick.prototype.get_numAxes },
	"numTrackballs": { get: Joystick.prototype.get_numTrackballs },
	"numButtons": { get: Joystick.prototype.get_numButtons },
	"numHats": { get: Joystick.prototype.get_numHats },
});



return Joystick;
}());
exports.default = exports.Joystick = Joystick;
