// Package: lime.utils.Assets
var haxe_ds_StringMap = require("../../haxe/ds/StringMap").StringMap;
var lime_app__Event_Void_Void = require("../../lime/app/_Event_Void_Void")._Event_Void_Void;
var lime_utils_AssetCache = require("../../lime/utils/AssetCache").AssetCache;
var lime_app_Promise = require("../../lime/app/Promise").Promise;
var haxe_ds__StringMap_StringMapIterator = require("../../haxe/ds/_StringMap/StringMapIterator").StringMapIterator;
var lime_app_Application = require("../../lime/app/Application").Application;


// Class: lime.utils.Assets

var Assets = (function () {
var Assets = function() {};
Assets.prototype = {
 __class__: Assets
};
Assets.__name__ = "lime.utils.Assets";
Assets.getText = function(id) {
	return Assets.getAsset(id,"TEXT",false);
};
Assets.list = function(type) {
	var items = [];
	var _this = Assets.libraries;
	var library = new haxe_ds__StringMap_StringMapIterator(_this,_this.arrayKeys());
	while(library.hasNext()) {
		var library1 = library.next();
		var libraryItems = library1.list(type);
		if(libraryItems != null) {
			items = items.concat(libraryItems);
		}
	}
	return items;
};
Assets.onChange = new lime_app__Event_Void_Void();
Assets.getFont = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	return Assets.getAsset(id,"FONT",useCache);
};
Assets.loadAudioBuffer = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	return Assets.loadAsset(id,"SOUND",useCache);
};
Assets.loadBytes = function(id) {
	return Assets.loadAsset(id,"BINARY",false);
};
Assets.registerLibrary = function(name,library) {
	var _this = Assets.libraries;
	if(__map_reserved[name] != null ? _this.existsReserved(name) : _this.h.hasOwnProperty(name)) {
		var _this1 = Assets.libraries;
		if((__map_reserved[name] != null ? _this1.getReserved(name) : _this1.h[name]) == library) {
			return;
		} else {
			Assets.unloadLibrary(name);
		}
	}
	if(library != null) {
		library.onChange.add(Assets.library_onChange);
	}
	var _this2 = Assets.libraries;
	if(__map_reserved[name] != null) {
		_this2.setReserved(name,library);
	} else {
		_this2.h[name] = library;
	}
};
Assets.cache = new lime_utils_AssetCache();
Assets.getLibrary = function(name) {
	if(name == null || name == "") {
		name = "default";
	}
	var _this = Assets.libraries;
	if(__map_reserved[name] != null) {
		return _this.getReserved(name);
	} else {
		return _this.h[name];
	}
};
Assets.unloadLibrary = function(name) {
};
Assets.loadFont = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	return Assets.loadAsset(id,"FONT",useCache);
};
Assets.getPath = function(id) {
	return null;
};
Assets.loadLibrary = function(id) {
	var promise = new lime_app_Promise();
	return promise.future;
};
Assets.defaultRootPath = null;
Assets.getAudioBuffer = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	return Assets.getAsset(id,"SOUND",useCache);
};
Assets.getBytes = function(id) {
	return Assets.getAsset(id,"BINARY",false);
};
Assets.hasLibrary = function(name) {
	if(name == null || name == "") {
		name = "default";
	}
	var _this = Assets.libraries;
	if(__map_reserved[name] != null) {
		return _this.existsReserved(name);
	} else {
		return _this.h.hasOwnProperty(name);
	}
};
Assets.library_onChange = function() {
	Assets.cache.clear();
	Assets.onChange.dispatch();
};
Assets.exists = function(id,type) {
	return false;
};
Assets.loadAsset = function(id,type,useCache) {
	return null;
};
Assets.loadImage = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	return Assets.loadAsset(id,"IMAGE",useCache);
};
Assets.isLocal = function(id,type,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	return false;
};
Assets.isValidAudio = function(buffer) {
	return buffer != null;
};
Assets.libraryPaths = new haxe_ds_StringMap();
Assets.isValidImage = function(image) {
	if(image != null) {
		return image.buffer != null;
	} else {
		return false;
	}
};
Assets.loadText = function(id) {
	return Assets.loadAsset(id,"TEXT",false);
};
Assets.libraries = new haxe_ds_StringMap();
Assets.getImage = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	return Assets.getAsset(id,"IMAGE",useCache);
};
Assets.__libraryNotFound = function(name) {
	if(name == null || name == "") {
		name = "default";
	}
	if(lime_app_Application.current != null && lime_app_Application.current.__preloader != null && !lime_app_Application.current.__preloader.complete) {
		return "There is no asset library named \"" + name + "\", or it is not yet preloaded";
	} else {
		return "There is no asset library named \"" + name + "\"";
	}
};
Assets.getAsset = function(id,type,useCache) {
	return null;
};


return Assets;
}());
exports.default = exports.Assets = Assets;
