// Package: openfl._Vector.BoolVector
var HxOverrides = require("../../HxOverrides").HxOverrides;
var js_Boot = require("../../js/Boot").Boot;
var openfl__Vector_IVector = require("../../openfl/_Vector/IVector").IVector;


// Class: openfl._Vector.BoolVector

var BoolVector = (function () {
var BoolVector = function(length,fixed,array) {
	if(array == null) {
		array = [];
	}
	this.__array = array;
	if(length != null) {
		this.set_length(length);
	}
	this.fixed = fixed == true;
};
BoolVector.__interfaces__ = [openfl__Vector_IVector];
BoolVector.prototype = {
    "__properties__": {"get_length":"get_length","set_length":"set_length"},
  copy: function() {
		return new BoolVector(null,this.fixed,this.__array.slice());
	},
  shift: function() {
		if(!this.fixed) {
			return this.__array.shift();
		} else {
			return null;
		}
	},
  pop: function() {
		if(!this.fixed) {
			return this.__array.pop();
		} else {
			return null;
		}
	},
  set: function(index,value) {
		if(!this.fixed || index < this.__array.length) {
			return this.__array[index] = value;
		} else {
			return value;
		}
	},
  slice: function(startIndex,endIndex) {
		if(endIndex == null) {
			endIndex = 16777215;
		}
		if(startIndex == null) {
			startIndex = 0;
		}
		return new BoolVector(null,null,this.__array.slice(startIndex,endIndex));
	},
  splice: function(pos,len) {
		return new BoolVector(null,null,this.__array.splice(pos,len));
	},
  toJSON: function() {
		return this.__array;
	},
  iterator: function() {
		return HxOverrides.iter(this.__array);
	},
  concat: function(a) {
		if(a == null) {
			return new BoolVector(null,null,this.__array.slice());
		} else {
			return new BoolVector(null,null,this.__array.concat((js_Boot.__cast(a , BoolVector)).__array));
		}
	},
  sort: function(f) {
		this.__array.sort(f);
	},
  join: function(sep) {
		if(sep == null) {
			sep = ",";
		}
		return this.__array.join(sep);
	},
  get_length: function() {
		return this.__array.length;
	},
  fixed: null,
  insertAt: function(index,element) {
		if(!this.fixed || index < this.__array.length) {
			this.__array.splice(index,0,element);
		}
	},
  __array: null,
  reverse: function() {
		this.__array.reverse();
		return this;
	},
  set_length: function(value) {
		if(!this.fixed) {
			var currentLength = this.__array.length;
			if(value < 0) {
				value = 0;
			}
			if(value > currentLength) {
				var _g1 = currentLength;
				var _g = value;
				while(_g1 < _g) {
					var i = _g1++;
					this.__array[i] = false;
				}
			} else {
				while(this.__array.length > value) this.__array.pop();
			}
		}
		return this.__array.length;
	},
  length: null,
  indexOf: function(x,from) {
		if(from == null) {
			from = 0;
		}
		var _g1 = from;
		var _g = this.__array.length;
		while(_g1 < _g) {
			var i = _g1++;
			if(this.__array[i] == x) {
				return i;
			}
		}
		return -1;
	},
  toString: function() {
		if(this.__array != null) {
			return this.__array.toString();
		} else {
			return null;
		}
	},
  push: function(x) {
		if(!this.fixed) {
			return this.__array.push(x);
		} else {
			return this.__array.length;
		}
	},
  unshift: function(x) {
		if(!this.fixed) {
			this.__array.unshift(x);
		}
	},
  get: function(index) {
		if(index >= this.__array.length) {
			return false;
		} else {
			return this.__array[index];
		}
	},
  removeAt: function(index) {
		if(!this.fixed || index < this.__array.length) {
			return this.__array.splice(index,1)[0];
		}
		return false;
	},
  lastIndexOf: function(x,from) {
		if(from == null) {
			from = 0;
		}
		var i = this.__array.length - 1;
		while(i >= from) {
			if(this.__array[i] == x) {
				return i;
			}
			--i;
		}
		return -1;
	},
 __class__: BoolVector
};
BoolVector.__name__ = "openfl._Vector.BoolVector";
Object.defineProperties(BoolVector.prototype, {
	"length": { get: BoolVector.prototype.get_length, set: BoolVector.prototype.set_length },
});



return BoolVector;
}());
exports.default = exports.BoolVector = BoolVector;
