// Package: openfl._internal.renderer.canvas.CanvasMaskManager
var $extend = require("../../../../extend_stub").extend_stub;
var openfl__internal_renderer_AbstractMaskManager = require("../../../../openfl/_internal/renderer/AbstractMaskManager").AbstractMaskManager;


// Class: openfl._internal.renderer.canvas.CanvasMaskManager

var CanvasMaskManager = (function () {
var CanvasMaskManager = function(renderSession) {
	openfl__internal_renderer_AbstractMaskManager.call(this,renderSession);
};
CanvasMaskManager.__super__ = openfl__internal_renderer_AbstractMaskManager;
CanvasMaskManager.prototype = $extend(openfl__internal_renderer_AbstractMaskManager.prototype, {
  pushMask: function(mask) {
		var context = this.renderSession.context;
		context.save();
		var transform = mask.__getRenderTransform();
		context.setTransform(transform.a,transform.b,transform.c,transform.d,transform.tx,transform.ty);
		context.beginPath();
		mask.__renderCanvasMask(this.renderSession);
		context.clip();
	},
  popMask: function() {
		this.renderSession.context.restore();
	},
  pushRect: function(rect,transform) {
		var context = this.renderSession.context;
		context.save();
		context.setTransform(transform.a,transform.b,transform.c,transform.d,transform.tx,transform.ty);
		context.beginPath();
		context.rect(rect.x,rect.y,rect.width,rect.height);
		context.clip();
	},
  popObject: function(object,handleScrollRect) {
		if(handleScrollRect == null) {
			handleScrollRect = true;
		}
		if(!object.__cacheBitmapRender && object.__mask != null) {
			this.popMask();
		}
		if(handleScrollRect && object.__scrollRect != null) {
			this.popRect();
		}
	},
  popRect: function() {
		this.renderSession.context.restore();
	},
  pushObject: function(object,handleScrollRect) {
		if(handleScrollRect == null) {
			handleScrollRect = true;
		}
		if(handleScrollRect && object.__scrollRect != null) {
			this.pushRect(object.__scrollRect,object.__renderTransform);
		}
		if(!object.__cacheBitmapRender && object.__mask != null) {
			this.pushMask(object.__mask);
		}
	},
 __class__: CanvasMaskManager
});
CanvasMaskManager.__name__ = "openfl._internal.renderer.canvas.CanvasMaskManager";


return CanvasMaskManager;
}());
exports.default = exports.CanvasMaskManager = CanvasMaskManager;
