// Package: openfl._internal.renderer.canvas.CanvasRenderer
var openfl__internal_renderer_AbstractRenderer = require("../../../../openfl/_internal/renderer/AbstractRenderer").AbstractRenderer;
var openfl__internal_renderer_RenderSession = require("../../../../openfl/_internal/renderer/RenderSession").RenderSession;
var openfl__internal_renderer_canvas_CanvasMaskManager = require("../../../../openfl/_internal/renderer/canvas/CanvasMaskManager").CanvasMaskManager;
var $extend = require("../../../../extend_stub").extend_stub;
var openfl__internal_renderer_canvas_CanvasBlendModeManager = require("../../../../openfl/_internal/renderer/canvas/CanvasBlendModeManager").CanvasBlendModeManager;


// Class: openfl._internal.renderer.canvas.CanvasRenderer

var CanvasRenderer = (function () {
var CanvasRenderer = function(stage,context) {
	openfl__internal_renderer_AbstractRenderer.call(this,stage);
	this.context = context;
	this.renderSession = new openfl__internal_renderer_RenderSession();
	this.renderSession.clearRenderDirty = true;
	this.renderSession.context = context;
	this.renderSession.renderer = this;
	this.renderSession.blendModeManager = new openfl__internal_renderer_canvas_CanvasBlendModeManager(this.renderSession);
	this.renderSession.maskManager = new openfl__internal_renderer_canvas_CanvasMaskManager(this.renderSession);
	var config = stage.window.config;
	if(config != null && Object.prototype.hasOwnProperty.call(config,"allowHighDPI") && config.allowHighDPI) {
		CanvasRenderer.scale = window.devicePixelRatio || 1;
	}
};
CanvasRenderer.__super__ = openfl__internal_renderer_AbstractRenderer;
CanvasRenderer.prototype = $extend(openfl__internal_renderer_AbstractRenderer.prototype, {
  render: function() {
		this.renderSession.allowSmoothing = this.stage.quality != 2;
		this.stage.__renderCanvas(this.renderSession);
	},
  clear: function() {
		this.renderSession.blendModeManager.setBlendMode(10);
		this.context.setTransform(1,0,0,1,0,0);
		this.context.globalAlpha = 1;
		if(!this.stage.__transparent && this.stage.__clearBeforeRender) {
			this.context.fillStyle = this.stage.__colorString;
			this.context.fillRect(0,0,this.stage.stageWidth * this.stage.window.__scale,this.stage.stageHeight * this.stage.window.__scale);
		} else if(this.stage.__transparent && this.stage.__clearBeforeRender) {
			this.context.clearRect(0,0,this.stage.stageWidth * this.stage.window.__scale,this.stage.stageHeight * this.stage.window.__scale);
		}
	},
  renderStage3D: function() {
		var _g = 0;
		var _g1 = this.stage.stage3Ds;
		while(_g < _g1.data.get_length()) {
			var stage3D = _g1.data.get(_g);
			++_g;
			stage3D.__renderCanvas(this.stage,this.renderSession);
		}
	},
  context: null,
 __class__: CanvasRenderer
});
CanvasRenderer.__name__ = "openfl._internal.renderer.canvas.CanvasRenderer";
CanvasRenderer.scale = 1;


return CanvasRenderer;
}());
exports.default = exports.CanvasRenderer = CanvasRenderer;
