// Package: openfl._internal.renderer.canvas.CanvasVideo


// Class: openfl._internal.renderer.canvas.CanvasVideo

var CanvasVideo = (function () {
var CanvasVideo = function() {};
CanvasVideo.prototype = {
 __class__: CanvasVideo
};
CanvasVideo.__name__ = "openfl._internal.renderer.canvas.CanvasVideo";
CanvasVideo.render = function(video,renderSession) {
	if(!video.__renderable || video.__worldAlpha <= 0 || video.__stream == null) {
		return;
	}
	var context = renderSession.context;
	if(video.__stream.__video != null) {
		renderSession.blendModeManager.setBlendMode(video.__worldBlendMode);
		renderSession.maskManager.pushObject(video);
		context.globalAlpha = video.__worldAlpha;
		var transform = video.__worldTransform;
		var scrollRect = video.__scrollRect;
		var smoothing = video.smoothing;
		if(renderSession.roundPixels) {
			context.setTransform(transform.a,transform.b,transform.c,transform.d,transform.tx | 0,transform.ty | 0);
		} else {
			context.setTransform(transform.a,transform.b,transform.c,transform.d,transform.tx,transform.ty);
		}
		if(!smoothing) {
			context.mozImageSmoothingEnabled = false;
			context.msImageSmoothingEnabled = false;
			context.imageSmoothingEnabled = false;
		}
		if(scrollRect == null) {
			context.drawImage(video.__stream.__video,0,0,video.get_width(),video.get_height());
		} else {
			context.drawImage(video.__stream.__video,scrollRect.x,scrollRect.y,scrollRect.width,scrollRect.height,scrollRect.x,scrollRect.y,scrollRect.width,scrollRect.height);
		}
		if(!smoothing) {
			context.mozImageSmoothingEnabled = true;
			context.msImageSmoothingEnabled = true;
			context.imageSmoothingEnabled = true;
		}
		renderSession.maskManager.popObject(video);
	}
};


return CanvasVideo;
}());
exports.default = exports.CanvasVideo = CanvasVideo;
