// Package: openfl._internal.renderer.dom.DOMBitmap
var openfl__internal_renderer_dom_DOMRenderer = require("../../../../openfl/_internal/renderer/dom/DOMRenderer").DOMRenderer;
var lime_graphics_utils_ImageCanvasUtil = require("../../../../lime/graphics/utils/ImageCanvasUtil").ImageCanvasUtil;


// Class: openfl._internal.renderer.dom.DOMBitmap

var DOMBitmap = (function () {
var DOMBitmap = function() {};
DOMBitmap.prototype = {
 __class__: DOMBitmap
};
DOMBitmap.__name__ = "openfl._internal.renderer.dom.DOMBitmap";
DOMBitmap.render = function(bitmap,renderSession) {
	if(bitmap.stage != null && bitmap.__worldVisible && bitmap.__renderable && bitmap.bitmapData != null && bitmap.bitmapData.__isValid && bitmap.bitmapData.readable) {
		renderSession.maskManager.pushObject(bitmap);
		if(bitmap.bitmapData.image.buffer.__srcImage != null) {
			DOMBitmap.renderImage(bitmap,renderSession);
		} else {
			DOMBitmap.renderCanvas(bitmap,renderSession);
		}
		renderSession.maskManager.popObject(bitmap);
	} else {
		DOMBitmap.clear(bitmap,renderSession);
	}
};
DOMBitmap.clear = function(bitmap,renderSession) {
	if(bitmap.__image != null) {
		renderSession.element.removeChild(bitmap.__image);
		bitmap.__image = null;
		bitmap.__style = null;
	}
	if(bitmap.__canvas != null) {
		renderSession.element.removeChild(bitmap.__canvas);
		bitmap.__canvas = null;
		bitmap.__style = null;
	}
};
DOMBitmap.renderCanvas = function(bitmap,renderSession) {
	if(bitmap.__image != null) {
		renderSession.element.removeChild(bitmap.__image);
		bitmap.__image = null;
	}
	if(bitmap.__canvas == null) {
		bitmap.__canvas = window.document.createElement("canvas");
		bitmap.__context = bitmap.__canvas.getContext("2d");
		bitmap.__imageVersion = -1;
		if(!renderSession.allowSmoothing || !bitmap.smoothing) {
			bitmap.__context.mozImageSmoothingEnabled = false;
			bitmap.__context.msImageSmoothingEnabled = false;
			bitmap.__context.imageSmoothingEnabled = false;
		}
		openfl__internal_renderer_dom_DOMRenderer.initializeElement(bitmap,bitmap.__canvas,renderSession);
	}
	if(bitmap.__imageVersion != bitmap.bitmapData.image.version) {
		lime_graphics_utils_ImageCanvasUtil.convertToCanvas(bitmap.bitmapData.image);
		bitmap.__canvas.width = bitmap.bitmapData.width + 1;
		bitmap.__canvas.width = bitmap.bitmapData.width;
		bitmap.__canvas.height = bitmap.bitmapData.height;
		bitmap.__context.drawImage(bitmap.bitmapData.image.buffer.__srcCanvas,0,0);
		bitmap.__imageVersion = bitmap.bitmapData.image.version;
	}
	openfl__internal_renderer_dom_DOMRenderer.updateClip(bitmap,renderSession);
	openfl__internal_renderer_dom_DOMRenderer.applyStyle(bitmap,renderSession,true,true,true);
};
DOMBitmap.renderImage = function(bitmap,renderSession) {
	if(bitmap.__canvas != null) {
		renderSession.element.removeChild(bitmap.__canvas);
		bitmap.__canvas = null;
	}
	if(bitmap.__image == null) {
		bitmap.__image = window.document.createElement("img");
		bitmap.__image.crossOrigin = "Anonymous";
		bitmap.__image.src = bitmap.bitmapData.image.buffer.__srcImage.src;
		openfl__internal_renderer_dom_DOMRenderer.initializeElement(bitmap,bitmap.__image,renderSession);
	}
	openfl__internal_renderer_dom_DOMRenderer.updateClip(bitmap,renderSession);
	openfl__internal_renderer_dom_DOMRenderer.applyStyle(bitmap,renderSession,true,true,true);
};


return DOMBitmap;
}());
exports.default = exports.DOMBitmap = DOMBitmap;
