// Package: openfl._internal.renderer.dom.DOMTilemap
var openfl__internal_renderer_dom_DOMRenderer = require("../../../../openfl/_internal/renderer/dom/DOMRenderer").DOMRenderer;
var lime_graphics_utils_ImageCanvasUtil = require("../../../../lime/graphics/utils/ImageCanvasUtil").ImageCanvasUtil;
var openfl_geom_Rectangle = require("../../../../openfl/geom/Rectangle").Rectangle;


// Class: openfl._internal.renderer.dom.DOMTilemap

var DOMTilemap = (function () {
var DOMTilemap = function() {};
DOMTilemap.prototype = {
 __class__: DOMTilemap
};
DOMTilemap.__name__ = "openfl._internal.renderer.dom.DOMTilemap";
DOMTilemap.render = function(tilemap,renderSession) {
	if(tilemap.stage != null && tilemap.__worldVisible && tilemap.__renderable && tilemap.__tiles.data.get_length() > 0) {
		if(tilemap.__canvas == null) {
			tilemap.__canvas = window.document.createElement("canvas");
			tilemap.__context = tilemap.__canvas.getContext("2d");
			openfl__internal_renderer_dom_DOMRenderer.initializeElement(tilemap,tilemap.__canvas,renderSession);
		}
		tilemap.__canvas.width = tilemap.__width;
		tilemap.__canvas.height = tilemap.__height;
		tilemap.__context.globalAlpha = tilemap.__worldAlpha;
		renderSession.context = tilemap.__context;
		if(!(!tilemap.__renderable || tilemap.__worldAlpha <= 0)) {
			tilemap.__updateTileArray();
			if(!(tilemap.__tileArray == null || tilemap.__tileArray.__length == 0)) {
				var context = renderSession.context;
				renderSession.blendModeManager.setBlendMode(tilemap.__worldBlendMode);
				renderSession.maskManager.pushObject(tilemap);
				var rect = openfl_geom_Rectangle.__pool.get();
				rect.setTo(0,0,tilemap.__width,tilemap.__height);
				renderSession.maskManager.pushRect(rect,tilemap.__renderTransform);
				var transform = tilemap.__renderTransform;
				var roundPixels = renderSession.roundPixels;
				if(!renderSession.allowSmoothing || !tilemap.smoothing) {
					context.mozImageSmoothingEnabled = false;
					context.msImageSmoothingEnabled = false;
					context.imageSmoothingEnabled = false;
				}
				var defaultTileset = tilemap.tileset;
				var cacheBitmapData = null;
				var source = null;
				var alpha;
				var visible;
				var tileset;
				var id;
				var tileData;
				var bitmapData;
				var tileArray = tilemap.__tileArray;
				var tileTransform;
				var tileRect = openfl_geom_Rectangle.__pool.get();
				var tile = tileArray.iterator();
				while(tile.hasNext()) {
					var tile1 = tile.next();
					alpha = tile1.get_alpha();
					visible = tile1.get_visible();
					if(!visible || alpha <= 0) {
						continue;
					}
					tileset = tile1.get_tileset();
					if(tileset == null) {
						tileset = defaultTileset;
					}
					if(tileset == null) {
						continue;
					}
					id = tile1.get_id();
					if(id == -1) {
						tileRect.copyFrom(tile1.get_rect());
						if(tileRect.width <= 0 || tileRect.height <= 0) {
							continue;
						}
					} else {
						tileData = tileset.__data[id];
						if(tileData == null) {
							continue;
						}
						tileRect.setTo(tileData.x,tileData.y,tileData.width,tileData.height);
					}
					bitmapData = tileset.bitmapData;
					if(bitmapData == null || !bitmapData.readable) {
						continue;
					}
					if(bitmapData != cacheBitmapData) {
						if(bitmapData.image.buffer.__srcImage == null) {
							lime_graphics_utils_ImageCanvasUtil.convertToCanvas(bitmapData.image);
						}
						source = bitmapData.image.get_src();
						cacheBitmapData = bitmapData;
					}
					context.globalAlpha = tilemap.__worldAlpha * alpha;
					tileTransform = tile1.get_matrix();
					tileTransform.concat(transform);
					if(roundPixels) {
						context.setTransform(tileTransform.a,tileTransform.b,tileTransform.c,tileTransform.d,tileTransform.tx | 0,tileTransform.ty | 0);
					} else {
						context.setTransform(tileTransform.a,tileTransform.b,tileTransform.c,tileTransform.d,tileTransform.tx,tileTransform.ty);
					}
					context.drawImage(source,tileRect.x,tileRect.y,tileRect.width,tileRect.height,0,0,tileRect.width,tileRect.height);
				}
				if(!renderSession.allowSmoothing || !tilemap.smoothing) {
					context.mozImageSmoothingEnabled = true;
					context.msImageSmoothingEnabled = true;
					context.imageSmoothingEnabled = true;
				}
				renderSession.maskManager.popRect();
				renderSession.maskManager.popObject(tilemap);
				openfl_geom_Rectangle.__pool.release(rect);
				openfl_geom_Rectangle.__pool.release(tileRect);
			}
		}
		renderSession.context = null;
		openfl__internal_renderer_dom_DOMRenderer.updateClip(tilemap,renderSession);
		openfl__internal_renderer_dom_DOMRenderer.applyStyle(tilemap,renderSession,true,false,true);
	} else {
		DOMTilemap.clear(tilemap,renderSession);
	}
};
DOMTilemap.clear = function(tilemap,renderSession) {
	if(tilemap.__canvas != null) {
		renderSession.element.removeChild(tilemap.__canvas);
		tilemap.__canvas = null;
		tilemap.__style = null;
	}
};


return DOMTilemap;
}());
exports.default = exports.DOMTilemap = DOMTilemap;
