// Package: openfl._internal.renderer.opengl.GLBitmap
var lime_utils__DataPointer_DataPointer_Impl_ = require("../../../../lime/utils/_DataPointer/DataPointer_Impl_").DataPointer_Impl_;
var openfl__internal_renderer_opengl_GLMaskManager = require("../../../../openfl/_internal/renderer/opengl/GLMaskManager").GLMaskManager;


// Class: openfl._internal.renderer.opengl.GLBitmap

var GLBitmap = (function () {
var GLBitmap = function() {};
GLBitmap.prototype = {
 __class__: GLBitmap
};
GLBitmap.__name__ = "openfl._internal.renderer.opengl.GLBitmap";
GLBitmap.render = function(bitmap,renderSession) {
	if(!bitmap.__renderable || bitmap.__worldAlpha <= 0) {
		return;
	}
	if(bitmap.bitmapData != null && bitmap.bitmapData.__isValid) {
		var renderer = renderSession.renderer;
		var gl = renderSession.gl;
		renderSession.blendModeManager.setBlendMode(bitmap.__worldBlendMode);
		renderSession.maskManager.pushObject(bitmap);
		renderSession.filterManager.pushObject(bitmap);
		var shader = renderSession.shaderManager.initShader(bitmap.shader);
		renderSession.shaderManager.setShader(shader);
		shader.get_data().uImage0.input = bitmap.bitmapData;
		var tmp = renderSession.allowSmoothing && (bitmap.smoothing || renderSession.upscaled);
		shader.get_data().uImage0.smoothing = tmp;
		shader.get_data().uMatrix.value = renderer.getMatrix(bitmap.__renderTransform);
		var useColorTransform = !bitmap.__worldColorTransform.__isDefault();
		if(shader.get_data().uColorTransform.value == null) {
			shader.get_data().uColorTransform.value = [];
		}
		shader.get_data().uColorTransform.value[0] = useColorTransform;
		renderSession.shaderManager.updateShader(shader);
		var target = gl.ARRAY_BUFFER;
		var buffer = bitmap.bitmapData.getBuffer(gl,bitmap.__worldAlpha,bitmap.__worldColorTransform);
		gl.__context.bindBuffer(target,buffer);
		var index = shader.get_data().aPosition.index;
		var type = gl.FLOAT;
		var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(0);
		gl.__context.vertexAttribPointer(index,3,type,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
		var index1 = shader.get_data().aTexCoord.index;
		var type1 = gl.FLOAT;
		var offset1 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(12);
		gl.__context.vertexAttribPointer(index1,2,type1,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset1));
		var index2 = shader.get_data().aAlpha.index;
		var type2 = gl.FLOAT;
		var offset2 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(20);
		gl.__context.vertexAttribPointer(index2,1,type2,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset2));
		var index3 = shader.get_data().aColorMultipliers.index;
		var type3 = gl.FLOAT;
		var offset3 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(24);
		gl.__context.vertexAttribPointer(index3,4,type3,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset3));
		var index4 = shader.get_data().aColorMultipliers.index + 1;
		var type4 = gl.FLOAT;
		var offset4 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(40);
		gl.__context.vertexAttribPointer(index4,4,type4,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset4));
		var index5 = shader.get_data().aColorMultipliers.index + 2;
		var type5 = gl.FLOAT;
		var offset5 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(56);
		gl.__context.vertexAttribPointer(index5,4,type5,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset5));
		var index6 = shader.get_data().aColorMultipliers.index + 3;
		var type6 = gl.FLOAT;
		var offset6 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(72);
		gl.__context.vertexAttribPointer(index6,4,type6,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset6));
		var index7 = shader.get_data().aColorOffsets.index;
		var type7 = gl.FLOAT;
		var offset7 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(88);
		gl.__context.vertexAttribPointer(index7,4,type7,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset7));
		gl.__context.drawArrays(gl.TRIANGLE_STRIP,0,4);
		renderSession.filterManager.popObject(bitmap);
		renderSession.maskManager.popObject(bitmap);
	}
};
GLBitmap.renderMask = function(bitmap,renderSession) {
	if(bitmap.bitmapData != null && bitmap.bitmapData.__isValid) {
		var renderer = renderSession.renderer;
		var gl = renderSession.gl;
		var shader = openfl__internal_renderer_opengl_GLMaskManager.maskShader;
		renderSession.shaderManager.setShader(shader);
		shader.get_data().uImage0.input = bitmap.bitmapData;
		var tmp = renderSession.allowSmoothing && (bitmap.smoothing || renderSession.upscaled);
		shader.get_data().uImage0.smoothing = tmp;
		shader.get_data().uMatrix.value = renderer.getMatrix(bitmap.__renderTransform);
		renderSession.shaderManager.updateShader(shader);
		var target = gl.ARRAY_BUFFER;
		var buffer = bitmap.bitmapData.getBuffer(gl,bitmap.__worldAlpha,bitmap.__worldColorTransform);
		gl.__context.bindBuffer(target,buffer);
		var index = shader.get_data().aPosition.index;
		var type = gl.FLOAT;
		var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(0);
		gl.__context.vertexAttribPointer(index,3,type,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
		var index1 = shader.get_data().aTexCoord.index;
		var type1 = gl.FLOAT;
		var offset1 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(12);
		gl.__context.vertexAttribPointer(index1,2,type1,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset1));
		gl.__context.drawArrays(gl.TRIANGLE_STRIP,0,4);
	}
};


return GLBitmap;
}());
exports.default = exports.GLBitmap = GLBitmap;
