// Package: openfl._internal.renderer.opengl.GLDisplayObject
var openfl__internal_renderer_canvas_CanvasGraphics = require("../../../../openfl/_internal/renderer/canvas/CanvasGraphics").CanvasGraphics;
var openfl_geom_Rectangle = require("../../../../openfl/geom/Rectangle").Rectangle;
var lime_utils__DataPointer_DataPointer_Impl_ = require("../../../../lime/utils/_DataPointer/DataPointer_Impl_").DataPointer_Impl_;
var openfl__internal_renderer_opengl_GLMaskManager = require("../../../../openfl/_internal/renderer/opengl/GLMaskManager").GLMaskManager;


// Class: openfl._internal.renderer.opengl.GLDisplayObject

var GLDisplayObject = (function () {
var GLDisplayObject = function() {};
GLDisplayObject.prototype = {
 __class__: GLDisplayObject
};
GLDisplayObject.__name__ = "openfl._internal.renderer.opengl.GLDisplayObject";
GLDisplayObject.render = function(displayObject,renderSession) {
	if(displayObject.opaqueBackground == null && displayObject.__graphics == null) {
		return;
	}
	if(!displayObject.__renderable || displayObject.__worldAlpha <= 0) {
		return;
	}
	if(displayObject.opaqueBackground != null && !displayObject.__cacheBitmapRender && displayObject.get_width() > 0 && displayObject.get_height() > 0) {
		renderSession.blendModeManager.setBlendMode(displayObject.__worldBlendMode);
		renderSession.maskManager.pushObject(displayObject);
		var gl = renderSession.gl;
		var rect = openfl_geom_Rectangle.__pool.get();
		rect.setTo(0,0,displayObject.get_width(),displayObject.get_height());
		renderSession.maskManager.pushRect(rect,displayObject.__renderTransform);
		var color = displayObject.opaqueBackground;
		gl.__context.clearColor((color >>> 16 & 255) / 255,(color >>> 8 & 255) / 255,(color & 255) / 255,1);
		gl.__context.clear(gl.COLOR_BUFFER_BIT);
		renderSession.maskManager.popRect();
		renderSession.maskManager.popObject(displayObject);
		openfl_geom_Rectangle.__pool.release(rect);
	}
	if(displayObject.__graphics != null) {
		if(!(!displayObject.__renderable || displayObject.__worldAlpha <= 0)) {
			var graphics = displayObject.__graphics;
			if(graphics != null) {
				openfl__internal_renderer_canvas_CanvasGraphics.render(graphics,renderSession,displayObject.__renderTransform);
				var bounds = graphics.__bounds;
				if(graphics.__bitmap != null && graphics.__visible) {
					var renderer = renderSession.renderer;
					var gl1 = renderSession.gl;
					renderSession.blendModeManager.setBlendMode(displayObject.__worldBlendMode);
					renderSession.maskManager.pushObject(displayObject);
					var shader = renderSession.filterManager.pushObject(displayObject);
					renderSession.shaderManager.setShader(shader);
					shader.get_data().uImage0.input = graphics.__bitmap;
					shader.get_data().uImage0.smoothing = renderSession.allowSmoothing;
					shader.get_data().uMatrix.value = renderer.getMatrix(graphics.__worldTransform);
					var useColorTransform = !displayObject.__worldColorTransform.__isDefault();
					if(shader.get_data().uColorTransform.value == null) {
						shader.get_data().uColorTransform.value = [];
					}
					shader.get_data().uColorTransform.value[0] = useColorTransform;
					renderSession.shaderManager.updateShader(shader);
					var target = gl1.ARRAY_BUFFER;
					var buffer = graphics.__bitmap.getBuffer(gl1,displayObject.__worldAlpha,displayObject.__worldColorTransform);
					gl1.__context.bindBuffer(target,buffer);
					var index = shader.get_data().aPosition.index;
					var type = gl1.FLOAT;
					var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(0);
					gl1.__context.vertexAttribPointer(index,3,type,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
					var index1 = shader.get_data().aTexCoord.index;
					var type1 = gl1.FLOAT;
					var offset1 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(12);
					gl1.__context.vertexAttribPointer(index1,2,type1,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset1));
					var index2 = shader.get_data().aAlpha.index;
					var type2 = gl1.FLOAT;
					var offset2 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(20);
					gl1.__context.vertexAttribPointer(index2,1,type2,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset2));
					var index3 = shader.get_data().aColorMultipliers.index;
					var type3 = gl1.FLOAT;
					var offset3 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(24);
					gl1.__context.vertexAttribPointer(index3,4,type3,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset3));
					var index4 = shader.get_data().aColorMultipliers.index + 1;
					var type4 = gl1.FLOAT;
					var offset4 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(40);
					gl1.__context.vertexAttribPointer(index4,4,type4,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset4));
					var index5 = shader.get_data().aColorMultipliers.index + 2;
					var type5 = gl1.FLOAT;
					var offset5 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(56);
					gl1.__context.vertexAttribPointer(index5,4,type5,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset5));
					var index6 = shader.get_data().aColorMultipliers.index + 3;
					var type6 = gl1.FLOAT;
					var offset6 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(72);
					gl1.__context.vertexAttribPointer(index6,4,type6,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset6));
					var index7 = shader.get_data().aColorOffsets.index;
					var type7 = gl1.FLOAT;
					var offset7 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(88);
					gl1.__context.vertexAttribPointer(index7,4,type7,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset7));
					gl1.__context.drawArrays(gl1.TRIANGLE_STRIP,0,4);
					renderSession.filterManager.popObject(displayObject);
					renderSession.maskManager.popObject(displayObject);
				}
			}
		}
	}
};
GLDisplayObject.renderMask = function(displayObject,renderSession) {
	if(displayObject.opaqueBackground == null && displayObject.__graphics == null) {
		return;
	}
	if(displayObject.opaqueBackground != null && !displayObject.__cacheBitmapRender && displayObject.get_width() > 0 && displayObject.get_height() > 0) {
		var gl = renderSession.gl;
	}
	if(displayObject.__graphics != null) {
		var graphics = displayObject.__graphics;
		if(graphics != null) {
			openfl__internal_renderer_canvas_CanvasGraphics.render(graphics,renderSession,displayObject.__renderTransform);
			var bounds = graphics.__bounds;
			if(graphics.__bitmap != null) {
				var renderer = renderSession.renderer;
				var gl1 = renderSession.gl;
				var shader = openfl__internal_renderer_opengl_GLMaskManager.maskShader;
				renderSession.shaderManager.setShader(shader);
				shader.get_data().uImage0.input = graphics.__bitmap;
				shader.get_data().uImage0.smoothing = renderSession.allowSmoothing;
				shader.get_data().uMatrix.value = renderer.getMatrix(graphics.__worldTransform);
				renderSession.shaderManager.updateShader(shader);
				var target = gl1.ARRAY_BUFFER;
				var buffer = graphics.__bitmap.getBuffer(gl1,displayObject.__worldAlpha,displayObject.__worldColorTransform);
				gl1.__context.bindBuffer(target,buffer);
				var index = shader.get_data().aPosition.index;
				var type = gl1.FLOAT;
				var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(0);
				gl1.__context.vertexAttribPointer(index,3,type,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
				var index1 = shader.get_data().aTexCoord.index;
				var type1 = gl1.FLOAT;
				var offset1 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(12);
				gl1.__context.vertexAttribPointer(index1,2,type1,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset1));
				gl1.__context.drawArrays(gl1.TRIANGLE_STRIP,0,4);
			}
		}
	}
};


return GLDisplayObject;
}());
exports.default = exports.GLDisplayObject = GLDisplayObject;
