// Package: openfl._internal.renderer.opengl.GLShaderManager
var openfl__internal_renderer_AbstractShaderManager = require("../../../../openfl/_internal/renderer/AbstractShaderManager").AbstractShaderManager;
var $extend = require("../../../../extend_stub").extend_stub;
var openfl_display_Shader = require("../../../../openfl/display/Shader").Shader;


// Class: openfl._internal.renderer.opengl.GLShaderManager

var GLShaderManager = (function () {
var GLShaderManager = function(gl) {
	openfl__internal_renderer_AbstractShaderManager.call(this);
	this.gl = gl;
	this.defaultShader = new openfl_display_Shader();
	this.initShader(this.defaultShader);
};
GLShaderManager.__super__ = openfl__internal_renderer_AbstractShaderManager;
GLShaderManager.prototype = $extend(openfl__internal_renderer_AbstractShaderManager.prototype, {
  gl: null,
  initShader: function(shader) {
		if(shader != null) {
			if(shader.gl == null) {
				shader.gl = this.gl;
				shader.__init();
			}
			return shader;
		}
		return this.defaultShader;
	},
  updateShader: function(shader) {
		if(this.currentShader != null) {
			this.currentShader.__update();
		}
	},
  setShader: function(shader) {
		if(this.currentShader == shader) {
			return;
		}
		if(this.currentShader != null) {
			this.currentShader.__disable();
		}
		if(shader == null) {
			this.currentShader = null;
			this.gl.__context.useProgram(null);
			return;
		} else {
			this.currentShader = shader;
			this.initShader(shader);
			this.gl.__context.useProgram(shader.glProgram);
			this.currentShader.__enable();
		}
	},
 __class__: GLShaderManager
});
GLShaderManager.__name__ = "openfl._internal.renderer.opengl.GLShaderManager";


return GLShaderManager;
}());
exports.default = exports.GLShaderManager = GLShaderManager;
