// Package: openfl._internal.renderer.opengl.GLShape
var openfl__internal_renderer_canvas_CanvasGraphics = require("../../../../openfl/_internal/renderer/canvas/CanvasGraphics").CanvasGraphics;
var lime_utils__DataPointer_DataPointer_Impl_ = require("../../../../lime/utils/_DataPointer/DataPointer_Impl_").DataPointer_Impl_;
var openfl__internal_renderer_opengl_GLMaskManager = require("../../../../openfl/_internal/renderer/opengl/GLMaskManager").GLMaskManager;


// Class: openfl._internal.renderer.opengl.GLShape

var GLShape = (function () {
var GLShape = function() {};
GLShape.prototype = {
 __class__: GLShape
};
GLShape.__name__ = "openfl._internal.renderer.opengl.GLShape";
GLShape.render = function(shape,renderSession) {
	if(!shape.__renderable || shape.__worldAlpha <= 0) {
		return;
	}
	var graphics = shape.__graphics;
	if(graphics != null) {
		openfl__internal_renderer_canvas_CanvasGraphics.render(graphics,renderSession,shape.__renderTransform);
		var bounds = graphics.__bounds;
		if(graphics.__bitmap != null && graphics.__visible) {
			var renderer = renderSession.renderer;
			var gl = renderSession.gl;
			renderSession.blendModeManager.setBlendMode(shape.__worldBlendMode);
			renderSession.maskManager.pushObject(shape);
			var shader = renderSession.filterManager.pushObject(shape);
			renderSession.shaderManager.setShader(shader);
			shader.get_data().uImage0.input = graphics.__bitmap;
			shader.get_data().uImage0.smoothing = renderSession.allowSmoothing;
			shader.get_data().uMatrix.value = renderer.getMatrix(graphics.__worldTransform);
			var useColorTransform = !shape.__worldColorTransform.__isDefault();
			if(shader.get_data().uColorTransform.value == null) {
				shader.get_data().uColorTransform.value = [];
			}
			shader.get_data().uColorTransform.value[0] = useColorTransform;
			renderSession.shaderManager.updateShader(shader);
			var target = gl.ARRAY_BUFFER;
			var buffer = graphics.__bitmap.getBuffer(gl,shape.__worldAlpha,shape.__worldColorTransform);
			gl.__context.bindBuffer(target,buffer);
			var index = shader.get_data().aPosition.index;
			var type = gl.FLOAT;
			var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(0);
			gl.__context.vertexAttribPointer(index,3,type,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
			var index1 = shader.get_data().aTexCoord.index;
			var type1 = gl.FLOAT;
			var offset1 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(12);
			gl.__context.vertexAttribPointer(index1,2,type1,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset1));
			var index2 = shader.get_data().aAlpha.index;
			var type2 = gl.FLOAT;
			var offset2 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(20);
			gl.__context.vertexAttribPointer(index2,1,type2,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset2));
			var index3 = shader.get_data().aColorMultipliers.index;
			var type3 = gl.FLOAT;
			var offset3 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(24);
			gl.__context.vertexAttribPointer(index3,4,type3,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset3));
			var index4 = shader.get_data().aColorMultipliers.index + 1;
			var type4 = gl.FLOAT;
			var offset4 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(40);
			gl.__context.vertexAttribPointer(index4,4,type4,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset4));
			var index5 = shader.get_data().aColorMultipliers.index + 2;
			var type5 = gl.FLOAT;
			var offset5 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(56);
			gl.__context.vertexAttribPointer(index5,4,type5,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset5));
			var index6 = shader.get_data().aColorMultipliers.index + 3;
			var type6 = gl.FLOAT;
			var offset6 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(72);
			gl.__context.vertexAttribPointer(index6,4,type6,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset6));
			var index7 = shader.get_data().aColorOffsets.index;
			var type7 = gl.FLOAT;
			var offset7 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(88);
			gl.__context.vertexAttribPointer(index7,4,type7,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset7));
			gl.__context.drawArrays(gl.TRIANGLE_STRIP,0,4);
			renderSession.filterManager.popObject(shape);
			renderSession.maskManager.popObject(shape);
		}
	}
};
GLShape.renderMask = function(shape,renderSession) {
	var graphics = shape.__graphics;
	if(graphics != null) {
		openfl__internal_renderer_canvas_CanvasGraphics.render(graphics,renderSession,shape.__renderTransform);
		var bounds = graphics.__bounds;
		if(graphics.__bitmap != null) {
			var renderer = renderSession.renderer;
			var gl = renderSession.gl;
			var shader = openfl__internal_renderer_opengl_GLMaskManager.maskShader;
			renderSession.shaderManager.setShader(shader);
			shader.get_data().uImage0.input = graphics.__bitmap;
			shader.get_data().uImage0.smoothing = renderSession.allowSmoothing;
			shader.get_data().uMatrix.value = renderer.getMatrix(graphics.__worldTransform);
			renderSession.shaderManager.updateShader(shader);
			var target = gl.ARRAY_BUFFER;
			var buffer = graphics.__bitmap.getBuffer(gl,shape.__worldAlpha,shape.__worldColorTransform);
			gl.__context.bindBuffer(target,buffer);
			var index = shader.get_data().aPosition.index;
			var type = gl.FLOAT;
			var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(0);
			gl.__context.vertexAttribPointer(index,3,type,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
			var index1 = shader.get_data().aTexCoord.index;
			var type1 = gl.FLOAT;
			var offset1 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(12);
			gl.__context.vertexAttribPointer(index1,2,type1,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset1));
			gl.__context.drawArrays(gl.TRIANGLE_STRIP,0,4);
		}
	}
};


return GLShape;
}());
exports.default = exports.GLShape = GLShape;
