// Package: openfl._internal.renderer.opengl.GLTilemap
var openfl_geom_Rectangle = require("../../../../openfl/geom/Rectangle").Rectangle;
var lime_utils__DataPointer_DataPointer_Impl_ = require("../../../../lime/utils/_DataPointer/DataPointer_Impl_").DataPointer_Impl_;
var haxe_ds_IntMap = require("../../../../haxe/ds/IntMap").IntMap;
var openfl__internal_renderer_opengl_GLMaskManager = require("../../../../openfl/_internal/renderer/opengl/GLMaskManager").GLMaskManager;


// Class: openfl._internal.renderer.opengl.GLTilemap

var GLTilemap = (function () {
var GLTilemap = function() {};
GLTilemap.prototype = {
 __class__: GLTilemap
};
GLTilemap.__name__ = "openfl._internal.renderer.opengl.GLTilemap";
GLTilemap.render = function(tilemap,renderSession) {
	if(!tilemap.__renderable || tilemap.__worldAlpha <= 0) {
		return;
	}
	tilemap.__updateTileArray();
	if(tilemap.__tileArray == null || tilemap.__tileArray.__length == 0) {
		return;
	}
	var renderer = renderSession.renderer;
	var gl = renderSession.gl;
	renderSession.blendModeManager.setBlendMode(tilemap.__worldBlendMode);
	renderSession.maskManager.pushObject(tilemap);
	renderSession.filterManager.pushObject(tilemap);
	var shader = renderSession.shaderManager.initShader(tilemap.shader);
	var uMatrix = renderer.getMatrix(tilemap.__renderTransform);
	var smoothing = renderSession.allowSmoothing && tilemap.smoothing;
	var useColorTransform = true;
	var rect = openfl_geom_Rectangle.__pool.get();
	rect.setTo(0,0,tilemap.__width,tilemap.__height);
	renderSession.maskManager.pushRect(rect,tilemap.__renderTransform);
	var tileArray = tilemap.__tileArray;
	var defaultShader = shader;
	var defaultTileset = tilemap.tileset;
	tileArray.__updateGLBuffer(gl,defaultTileset,tilemap.__worldAlpha,tilemap.__worldColorTransform);
	var index = shader.get_data().aPosition.index;
	var type = gl.FLOAT;
	var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(0);
	gl.__context.vertexAttribPointer(index,2,type,false,100,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
	var index1 = shader.get_data().aTexCoord.index;
	var type1 = gl.FLOAT;
	var offset1 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(8);
	gl.__context.vertexAttribPointer(index1,2,type1,false,100,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset1));
	var index2 = shader.get_data().aAlpha.index;
	var type2 = gl.FLOAT;
	var offset2 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(16);
	gl.__context.vertexAttribPointer(index2,1,type2,false,100,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset2));
	var index3 = shader.get_data().aColorMultipliers.index;
	var type3 = gl.FLOAT;
	var offset3 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(20);
	gl.__context.vertexAttribPointer(index3,4,type3,false,100,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset3));
	var index4 = shader.get_data().aColorMultipliers.index + 1;
	var type4 = gl.FLOAT;
	var offset4 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(36);
	gl.__context.vertexAttribPointer(index4,4,type4,false,100,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset4));
	var index5 = shader.get_data().aColorMultipliers.index + 2;
	var type5 = gl.FLOAT;
	var offset5 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(52);
	gl.__context.vertexAttribPointer(index5,4,type5,false,100,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset5));
	var index6 = shader.get_data().aColorMultipliers.index + 3;
	var type6 = gl.FLOAT;
	var offset6 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(68);
	gl.__context.vertexAttribPointer(index6,4,type6,false,100,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset6));
	var index7 = shader.get_data().aColorOffsets.index;
	var type7 = gl.FLOAT;
	var offset7 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(84);
	gl.__context.vertexAttribPointer(index7,4,type7,false,100,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset7));
	var cacheShader = null;
	var cacheBitmapData = null;
	var lastIndex = 0;
	var skipped = tileArray.__bufferSkipped;
	var drawCount = tileArray.__length;
	tileArray.position = 0;
	var shader1 = null;
	var tileset;
	var flush = false;
	var _g1 = 0;
	var _g = drawCount + 1;
	while(_g1 < _g) {
		var i = _g1++;
		if(skipped.data.get(i)) {
			continue;
		}
		tileArray.position = i < drawCount ? i : drawCount - 1;
		shader1 = tileArray.__shaders.data.get(tileArray.position);
		if(shader1 == null) {
			shader1 = defaultShader;
		}
		if(shader1 != cacheShader && cacheShader != null) {
			flush = true;
		}
		tileset = tileArray.__tilesets.data.get(tileArray.position);
		if(tileset == null) {
			tileset = defaultTileset;
		}
		if(tileset == null) {
			continue;
		}
		if(tileset.bitmapData != cacheBitmapData && cacheBitmapData != null) {
			flush = true;
		}
		if(flush) {
			cacheShader.get_data().uImage0.input = cacheBitmapData;
			renderSession.shaderManager.updateShader(cacheShader);
			gl.__context.drawArrays(gl.TRIANGLES,lastIndex * 6,(i - lastIndex) * 6);
			flush = false;
			lastIndex = i;
		}
		if(shader1 != cacheShader) {
			renderSession.shaderManager.setShader(shader1);
			shader1.get_data().uMatrix.value = uMatrix;
			shader1.get_data().uImage0.smoothing = smoothing;
			if(shader1.get_data().uColorTransform.value == null) {
				shader1.get_data().uColorTransform.value = [];
			}
			shader1.get_data().uColorTransform.value[0] = useColorTransform;
			cacheShader = shader1;
		}
		cacheBitmapData = tileset.bitmapData;
		if(i == drawCount && tileset.bitmapData != null) {
			shader1.get_data().uImage0.input = tileset.bitmapData;
			renderSession.shaderManager.updateShader(shader1);
			gl.__context.drawArrays(gl.TRIANGLES,lastIndex * 6,(i - lastIndex) * 6);
		}
	}
	renderSession.filterManager.popObject(tilemap);
	renderSession.maskManager.popRect();
	renderSession.maskManager.popObject(tilemap);
	openfl_geom_Rectangle.__pool.release(rect);
};
GLTilemap.renderMask = function(tilemap,renderSession) {
	tilemap.__updateTileArray();
	if(tilemap.__tileArray == null || tilemap.__tileArray.__length == 0) {
		return;
	}
	var renderer = renderSession.renderer;
	var gl = renderSession.gl;
	var shader = openfl__internal_renderer_opengl_GLMaskManager.maskShader;
	var uMatrix = renderer.getMatrix(tilemap.__renderTransform);
	var smoothing = renderSession.allowSmoothing && tilemap.smoothing;
	var tileArray = tilemap.__tileArray;
	var defaultTileset = tilemap.tileset;
	tileArray.__updateGLBuffer(gl,defaultTileset,tilemap.__worldAlpha,tilemap.__worldColorTransform);
	var index = shader.get_data().aPosition.index;
	var type = gl.FLOAT;
	var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(0);
	gl.__context.vertexAttribPointer(index,2,type,false,100,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
	var index1 = shader.get_data().aTexCoord.index;
	var type1 = gl.FLOAT;
	var offset1 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(8);
	gl.__context.vertexAttribPointer(index1,2,type1,false,100,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset1));
	var cacheBitmapData = null;
	var lastIndex = 0;
	var skipped = tileArray.__bufferSkipped;
	var drawCount = tileArray.__length;
	tileArray.position = 0;
	var tileset;
	var flush = false;
	var _g1 = 0;
	var _g = drawCount + 1;
	while(_g1 < _g) {
		var i = _g1++;
		if(skipped.data.get(i)) {
			continue;
		}
		tileArray.position = i < drawCount ? i : drawCount - 1;
		tileset = tileArray.__tilesets.data.get(tileArray.position);
		if(tileset == null) {
			tileset = defaultTileset;
		}
		if(tileset == null) {
			continue;
		}
		if(tileset.bitmapData != cacheBitmapData && cacheBitmapData != null) {
			flush = true;
		}
		if(flush) {
			shader.get_data().uImage0.input = cacheBitmapData;
			renderSession.shaderManager.updateShader(shader);
			gl.__context.drawArrays(gl.TRIANGLES,lastIndex * 6,(i - lastIndex) * 6);
			flush = false;
			lastIndex = i;
		}
		cacheBitmapData = tileset.bitmapData;
		if(i == drawCount && tileset.bitmapData != null) {
			shader.get_data().uImage0.input = tileset.bitmapData;
			renderSession.shaderManager.updateShader(shader);
			gl.__context.drawArrays(gl.TRIANGLES,lastIndex * 6,(i - lastIndex) * 6);
		}
	}
};
GLTilemap.__skippedTiles = new haxe_ds_IntMap();


return GLTilemap;
}());
exports.default = exports.GLTilemap = GLTilemap;
