// Package: openfl._internal.renderer.opengl.GLVideo
var lime_utils__DataPointer_DataPointer_Impl_ = require("../../../../lime/utils/_DataPointer/DataPointer_Impl_").DataPointer_Impl_;
var openfl__internal_renderer_opengl_GLMaskManager = require("../../../../openfl/_internal/renderer/opengl/GLMaskManager").GLMaskManager;


// Class: openfl._internal.renderer.opengl.GLVideo

var GLVideo = (function () {
var GLVideo = function() {};
GLVideo.prototype = {
 __class__: GLVideo
};
GLVideo.__name__ = "openfl._internal.renderer.opengl.GLVideo";
GLVideo.render = function(video,renderSession) {
	if(!video.__renderable || video.__worldAlpha <= 0 || video.__stream == null) {
		return;
	}
	if(video.__stream.__video != null) {
		var renderer = renderSession.renderer;
		var gl = renderSession.gl;
		renderSession.blendModeManager.setBlendMode(video.__worldBlendMode);
		renderSession.maskManager.pushObject(video);
		renderSession.filterManager.pushObject(video);
		var shader = renderSession.shaderManager.initShader(video.shader);
		renderSession.shaderManager.setShader(shader);
		shader.get_data().uMatrix.value = renderer.getMatrix(video.__renderTransform);
		var useColorTransform = !video.__worldColorTransform.__isDefault();
		if(shader.get_data().uColorTransform.value == null) {
			shader.get_data().uColorTransform.value = [];
		}
		shader.get_data().uColorTransform.value[0] = useColorTransform;
		renderSession.shaderManager.updateShader(shader);
		var target = gl.TEXTURE_2D;
		var texture = video.__getTexture(gl);
		gl.__context.bindTexture(target,texture);
		if(video.smoothing) {
			gl.__context.texParameteri(gl.TEXTURE_2D,gl.TEXTURE_MAG_FILTER,gl.LINEAR);
			gl.__context.texParameteri(gl.TEXTURE_2D,gl.TEXTURE_MIN_FILTER,gl.LINEAR);
		} else {
			gl.__context.texParameteri(gl.TEXTURE_2D,gl.TEXTURE_MAG_FILTER,gl.NEAREST);
			gl.__context.texParameteri(gl.TEXTURE_2D,gl.TEXTURE_MIN_FILTER,gl.NEAREST);
		}
		var target1 = gl.ARRAY_BUFFER;
		var buffer = video.__getBuffer(gl,video.__worldAlpha,video.__worldColorTransform);
		gl.__context.bindBuffer(target1,buffer);
		var index = shader.get_data().aPosition.index;
		var type = gl.FLOAT;
		var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(0);
		gl.__context.vertexAttribPointer(index,3,type,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
		var index1 = shader.get_data().aTexCoord.index;
		var type1 = gl.FLOAT;
		var offset1 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(12);
		gl.__context.vertexAttribPointer(index1,2,type1,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset1));
		var index2 = shader.get_data().aAlpha.index;
		var type2 = gl.FLOAT;
		var offset2 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(20);
		gl.__context.vertexAttribPointer(index2,1,type2,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset2));
		var index3 = shader.get_data().aColorMultipliers.index;
		var type3 = gl.FLOAT;
		var offset3 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(24);
		gl.__context.vertexAttribPointer(index3,4,type3,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset3));
		var index4 = shader.get_data().aColorMultipliers.index + 1;
		var type4 = gl.FLOAT;
		var offset4 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(40);
		gl.__context.vertexAttribPointer(index4,4,type4,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset4));
		var index5 = shader.get_data().aColorMultipliers.index + 2;
		var type5 = gl.FLOAT;
		var offset5 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(56);
		gl.__context.vertexAttribPointer(index5,4,type5,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset5));
		var index6 = shader.get_data().aColorMultipliers.index + 3;
		var type6 = gl.FLOAT;
		var offset6 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(72);
		gl.__context.vertexAttribPointer(index6,4,type6,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset6));
		var index7 = shader.get_data().aColorOffsets.index;
		var type7 = gl.FLOAT;
		var offset7 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(88);
		gl.__context.vertexAttribPointer(index7,4,type7,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset7));
		gl.__context.drawArrays(gl.TRIANGLE_STRIP,0,4);
		renderSession.filterManager.popObject(video);
		renderSession.maskManager.popObject(video);
	}
};
GLVideo.renderMask = function(video,renderSession) {
	if(video.__stream == null) {
		return;
	}
	if(video.__stream.__video != null) {
		var renderer = renderSession.renderer;
		var gl = renderSession.gl;
		var shader = openfl__internal_renderer_opengl_GLMaskManager.maskShader;
		renderSession.shaderManager.setShader(shader);
		shader.get_data().uMatrix.value = renderer.getMatrix(video.__renderTransform);
		renderSession.shaderManager.updateShader(shader);
		var target = gl.TEXTURE_2D;
		var texture = video.__getTexture(gl);
		gl.__context.bindTexture(target,texture);
		var target1 = gl.ARRAY_BUFFER;
		var buffer = video.__getBuffer(gl,video.__worldAlpha,video.__worldColorTransform);
		gl.__context.bindBuffer(target1,buffer);
		var index = shader.get_data().aPosition.index;
		var type = gl.FLOAT;
		var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(0);
		gl.__context.vertexAttribPointer(index,3,type,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
		var index1 = shader.get_data().aTexCoord.index;
		var type1 = gl.FLOAT;
		var offset1 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(12);
		gl.__context.vertexAttribPointer(index1,2,type1,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset1));
		gl.__context.drawArrays(gl.TRIANGLE_STRIP,0,4);
	}
};


return GLVideo;
}());
exports.default = exports.GLVideo = GLVideo;
