// Package: openfl._internal.stage3D.AGALConverter
var openfl__internal_stage3D_RegisterMap = require("../../../openfl/_internal/stage3D/RegisterMap").RegisterMap;
var js__Boot_HaxeError = require("../../../js/_Boot/HaxeError").HaxeError;
var openfl_utils__ByteArray_ByteArray_Impl_ = require("../../../openfl/utils/_ByteArray/ByteArray_Impl_").ByteArray_Impl_;
var openfl__internal_stage3D__AGALConverter_DestRegister = require("../../../openfl/_internal/stage3D/_AGALConverter/DestRegister").DestRegister;
var openfl__internal_stage3D__AGALConverter_SourceRegister = require("../../../openfl/_internal/stage3D/_AGALConverter/SourceRegister").SourceRegister;
var openfl__internal_stage3D__AGALConverter_ProgramType = require("../../../openfl/_internal/stage3D/_AGALConverter/ProgramType").ProgramType;
var openfl__internal_stage3D__AGALConverter_SamplerRegister = require("../../../openfl/_internal/stage3D/_AGALConverter/SamplerRegister").SamplerRegister;
var openfl_errors_IllegalOperationError = require("../../../openfl/errors/IllegalOperationError").IllegalOperationError;
var Std = require("../../../Std").Std;
var openfl__internal_stage3D__AGALConverter_RegisterUsage = require("../../../openfl/_internal/stage3D/_AGALConverter/RegisterUsage").RegisterUsage;
var lime_graphics_opengl_GL = require("../../../lime/graphics/opengl/GL").GL;
var haxe__Int64____Int64 = require("../../../haxe/_Int64/___Int64").___Int64;


// Class: openfl._internal.stage3D.AGALConverter

var AGALConverter = (function () {
var AGALConverter = function() {};
AGALConverter.prototype = {
 __class__: AGALConverter
};
AGALConverter.__name__ = "openfl._internal.stage3D.AGALConverter";
AGALConverter.convertToGLSL = function(agal,samplerState) {
	agal.position = 0;
	agal.__endian = 1;
	var magic = agal.readByte() & 255;
	if(magic == 176) {
		return agal.readUTF();
	}
	if(magic != 160) {
		throw new js__Boot_HaxeError(new openfl_errors_IllegalOperationError("Magic value must be 0xA0, may not be AGAL"));
	}
	var version = agal.readInt();
	if(version != 1) {
		throw new js__Boot_HaxeError(new openfl_errors_IllegalOperationError("Version must be 1"));
	}
	var shaderTypeID = agal.readByte() & 255;
	if(shaderTypeID != 161) {
		throw new js__Boot_HaxeError(new openfl_errors_IllegalOperationError("Shader type ID must be 0xA1"));
	}
	var programType = (agal.readByte() & 255) == 0 ? openfl__internal_stage3D__AGALConverter_ProgramType.VERTEX : openfl__internal_stage3D__AGALConverter_ProgramType.FRAGMENT;
	var map = new openfl__internal_stage3D_RegisterMap();
	var sb_b = "";
	while(agal.position < openfl_utils__ByteArray_ByteArray_Impl_.get_length(agal)) {
		var opcode = agal.readInt();
		var dest = agal.readUnsignedInt();
		var source1 = AGALConverter.readUInt64(agal);
		var source2 = AGALConverter.readUInt64(agal);
		var dr = openfl__internal_stage3D__AGALConverter_DestRegister.parse(dest,programType);
		var sr1 = openfl__internal_stage3D__AGALConverter_SourceRegister.parse(source1,programType,dr.mask);
		var sr2 = openfl__internal_stage3D__AGALConverter_SourceRegister.parse(source2,programType,dr.mask);
		sb_b += "\t";
		switch(opcode) {
		case 0:
			sb_b += Std.string(dr.toGLSL() + " = " + sr1.toGLSL() + "; // mov");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 1:
			sb_b += Std.string(dr.toGLSL() + " = " + sr1.toGLSL() + " + " + sr2.toGLSL() + "; // add");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 2:
			sb_b += Std.string(dr.toGLSL() + " = " + sr1.toGLSL() + " - " + sr2.toGLSL() + "; // sub");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 3:
			sb_b += Std.string(dr.toGLSL() + " = " + sr1.toGLSL() + " * " + sr2.toGLSL() + "; // mul");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 4:
			sb_b += Std.string(dr.toGLSL() + " = " + sr1.toGLSL() + " / " + sr2.toGLSL() + "; // div");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 5:
			var sr = sr1.toGLSL();
			if(sr.indexOf(".") > -1) {
				sb_b += Std.string(dr.toGLSL() + " = 1.0 / " + sr1.toGLSL() + "; // rcp");
			} else {
				sb_b += Std.string(dr.toGLSL() + " = vec4(1) / " + sr1.toGLSL() + "; // rcp");
			}
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 6:
			sb_b += Std.string(dr.toGLSL() + " = min(" + sr1.toGLSL() + ", " + sr2.toGLSL() + "); // min");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 7:
			sb_b += Std.string(dr.toGLSL() + " = max(" + sr1.toGLSL() + ", " + sr2.toGLSL() + "); // max");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 8:
			sb_b += Std.string(dr.toGLSL() + " = fract(" + sr1.toGLSL() + "); // frc");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 9:
			sb_b += Std.string(dr.toGLSL() + " = sqrt(" + sr1.toGLSL() + "); // sqrt");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 10:
			sb_b += Std.string(dr.toGLSL() + " = inversesqrt(" + sr1.toGLSL() + "); // rsq");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 11:
			sb_b += Std.string(dr.toGLSL() + " = pow(" + sr1.toGLSL() + ", " + sr2.toGLSL() + "); // pow");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 12:
			sb_b += Std.string(dr.toGLSL() + " = log2(" + sr1.toGLSL() + "); // log");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 13:
			sb_b += Std.string(dr.toGLSL() + " = exp2(" + sr1.toGLSL() + "); // exp");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 14:
			sb_b += Std.string(dr.toGLSL() + " = normalize(" + sr1.toGLSL() + "); // normalize");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 15:
			sb_b += Std.string(dr.toGLSL() + " = sin(" + sr1.toGLSL() + "); // sin");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 16:
			sb_b += Std.string(dr.toGLSL() + " = cos(" + sr1.toGLSL() + "); // cos");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 17:
			sr1.sourceMask = sr2.sourceMask = 7;
			sb_b += Std.string(dr.toGLSL() + " = cross(vec3(" + sr1.toGLSL() + "), vec3(" + sr2.toGLSL() + ")); // crs");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 18:
			sr1.sourceMask = sr2.sourceMask = 7;
			sb_b += Std.string(dr.toGLSL() + " = vec4(dot(vec3(" + sr1.toGLSL() + "), vec3(" + sr2.toGLSL() + ")))" + dr.getWriteMask() + "; // dp3");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 19:
			sr1.sourceMask = sr2.sourceMask = 15;
			sb_b += Std.string(dr.toGLSL() + " = vec4(dot(vec4(" + sr1.toGLSL() + "), vec4(" + sr2.toGLSL() + ")))" + dr.getWriteMask() + "; // dp4");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 20:
			sb_b += Std.string(dr.toGLSL() + " = abs(" + sr1.toGLSL() + "); // abs");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 21:
			sb_b += Std.string(dr.toGLSL() + " = -" + sr1.toGLSL() + "; // neg");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 22:
			sb_b += Std.string(dr.toGLSL() + " = clamp(" + sr1.toGLSL() + ", 0.0, 1.0); // saturate");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 23:
			var existingUsage = map.getRegisterUsage(sr2);
			if(existingUsage != openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4 && existingUsage != openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4_ARRAY) {
				sb_b += Std.string(dr.toGLSL() + " = " + sr1.toGLSL() + " * mat3(" + sr2.toGLSL(false) + "); // m33");
				map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
				map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
				map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.MATRIX_4_4);
			} else {
				sr1.sourceMask = sr2.sourceMask = 7;
				sb_b += Std.string(dr.toGLSL() + " = vec3(" + "dot(" + sr1.toGLSL(true) + "," + sr2.toGLSL(true,0) + "), " + "dot(" + sr1.toGLSL(true) + "," + sr2.toGLSL(true,1) + ")," + "dot(" + sr1.toGLSL(true) + "," + sr2.toGLSL(true,2) + ")); // m33");
				map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
				map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
				map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4,0);
				map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4,1);
				map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4,2);
			}
			break;
		case 24:
			var existingUsage1 = map.getRegisterUsage(sr2);
			if(existingUsage1 != openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4 && existingUsage1 != openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4_ARRAY) {
				sb_b += Std.string(dr.toGLSL() + " = " + sr1.toGLSL() + " * " + sr2.toGLSL(false) + "; // m44");
				map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
				map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
				map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.MATRIX_4_4);
			} else {
				sr1.sourceMask = sr2.sourceMask = 15;
				sb_b += Std.string(dr.toGLSL() + " = vec4(" + "dot(" + sr1.toGLSL(true) + "," + sr2.toGLSL(true,0) + "), " + "dot(" + sr1.toGLSL(true) + "," + sr2.toGLSL(true,1) + "), " + "dot(" + sr1.toGLSL(true) + "," + sr2.toGLSL(true,2) + "), " + "dot(" + sr1.toGLSL(true) + "," + sr2.toGLSL(true,3) + ")); // m44");
				map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
				map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
				map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4,0);
				map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4,1);
				map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4,2);
				map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4,3);
			}
			break;
		case 25:
			dr.mask &= 7;
			var existingUsage2 = map.getRegisterUsage(sr2);
			if(existingUsage2 != openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4 && existingUsage2 != openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4_ARRAY) {
				sb_b += Std.string(dr.toGLSL() + " = " + sr1.toGLSL() + " * " + sr2.toGLSL(false) + "; // m34");
				map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
				map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
				map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.MATRIX_4_4);
			} else {
				sr1.sourceMask = sr2.sourceMask = 15;
				sb_b += Std.string(dr.toGLSL() + " = vec3(" + "dot(" + sr1.toGLSL(true) + "," + sr2.toGLSL(true,0) + "), " + "dot(" + sr1.toGLSL(true) + "," + sr2.toGLSL(true,1) + ")," + "dot(" + sr1.toGLSL(true) + "," + sr2.toGLSL(true,2) + ")); // m34");
				map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
				map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
				map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4,0);
				map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4,1);
				map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4,2);
			}
			break;
		case 39:
			sr1.sourceMask = 15;
			sb_b += Std.string("if (any(lessThan(" + sr1.toGLSL() + ", vec4(0)))) discard;");
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 40:
			var sampler = openfl__internal_stage3D__AGALConverter_SamplerRegister.parse(source2,programType);
			var _g = sampler.d;
			switch(_g) {
			case 0:
				sr1.sourceMask = 3;
				map.addSaR(sampler,openfl__internal_stage3D__AGALConverter_RegisterUsage.SAMPLER_2D);
				sb_b += Std.string(dr.toGLSL() + " = texture2D(" + sampler.toGLSL() + ", " + sr1.toGLSL() + "); // tex");
				break;
			case 1:
				sr1.sourceMask = 7;
				sb_b += Std.string(dr.toGLSL() + " = textureCube(" + sampler.toGLSL() + ", " + sr1.toGLSL() + "); // tex");
				map.addSaR(sampler,openfl__internal_stage3D__AGALConverter_RegisterUsage.SAMPLER_CUBE);
				break;
			}
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			if(samplerState != null) {
				samplerState[sampler.n] = sampler.toSamplerState();
			}
			break;
		case 41:
			sr1.sourceMask = sr2.sourceMask = 15;
			sb_b += Std.string(dr.toGLSL() + " = vec4(greaterThanEqual(" + sr1.toGLSL() + ", " + sr2.toGLSL() + "))" + dr.getWriteMask() + "; // ste");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 42:
			sr1.sourceMask = sr2.sourceMask = 15;
			sb_b += Std.string(dr.toGLSL() + " = vec4(lessThan(" + sr1.toGLSL() + ", " + sr2.toGLSL() + "))" + dr.getWriteMask() + "; // slt");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 44:
			sr1.sourceMask = sr2.sourceMask = 15;
			sb_b += Std.string(dr.toGLSL() + " = vec4(equal(" + sr1.toGLSL() + ", " + sr2.toGLSL() + "))" + dr.getWriteMask() + "; // seq");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		case 45:
			sr1.sourceMask = sr2.sourceMask = 15;
			sb_b += Std.string(dr.toGLSL() + " = vec4(notEqual(" + sr1.toGLSL() + ", " + sr2.toGLSL() + "))" + dr.getWriteMask() + "; // sne");
			map.addDR(dr,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr1,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			map.addSR(sr2,openfl__internal_stage3D__AGALConverter_RegisterUsage.VECTOR_4);
			break;
		default:
			throw new js__Boot_HaxeError(new openfl_errors_IllegalOperationError("Opcode " + opcode));
		}
		sb_b += "\n";
	}
	if(AGALConverter.limitedProfile == null) {
		var version1 = lime_graphics_opengl_GL.context.__context.getParameter(7938);
		AGALConverter.limitedProfile = version1.indexOf("OpenGL ES") > -1 || version1.indexOf("WebGL") > -1;
	}
	var glsl_b = "";
	glsl_b += Std.string("// AGAL " + (programType == openfl__internal_stage3D__AGALConverter_ProgramType.VERTEX ? "vertex" : "fragment") + " shader\n");
	if(AGALConverter.limitedProfile) {
		glsl_b += "#version 100\n";
		glsl_b += "precision highp float;\n";
	} else {
		glsl_b += "#version 120\n";
	}
	glsl_b += Std.string(map.toGLSL(false));
	if(programType == openfl__internal_stage3D__AGALConverter_ProgramType.VERTEX) {
		glsl_b += "uniform vec4 vcPositionScale;\n";
	}
	glsl_b += "void main() {\n";
	glsl_b += Std.string(map.toGLSL(true));
	glsl_b += Std.string(sb_b);
	if(programType == openfl__internal_stage3D__AGALConverter_ProgramType.VERTEX) {
		glsl_b += "\tgl_Position *= vcPositionScale;\n";
	}
	glsl_b += "}\n";
	return glsl_b;
};
AGALConverter.prefixFromType = function(regType,programType) {
	switch(regType) {
	case 0:
		return "va";
	case 1:
		if(programType == openfl__internal_stage3D__AGALConverter_ProgramType.VERTEX) {
			return "vc";
		} else {
			return "fc";
		}
		break;
	case 2:
		if(programType == openfl__internal_stage3D__AGALConverter_ProgramType.VERTEX) {
			return "vt";
		} else {
			return "ft";
		}
		break;
	case 3:
		return "output_";
	case 4:
		return "v";
	case 5:
		return "sampler";
	default:
		throw new js__Boot_HaxeError(new openfl_errors_IllegalOperationError("Invalid data!"));
	}
};
AGALConverter.readUInt64 = function(byteArray) {
	var low = byteArray.readInt();
	var high = byteArray.readInt();
	var this1 = new haxe__Int64____Int64(high,low);
	return this1;
};
AGALConverter.limitedProfile = true;


return AGALConverter;
}());
exports.default = exports.AGALConverter = AGALConverter;
