// Package: openfl._internal.stage3D.GLCompressedTextureFormats
var haxe_ds_IntMap = require("../../../haxe/ds/IntMap").IntMap;


// Class: openfl._internal.stage3D.GLCompressedTextureFormats

var GLCompressedTextureFormats = (function () {
var GLCompressedTextureFormats = function(gl) {
	this.__formatMapAlpha = new haxe_ds_IntMap();
	this.__formatMap = new haxe_ds_IntMap();
	this.checkDXT(gl);
	this.checkETC1(gl);
	this.checkPVRTC(gl);
};
GLCompressedTextureFormats.prototype = {
  checkETC1: function(gl) {
		var compressedExtension = gl.__context.getExtension("WEBGL_compressed_texture_etc1");
		if(compressedExtension != null) {
			var v = compressedExtension.COMPRESSED_RGB_ETC1_WEBGL;
			this.__formatMap.h[2] = v;
		}
	},
  __formatMap: null,
  __formatMapAlpha: null,
  checkPVRTC: function(gl) {
		var compressedExtension = gl.__context.getExtension("WEBKIT_WEBGL_compressed_texture_pvrtc");
		if(compressedExtension != null) {
			var v = compressedExtension.COMPRESSED_RGB_PVRTC_4BPPV1_IMG;
			this.__formatMap.h[1] = v;
			var v1 = compressedExtension.COMPRESSED_RGBA_PVRTC_4BPPV1_IMG;
			this.__formatMapAlpha.h[1] = v1;
		}
	},
  checkDXT: function(gl) {
		var compressedExtension = gl.__context.getExtension("WEBGL_compressed_texture_s3tc");
		if(compressedExtension != null) {
			var v = compressedExtension.COMPRESSED_RGBA_S3TC_DXT1_EXT;
			this.__formatMap.h[0] = v;
			var v1 = compressedExtension.COMPRESSED_RGBA_S3TC_DXT5_EXT;
			this.__formatMapAlpha.h[0] = v1;
		}
	},
  toTextureFormat: function(alpha,gpuFormat) {
		if(alpha) {
			return this.__formatMap.h[gpuFormat];
		} else {
			return this.__formatMapAlpha.h[gpuFormat];
		}
	},
 __class__: GLCompressedTextureFormats
};
GLCompressedTextureFormats.__name__ = "openfl._internal.stage3D.GLCompressedTextureFormats";


return GLCompressedTextureFormats;
}());
exports.default = exports.GLCompressedTextureFormats = GLCompressedTextureFormats;
