// Package: openfl._internal.stage3D.SamplerState


// Class: openfl._internal.stage3D.SamplerState

var SamplerState = (function () {
var SamplerState = function(minFilter,magFilter,wrapModeS,wrapModeT,lodBias,maxAniso,ignoreSampler,centroid,mipmapGenerated) {
	if(mipmapGenerated == null) {
		mipmapGenerated = false;
	}
	if(centroid == null) {
		centroid = false;
	}
	if(ignoreSampler == null) {
		ignoreSampler = false;
	}
	if(maxAniso == null) {
		maxAniso = 0.0;
	}
	if(lodBias == null) {
		lodBias = 0.0;
	}
	this.set_minFilter(minFilter);
	this.set_magFilter(magFilter);
	this.set_wrapModeS(wrapModeS);
	this.set_wrapModeT(wrapModeT);
	this.set_lodBias(lodBias);
	this.set_maxAniso(maxAniso);
	this.ignoreSampler = ignoreSampler;
	this.centroid = centroid;
	this.mipmapGenerated = mipmapGenerated;
	this.__samplerDirty = true;
};
SamplerState.prototype = {
    "__properties__": {"set_lodBias":"set_lodBias","set_magFilter":"set_magFilter","set_maxAniso":"set_maxAniso","set_minFilter":"set_minFilter","set_wrapModeS":"set_wrapModeS","set_wrapModeT":"set_wrapModeT"},
  minFilter: null,
  centroid: null,
  copyFrom: function(other) {
		if(other == null || other.ignoreSampler) {
			return;
		}
		this.set_minFilter(other.minFilter);
		this.set_magFilter(other.magFilter);
		this.set_wrapModeS(other.wrapModeS);
		this.set_wrapModeT(other.wrapModeT);
		this.set_lodBias(other.lodBias);
		this.set_maxAniso(other.maxAniso);
		this.centroid = other.centroid;
		this.mipmapGenerated = other.mipmapGenerated;
	},
  ignoreSampler: null,
  lodBias: null,
  set_wrapModeT: function(value) {
		if(this.wrapModeT != value) {
			this.__samplerDirty = true;
		}
		return this.wrapModeT = value;
	},
  wrapModeS: null,
  wrapModeT: null,
  set_minFilter: function(value) {
		if(this.minFilter != value) {
			this.__samplerDirty = true;
		}
		return this.minFilter = value;
	},
  set_wrapModeS: function(value) {
		if(this.wrapModeS != value) {
			this.__samplerDirty = true;
		}
		return this.wrapModeS = value;
	},
  set_lodBias: function(value) {
		if(this.lodBias != value) {
			this.__samplerDirty = true;
		}
		return this.lodBias = value;
	},
  __samplerDirty: null,
  magFilter: null,
  mipmapGenerated: null,
  equals: function(other) {
		if(this == other) {
			return !this.__samplerDirty;
		}
		if(other == null) {
			return false;
		}
		if(this.minFilter == other.minFilter && this.magFilter == other.magFilter && this.wrapModeS == other.wrapModeS && this.wrapModeT == other.wrapModeT && this.lodBias == other.lodBias && this.maxAniso == other.maxAniso) {
			return this.mipmapGenerated == other.mipmapGenerated;
		} else {
			return false;
		}
	},
  maxAniso: null,
  set_magFilter: function(value) {
		if(this.magFilter != value) {
			this.__samplerDirty = true;
		}
		return this.magFilter = value;
	},
  set_maxAniso: function(value) {
		if(this.maxAniso != value) {
			this.__samplerDirty = true;
		}
		return this.maxAniso = value;
	},
 __class__: SamplerState
};
SamplerState.__name__ = "openfl._internal.stage3D.SamplerState";
Object.defineProperties(SamplerState.prototype, {
	"minFilter": { set: SamplerState.prototype.set_minFilter },
	"lodBias": { set: SamplerState.prototype.set_lodBias },
	"wrapModeS": { set: SamplerState.prototype.set_wrapModeS },
	"wrapModeT": { set: SamplerState.prototype.set_wrapModeT },
	"magFilter": { set: SamplerState.prototype.set_magFilter },
	"maxAniso": { set: SamplerState.prototype.set_maxAniso },
});



return SamplerState;
}());
exports.default = exports.SamplerState = SamplerState;
