// Package: openfl._internal.stage3D.opengl.GLContext3D
var openfl_display3D_Context3D = require("../../../../openfl/display3D/Context3D").Context3D;
var openfl__internal_stage3D_GLUtils = require("../../../../openfl/_internal/stage3D/GLUtils").GLUtils;
var openfl__Vector_Vector_Impl_ = require("../../../../openfl/_Vector/Vector_Impl_").Vector_Impl_;
var openfl_display3D_textures_RectangleTexture = require("../../../../openfl/display3D/textures/RectangleTexture").RectangleTexture;
var js__Boot_HaxeError = require("../../../../js/_Boot/HaxeError").HaxeError;
var openfl_utils__ByteArray_ByteArray_Impl_ = require("../../../../openfl/utils/_ByteArray/ByteArray_Impl_").ByteArray_Impl_;
var haxe_Log = require("../../../../haxe/Log").Log;
var lime_math_Rectangle = require("../../../../lime/math/Rectangle").Rectangle;
var js_Boot = require("../../../../js/Boot").Boot;
var _UInt_UInt_Impl_ = require("../../../../_UInt/UInt_Impl_").UInt_Impl_;
var openfl_errors_Error = require("../../../../openfl/errors/Error").Error;
var openfl__internal_stage3D_SamplerState = require("../../../../openfl/_internal/stage3D/SamplerState").SamplerState;
var lime_math_Vector2 = require("../../../../lime/math/Vector2").Vector2;
var openfl_display3D_textures_CubeTexture = require("../../../../openfl/display3D/textures/CubeTexture").CubeTexture;
var openfl_display_Stage3D = require("../../../../openfl/display/Stage3D").Stage3D;
var openfl_errors_IllegalOperationError = require("../../../../openfl/errors/IllegalOperationError").IllegalOperationError;
var lime_utils__DataPointer_DataPointer_Impl_ = require("../../../../lime/utils/_DataPointer/DataPointer_Impl_").DataPointer_Impl_;
var openfl_display3D_textures_Texture = require("../../../../openfl/display3D/textures/Texture").Texture;


// Class: openfl._internal.stage3D.opengl.GLContext3D

var GLContext3D = (function () {
var GLContext3D = function() {};
GLContext3D.prototype = {
 __class__: GLContext3D
};
GLContext3D.__name__ = "openfl._internal.stage3D.opengl.GLContext3D";
GLContext3D.__flushSamplerState = function() {
	var sampler = 0;
	while(GLContext3D.context.__samplerDirty != 0) {
		if((GLContext3D.context.__samplerDirty & 1 << sampler) != 0) {
			if(openfl_display3D_Context3D.__stateCache.updateActiveTextureSample(sampler)) {
				GLContext3D.gl.__context.activeTexture(GLContext3D.gl.TEXTURE0 + sampler);
				openfl__internal_stage3D_GLUtils.CheckGLError();
			}
			var texture = GLContext3D.context.__samplerTextures.data.get(sampler);
			if(texture != null) {
				var target = texture.__textureTarget;
				var _this = GLContext3D.gl;
				var texture1 = texture.__getTexture();
				_this.__context.bindTexture(target,texture1);
				openfl__internal_stage3D_GLUtils.CheckGLError();
				texture.__setSamplerState(GLContext3D.context.__samplerStates[sampler]);
			} else {
				GLContext3D.gl.__context.bindTexture(GLContext3D.gl.TEXTURE_2D,null);
				openfl__internal_stage3D_GLUtils.CheckGLError();
			}
			GLContext3D.context.__samplerDirty &= ~(1 << sampler);
		}
		++sampler;
	}
};
GLContext3D.gl = null;
GLContext3D.__getGLCompareMode = function(compareMode) {
	switch(compareMode) {
	case 0:
		return GLContext3D.gl.ALWAYS;
	case 1:
		return GLContext3D.gl.EQUAL;
	case 2:
		return GLContext3D.gl.GREATER;
	case 3:
		return GLContext3D.gl.GEQUAL;
	case 4:
		return GLContext3D.gl.LESS;
	case 5:
		return GLContext3D.gl.LEQUAL;
	case 6:
		return GLContext3D.gl.NEVER;
	case 7:
		return GLContext3D.gl.NOTEQUAL;
	default:
		return GLContext3D.gl.EQUAL;
	}
};
GLContext3D.setProgram = function(context,program) {
	if(openfl_display3D_Context3D.__stateCache.updateProgram3D(program)) {
		program.__use();
		program.__setPositionScale(context.__positionScale);
		context.__program = program;
		context.__samplerDirty |= context.__program.__samplerUsageMask;
		var _g = 0;
		while(_g < 8) {
			var i = _g++;
			context.__samplerStates[i].copyFrom(context.__program.__getSamplerState(i));
		}
	}
};
GLContext3D.__updateDepthAndStencilState = function() {
	var depthAndStencil = GLContext3D.context.__renderToTexture != null ? GLContext3D.context.__rttDepthAndStencil : GLContext3D.context.__backBufferEnableDepthAndStencil;
	if(depthAndStencil) {
		GLContext3D.gl.__context.enable(GLContext3D.gl.DEPTH_TEST);
		openfl__internal_stage3D_GLUtils.CheckGLError();
		GLContext3D.gl.__context.enable(GLContext3D.gl.STENCIL_TEST);
		openfl__internal_stage3D_GLUtils.CheckGLError();
	} else {
		GLContext3D.gl.__context.disable(GLContext3D.gl.DEPTH_TEST);
		openfl__internal_stage3D_GLUtils.CheckGLError();
		GLContext3D.gl.__context.disable(GLContext3D.gl.STENCIL_TEST);
		openfl__internal_stage3D_GLUtils.CheckGLError();
	}
};
GLContext3D.setScissorRectangle = function(context,rectangle) {
	GLContext3D.context = context;
	GLContext3D.gl = context.__renderSession.gl;
	context.__scissorRectangle = rectangle != null ? rectangle.clone() : null;
	GLContext3D.__updateScissorRectangle();
};
GLContext3D.setStencilReferenceValue = function(context,referenceValue,readMask,writeMask) {
	if(writeMask == null) {
		writeMask = 255;
	}
	if(readMask == null) {
		readMask = 255;
	}
	GLContext3D.context = context;
	GLContext3D.gl = context.__renderSession.gl;
	context.__stencilReadMask = readMask;
	context.__stencilRef = referenceValue;
	var _this = GLContext3D.gl;
	var func = GLContext3D.__getGLCompareMode(context.__stencilCompareMode);
	_this.__context.stencilFunc(func,context.__stencilRef,context.__stencilReadMask);
	GLContext3D.gl.__context.stencilMask(writeMask);
};
GLContext3D.setVertexBufferAt = function(context,index,buffer,bufferOffset,format) {
	if(format == null) {
		format = 4;
	}
	if(bufferOffset == null) {
		bufferOffset = 0;
	}
	var gl = context.__renderSession.gl;
	if(buffer == null) {
		gl.__context.disableVertexAttribArray(index);
		openfl__internal_stage3D_GLUtils.CheckGLError();
		gl.__context.bindBuffer(gl.ARRAY_BUFFER,null);
		openfl__internal_stage3D_GLUtils.CheckGLError();
		return;
	}
	gl.__context.enableVertexAttribArray(index);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	gl.__context.bindBuffer(gl.ARRAY_BUFFER,buffer.__id);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var byteOffset = bufferOffset * 4;
	switch(format) {
	case 0:
		var type = gl.UNSIGNED_BYTE;
		var stride = buffer.__stride;
		var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(byteOffset);
		gl.__context.vertexAttribPointer(index,4,type,true,stride,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
		openfl__internal_stage3D_GLUtils.CheckGLError();
		break;
	case 1:
		var type1 = gl.FLOAT;
		var stride1 = buffer.__stride;
		var offset1 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(byteOffset);
		gl.__context.vertexAttribPointer(index,1,type1,false,stride1,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset1));
		openfl__internal_stage3D_GLUtils.CheckGLError();
		break;
	case 2:
		var type2 = gl.FLOAT;
		var stride2 = buffer.__stride;
		var offset2 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(byteOffset);
		gl.__context.vertexAttribPointer(index,2,type2,false,stride2,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset2));
		openfl__internal_stage3D_GLUtils.CheckGLError();
		break;
	case 3:
		var type3 = gl.FLOAT;
		var stride3 = buffer.__stride;
		var offset3 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(byteOffset);
		gl.__context.vertexAttribPointer(index,3,type3,false,stride3,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset3));
		openfl__internal_stage3D_GLUtils.CheckGLError();
		break;
	case 4:
		var type4 = gl.FLOAT;
		var stride4 = buffer.__stride;
		var offset4 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(byteOffset);
		gl.__context.vertexAttribPointer(index,4,type4,false,stride4,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset4));
		openfl__internal_stage3D_GLUtils.CheckGLError();
		break;
	default:
		throw new js__Boot_HaxeError(new openfl_errors_IllegalOperationError());
	}
};
GLContext3D.__updateBlendFactors = function() {
	if(openfl_display3D_Context3D.__stateCache._srcBlendFactor == null || openfl_display3D_Context3D.__stateCache._destBlendFactor == null) {
		return;
	}
	var src = GLContext3D.gl.ONE;
	var dest = GLContext3D.gl.ZERO;
	var _g = openfl_display3D_Context3D.__stateCache._srcBlendFactor;
	switch(_g) {
	case 0:
		src = GLContext3D.gl.DST_ALPHA;
		break;
	case 1:
		src = GLContext3D.gl.DST_COLOR;
		break;
	case 2:
		src = GLContext3D.gl.ONE;
		break;
	case 3:
		src = GLContext3D.gl.ONE_MINUS_DST_ALPHA;
		break;
	case 4:
		src = GLContext3D.gl.ONE_MINUS_DST_COLOR;
		break;
	case 5:
		src = GLContext3D.gl.ONE_MINUS_SRC_ALPHA;
		break;
	case 7:
		src = GLContext3D.gl.SRC_ALPHA;
		break;
	case 9:
		src = GLContext3D.gl.ZERO;
		break;
	default:
		throw new js__Boot_HaxeError(new openfl_errors_IllegalOperationError());
	}
	var _g1 = openfl_display3D_Context3D.__stateCache._destBlendFactor;
	switch(_g1) {
	case 0:
		dest = GLContext3D.gl.DST_ALPHA;
		break;
	case 2:
		dest = GLContext3D.gl.ONE;
		break;
	case 3:
		dest = GLContext3D.gl.ONE_MINUS_DST_ALPHA;
		break;
	case 5:
		dest = GLContext3D.gl.ONE_MINUS_SRC_ALPHA;
		break;
	case 6:
		dest = GLContext3D.gl.ONE_MINUS_SRC_COLOR;
		break;
	case 7:
		dest = GLContext3D.gl.SRC_ALPHA;
		break;
	case 8:
		dest = GLContext3D.gl.SRC_COLOR;
		break;
	case 9:
		dest = GLContext3D.gl.ZERO;
		break;
	default:
		throw new js__Boot_HaxeError(new openfl_errors_IllegalOperationError());
	}
	GLContext3D.gl.__context.enable(GLContext3D.gl.BLEND);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	GLContext3D.gl.__context.blendFunc(src,dest);
	openfl__internal_stage3D_GLUtils.CheckGLError();
};
GLContext3D.__updateBackbufferViewportTEMP = function(context) {
	GLContext3D.context = context;
	GLContext3D.gl = context.__renderSession.gl;
	GLContext3D.__updateBackbufferViewport();
};
GLContext3D.setProgramConstantsFromMatrix = function(context,programType,firstRegister,matrix,transposedMatrix) {
	if(transposedMatrix == null) {
		transposedMatrix = false;
	}
	var isVertex = programType == 1;
	var dest = isVertex ? context.__vertexConstants : context.__fragmentConstants;
	var source = matrix.rawData;
	var i = firstRegister * 4;
	if(transposedMatrix) {
		dest[i++] = source.data.get(0);
		dest[i++] = source.data.get(4);
		dest[i++] = source.data.get(8);
		dest[i++] = source.data.get(12);
		dest[i++] = source.data.get(1);
		dest[i++] = source.data.get(5);
		dest[i++] = source.data.get(9);
		dest[i++] = source.data.get(13);
		dest[i++] = source.data.get(2);
		dest[i++] = source.data.get(6);
		dest[i++] = source.data.get(10);
		dest[i++] = source.data.get(14);
		dest[i++] = source.data.get(3);
		dest[i++] = source.data.get(7);
		dest[i++] = source.data.get(11);
		dest[i++] = source.data.get(15);
	} else {
		dest[i++] = source.data.get(0);
		dest[i++] = source.data.get(1);
		dest[i++] = source.data.get(2);
		dest[i++] = source.data.get(3);
		dest[i++] = source.data.get(4);
		dest[i++] = source.data.get(5);
		dest[i++] = source.data.get(6);
		dest[i++] = source.data.get(7);
		dest[i++] = source.data.get(8);
		dest[i++] = source.data.get(9);
		dest[i++] = source.data.get(10);
		dest[i++] = source.data.get(11);
		dest[i++] = source.data.get(12);
		dest[i++] = source.data.get(13);
		dest[i++] = source.data.get(14);
		dest[i++] = source.data.get(15);
	}
	if(context.__program != null) {
		context.__program.__markDirty(isVertex,firstRegister,4);
	}
};
GLContext3D.setBlendFactors = function(context,sourceFactor,destinationFactor) {
	var updateSrc = openfl_display3D_Context3D.__stateCache.updateBlendSrcFactor(sourceFactor);
	var updateDest = openfl_display3D_Context3D.__stateCache.updateBlendDestFactor(destinationFactor);
	if(updateSrc || updateDest) {
		GLContext3D.context = context;
		GLContext3D.gl = context.__renderSession.gl;
		GLContext3D.__updateBlendFactors();
	}
};
GLContext3D.setProgramConstantsFromVector = function(context,programType,firstRegister,data,numRegisters) {
	if(numRegisters == null) {
		numRegisters = -1;
	}
	if(numRegisters == -1) {
		numRegisters = data.data.get_length() >> 2;
	}
	var isVertex = programType == 1;
	var dest = isVertex ? context.__vertexConstants : context.__fragmentConstants;
	var source = data;
	var sourceIndex = 0;
	var destIndex = firstRegister * 4;
	var _g1 = 0;
	var _g = numRegisters;
	while(_g1 < _g) {
		var i = _g1++;
		dest[destIndex++] = source.data.get(sourceIndex++);
		dest[destIndex++] = source.data.get(sourceIndex++);
		dest[destIndex++] = source.data.get(sourceIndex++);
		dest[destIndex++] = source.data.get(sourceIndex++);
	}
	if(context.__program != null) {
		context.__program.__markDirty(isVertex,firstRegister,numRegisters);
	}
};
GLContext3D.__updateBackbufferViewport = function() {
	if(!openfl_display_Stage3D.__active) {
		openfl_display_Stage3D.__active = true;
		GLContext3D.context.__renderSession.renderer.clear();
	}
	if(GLContext3D.context.__renderToTexture == null && GLContext3D.context.backBufferWidth > 0 && GLContext3D.context.backBufferHeight > 0) {
		GLContext3D.__setViewport(GLContext3D.context.__stage3D.x | 0,GLContext3D.context.__stage3D.y | 0,GLContext3D.context.backBufferWidth,GLContext3D.context.backBufferHeight);
	}
};
GLContext3D.dispose = function(context,recreate) {
	if(recreate == null) {
		recreate = true;
	}
};
GLContext3D.setCulling = function(context,triangleFaceToCull) {
	var gl = context.__renderSession.gl;
	if(openfl_display3D_Context3D.__stateCache.updateCullingMode(triangleFaceToCull)) {
		switch(triangleFaceToCull) {
		case 0:
			gl.__context.enable(gl.CULL_FACE);
			gl.__context.cullFace(gl.FRONT);
			break;
		case 1:
			gl.__context.enable(gl.CULL_FACE);
			gl.__context.cullFace(gl.BACK);
			break;
		case 2:
			gl.__context.enable(gl.CULL_FACE);
			gl.__context.cullFace(gl.FRONT_AND_BACK);
			break;
		case 3:
			gl.__context.disable(gl.CULL_FACE);
			break;
		default:
			return new openfl_errors_IllegalOperationError();
		}
	}
	return null;
};
GLContext3D.setEnableErrorChecking = function(value) {
	openfl__internal_stage3D_GLUtils.debug = value;
};
GLContext3D.drawTriangles = function(context,indexBuffer,firstIndex,numTriangles) {
	if(numTriangles == null) {
		numTriangles = -1;
	}
	if(firstIndex == null) {
		firstIndex = 0;
	}
	if(context.__program == null) {
		return;
	}
	GLContext3D.context = context;
	GLContext3D.gl = context.__renderSession.gl;
	GLContext3D.__flushSamplerState();
	context.__program.__flush();
	var count = numTriangles == -1 ? indexBuffer.__numIndices : numTriangles * 3;
	GLContext3D.gl.__context.bindBuffer(GLContext3D.gl.ELEMENT_ARRAY_BUFFER,indexBuffer.__id);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var _this = GLContext3D.gl;
	var mode = GLContext3D.gl.TRIANGLES;
	var type = indexBuffer.__elementType;
	var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(firstIndex);
	_this.__context.drawElements(mode,count,type,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
	openfl__internal_stage3D_GLUtils.CheckGLError();
};
GLContext3D.setStencilActions = function(context,triangleFace,compareMode,actionOnBothPass,actionOnDepthFail,actionOnDepthPassStencilFail) {
	if(actionOnDepthPassStencilFail == null) {
		actionOnDepthPassStencilFail = 5;
	}
	if(actionOnDepthFail == null) {
		actionOnDepthFail = 5;
	}
	if(actionOnBothPass == null) {
		actionOnBothPass = 5;
	}
	if(compareMode == null) {
		compareMode = 0;
	}
	if(triangleFace == null) {
		triangleFace = 2;
	}
	GLContext3D.context = context;
	GLContext3D.gl = context.__renderSession.gl;
	context.__stencilCompareMode = compareMode;
	var _this = GLContext3D.gl;
	var face = GLContext3D.__getGLTriangleFace(triangleFace);
	var fail = GLContext3D.__getGLStencilAction(actionOnDepthPassStencilFail);
	var zfail = GLContext3D.__getGLStencilAction(actionOnDepthFail);
	var zpass = GLContext3D.__getGLStencilAction(actionOnBothPass);
	_this.__context.stencilOpSeparate(face,fail,zfail,zpass);
	var _this1 = GLContext3D.gl;
	var func = GLContext3D.__getGLCompareMode(context.__stencilCompareMode);
	_this1.__context.stencilFunc(func,context.__stencilRef,context.__stencilReadMask);
};
GLContext3D.setTextureAt = function(context,sampler,texture) {
	if(context.__samplerTextures.data.get(sampler) != texture) {
		context.__samplerTextures.data.set(sampler,texture);
		context.__samplerDirty |= 1 << sampler;
	}
};
GLContext3D.__setViewport = function(originX,originY,width,height) {
	if(GLContext3D.context.__renderToTexture != null) {
		originY *= -1;
	}
	if(openfl_display3D_Context3D.__stateCache.updateViewport(originX,originY,width,height)) {
		GLContext3D.gl.__context.viewport(originX,originY,width,height);
		openfl__internal_stage3D_GLUtils.CheckGLError();
	}
};
GLContext3D.configureBackBuffer = function(context,width,height,antiAlias,enableDepthAndStencil,wantsBestResolution,wantsBestResolutionOnBrowserZoom) {
	if(wantsBestResolutionOnBrowserZoom == null) {
		wantsBestResolutionOnBrowserZoom = false;
	}
	if(wantsBestResolution == null) {
		wantsBestResolution = false;
	}
	if(enableDepthAndStencil == null) {
		enableDepthAndStencil = true;
	}
	GLContext3D.context = context;
	GLContext3D.gl = context.__renderSession.gl;
	GLContext3D.__updateBackbufferViewport();
	context.backBufferWidth = width;
	context.backBufferHeight = height;
	context.__backBufferAntiAlias = antiAlias;
	context.__backBufferEnableDepthAndStencil = enableDepthAndStencil;
	context.__backBufferWantsBestResolution = wantsBestResolution;
	openfl_display3D_Context3D.__stateCache.clearSettings();
};
GLContext3D.drawToBitmapData = function(context,destination) {
	var $window = context.__stage3D.__stage.window;
	if($window != null) {
		var image = $window.renderer.readPixels();
		var heightOffset = image.height - context.backBufferHeight;
		destination.image.copyPixels(image,new lime_math_Rectangle(context.__stage3D.x | 0,context.__stage3D.y + heightOffset | 0,context.backBufferWidth,context.backBufferHeight),new lime_math_Vector2());
	}
};
GLContext3D.__getGLStencilAction = function(stencilAction) {
	switch(stencilAction) {
	case 0:
		return GLContext3D.gl.DECR;
	case 1:
		return GLContext3D.gl.DECR_WRAP;
	case 2:
		return GLContext3D.gl.INCR;
	case 3:
		return GLContext3D.gl.INCR_WRAP;
	case 4:
		return GLContext3D.gl.INVERT;
	case 5:
		return GLContext3D.gl.KEEP;
	case 6:
		return GLContext3D.gl.REPLACE;
	case 7:
		return GLContext3D.gl.ZERO;
	default:
		return GLContext3D.gl.KEEP;
	}
};
GLContext3D.setColorMask = function(context,red,green,blue,alpha) {
	var gl = context.__renderSession.gl;
	gl.__context.colorMask(red,green,blue,alpha);
};
GLContext3D.__updateBlendFactorsTEMP = function(context) {
	GLContext3D.context = context;
	GLContext3D.gl = context.__renderSession.gl;
	GLContext3D.__updateBlendFactors();
};
GLContext3D.create = function(context) {
	var gl = context.__renderSession.gl;
	var this1 = new Float32Array(512);
	context.__vertexConstants = this1;
	var this2 = new Float32Array(512);
	context.__fragmentConstants = this2;
	var array = [1.0,1.0,1.0,1.0];
	var this3;
	if(array != null) {
		this3 = new Float32Array(array);
	} else {
		this3 = null;
	}
	context.__positionScale = this3;
	context.__samplerDirty = 0;
	context.__samplerTextures = openfl__Vector_Vector_Impl_.toObjectVector(null,8);
	context.__samplerStates = [];
	var _g = 0;
	while(_g < 8) {
		var i = _g++;
		context.__samplerStates[i] = new openfl__internal_stage3D_SamplerState(gl.LINEAR,gl.LINEAR,gl.CLAMP_TO_EDGE,gl.CLAMP_TO_EDGE);
	}
	context.maxBackBufferHeight = context.maxBackBufferWidth = gl.__context.getParameter(gl.MAX_VIEWPORT_DIMS);
	context.__backBufferAntiAlias = 0;
	context.__backBufferEnableDepthAndStencil = true;
	context.__backBufferWantsBestResolution = false;
	context.__frameCount = 0;
	context.__rttDepthAndStencil = false;
	context.__samplerDirty = 0;
	context.__stencilCompareMode = 0;
	context.__stencilRef = 0;
	context.__stencilReadMask = 255;
	var anisoExtension = gl.__context.getExtension("EXT_texture_filter_anisotropic");
	if(anisoExtension == null || !Object.prototype.hasOwnProperty.call(anisoExtension,"MAX_TEXTURE_MAX_ANISOTROPY_EXT")) {
		anisoExtension = gl.__context.getExtension("MOZ_EXT_texture_filter_anisotropic");
	}
	if(anisoExtension == null || !Object.prototype.hasOwnProperty.call(anisoExtension,"MAX_TEXTURE_MAX_ANISOTROPY_EXT")) {
		anisoExtension = gl.__context.getExtension("WEBKIT_EXT_texture_filter_anisotropic");
	}
	context.__supportsPackedDepthStencil = true;
	openfl_display3D_Context3D.DEPTH_STENCIL = gl.DEPTH_STENCIL;
	context.__supportsAnisotropicFiltering = anisoExtension != null;
	if(context.__supportsAnisotropicFiltering) {
		openfl_display3D_Context3D.TEXTURE_MAX_ANISOTROPY_EXT = anisoExtension.TEXTURE_MAX_ANISOTROPY_EXT;
		var maxAnisotropy = gl.__context.getParameter(anisoExtension.MAX_TEXTURE_MAX_ANISOTROPY_EXT);
		context.__maxAnisotropyTexture2D = maxAnisotropy;
		context.__maxAnisotropyTexture2D = maxAnisotropy;
	}
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var vendor = gl.__context.getParameter(gl.VENDOR);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var version = gl.__context.getParameter(gl.VERSION);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var renderer = gl.__context.getParameter(gl.RENDERER);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var glslVersion = gl.__context.getParameter(gl.SHADING_LANGUAGE_VERSION);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	context.driverInfo = "OpenGL" + " Vendor=" + vendor + " Version=" + version + " Renderer=" + renderer + " GLSL=" + glslVersion;
};
GLContext3D.setRenderToBackBuffer = function(context) {
	var gl = context.__renderSession.gl;
	gl.__context.bindFramebuffer(gl.FRAMEBUFFER,null);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	gl.__context.frontFace(gl.CCW);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	context.__renderToTexture = null;
	context.__scissorRectangle = null;
	GLContext3D.__updateBackbufferViewport();
	GLContext3D.__updateScissorRectangle();
	GLContext3D.__updateDepthAndStencilState();
	context.__positionScale[1] = 1.0;
	if(context.__program != null) {
		context.__program.__setPositionScale(context.__positionScale);
	}
};
GLContext3D.setSamplerStateAt = function(context,sampler,wrap,filter,mipfilter) {
	if(sampler < 0 || sampler > 8) {
		throw new js__Boot_HaxeError(new openfl_errors_Error("sampler out of range"));
	}
	var gl = context.__renderSession.gl;
	var state = context.__samplerStates[sampler];
	switch(wrap) {
	case 0:
		state.set_wrapModeS(gl.CLAMP_TO_EDGE);
		state.set_wrapModeT(gl.CLAMP_TO_EDGE);
		break;
	case 1:
		state.set_wrapModeS(gl.CLAMP_TO_EDGE);
		state.set_wrapModeT(gl.REPEAT);
		break;
	case 2:
		state.set_wrapModeS(gl.REPEAT);
		state.set_wrapModeT(gl.REPEAT);
		break;
	case 3:
		state.set_wrapModeS(gl.REPEAT);
		state.set_wrapModeT(gl.CLAMP_TO_EDGE);
		break;
	default:
		throw new js__Boot_HaxeError(new openfl_errors_Error("wrap bad enum"));
	}
	switch(filter) {
	case 0:
		if(context.__supportsAnisotropicFiltering) {
			state.set_maxAniso(context.__maxAnisotropyTexture2D < 16 ? context.__maxAnisotropyTexture2D : 16);
		}
		break;
	case 1:
		if(context.__supportsAnisotropicFiltering) {
			state.set_maxAniso(context.__maxAnisotropyTexture2D < 2 ? context.__maxAnisotropyTexture2D : 2);
		}
		break;
	case 2:
		if(context.__supportsAnisotropicFiltering) {
			state.set_maxAniso(context.__maxAnisotropyTexture2D < 4 ? context.__maxAnisotropyTexture2D : 4);
		}
		break;
	case 3:
		if(context.__supportsAnisotropicFiltering) {
			state.set_maxAniso(context.__maxAnisotropyTexture2D < 8 ? context.__maxAnisotropyTexture2D : 8);
		}
		break;
	case 4:
		state.set_magFilter(gl.LINEAR);
		if(context.__supportsAnisotropicFiltering) {
			state.set_maxAniso(1);
		}
		break;
	case 5:
		state.set_magFilter(gl.NEAREST);
		if(context.__supportsAnisotropicFiltering) {
			state.set_maxAniso(1);
		}
		break;
	default:
		throw new js__Boot_HaxeError(new openfl_errors_Error("filter bad enum"));
	}
	switch(mipfilter) {
	case 0:
		state.set_minFilter(filter == 5 ? gl.NEAREST_MIPMAP_LINEAR : gl.LINEAR_MIPMAP_LINEAR);
		break;
	case 1:
		state.set_minFilter(filter == 5 ? gl.NEAREST_MIPMAP_NEAREST : gl.LINEAR_MIPMAP_NEAREST);
		break;
	case 2:
		state.set_minFilter(filter == 5 ? gl.NEAREST : gl.LINEAR);
		break;
	default:
		throw new js__Boot_HaxeError(new openfl_errors_Error("mipfiter bad enum"));
	}
};
GLContext3D.__getGLTriangleFace = function(triangleFace) {
	switch(triangleFace) {
	case 0:
		return GLContext3D.gl.BACK;
	case 1:
		return GLContext3D.gl.FRONT;
	case 2:
		return GLContext3D.gl.FRONT_AND_BACK;
	case 3:
		return GLContext3D.gl.NONE;
	default:
		return GLContext3D.gl.FRONT_AND_BACK;
	}
};
GLContext3D.clear = function(context,red,green,blue,alpha,depth,stencil,mask) {
	if(mask == null) {
		mask = 7;
	}
	if(stencil == null) {
		stencil = 0;
	}
	if(depth == null) {
		depth = 1;
	}
	if(alpha == null) {
		alpha = 1;
	}
	if(blue == null) {
		blue = 0;
	}
	if(green == null) {
		green = 0;
	}
	if(red == null) {
		red = 0;
	}
	var gl = context.__renderSession.gl;
	var clearMask = 0;
	if((mask & 1) != 0) {
		clearMask |= gl.COLOR_BUFFER_BIT;
		gl.__context.clearColor(red,green,blue,alpha);
		openfl__internal_stage3D_GLUtils.CheckGLError();
	}
	if((mask & 2) != 0) {
		clearMask |= gl.DEPTH_BUFFER_BIT;
		gl.__context.depthMask(true);
		gl.__context.clearDepth(depth);
		openfl__internal_stage3D_GLUtils.CheckGLError();
	}
	if((mask & 4) != 0) {
		clearMask |= gl.STENCIL_BUFFER_BIT;
		gl.__context.clearStencil(stencil);
		openfl__internal_stage3D_GLUtils.CheckGLError();
	}
	gl.__context.clear(clearMask);
	openfl__internal_stage3D_GLUtils.CheckGLError();
};
GLContext3D.setDepthTest = function(context,depthMask,passCompareMode) {
	var gl = context.__renderSession.gl;
	var depthTestEnabled = context.__backBufferEnableDepthAndStencil;
	if(openfl_display3D_Context3D.__stateCache.updateDepthTestEnabled(depthTestEnabled)) {
		if(depthTestEnabled) {
			gl.__context.enable(gl.DEPTH_TEST);
		} else {
			gl.__context.disable(gl.DEPTH_TEST);
		}
	}
	if(openfl_display3D_Context3D.__stateCache.updateDepthTestMask(depthMask)) {
		gl.__context.depthMask(depthMask);
	}
	if(openfl_display3D_Context3D.__stateCache.updateDepthCompareMode(passCompareMode)) {
		switch(passCompareMode) {
		case 0:
			gl.__context.depthFunc(gl.ALWAYS);
			break;
		case 1:
			gl.__context.depthFunc(gl.EQUAL);
			break;
		case 2:
			gl.__context.depthFunc(gl.GREATER);
			break;
		case 3:
			gl.__context.depthFunc(gl.GEQUAL);
			break;
		case 4:
			gl.__context.depthFunc(gl.LESS);
			break;
		case 5:
			gl.__context.depthFunc(gl.LEQUAL);
			break;
		case 6:
			gl.__context.depthFunc(gl.NEVER);
			break;
		case 7:
			gl.__context.depthFunc(gl.NOTEQUAL);
			break;
		default:
			throw new js__Boot_HaxeError(new openfl_errors_IllegalOperationError());
		}
	}
};
GLContext3D.setRenderToTexture = function(context,texture,enableDepthAndStencil,antiAlias,surfaceSelector) {
	if(surfaceSelector == null) {
		surfaceSelector = 0;
	}
	if(antiAlias == null) {
		antiAlias = 0;
	}
	if(enableDepthAndStencil == null) {
		enableDepthAndStencil = false;
	}
	var gl = context.__renderSession.gl;
	var width = 0;
	var height = 0;
	if(context.__framebuffer == null) {
		context.__framebuffer = gl.__context.createFramebuffer();
		openfl__internal_stage3D_GLUtils.CheckGLError();
	}
	gl.__context.bindFramebuffer(gl.FRAMEBUFFER,context.__framebuffer);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	if(js_Boot.__instanceof(texture,openfl_display3D_textures_Texture)) {
		var texture2D = texture;
		width = texture2D.__width;
		height = texture2D.__height;
		gl.__context.framebufferTexture2D(gl.FRAMEBUFFER,gl.COLOR_ATTACHMENT0,gl.TEXTURE_2D,texture.__textureID,0);
		openfl__internal_stage3D_GLUtils.CheckGLError();
	} else if(js_Boot.__instanceof(texture,openfl_display3D_textures_RectangleTexture)) {
		var rectTexture = texture;
		width = rectTexture.__width;
		height = rectTexture.__height;
		gl.__context.framebufferTexture2D(gl.FRAMEBUFFER,gl.COLOR_ATTACHMENT0,gl.TEXTURE_2D,texture.__textureID,0);
		openfl__internal_stage3D_GLUtils.CheckGLError();
	} else if(js_Boot.__instanceof(texture,openfl_display3D_textures_CubeTexture)) {
		var cubeTexture = texture;
		width = cubeTexture.__size;
		height = cubeTexture.__size;
		var _g = 0;
		while(_g < 6) {
			var i = _g++;
			gl.__context.framebufferTexture2D(gl.FRAMEBUFFER,gl.COLOR_ATTACHMENT0,gl.TEXTURE_CUBE_MAP_POSITIVE_X + i,texture.__textureID,0);
			openfl__internal_stage3D_GLUtils.CheckGLError();
		}
	} else {
		throw new js__Boot_HaxeError(new openfl_errors_Error("Invalid texture"));
	}
	if(enableDepthAndStencil) {
		if(context.__supportsPackedDepthStencil) {
			if(context.__depthStencilRenderBuffer == null) {
				context.__depthStencilRenderBuffer = gl.__context.createRenderbuffer();
				openfl__internal_stage3D_GLUtils.CheckGLError();
			}
			gl.__context.bindRenderbuffer(gl.RENDERBUFFER,context.__depthStencilRenderBuffer);
			openfl__internal_stage3D_GLUtils.CheckGLError();
			gl.__context.renderbufferStorage(gl.RENDERBUFFER,openfl_display3D_Context3D.DEPTH_STENCIL,width,height);
			openfl__internal_stage3D_GLUtils.CheckGLError();
			gl.__context.framebufferRenderbuffer(gl.FRAMEBUFFER,gl.DEPTH_STENCIL_ATTACHMENT,gl.RENDERBUFFER,context.__depthStencilRenderBuffer);
			openfl__internal_stage3D_GLUtils.CheckGLError();
		} else {
			if(context.__depthRenderBuffer == null) {
				context.__depthRenderBuffer = gl.__context.createRenderbuffer();
				openfl__internal_stage3D_GLUtils.CheckGLError();
			}
			if(context.__stencilRenderBuffer == null) {
				context.__stencilRenderBuffer = gl.__context.createRenderbuffer();
				openfl__internal_stage3D_GLUtils.CheckGLError();
			}
			gl.__context.bindRenderbuffer(gl.RENDERBUFFER,context.__depthRenderBuffer);
			openfl__internal_stage3D_GLUtils.CheckGLError();
			gl.__context.renderbufferStorage(gl.RENDERBUFFER,gl.DEPTH_COMPONENT16,width,height);
			openfl__internal_stage3D_GLUtils.CheckGLError();
			gl.__context.bindRenderbuffer(gl.RENDERBUFFER,context.__stencilRenderBuffer);
			openfl__internal_stage3D_GLUtils.CheckGLError();
			gl.__context.renderbufferStorage(gl.RENDERBUFFER,gl.STENCIL_INDEX8,width,height);
			openfl__internal_stage3D_GLUtils.CheckGLError();
			gl.__context.framebufferRenderbuffer(gl.FRAMEBUFFER,gl.DEPTH_ATTACHMENT,gl.RENDERBUFFER,context.__depthRenderBuffer);
			openfl__internal_stage3D_GLUtils.CheckGLError();
			gl.__context.framebufferRenderbuffer(gl.FRAMEBUFFER,gl.STENCIL_ATTACHMENT,gl.RENDERBUFFER,context.__stencilRenderBuffer);
			openfl__internal_stage3D_GLUtils.CheckGLError();
		}
		gl.__context.bindRenderbuffer(gl.RENDERBUFFER,null);
		openfl__internal_stage3D_GLUtils.CheckGLError();
	}
	GLContext3D.__setViewport(0,0,width,height);
	if(context.enableErrorChecking) {
		var code = gl.__context.checkFramebufferStatus(gl.FRAMEBUFFER);
		if(code != gl.FRAMEBUFFER_COMPLETE) {
			haxe_Log.trace("Error: Context3D.setRenderToTexture status:${code} width:${texture2D.__width} height:${texture2D.__height}",{ fileName : "GLContext3D.hx", lineNumber : 736, className : "openfl._internal.stage3D.opengl.GLContext3D", methodName : "setRenderToTexture"});
		}
	}
	context.__positionScale[1] = -1.0;
	if(context.__program != null) {
		context.__program.__setPositionScale(context.__positionScale);
	}
	gl.__context.frontFace(gl.CW);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	context.__renderToTexture = texture;
	context.__scissorRectangle = null;
	context.__rttDepthAndStencil = enableDepthAndStencil;
	GLContext3D.__updateScissorRectangle();
	GLContext3D.__updateDepthAndStencilState();
};
GLContext3D.__updateScissorRectangle = function() {
	if(GLContext3D.context.__scissorRectangle == null) {
		GLContext3D.gl.__context.disable(GLContext3D.gl.SCISSOR_TEST);
		openfl__internal_stage3D_GLUtils.CheckGLError();
		return;
	}
	GLContext3D.gl.__context.enable(GLContext3D.gl.SCISSOR_TEST);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var height = 0;
	var offsetX = 0;
	var offsetY = 0;
	if(GLContext3D.context.__renderToTexture != null) {
		if(js_Boot.__instanceof(GLContext3D.context.__renderToTexture,openfl_display3D_textures_Texture)) {
			var texture2D = GLContext3D.context.__renderToTexture;
			height = texture2D.__height;
		} else if(js_Boot.__instanceof(GLContext3D.context.__renderToTexture,openfl_display3D_textures_RectangleTexture)) {
			var rectTexture = GLContext3D.context.__renderToTexture;
			height = rectTexture.__height;
		}
	} else {
		height = GLContext3D.context.backBufferHeight;
		offsetX = GLContext3D.context.__stage3D.x | 0;
		offsetY = GLContext3D.context.__stage3D.y | 0;
	}
	GLContext3D.gl.__context.scissor((GLContext3D.context.__scissorRectangle.x | 0) + offsetX,height - (GLContext3D.context.__scissorRectangle.y | 0) - (GLContext3D.context.__scissorRectangle.height | 0) + offsetY,GLContext3D.context.__scissorRectangle.width | 0,GLContext3D.context.__scissorRectangle.height | 0);
	openfl__internal_stage3D_GLUtils.CheckGLError();
};
GLContext3D.context = null;
GLContext3D.present = function(context) {
};
GLContext3D.setProgramConstantsFromByteArray = function(context,programType,firstRegister,numRegisters,data,byteArrayOffset) {
	var gl = context.__renderSession.gl;
	if(numRegisters == -1) {
		numRegisters = (openfl_utils__ByteArray_ByteArray_Impl_.get_length(data) >> 2) - byteArrayOffset;
	}
	var isVertex = programType == 1;
	var dest = isVertex ? context.__vertexConstants : context.__fragmentConstants;
	var bytes = openfl_utils__ByteArray_ByteArray_Impl_.toBytes(data);
	var len = openfl_utils__ByteArray_ByteArray_Impl_.get_length(data);
	var floatData = len == null ? new Float32Array(bytes.b.bufferValue,0) : new Float32Array(bytes.b.bufferValue,0,len);
	var outOffset = firstRegister * 4;
	var inOffset = _UInt_UInt_Impl_.toFloat(byteArrayOffset) / _UInt_UInt_Impl_.toFloat(4) | 0;
	var _g1 = 0;
	var _g = numRegisters * 4;
	while(_g1 < _g) {
		var i = _g1++;
		dest[outOffset + i] = floatData[inOffset + i];
	}
	if(context.__program != null) {
		context.__program.__markDirty(isVertex,firstRegister,numRegisters);
	}
};
GLContext3D.__hasGLExtension = function(name) {
	return GLContext3D.gl.__context.getSupportedExtensions().indexOf(name) != -1;
};


return GLContext3D;
}());
exports.default = exports.GLContext3D = GLContext3D;
