// Package: openfl._internal.stage3D.opengl.GLCubeTexture
var openfl__internal_stage3D_GLUtils = require("../../../../openfl/_internal/stage3D/GLUtils").GLUtils;
var openfl_display3D_Context3D = require("../../../../openfl/display3D/Context3D").Context3D;
var openfl__internal_stage3D_opengl_GLTextureBase = require("../../../../openfl/_internal/stage3D/opengl/GLTextureBase").GLTextureBase;
var openfl_utils__ByteArray_ByteArray_Impl_ = require("../../../../openfl/utils/_ByteArray/ByteArray_Impl_").ByteArray_Impl_;
var js__Boot_HaxeError = require("../../../../js/_Boot/HaxeError").HaxeError;
var openfl__internal_stage3D_atf_ATFReader = require("../../../../openfl/_internal/stage3D/atf/ATFReader").ATFReader;
var openfl_errors_IllegalOperationError = require("../../../../openfl/errors/IllegalOperationError").IllegalOperationError;
var lime_utils__DataPointer_DataPointer_Impl_ = require("../../../../lime/utils/_DataPointer/DataPointer_Impl_").DataPointer_Impl_;


// Class: openfl._internal.stage3D.opengl.GLCubeTexture

var GLCubeTexture = (function () {
var GLCubeTexture = function() {};
GLCubeTexture.prototype = {
 __class__: GLCubeTexture
};
GLCubeTexture.__name__ = "openfl._internal.stage3D.opengl.GLCubeTexture";
GLCubeTexture.uploadFromByteArray = function(cubeTexture,renderSession,data,byteArrayOffset,side,miplevel) {
	if(byteArrayOffset == 0) {
		GLCubeTexture.uploadFromTypedArray(cubeTexture,renderSession,data.b,side,miplevel);
		return;
	}
	var buffer = openfl_utils__ByteArray_ByteArray_Impl_.toArrayBuffer(data);
	var this1;
	if(buffer != null) {
		this1 = new Uint8Array(buffer,byteArrayOffset);
	} else {
		this1 = null;
	}
	GLCubeTexture.uploadFromTypedArray(cubeTexture,renderSession,this1,side,miplevel);
};
GLCubeTexture.create = function(cubeTexture,renderSession) {
	var gl = renderSession.gl;
	cubeTexture.__textureTarget = gl.TEXTURE_CUBE_MAP;
	cubeTexture.__uploadedSides = 0;
};
GLCubeTexture.uploadCompressedTextureFromByteArray = function(cubeTexture,renderSession,data,byteArrayOffset) {
	var reader = new openfl__internal_stage3D_atf_ATFReader(data,byteArrayOffset);
	var alpha = reader.readHeader(cubeTexture.__size,cubeTexture.__size,true);
	var gl = renderSession.gl;
	gl.__context.bindTexture(cubeTexture.__textureTarget,cubeTexture.__textureID);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	reader.readTextures(function(side,level,gpuFormat,width,height,blockLength,bytes) {
		var format = openfl__internal_stage3D_opengl_GLTextureBase.__compressedTextureFormats.toTextureFormat(alpha,gpuFormat);
		if(format == 0) {
			return;
		}
		var target = GLCubeTexture.__sideToTarget(gl,side);
		cubeTexture.__format = format;
		gl.__context.compressedTexImage2D(target,level,cubeTexture.__format,width,height,0,lime_utils__DataPointer_DataPointer_Impl_.toBufferView(bytes,blockLength));
		openfl__internal_stage3D_GLUtils.CheckGLError();
	});
	gl.__context.bindTexture(cubeTexture.__textureTarget,null);
	openfl__internal_stage3D_GLUtils.CheckGLError();
};
GLCubeTexture.uploadFromBitmapData = function(cubeTexture,renderSession,source,side,miplevel,generateMipmap) {
	if(generateMipmap == null) {
		generateMipmap = false;
	}
	if(miplevel == null) {
		miplevel = 0;
	}
	var size = cubeTexture.__size >> miplevel;
	if(size == 0) {
		return;
	}
	var image = cubeTexture.__getImage(source);
	GLCubeTexture.uploadFromTypedArray(cubeTexture,renderSession,image.get_data(),side,miplevel);
};
GLCubeTexture.setSamplerState = function(cubeTexture,renderSession,state) {
	if(!state.equals(cubeTexture.__samplerState)) {
		var gl = renderSession.gl;
		if(state.minFilter != gl.NEAREST && state.minFilter != gl.LINEAR && !state.mipmapGenerated) {
			gl.__context.generateMipmap(gl.TEXTURE_CUBE_MAP);
			openfl__internal_stage3D_GLUtils.CheckGLError();
			state.mipmapGenerated = true;
		}
		if(state.maxAniso != 0.0) {
			gl.__context.texParameterf(gl.TEXTURE_CUBE_MAP,openfl_display3D_Context3D.TEXTURE_MAX_ANISOTROPY_EXT,state.maxAniso);
			openfl__internal_stage3D_GLUtils.CheckGLError();
		}
	}
	openfl__internal_stage3D_opengl_GLTextureBase.setSamplerState(cubeTexture,renderSession,state);
};
GLCubeTexture.__sideToTarget = function(gl,side) {
	switch(side) {
	case 0:
		return gl.TEXTURE_CUBE_MAP_NEGATIVE_X;
	case 1:
		return gl.TEXTURE_CUBE_MAP_POSITIVE_X;
	case 2:
		return gl.TEXTURE_CUBE_MAP_NEGATIVE_Y;
	case 3:
		return gl.TEXTURE_CUBE_MAP_POSITIVE_Y;
	case 4:
		return gl.TEXTURE_CUBE_MAP_NEGATIVE_Z;
	case 5:
		return gl.TEXTURE_CUBE_MAP_POSITIVE_Z;
	default:
		throw new js__Boot_HaxeError(new openfl_errors_IllegalOperationError());
	}
};
GLCubeTexture.uploadFromTypedArray = function(cubeTexture,renderSession,data,side,miplevel) {
	if(data == null) {
		return;
	}
	var gl = renderSession.gl;
	var size = cubeTexture.__size >> miplevel;
	if(size == 0) {
		return;
	}
	var target = GLCubeTexture.__sideToTarget(gl,side);
	gl.__context.bindTexture(gl.TEXTURE_CUBE_MAP,cubeTexture.__textureID);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var internalformat = cubeTexture.__internalFormat;
	var format = cubeTexture.__format;
	var type = gl.UNSIGNED_BYTE;
	var data1 = lime_utils__DataPointer_DataPointer_Impl_.fromArrayBufferView(data);
	gl.__context.texImage2D(target,miplevel,internalformat,size,size,0,format,type,lime_utils__DataPointer_DataPointer_Impl_.toBufferView(data1));
	openfl__internal_stage3D_GLUtils.CheckGLError();
	gl.__context.bindTexture(cubeTexture.__textureTarget,null);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	cubeTexture.__uploadedSides |= 1 << side;
};


return GLCubeTexture;
}());
exports.default = exports.GLCubeTexture = GLCubeTexture;
