// Package: openfl._internal.stage3D.opengl.GLProgram3D
var Lambda = require("../../../../Lambda").Lambda;
var openfl__internal_stage3D_GLUtils = require("../../../../openfl/_internal/stage3D/GLUtils").GLUtils;
var js__Boot_HaxeError = require("../../../../js/_Boot/HaxeError").HaxeError;
var haxe_Log = require("../../../../haxe/Log").Log;
var StringTools = require("../../../../StringTools").StringTools;
var openfl_display3D_UniformMap = require("../../../../openfl/display3D/UniformMap").UniformMap;
var openfl__internal_stage3D_AGALConverter = require("../../../../openfl/_internal/stage3D/AGALConverter").AGALConverter;
var openfl_errors_Error = require("../../../../openfl/errors/Error").Error;
var openfl_errors_IllegalOperationError = require("../../../../openfl/errors/IllegalOperationError").IllegalOperationError;
var Std = require("../../../../Std").Std;
var List = require("../../../../List").List;
var openfl_display3D_Uniform = require("../../../../openfl/display3D/Uniform").Uniform;
var lime_utils_Log = require("../../../../lime/utils/Log").Log;
var lime_utils__DataPointer_DataPointer_Impl_ = require("../../../../lime/utils/_DataPointer/DataPointer_Impl_").DataPointer_Impl_;


// Class: openfl._internal.stage3D.opengl.GLProgram3D

var GLProgram3D = (function () {
var GLProgram3D = function() {};
GLProgram3D.prototype = {
 __class__: GLProgram3D
};
GLProgram3D.__name__ = "openfl._internal.stage3D.opengl.GLProgram3D";
GLProgram3D.__getUniformRegisters = function(uniform,index,size) {
	return uniform.regData.subarray(index,index + size);
};
GLProgram3D.__uploadFromGLSL = function(vertexShaderSource,fragmentShaderSource) {
	var gl = GLProgram3D.renderSession.gl;
	GLProgram3D.__deleteShaders();
	if(lime_utils_Log.level == 5) {
		lime_utils_Log.info(vertexShaderSource,{ fileName : "GLProgram3D.hx", lineNumber : 322, className : "openfl._internal.stage3D.opengl.GLProgram3D", methodName : "__uploadFromGLSL"});
		lime_utils_Log.info(fragmentShaderSource,{ fileName : "GLProgram3D.hx", lineNumber : 323, className : "openfl._internal.stage3D.opengl.GLProgram3D", methodName : "__uploadFromGLSL"});
	}
	GLProgram3D.program.__vertexSource = vertexShaderSource;
	GLProgram3D.program.__fragmentSource = fragmentShaderSource;
	var tmp = gl.__context.createShader(gl.VERTEX_SHADER);
	GLProgram3D.program.__vertexShaderID = tmp;
	gl.__context.shaderSource(GLProgram3D.program.__vertexShaderID,vertexShaderSource);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	gl.__context.compileShader(GLProgram3D.program.__vertexShaderID);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var shaderCompiled = gl.__context.getShaderParameter(GLProgram3D.program.__vertexShaderID,gl.COMPILE_STATUS);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	if(shaderCompiled == 0) {
		var vertexInfoLog = gl.__context.getShaderInfoLog(GLProgram3D.program.__vertexShaderID);
		if(vertexInfoLog != null && vertexInfoLog.length != 0) {
			haxe_Log.trace("vertex: " + vertexInfoLog,{ fileName : "GLProgram3D.hx", lineNumber : 347, className : "openfl._internal.stage3D.opengl.GLProgram3D", methodName : "__uploadFromGLSL"});
		}
		throw new js__Boot_HaxeError(new openfl_errors_Error("Error compiling vertex shader: " + vertexInfoLog));
	}
	var tmp1 = gl.__context.createShader(gl.FRAGMENT_SHADER);
	GLProgram3D.program.__fragmentShaderID = tmp1;
	gl.__context.shaderSource(GLProgram3D.program.__fragmentShaderID,fragmentShaderSource);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	gl.__context.compileShader(GLProgram3D.program.__fragmentShaderID);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var fragmentCompiled = gl.__context.getShaderParameter(GLProgram3D.program.__fragmentShaderID,gl.COMPILE_STATUS);
	if(fragmentCompiled == 0) {
		var fragmentInfoLog = gl.__context.getShaderInfoLog(GLProgram3D.program.__fragmentShaderID);
		if(fragmentInfoLog != null && fragmentInfoLog.length != 0) {
			haxe_Log.trace("fragment: " + fragmentInfoLog,{ fileName : "GLProgram3D.hx", lineNumber : 370, className : "openfl._internal.stage3D.opengl.GLProgram3D", methodName : "__uploadFromGLSL"});
		}
		throw new js__Boot_HaxeError(new openfl_errors_Error("Error compiling fragment shader: " + fragmentInfoLog));
	}
	GLProgram3D.program.__programID = gl.__context.createProgram();
	gl.__context.attachShader(GLProgram3D.program.__programID,GLProgram3D.program.__vertexShaderID);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	gl.__context.attachShader(GLProgram3D.program.__programID,GLProgram3D.program.__fragmentShaderID);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var _g = 0;
	while(_g < 16) {
		var i = _g++;
		var name = "va" + i;
		if(vertexShaderSource.indexOf(" " + name) != -1) {
			gl.__context.bindAttribLocation(GLProgram3D.program.__programID,i,name);
		}
	}
	gl.__context.linkProgram(GLProgram3D.program.__programID);
	var infoLog = gl.__context.getProgramInfoLog(GLProgram3D.program.__programID);
	if(infoLog != null && infoLog.length != 0) {
		haxe_Log.trace("program: " + infoLog,{ fileName : "GLProgram3D.hx", lineNumber : 403, className : "openfl._internal.stage3D.opengl.GLProgram3D", methodName : "__uploadFromGLSL"});
	}
	GLProgram3D.__buildUniformList();
};
GLProgram3D.__deleteShaders = function() {
	var gl = GLProgram3D.renderSession.gl;
	if(GLProgram3D.program.__programID != null) {
		GLProgram3D.program.__programID = null;
	}
	if(GLProgram3D.program.__vertexShaderID != null) {
		gl.__context.deleteShader(GLProgram3D.program.__vertexShaderID);
		openfl__internal_stage3D_GLUtils.CheckGLError();
		GLProgram3D.program.__vertexShaderID = null;
	}
	if(GLProgram3D.program.__fragmentShaderID != null) {
		gl.__context.deleteShader(GLProgram3D.program.__fragmentShaderID);
		openfl__internal_stage3D_GLUtils.CheckGLError();
		GLProgram3D.program.__fragmentShaderID = null;
	}
};
GLProgram3D.setPositionScale = function(program,renderSession,positionScale) {
	var gl = renderSession.gl;
	var location = program.__positionScale.location;
	var v = lime_utils__DataPointer_DataPointer_Impl_.fromArrayBufferView(positionScale);
	gl.__context.uniform4fv(location,lime_utils__DataPointer_DataPointer_Impl_.toFloat32Array(v,16));
	openfl__internal_stage3D_GLUtils.CheckGLError();
};
GLProgram3D.renderSession = null;
GLProgram3D.dispose = function(program,renderSession) {
	GLProgram3D.program = program;
	GLProgram3D.renderSession = renderSession;
	GLProgram3D.__deleteShaders();
};
GLProgram3D.program = null;
GLProgram3D.flushUniform = function(uniform,gl) {
	var index = uniform.regIndex * 4;
	var _g = uniform.type;
	switch(_g) {
	case 35664:
		var location = uniform.location;
		var count = uniform.regCount;
		var v = lime_utils__DataPointer_DataPointer_Impl_.fromArrayBufferView(uniform.regData.subarray(index,index + uniform.regCount * 2));
		gl.__context.uniform2fv(location,lime_utils__DataPointer_DataPointer_Impl_.toFloat32Array(v,count * 4 * 2));
		break;
	case 35665:
		var location1 = uniform.location;
		var count1 = uniform.regCount;
		var v1 = lime_utils__DataPointer_DataPointer_Impl_.fromArrayBufferView(uniform.regData.subarray(index,index + uniform.regCount * 3));
		gl.__context.uniform3fv(location1,lime_utils__DataPointer_DataPointer_Impl_.toFloat32Array(v1,count1 * 4 * 3));
		break;
	case 35666:
		var location2 = uniform.location;
		var count2 = uniform.regCount;
		var v2 = lime_utils__DataPointer_DataPointer_Impl_.fromArrayBufferView(uniform.regData.subarray(index,index + uniform.regCount * 4));
		gl.__context.uniform4fv(location2,lime_utils__DataPointer_DataPointer_Impl_.toFloat32Array(v2,count2 * 4 * 4));
		break;
	case 35674:
		var location3 = uniform.location;
		var count3 = uniform.size;
		var v3 = lime_utils__DataPointer_DataPointer_Impl_.fromArrayBufferView(uniform.regData.subarray(index,index + uniform.size * 2 * 2));
		gl.__context.uniformMatrix2fv(location3,false,lime_utils__DataPointer_DataPointer_Impl_.toFloat32Array(v3,count3 * 4 * 4));
		break;
	case 35675:
		var location4 = uniform.location;
		var count4 = uniform.size;
		var v4 = lime_utils__DataPointer_DataPointer_Impl_.fromArrayBufferView(uniform.regData.subarray(index,index + uniform.size * 3 * 3));
		gl.__context.uniformMatrix3fv(location4,false,lime_utils__DataPointer_DataPointer_Impl_.toFloat32Array(v4,count4 * 4 * 9));
		break;
	case 35676:
		var location5 = uniform.location;
		var count5 = uniform.size;
		var v5 = lime_utils__DataPointer_DataPointer_Impl_.fromArrayBufferView(uniform.regData.subarray(index,index + uniform.size * 4 * 4));
		gl.__context.uniformMatrix4fv(location5,false,lime_utils__DataPointer_DataPointer_Impl_.toFloat32Array(v5,count5 * 4 * 16));
		break;
	default:
		var location6 = uniform.location;
		var count6 = uniform.regCount;
		var v6 = lime_utils__DataPointer_DataPointer_Impl_.fromArrayBufferView(uniform.regData.subarray(index,index + uniform.regCount * 4));
		gl.__context.uniform4fv(location6,lime_utils__DataPointer_DataPointer_Impl_.toFloat32Array(v6,count6 * 4 * 4));
	}
	openfl__internal_stage3D_GLUtils.CheckGLError();
};
GLProgram3D.upload = function(program,renderSession,vertexProgram,fragmentProgram) {
	GLProgram3D.program = program;
	GLProgram3D.renderSession = renderSession;
	var samplerStates = [];
	var glslVertex = openfl__internal_stage3D_AGALConverter.convertToGLSL(vertexProgram,null);
	var glslFragment = openfl__internal_stage3D_AGALConverter.convertToGLSL(fragmentProgram,samplerStates);
	GLProgram3D.__uploadFromGLSL(glslVertex,glslFragment);
	var _g1 = 0;
	var _g = samplerStates.length;
	while(_g1 < _g) {
		var i = _g1++;
		program.__samplerStates.data.set(i,samplerStates[i]);
	}
};
GLProgram3D.__buildUniformList = function() {
	var gl = GLProgram3D.renderSession.gl;
	GLProgram3D.program.__uniforms.clear();
	GLProgram3D.program.__samplerUniforms.clear();
	GLProgram3D.program.__alphaSamplerUniforms.clear();
	GLProgram3D.program.__samplerUsageMask = 0;
	var numActive = 0;
	numActive = gl.__context.getProgramParameter(GLProgram3D.program.__programID,gl.ACTIVE_UNIFORMS);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var vertexUniforms = new List();
	var fragmentUniforms = new List();
	var _g1 = 0;
	var _g = numActive;
	while(_g1 < _g) {
		var i = _g1++;
		var info = gl.__context.getActiveUniform(GLProgram3D.program.__programID,i);
		var name = info.name;
		var size = info.size;
		var uniformType = info.type;
		openfl__internal_stage3D_GLUtils.CheckGLError();
		var uniform = new openfl_display3D_Uniform(gl);
		uniform.name = name;
		uniform.size = size;
		uniform.type = uniformType;
		uniform.location = gl.__context.getUniformLocation(GLProgram3D.program.__programID,uniform.name);
		openfl__internal_stage3D_GLUtils.CheckGLError();
		var indexBracket = uniform.name.indexOf("[");
		if(indexBracket >= 0) {
			uniform.name = uniform.name.substring(0,indexBracket);
		}
		var _g2 = uniform.type;
		switch(_g2) {
		case 35674:
			uniform.regCount = 2;
			break;
		case 35675:
			uniform.regCount = 3;
			break;
		case 35676:
			uniform.regCount = 4;
			break;
		default:
			uniform.regCount = 1;
		}
		uniform.regCount *= uniform.size;
		GLProgram3D.program.__uniforms.add(uniform);
		if(uniform.name == "vcPositionScale") {
			GLProgram3D.program.__positionScale = uniform;
		} else if(StringTools.startsWith(uniform.name,"vc")) {
			uniform.regIndex = Std.parseInt(uniform.name.substring(2));
			uniform.regData = GLProgram3D.program.__context.__vertexConstants;
			vertexUniforms.add(uniform);
		} else if(StringTools.startsWith(uniform.name,"fc")) {
			uniform.regIndex = Std.parseInt(uniform.name.substring(2));
			uniform.regData = GLProgram3D.program.__context.__fragmentConstants;
			fragmentUniforms.add(uniform);
		} else if(StringTools.startsWith(uniform.name,"sampler") && !StringTools.endsWith(uniform.name,"_alpha")) {
			uniform.regIndex = Std.parseInt(uniform.name.substring(7));
			GLProgram3D.program.__samplerUniforms.add(uniform);
			var _g4 = 0;
			var _g3 = uniform.regCount;
			while(_g4 < _g3) {
				var reg = _g4++;
				GLProgram3D.program.__samplerUsageMask |= 1 << uniform.regIndex + reg;
			}
		} else if(StringTools.startsWith(uniform.name,"sampler") && StringTools.endsWith(uniform.name,"_alpha")) {
			var len = uniform.name.indexOf("_") - 7;
			uniform.regIndex = Std.parseInt(uniform.name.substring(7,7 + len)) + 4;
			GLProgram3D.program.__alphaSamplerUniforms.add(uniform);
		}
		if(lime_utils_Log.level == 5) {
			haxe_Log.trace("" + i + " name:" + uniform.name + " type:" + uniform.type + " size:" + uniform.size + " location:" + Std.string(uniform.location),{ fileName : "GLProgram3D.hx", lineNumber : 247, className : "openfl._internal.stage3D.opengl.GLProgram3D", methodName : "__buildUniformList"});
		}
	}
	var tmp = Lambda.array(vertexUniforms);
	GLProgram3D.program.__vertexUniformMap = new openfl_display3D_UniformMap(tmp);
	var tmp1 = Lambda.array(fragmentUniforms);
	GLProgram3D.program.__fragmentUniformMap = new openfl_display3D_UniformMap(tmp1);
};
GLProgram3D["use"] = function(program,renderSession) {
	var gl = renderSession.gl;
	gl.__context.useProgram(program.__programID);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	program.__vertexUniformMap.markAllDirty();
	program.__fragmentUniformMap.markAllDirty();
	var _g_head = program.__samplerUniforms.h;
	while(_g_head != null) {
		var val = _g_head.item;
		_g_head = _g_head.next;
		var sampler = val;
		if(sampler.regCount == 1) {
			gl.__context.uniform1i(sampler.location,sampler.regIndex);
			openfl__internal_stage3D_GLUtils.CheckGLError();
		} else {
			throw new js__Boot_HaxeError(new openfl_errors_IllegalOperationError("!!! TODO: uniform location on webgl"));
		}
	}
	var _g_head1 = program.__alphaSamplerUniforms.h;
	while(_g_head1 != null) {
		var val1 = _g_head1.item;
		_g_head1 = _g_head1.next;
		var sampler1 = val1;
		if(sampler1.regCount == 1) {
			gl.__context.uniform1i(sampler1.location,sampler1.regIndex);
			openfl__internal_stage3D_GLUtils.CheckGLError();
		} else {
			throw new js__Boot_HaxeError(new openfl_errors_IllegalOperationError("!!! TODO: uniform location on webgl"));
		}
	}
};


return GLProgram3D;
}());
exports.default = exports.GLProgram3D = GLProgram3D;
