// Package: openfl._internal.stage3D.opengl.GLRectangleTexture
var openfl__internal_stage3D_GLUtils = require("../../../../openfl/_internal/stage3D/GLUtils").GLUtils;
var openfl_display3D_Context3D = require("../../../../openfl/display3D/Context3D").Context3D;
var openfl__internal_stage3D_opengl_GLTextureBase = require("../../../../openfl/_internal/stage3D/opengl/GLTextureBase").GLTextureBase;
var openfl_utils__ByteArray_ByteArray_Impl_ = require("../../../../openfl/utils/_ByteArray/ByteArray_Impl_").ByteArray_Impl_;
var lime_utils__DataPointer_DataPointer_Impl_ = require("../../../../lime/utils/_DataPointer/DataPointer_Impl_").DataPointer_Impl_;


// Class: openfl._internal.stage3D.opengl.GLRectangleTexture

var GLRectangleTexture = (function () {
var GLRectangleTexture = function() {};
GLRectangleTexture.prototype = {
 __class__: GLRectangleTexture
};
GLRectangleTexture.__name__ = "openfl._internal.stage3D.opengl.GLRectangleTexture";
GLRectangleTexture.uploadFromByteArray = function(rectangleTexture,renderSession,data,byteArrayOffset) {
	if(byteArrayOffset == 0) {
		GLRectangleTexture.uploadFromTypedArray(rectangleTexture,renderSession,data.b);
		return;
	}
	var buffer = openfl_utils__ByteArray_ByteArray_Impl_.toArrayBuffer(data);
	var this1;
	if(buffer != null) {
		this1 = new Uint8Array(buffer,byteArrayOffset);
	} else {
		this1 = null;
	}
	GLRectangleTexture.uploadFromTypedArray(rectangleTexture,renderSession,this1);
};
GLRectangleTexture.create = function(rectangleTexture,renderSession) {
	var gl = renderSession.gl;
	rectangleTexture.__textureTarget = gl.TEXTURE_2D;
	GLRectangleTexture.uploadFromTypedArray(rectangleTexture,renderSession,null);
};
GLRectangleTexture.uploadFromBitmapData = function(rectangleTexture,renderSession,source) {
	if(source == null) {
		return;
	}
	var image = rectangleTexture.__getImage(source);
	if(image == null) {
		return;
	}
	GLRectangleTexture.uploadFromTypedArray(rectangleTexture,renderSession,image.get_data());
};
GLRectangleTexture.setSamplerState = function(rectangleTexture,renderSession,state) {
	if(!state.equals(rectangleTexture.__samplerState)) {
		var gl = renderSession.gl;
		if(state.maxAniso != 0.0) {
			gl.__context.texParameterf(gl.TEXTURE_2D,openfl_display3D_Context3D.TEXTURE_MAX_ANISOTROPY_EXT,state.maxAniso);
			openfl__internal_stage3D_GLUtils.CheckGLError();
		}
	}
	openfl__internal_stage3D_opengl_GLTextureBase.setSamplerState(rectangleTexture,renderSession,state);
};
GLRectangleTexture.uploadFromTypedArray = function(rectangleTexture,renderSession,data) {
	var gl = renderSession.gl;
	gl.__context.bindTexture(rectangleTexture.__textureTarget,rectangleTexture.__textureID);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var target = rectangleTexture.__textureTarget;
	var internalformat = rectangleTexture.__internalFormat;
	var width = rectangleTexture.__width;
	var height = rectangleTexture.__height;
	var format = rectangleTexture.__format;
	var type = gl.UNSIGNED_BYTE;
	var data1 = lime_utils__DataPointer_DataPointer_Impl_.fromArrayBufferView(data);
	gl.__context.texImage2D(target,0,internalformat,width,height,0,format,type,lime_utils__DataPointer_DataPointer_Impl_.toBufferView(data1));
	openfl__internal_stage3D_GLUtils.CheckGLError();
	gl.__context.bindTexture(rectangleTexture.__textureTarget,null);
	openfl__internal_stage3D_GLUtils.CheckGLError();
};


return GLRectangleTexture;
}());
exports.default = exports.GLRectangleTexture = GLRectangleTexture;
