// Package: openfl._internal.stage3D.opengl.GLTexture
var openfl__internal_stage3D_GLUtils = require("../../../../openfl/_internal/stage3D/GLUtils").GLUtils;
var openfl_display3D_Context3D = require("../../../../openfl/display3D/Context3D").Context3D;
var openfl__internal_stage3D_opengl_GLTextureBase = require("../../../../openfl/_internal/stage3D/opengl/GLTextureBase").GLTextureBase;
var openfl_utils__ByteArray_ByteArray_Impl_ = require("../../../../openfl/utils/_ByteArray/ByteArray_Impl_").ByteArray_Impl_;
var openfl__internal_stage3D_atf_ATFReader = require("../../../../openfl/_internal/stage3D/atf/ATFReader").ATFReader;
var lime_utils__DataPointer_DataPointer_Impl_ = require("../../../../lime/utils/_DataPointer/DataPointer_Impl_").DataPointer_Impl_;
var openfl_display_BitmapData = require("../../../../openfl/display/BitmapData").BitmapData;


// Class: openfl._internal.stage3D.opengl.GLTexture

var GLTexture = (function () {
var GLTexture = function() {};
GLTexture.prototype = {
 __class__: GLTexture
};
GLTexture.__name__ = "openfl._internal.stage3D.opengl.GLTexture";
GLTexture.uploadFromByteArray = function(texture,renderSession,data,byteArrayOffset,miplevel) {
	if(miplevel == null) {
		miplevel = 0;
	}
	if(byteArrayOffset == 0) {
		GLTexture.uploadFromTypedArray(texture,renderSession,data.b,miplevel);
		return;
	}
	var buffer = openfl_utils__ByteArray_ByteArray_Impl_.toArrayBuffer(data);
	var this1;
	if(buffer != null) {
		this1 = new Uint8Array(buffer,byteArrayOffset);
	} else {
		this1 = null;
	}
	GLTexture.uploadFromTypedArray(texture,renderSession,this1,miplevel);
};
GLTexture.create = function(texture,renderSession) {
	var gl = renderSession.gl;
	texture.__textureTarget = gl.TEXTURE_2D;
	gl.__context.bindTexture(texture.__textureTarget,texture.__textureID);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var target = texture.__textureTarget;
	var internalformat = texture.__internalFormat;
	var width = texture.__width;
	var height = texture.__height;
	var format = texture.__format;
	var type = gl.UNSIGNED_BYTE;
	var data = lime_utils__DataPointer_DataPointer_Impl_.fromInt(0);
	gl.__context.texImage2D(target,0,internalformat,width,height,0,format,type,lime_utils__DataPointer_DataPointer_Impl_.toBufferView(data));
	openfl__internal_stage3D_GLUtils.CheckGLError();
	gl.__context.bindTexture(texture.__textureTarget,null);
	GLTexture.uploadFromTypedArray(texture,renderSession,null);
};
GLTexture.uploadCompressedTextureFromByteArray = function(texture,renderSession,data,byteArrayOffset) {
	var reader = new openfl__internal_stage3D_atf_ATFReader(data,byteArrayOffset);
	var alpha = reader.readHeader(texture.__width,texture.__height,false);
	var gl = renderSession.gl;
	gl.__context.bindTexture(texture.__textureTarget,texture.__textureID);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	reader.readTextures(function(target,level,gpuFormat,width,height,blockLength,bytes) {
		var format = openfl__internal_stage3D_opengl_GLTextureBase.__compressedTextureFormats.toTextureFormat(alpha,gpuFormat);
		if(format == 0) {
			return;
		}
		texture.__format = format;
		gl.__context.compressedTexImage2D(texture.__textureTarget,level,texture.__format,width,height,0,lime_utils__DataPointer_DataPointer_Impl_.toBufferView(bytes,blockLength));
		openfl__internal_stage3D_GLUtils.CheckGLError();
	});
	gl.__context.bindTexture(texture.__textureTarget,null);
	openfl__internal_stage3D_GLUtils.CheckGLError();
};
GLTexture.uploadFromBitmapData = function(texture,renderSession,source,miplevel,generateMipmap) {
	if(source == null) {
		return;
	}
	var width = texture.__width >> miplevel;
	var height = texture.__height >> miplevel;
	if(width == 0 && height == 0) {
		return;
	}
	if(width == 0) {
		width = 1;
	}
	if(height == 0) {
		height = 1;
	}
	if(source.width != width || source.height != height) {
		var copy = new openfl_display_BitmapData(width,height,true,0);
		copy.draw(source);
		source = copy;
	}
	var image = texture.__getImage(source);
	GLTexture.uploadFromTypedArray(texture,renderSession,image.get_data(),miplevel);
};
GLTexture.setSamplerState = function(texture,renderSession,state) {
	if(!state.equals(texture.__samplerState)) {
		var gl = renderSession.gl;
		if(state.minFilter != gl.NEAREST && state.minFilter != gl.LINEAR && !state.mipmapGenerated) {
			gl.__context.generateMipmap(gl.TEXTURE_2D);
			openfl__internal_stage3D_GLUtils.CheckGLError();
			state.mipmapGenerated = true;
		}
		if(state.maxAniso != 0.0) {
			gl.__context.texParameterf(gl.TEXTURE_2D,openfl_display3D_Context3D.TEXTURE_MAX_ANISOTROPY_EXT,state.maxAniso);
			openfl__internal_stage3D_GLUtils.CheckGLError();
		}
	}
	openfl__internal_stage3D_opengl_GLTextureBase.setSamplerState(texture,renderSession,state);
};
GLTexture.uploadFromTypedArray = function(texture,renderSession,data,miplevel) {
	if(miplevel == null) {
		miplevel = 0;
	}
	if(data == null) {
		return;
	}
	var gl = renderSession.gl;
	var width = texture.__width >> miplevel;
	var height = texture.__height >> miplevel;
	if(width == 0 && height == 0) {
		return;
	}
	if(width == 0) {
		width = 1;
	}
	if(height == 0) {
		height = 1;
	}
	gl.__context.bindTexture(texture.__textureTarget,texture.__textureID);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	var target = texture.__textureTarget;
	var internalformat = texture.__internalFormat;
	var format = texture.__format;
	var type = gl.UNSIGNED_BYTE;
	var data1 = lime_utils__DataPointer_DataPointer_Impl_.fromArrayBufferView(data);
	gl.__context.texImage2D(target,miplevel,internalformat,width,height,0,format,type,lime_utils__DataPointer_DataPointer_Impl_.toBufferView(data1));
	openfl__internal_stage3D_GLUtils.CheckGLError();
	gl.__context.bindTexture(texture.__textureTarget,null);
	openfl__internal_stage3D_GLUtils.CheckGLError();
};


return GLTexture;
}());
exports.default = exports.GLTexture = GLTexture;
