// Package: openfl._internal.stage3D.opengl.GLTextureBase
var lime_graphics_ImageType = require("../../../../lime/graphics/ImageType").ImageType;
var openfl__internal_stage3D_GLUtils = require("../../../../openfl/_internal/stage3D/GLUtils").GLUtils;
var lime_graphics_utils_ImageCanvasUtil = require("../../../../lime/graphics/utils/ImageCanvasUtil").ImageCanvasUtil;
var openfl__internal_stage3D_GLCompressedTextureFormats = require("../../../../openfl/_internal/stage3D/GLCompressedTextureFormats").GLCompressedTextureFormats;
var lime_graphics_opengl_GLContextType = require("../../../../lime/graphics/opengl/GLContextType").GLContextType;


// Class: openfl._internal.stage3D.opengl.GLTextureBase

var GLTextureBase = (function () {
var GLTextureBase = function() {};
GLTextureBase.prototype = {
 __class__: GLTextureBase
};
GLTextureBase.__name__ = "openfl._internal.stage3D.opengl.GLTextureBase";
GLTextureBase.create = function(textureBase,renderSession) {
	var gl = renderSession.gl;
	textureBase.__textureID = gl.__context.createTexture();
	textureBase.__textureContext = gl;
	if(GLTextureBase.__supportsBGRA == null) {
		GLTextureBase.__textureInternalFormat = gl.RGBA;
		var bgraExtension = null;
		if(bgraExtension != null) {
			GLTextureBase.__supportsBGRA = true;
			GLTextureBase.__textureFormat = bgraExtension.BGRA_EXT;
			if(gl.type == lime_graphics_opengl_GLContextType.GLES) {
				GLTextureBase.__textureInternalFormat = bgraExtension.BGRA_EXT;
			}
		} else {
			GLTextureBase.__supportsBGRA = false;
			GLTextureBase.__textureFormat = gl.RGBA;
		}
	}
	if(GLTextureBase.__compressedTextureFormats == null) {
		GLTextureBase.__compressedTextureFormats = new openfl__internal_stage3D_GLCompressedTextureFormats(gl);
	}
	textureBase.__internalFormat = GLTextureBase.__textureInternalFormat;
	textureBase.__format = GLTextureBase.__textureFormat;
};
GLTextureBase.__supportsBGRA = null;
GLTextureBase.__textureFormat = null;
GLTextureBase.dispose = function(textureBase,renderSession) {
	var gl = renderSession.gl;
	if(textureBase.__alphaTexture != null) {
		textureBase.__alphaTexture.dispose();
	}
	gl.__context.deleteTexture(textureBase.__textureID);
};
GLTextureBase.setSamplerState = function(textureBase,renderSession,state) {
	if(!state.equals(textureBase.__samplerState)) {
		var gl = renderSession.gl;
		gl.__context.bindTexture(textureBase.__textureTarget,textureBase.__textureID);
		openfl__internal_stage3D_GLUtils.CheckGLError();
		gl.__context.texParameteri(textureBase.__textureTarget,gl.TEXTURE_MIN_FILTER,state.minFilter);
		openfl__internal_stage3D_GLUtils.CheckGLError();
		gl.__context.texParameteri(textureBase.__textureTarget,gl.TEXTURE_MAG_FILTER,state.magFilter);
		openfl__internal_stage3D_GLUtils.CheckGLError();
		gl.__context.texParameteri(textureBase.__textureTarget,gl.TEXTURE_WRAP_S,state.wrapModeS);
		openfl__internal_stage3D_GLUtils.CheckGLError();
		gl.__context.texParameteri(textureBase.__textureTarget,gl.TEXTURE_WRAP_T,state.wrapModeT);
		openfl__internal_stage3D_GLUtils.CheckGLError();
		var tmp = state.lodBias != 0.0;
		textureBase.__samplerState = state;
		textureBase.__samplerState.__samplerDirty = false;
	}
};
GLTextureBase.__textureInternalFormat = null;
GLTextureBase.__compressedTextureFormats = null;
GLTextureBase.getImage = function(textureBase,renderSession,bitmapData) {
	var image = bitmapData.image;
	if(!bitmapData.__isValid || image == null) {
		return null;
	}
	lime_graphics_utils_ImageCanvasUtil.sync(image,false);
	var gl = renderSession.gl;
	if(image.type != lime_graphics_ImageType.DATA && !image.get_premultiplied()) {
		gl.__context.pixelStorei(gl.UNPACK_PREMULTIPLY_ALPHA_WEBGL,1);
	} else if(!image.get_premultiplied() && image.get_transparent()) {
		gl.__context.pixelStorei(gl.UNPACK_PREMULTIPLY_ALPHA_WEBGL,0);
		image = image.clone();
		image.set_premultiplied(true);
	}
	if(image.get_format() != 0) {
		image = image.clone();
		image.set_format(0);
		image.buffer.premultiplied = true;
	}
	return image;
};


return GLTextureBase;
}());
exports.default = exports.GLTextureBase = GLTextureBase;
