// Package: openfl._internal.stage3D.opengl.GLVertexBuffer3D
var openfl__internal_stage3D_GLUtils = require("../../../../openfl/_internal/stage3D/GLUtils").GLUtils;
var openfl_utils__ByteArray_ByteArray_Impl_ = require("../../../../openfl/utils/_ByteArray/ByteArray_Impl_").ByteArray_Impl_;
var lime_graphics_opengl__WebGLContext_WebGLContext_Impl_ = require("../../../../lime/graphics/opengl/_WebGLContext/WebGLContext_Impl_").WebGLContext_Impl_;


// Class: openfl._internal.stage3D.opengl.GLVertexBuffer3D

var GLVertexBuffer3D = (function () {
var GLVertexBuffer3D = function() {};
GLVertexBuffer3D.prototype = {
 __class__: GLVertexBuffer3D
};
GLVertexBuffer3D.__name__ = "openfl._internal.stage3D.opengl.GLVertexBuffer3D";
GLVertexBuffer3D.uploadFromByteArray = function(vertexBuffer,renderSession,data,byteArrayOffset,startVertex,numVertices) {
	var offset = byteArrayOffset + startVertex * vertexBuffer.__stride;
	var length = numVertices * vertexBuffer.__vertexSize;
	var buffer = openfl_utils__ByteArray_ByteArray_Impl_.toArrayBuffer(data);
	var this1;
	if(buffer != null) {
		if(length == null) {
			this1 = new Float32Array(buffer,offset);
		} else {
			this1 = new Float32Array(buffer,offset,length);
		}
	} else {
		this1 = null;
	}
	GLVertexBuffer3D.uploadFromTypedArray(vertexBuffer,renderSession,this1);
};
GLVertexBuffer3D.uploadFromVector = function(vertexBuffer,renderSession,data,startVertex,numVertices) {
	if(data == null) {
		return;
	}
	var gl = renderSession.gl;
	var start = startVertex * vertexBuffer.__vertexSize;
	var count = numVertices * vertexBuffer.__vertexSize;
	var length = start + count;
	var existingFloat32Array = vertexBuffer.__tempFloat32Array;
	if(vertexBuffer.__tempFloat32Array == null || vertexBuffer.__tempFloat32Array.length < count) {
		var this1;
		if(count != null) {
			this1 = new Float32Array(count);
		} else {
			this1 = null;
		}
		vertexBuffer.__tempFloat32Array = this1;
		if(existingFloat32Array != null) {
			vertexBuffer.__tempFloat32Array.set(existingFloat32Array);
		}
	}
	var _g1 = start;
	var _g = length;
	while(_g1 < _g) {
		var i = _g1++;
		vertexBuffer.__tempFloat32Array[i - start] = data.data.get(i);
	}
	GLVertexBuffer3D.uploadFromTypedArray(vertexBuffer,renderSession,vertexBuffer.__tempFloat32Array);
};
GLVertexBuffer3D.create = function(vertexBuffer,renderSession,bufferUsage) {
	var gl = renderSession.gl;
	vertexBuffer.__id = gl.__context.createBuffer();
	openfl__internal_stage3D_GLUtils.CheckGLError();
	vertexBuffer.__stride = vertexBuffer.__vertexSize * 4;
	vertexBuffer.__usage = bufferUsage == 0 ? gl.DYNAMIC_DRAW : gl.STATIC_DRAW;
};
GLVertexBuffer3D.dispose = function(vertexBuffer,renderSession) {
	var gl = renderSession.gl;
	gl.__context.deleteBuffer(vertexBuffer.__id);
};
GLVertexBuffer3D.uploadFromTypedArray = function(vertexBuffer,renderSession,data) {
	if(data == null) {
		return;
	}
	var gl = renderSession.gl;
	gl.__context.bindBuffer(gl.ARRAY_BUFFER,vertexBuffer.__id);
	openfl__internal_stage3D_GLUtils.CheckGLError();
	lime_graphics_opengl__WebGLContext_WebGLContext_Impl_.bufferData(gl,gl.ARRAY_BUFFER,data,vertexBuffer.__usage);
	openfl__internal_stage3D_GLUtils.CheckGLError();
};


return GLVertexBuffer3D;
}());
exports.default = exports.GLVertexBuffer3D = GLVertexBuffer3D;
