// Package: openfl.desktop.Clipboard
var openfl_Lib = require("../../openfl/Lib").Lib;
var lime_system_Clipboard = require("../../lime/system/Clipboard").Clipboard;
var Std = require("../../Std").Std;


// Class: openfl.desktop.Clipboard

var Clipboard = (function () {
var Clipboard = function() {
};
Clipboard.prototype = {
    "__properties__": {"get_formats":"get_formats"},
  formats: null,
  hasFormat: function(format) {
		if(!this.__systemClipboard) {
			switch(format) {
			case 0:
				return this.__htmlText != null;
			case 1:
				return this.__richText != null;
			case 2:
				return this.__text != null;
			default:
				return false;
			}
		} else {
			switch(format) {
			case 0:case 1:case 2:
				return lime_system_Clipboard.get_text() != null;
			default:
				return false;
			}
		}
	},
  __htmlText: null,
  setDataHandler: function(format,handler,serializable) {
		if(serializable == null) {
			serializable = true;
		}
		openfl_Lib.notImplemented({ fileName : "Clipboard.hx", lineNumber : 200, className : "openfl.desktop.Clipboard", methodName : "setDataHandler"});
		return false;
	},
  __richText: null,
  getData: function(format,transferMode) {
		if(transferMode == null) {
			transferMode = 3;
		}
		if(!this.__systemClipboard) {
			switch(format) {
			case 0:
				return this.__htmlText;
			case 1:
				return this.__richText;
			case 2:
				return this.__text;
			default:
				return null;
			}
		} else {
			switch(format) {
			case 0:case 1:case 2:
				return lime_system_Clipboard.get_text();
			default:
				return null;
			}
		}
	},
  __systemClipboard: null,
  __text: null,
  clear: function() {
		if(!this.__systemClipboard) {
			this.__htmlText = null;
			this.__richText = null;
			this.__text = null;
		} else {
			lime_system_Clipboard.set_text(null);
		}
	},
  get_formats: function() {
		var formats = [2];
		if(this.hasFormat(0)) {
			formats.push(0);
		}
		if(this.hasFormat(1)) {
			formats.push(1);
		}
		if(this.hasFormat(2)) {
			formats.push(2);
		}
		return formats;
	},
  clearData: function(format) {
		if(!this.__systemClipboard) {
			switch(format) {
			case 0:
				this.__htmlText = null;
				break;
			case 1:
				this.__richText = null;
				break;
			case 2:
				this.__text = null;
				break;
			default:
			}
		} else {
			switch(format) {
			case 0:case 1:case 2:
				lime_system_Clipboard.set_text(null);
				break;
			default:
			}
		}
	},
  setData: function(format,data,serializable) {
		if(serializable == null) {
			serializable = true;
		}
		if(!this.__systemClipboard) {
			switch(format) {
			case 0:
				this.__htmlText = Std.string(data);
				return true;
			case 1:
				this.__richText = Std.string(data);
				return true;
			case 2:
				this.__text = Std.string(data);
				return true;
			default:
				return false;
			}
		} else {
			switch(format) {
			case 0:case 1:case 2:
				lime_system_Clipboard.set_text(Std.string(data));
				return true;
			default:
				return false;
			}
		}
	},
 __class__: Clipboard
};
Clipboard.__name__ = "openfl.desktop.Clipboard";
Clipboard.get_generalClipboard = function() {
	if(Clipboard.__generalClipboard == null) {
		Clipboard.__generalClipboard = new Clipboard();
		Clipboard.__generalClipboard.__systemClipboard = true;
	}
	return Clipboard.__generalClipboard;
};
Clipboard.generalClipboard = null;
Clipboard.__generalClipboard = null;
Object.defineProperties(Clipboard.prototype, {
	"formats": { get: Clipboard.prototype.get_formats },
});



return Clipboard;
}());
exports.default = exports.Clipboard = Clipboard;
