// Package: openfl.display.GraphicsPath
var openfl__Vector_Vector_Impl_ = require("../../openfl/_Vector/Vector_Impl_").Vector_Impl_;
var openfl_display_GraphicsDataType = require("../../openfl/display/GraphicsDataType").GraphicsDataType;
var openfl_display_IGraphicsData = require("../../openfl/display/IGraphicsData").IGraphicsData;
var openfl_display_IGraphicsPath = require("../../openfl/display/IGraphicsPath").IGraphicsPath;


// Class: openfl.display.GraphicsPath

var GraphicsPath = (function () {
var GraphicsPath = function(commands,data,winding) {
	if(winding == null) {
		winding = 0;
	}
	this.commands = commands;
	this.data = data;
	this.winding = winding;
	this.__graphicsDataType = openfl_display_GraphicsDataType.PATH;
};
GraphicsPath.__interfaces__ = [openfl_display_IGraphicsPath,openfl_display_IGraphicsData];
GraphicsPath.prototype = {
  moveTo: function(x,y) {
		if(this.commands == null) {
			this.commands = openfl__Vector_Vector_Impl_.toIntVector(null);
		}
		if(this.data == null) {
			this.data = openfl__Vector_Vector_Impl_.toFloatVector(null);
		}
		this.commands.data.push(1);
		this.data.data.push(x);
		this.data.data.push(y);
	},
  __drawCircle: function(x,y,radius) {
		this.__drawRoundRect(x - radius,y - radius,radius * 2,radius * 2,radius * 2,radius * 2);
	},
  curveTo: function(controlX,controlY,anchorX,anchorY) {
		if(this.commands == null) {
			this.commands = openfl__Vector_Vector_Impl_.toIntVector(null);
		}
		if(this.data == null) {
			this.data = openfl__Vector_Vector_Impl_.toFloatVector(null);
		}
		this.commands.data.push(3);
		this.data.data.push(controlX);
		this.data.data.push(controlY);
		this.data.data.push(anchorX);
		this.data.data.push(anchorY);
	},
  wideLineTo: function(x,y) {
		if(this.commands == null) {
			this.commands = openfl__Vector_Vector_Impl_.toIntVector(null);
		}
		if(this.data == null) {
			this.data = openfl__Vector_Vector_Impl_.toFloatVector(null);
		}
		this.commands.data.push(2);
		this.data.data.push(x);
		this.data.data.push(y);
	},
  __drawEllipse: function(x,y,width,height) {
		this.__drawRoundRect(x,y,width,height,width,height);
	},
  __drawRect: function(x,y,width,height) {
		this.moveTo(x,y);
		this.lineTo(x + width,y);
		this.lineTo(x + width,y + height);
		this.lineTo(x,y + height);
		this.lineTo(x,y);
	},
  winding: null,
  __drawRoundRect: function(x,y,width,height,ellipseWidth,ellipseHeight) {
		ellipseWidth *= 0.5;
		ellipseHeight *= 0.5;
		if(ellipseWidth > width / 2) {
			ellipseWidth = width / 2;
		}
		if(ellipseHeight > height / 2) {
			ellipseHeight = height / 2;
		}
		var xe = x + width;
		var ye = y + height;
		var cx1 = -ellipseWidth + ellipseWidth * GraphicsPath.SIN45;
		var cx2 = -ellipseWidth + ellipseWidth * GraphicsPath.TAN22;
		var cy1 = -ellipseHeight + ellipseHeight * GraphicsPath.SIN45;
		var cy2 = -ellipseHeight + ellipseHeight * GraphicsPath.TAN22;
		this.moveTo(xe,ye - ellipseHeight);
		this.curveTo(xe,ye + cy2,xe + cx1,ye + cy1);
		this.curveTo(xe + cx2,ye,xe - ellipseWidth,ye);
		this.lineTo(x + ellipseWidth,ye);
		this.curveTo(x - cx2,ye,x - cx1,ye + cy1);
		this.curveTo(x,ye + cy2,x,ye - ellipseHeight);
		this.lineTo(x,y + ellipseHeight);
		this.curveTo(x,y - cy2,x - cx1,y - cy1);
		this.curveTo(x - cx2,y,x + ellipseWidth,y);
		this.lineTo(xe - ellipseWidth,y);
		this.curveTo(xe + cx2,y,xe + cx1,y - cy1);
		this.curveTo(xe,y - cy2,xe,y + ellipseHeight);
		this.lineTo(xe,ye - ellipseHeight);
	},
  data: null,
  __graphicsDataType: null,
  cubicCurveTo: function(controlX1,controlY1,controlX2,controlY2,anchorX,anchorY) {
		if(this.commands == null) {
			this.commands = openfl__Vector_Vector_Impl_.toIntVector(null);
		}
		if(this.data == null) {
			this.data = openfl__Vector_Vector_Impl_.toFloatVector(null);
		}
		this.commands.data.push(6);
		this.data.data.push(controlX1);
		this.data.data.push(controlY1);
		this.data.data.push(controlX2);
		this.data.data.push(controlY2);
		this.data.data.push(anchorX);
		this.data.data.push(anchorY);
	},
  wideMoveTo: function(x,y) {
		if(this.commands == null) {
			this.commands = openfl__Vector_Vector_Impl_.toIntVector(null);
		}
		if(this.data == null) {
			this.data = openfl__Vector_Vector_Impl_.toFloatVector(null);
		}
		this.commands.data.push(1);
		this.data.data.push(x);
		this.data.data.push(y);
	},
  commands: null,
  lineTo: function(x,y) {
		if(this.commands == null) {
			this.commands = openfl__Vector_Vector_Impl_.toIntVector(null);
		}
		if(this.data == null) {
			this.data = openfl__Vector_Vector_Impl_.toFloatVector(null);
		}
		this.commands.data.push(2);
		this.data.data.push(x);
		this.data.data.push(y);
	},
 __class__: GraphicsPath
};
GraphicsPath.__name__ = "openfl.display.GraphicsPath";
GraphicsPath.TAN22 = 0.4142135623730950488016887242097;
GraphicsPath.SIN45 = 0.70710678118654752440084436210485;


return GraphicsPath;
}());
exports.default = exports.GraphicsPath = GraphicsPath;
