// Package: openfl.display.Preloader
var openfl_Lib = require("../../openfl/Lib").Lib;
var openfl_events_ProgressEvent = require("../../openfl/events/ProgressEvent").ProgressEvent;
var lime_app_Preloader = require("../../lime/app/Preloader").Preloader;
var $bind = require("../../bind_stub").bind_stub;
var $extend = require("../../extend_stub").extend_stub;
var openfl_events_Event = require("../../openfl/events/Event").Event;


// Class: openfl.display.Preloader

var Preloader = (function () {
var Preloader = function(display) {
	lime_app_Preloader.call(this);
	this.display = display;
	if(display != null) {
		display.addEventListener("unload",$bind(this,this.display_onUnload));
		openfl_Lib.current.addChild(display);
	}
};
Preloader.__super__ = lime_app_Preloader;
Preloader.prototype = $extend(lime_app_Preloader.prototype, {
  update: function(loaded,total) {
		openfl_Lib.current.get_loaderInfo().__update(loaded,total);
		if(this.display != null) {
			this.display.dispatchEvent(new openfl_events_ProgressEvent("progress",true,true,loaded,total));
		}
	},
  ready: null,
  display_onUnload: function(event) {
		if(this.display != null) {
			this.display.removeEventListener("unload",$bind(this,this.display_onUnload));
			if(this.display.parent == openfl_Lib.current) {
				openfl_Lib.current.removeChild(this.display);
			}
			openfl_Lib.current.stage.set_focus(null);
			this.display = null;
		}
		if(this.ready && !this.simulateProgress) {
			lime_app_Preloader.prototype.start.call(this);
		}
	},
  display: null,
  start: function() {
		if(this.simulateProgress) {
			return;
		}
		this.ready = true;
		openfl_Lib.current.get_loaderInfo().__complete();
		if(this.display != null) {
			var complete = new openfl_events_Event("complete",true,true);
			this.display.dispatchEvent(complete);
			if(!complete.isDefaultPrevented()) {
				this.display.dispatchEvent(new openfl_events_Event("unload"));
			}
		} else {
			lime_app_Preloader.prototype.start.call(this);
		}
	},
 __class__: Preloader
});
Preloader.__name__ = "openfl.display.Preloader";


return Preloader;
}());
exports.default = exports.Preloader = Preloader;
