// Package: openfl.display.Stage3D
var openfl_display3D_Context3D = require("../../openfl/display3D/Context3D").Context3D;
var openfl__internal_stage3D_GLUtils = require("../../openfl/_internal/stage3D/GLUtils").GLUtils;
var lime__backend_html5_HTML5GLRenderContext = require("../../lime/_backend/html5/HTML5GLRenderContext").HTML5GLRenderContext;
var openfl_events_ErrorEvent = require("../../openfl/events/ErrorEvent").ErrorEvent;
var openfl_events_EventDispatcher = require("../../openfl/events/EventDispatcher").EventDispatcher;
var haxe_Timer = require("../../haxe/Timer").Timer;
var js_html__CanvasElement_CanvasUtil = require("../../js/html/_CanvasElement/CanvasUtil").CanvasUtil;
var $bind = require("../../bind_stub").bind_stub;
var $extend = require("../../extend_stub").extend_stub;
var openfl_events_Event = require("../../openfl/events/Event").Event;
var lime_graphics_opengl_GL = require("../../lime/graphics/opengl/GL").GL;


// Class: openfl.display.Stage3D

var Stage3D = (function () {
var Stage3D = function() {
	openfl_events_EventDispatcher.call(this);
	this.set_x(0);
	this.set_y(0);
	this.visible = true;
};
Stage3D.__super__ = openfl_events_EventDispatcher;
Stage3D.prototype = $extend(openfl_events_EventDispatcher.prototype, {
    "__properties__": {"set_x":"set_x","set_y":"set_y"},
  context3D: null,
  __renderDOM: function(stage,renderSession) {
		if(!this.visible) {
			return;
		}
		if(this.__contextRequested && this.context3D == null) {
			this.__createContext(stage,renderSession);
		}
		if(this.context3D != null) {
			lime_graphics_opengl_GL.context = this.__renderContext;
			this.__resetContext3DStates();
		}
	},
  __renderGL: function(stage,renderSession) {
		if(!this.visible) {
			return;
		}
		if(this.__contextRequested && this.context3D == null) {
			this.__createContext(stage,renderSession);
		}
		if(this.context3D != null) {
			this.__resetContext3DStates();
			if(this.context3D != null) {
				renderSession.blendModeManager.setBlendMode(null);
				if(renderSession.shaderManager.currentShader != null) {
					renderSession.shaderManager.setShader(null);
					if(this.context3D.__program != null) {
						this.context3D.__program.__use();
					}
				}
			}
			if(openfl__internal_stage3D_GLUtils.debug) {
				renderSession.gl.__context.getError();
			}
		}
	},
  set_x: function(value) {
		if(this.x == value) {
			return value;
		}
		this.x = value;
		if(this.context3D != null) {
			this.context3D.__updateBackbufferViewport();
		}
		return value;
	},
  visible: null,
  requestContext3D: function(context3DRenderMode,profile) {
		if(profile == null) {
			profile = 0;
		}
		if(context3DRenderMode == null) {
			context3DRenderMode = 0;
		}
		this.__contextRequested = true;
		if(this.context3D != null) {
			haxe_Timer.delay($bind(this,this.__dispatchCreate),1);
		}
	},
  __createContext: function(stage,renderSession) {
		this.__stage = stage;
		if(renderSession.gl != null) {
			this.context3D = new openfl_display3D_Context3D(this,renderSession);
			this.__dispatchCreate();
		} else {
			this.__canvas = window.document.createElement("canvas");
			this.__canvas.width = stage.stageWidth;
			this.__canvas.height = stage.stageHeight;
			var $window = stage.window;
			var transparentBackground = Object.prototype.hasOwnProperty.call($window.config,"background") && $window.config.background == null;
			var colorDepth = Object.prototype.hasOwnProperty.call($window.config,"colorDepth") ? $window.config.colorDepth : 16;
			var options = Object.prototype.hasOwnProperty.call($window.config,"antialiasing") && $window.config.antialiasing > 0;
			var options1 = { alpha : transparentBackground || colorDepth > 16, antialias : options, depth : Object.prototype.hasOwnProperty.call($window.config,"depthBuffer") ? $window.config.depthBuffer : true, premultipliedAlpha : true, stencil : Object.prototype.hasOwnProperty.call($window.config,"stencilBuffer") && $window.config.stencilBuffer, preserveDrawingBuffer : false};
			this.__webgl = js_html__CanvasElement_CanvasUtil.getContextWebGL(this.__canvas,options1);
			if(this.__webgl != null) {
				this.__renderContext = new lime__backend_html5_HTML5GLRenderContext(this.__webgl);
				lime_graphics_opengl_GL.context = this.__renderContext;
				this.context3D = new openfl_display3D_Context3D(this,renderSession);
				renderSession.element.appendChild(this.__canvas);
				this.__style = this.__canvas.style;
				this.__style.setProperty("position","absolute",null);
				this.__style.setProperty("top","0",null);
				this.__style.setProperty("left","0",null);
				this.__style.setProperty(renderSession.transformOriginProperty,"0 0 0",null);
				this.__style.setProperty("z-index","-1",null);
				this.__dispatchCreate();
			} else {
				this.__dispatchError();
			}
		}
	},
  __renderContext: null,
  requestContext3DMatchingProfiles: function(profiles) {
		this.requestContext3D();
	},
  __dispatchError: function() {
		this.__contextRequested = false;
		this.dispatchEvent(new openfl_events_ErrorEvent("error",false,false,"Context3D not available"));
	},
  set_y: function(value) {
		if(this.y == value) {
			return value;
		}
		this.y = value;
		if(this.context3D != null) {
			this.context3D.__updateBackbufferViewport();
		}
		return value;
	},
  __renderCairo: function(stage,renderSession) {
		if(!this.visible) {
			return;
		}
		if(this.__contextRequested) {
			this.__dispatchError();
			this.__contextRequested = false;
		}
	},
  __renderCanvas: function(stage,renderSession) {
		if(!this.visible) {
			return;
		}
		if(this.__contextRequested) {
			this.__dispatchError();
			this.__contextRequested = false;
		}
	},
  __style: null,
  __dispatchCreate: function() {
		if(this.__contextRequested) {
			this.__contextRequested = false;
			this.dispatchEvent(new openfl_events_Event("context3DCreate"));
		}
	},
  y: null,
  __canvas: null,
  __webgl: null,
  __contextRequested: null,
  x: null,
  __stage: null,
  __resize: function(width,height) {
		if(this.__canvas != null) {
			this.__canvas.width = width;
			this.__canvas.height = height;
		}
	},
  __resetContext3DStates: function() {
		this.context3D.__updateBlendFactors();
		this.context3D.__updateBackbufferViewport();
	},
 __class__: Stage3D
});
Stage3D.__name__ = "openfl.display.Stage3D";
Stage3D.__active = null;
Object.defineProperties(Stage3D.prototype, {
	"y": { set: Stage3D.prototype.set_y },
	"x": { set: Stage3D.prototype.set_x },
});



return Stage3D;
}());
exports.default = exports.Stage3D = Stage3D;
