// Package: openfl.display.Tile
var openfl_display_ITile = require("../../openfl/display/ITile").ITile;
var openfl_geom_ColorTransform = require("../../openfl/geom/ColorTransform").ColorTransform;
var openfl_geom_Matrix = require("../../openfl/geom/Matrix").Matrix;


// Class: openfl.display.Tile

var Tile = (function () {
var Tile = function(id,x,y,scaleX,scaleY,rotation,originX,originY) {
	if(originY == null) {
		originY = 0;
	}
	if(originX == null) {
		originX = 0;
	}
	if(rotation == null) {
		rotation = 0;
	}
	if(scaleY == null) {
		scaleY = 1;
	}
	if(scaleX == null) {
		scaleX = 1;
	}
	if(y == null) {
		y = 0;
	}
	if(x == null) {
		x = 0;
	}
	if(id == null) {
		id = 0;
	}
	this.__id = id;
	this.__matrix = new openfl_geom_Matrix();
	if(x != 0) {
		this.set_x(x);
	}
	if(y != 0) {
		this.set_y(y);
	}
	if(scaleX != 1) {
		this.set_scaleX(scaleX);
	}
	if(scaleY != 1) {
		this.set_scaleY(scaleY);
	}
	if(rotation != 0) {
		this.set_rotation(rotation);
	}
	this.set_originX(originX);
	this.set_originY(originY);
	this.__alpha = 1;
	this.__visible = true;
	this.__alphaDirty = true;
	this.__sourceDirty = true;
	this.__transformDirty = true;
	this.__visibleDirty = true;
};
Tile.__interfaces__ = [openfl_display_ITile];
Tile.prototype = {
    "__properties__": {"get_alpha":"get_alpha","set_alpha":"set_alpha","get_colorTransform":"get_colorTransform","set_colorTransform":"set_colorTransform","get_id":"get_id","set_id":"set_id","get_matrix":"get_matrix","set_matrix":"set_matrix","set_originX":"set_originX","set_originY":"set_originY","get_rect":"get_rect","set_rect":"set_rect","get_rotation":"get_rotation","set_rotation":"set_rotation","get_scaleX":"get_scaleX","set_scaleX":"set_scaleX","get_scaleY":"get_scaleY","set_scaleY":"set_scaleY","get_shader":"get_shader","set_shader":"set_shader","get_tileset":"get_tileset","set_tileset":"set_tileset","get_visible":"get_visible","set_visible":"set_visible","get_x":"get_x","set_x":"set_x","get_y":"get_y","set_y":"set_y"},
  __rotationSine: null,
  __scaleY: null,
  __visibleDirty: null,
  __tileset: null,
  __scaleX: null,
  set_visible: function(value) {
		this.__visibleDirty = true;
		if(this.parent != null) {
			var _this = this.parent;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
		return this.__visible = value;
	},
  get_scaleX: function() {
		if(this.__scaleX == null) {
			if(this.get_matrix().b == 0) {
				this.__scaleX = this.__matrix.a;
			} else {
				this.__scaleX = Math.sqrt(this.__matrix.a * this.__matrix.a + this.__matrix.b * this.__matrix.b);
			}
		}
		return this.__scaleX;
	},
  get_colorTransform: function() {
		if(this.__colorTransform == null) {
			this.__colorTransform = new openfl_geom_ColorTransform();
		}
		return this.__colorTransform;
	},
  get_rect: function() {
		return this.__rect;
	},
  y: null,
  __transformDirty: null,
  __updateTileArray: function(position,tileArray,forceUpdate) {
		var cachePosition = tileArray.position;
		tileArray.position = position;
		if(this.__shaderDirty || forceUpdate) {
			var value = this.__shader;
			tileArray.__shaders.data.set(tileArray.position,value);
			this.__shaderDirty = false;
		}
		if(this.__colorTransformDirty || forceUpdate) {
			tileArray.set_colorTransform(this.__colorTransform);
			this.__colorTransformDirty = false;
		}
		if(this.__visibleDirty || forceUpdate) {
			var value1 = this.__visible;
			tileArray.__visible.data.set(tileArray.position,value1);
			tileArray.__bufferDirty = true;
			this.__visibleDirty = false;
		}
		if(this.__alphaDirty || forceUpdate) {
			var value2 = this.__alpha;
			tileArray.__dirty.data.set(2 + tileArray.position * 5,true);
			tileArray.__data.data.set(11 + tileArray.position * 21,value2);
			tileArray.__bufferDirty = true;
			this.__alphaDirty = false;
		}
		if(this.__sourceDirty || forceUpdate) {
			if(this.__rect == null) {
				var value3 = this.__id;
				tileArray.__dirty.data.set(tileArray.position * 5,true);
				tileArray.__data.data.set(tileArray.position * 21,value3);
			} else {
				tileArray.set_rect(this.get_rect());
			}
			var value4 = this.__tileset;
			tileArray.__tilesets.data.set(tileArray.position,value4);
			tileArray.__bufferDirty = true;
			this.__sourceDirty = true;
		}
		if(this.__transformDirty || forceUpdate) {
			if(this.originX != 0 || this.originY != 0) {
				Tile.__tempMatrix.setTo(1,0,0,1,-this.originX,-this.originY);
				Tile.__tempMatrix.concat(this.__matrix);
				tileArray.set_matrix(Tile.__tempMatrix);
			} else {
				tileArray.set_matrix(this.__matrix);
			}
			tileArray.__bufferDirty = true;
			this.__transformDirty = false;
		}
		tileArray.position = cachePosition;
	},
  set_colorTransform: function(value) {
		if(this.__colorTransform == null) {
			if(value != null) {
				this.__colorTransform = value.__clone();
			}
		} else if(value != null) {
			this.__colorTransform.__copyFrom(value);
		} else {
			this.__colorTransform.__identity();
		}
		this.__colorTransformDirty = true;
		if(this.parent != null) {
			var _this = this.parent;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
		return value;
	},
  x: null,
  __setRenderDirty: function() {
		if(this.parent != null) {
			var _this = this.parent;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
	},
  get_x: function() {
		return this.__matrix.tx;
	},
  tileset: null,
  set_alpha: function(value) {
		this.__alphaDirty = true;
		if(this.parent != null) {
			var _this = this.parent;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
		return this.__alpha = value;
	},
  id: null,
  originX: null,
  get_scaleY: function() {
		if(this.__scaleY == null) {
			if(this.__matrix.c == 0) {
				this.__scaleY = this.get_matrix().d;
			} else {
				this.__scaleY = Math.sqrt(this.__matrix.c * this.__matrix.c + this.__matrix.d * this.__matrix.d);
			}
		}
		return this.__scaleY;
	},
  get_matrix: function() {
		return this.__matrix;
	},
  scaleY: null,
  __id: null,
  set_scaleX: function(value) {
		if(this.__scaleX != value) {
			this.__scaleX = value;
			if(this.__matrix.b == 0) {
				this.__matrix.a = value;
			} else {
				var rotation = this.get_rotation();
				var a = this.__rotationCosine * value;
				var b = this.__rotationSine * value;
				this.__matrix.a = a;
				this.__matrix.b = b;
			}
			this.__transformDirty = true;
			if(this.parent != null) {
				var _this = this.parent;
				if(!_this.__renderDirty) {
					_this.__renderDirty = true;
					_this.__setParentRenderDirty();
				}
			}
		}
		return value;
	},
  get_tileset: function() {
		return this.__tileset;
	},
  get_id: function() {
		return this.__id;
	},
  get_shader: function() {
		return this.__shader;
	},
  matrix: null,
  set_y: function(value) {
		this.__transformDirty = true;
		if(this.parent != null) {
			var _this = this.parent;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
		return this.__matrix.ty = value;
	},
  set_matrix: function(value) {
		this.__rotation = null;
		this.__scaleX = null;
		this.__scaleY = null;
		this.__transformDirty = true;
		if(this.parent != null) {
			var _this = this.parent;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
		return this.__matrix = value;
	},
  __alphaDirty: null,
  get_visible: function() {
		return this.__visible;
	},
  originY: null,
  __colorTransform: null,
  set_tileset: function(value) {
		this.__sourceDirty = true;
		if(this.parent != null) {
			var _this = this.parent;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
		return this.__tileset = value;
	},
  __rotation: null,
  shader: null,
  get_rotation: function() {
		if(this.__rotation == null) {
			if(this.__matrix.b == 0 && this.__matrix.c == 0) {
				this.__rotation = 0;
				this.__rotationSine = 0;
				this.__rotationCosine = 1;
			} else {
				var radians = Math.atan2(this.__matrix.d,this.__matrix.c) - Math.PI / 2;
				this.__rotation = radians * (180 / Math.PI);
				this.__rotationSine = Math.sin(radians);
				this.__rotationCosine = Math.cos(radians);
			}
		}
		return this.__rotation;
	},
  __rect: null,
  set_scaleY: function(value) {
		if(this.__scaleY != value) {
			this.__scaleY = value;
			if(this.__matrix.c == 0) {
				this.__matrix.d = value;
			} else {
				var rotation = this.get_rotation();
				var c = -this.__rotationSine * value;
				var d = this.__rotationCosine * value;
				this.__matrix.c = c;
				this.__matrix.d = d;
			}
			this.__transformDirty = true;
			if(this.parent != null) {
				var _this = this.parent;
				if(!_this.__renderDirty) {
					_this.__renderDirty = true;
					_this.__setParentRenderDirty();
				}
			}
		}
		return value;
	},
  set_shader: function(value) {
		this.__shaderDirty = true;
		if(this.parent != null) {
			var _this = this.parent;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
		return this.__shader = value;
	},
  visible: null,
  set_rotation: function(value) {
		if(value != this.__rotation) {
			this.__rotation = value;
			var radians = value * (Math.PI / 180);
			this.__rotationSine = Math.sin(radians);
			this.__rotationCosine = Math.cos(radians);
			var __scaleX = this.get_scaleX();
			var __scaleY = this.get_scaleY();
			this.__matrix.a = this.__rotationCosine * __scaleX;
			this.__matrix.b = this.__rotationSine * __scaleX;
			this.__matrix.c = -this.__rotationSine * __scaleY;
			this.__matrix.d = this.__rotationCosine * __scaleY;
			this.__transformDirty = true;
			if(this.parent != null) {
				var _this = this.parent;
				if(!_this.__renderDirty) {
					_this.__renderDirty = true;
					_this.__setParentRenderDirty();
				}
			}
		}
		return value;
	},
  __rotationCosine: null,
  __shader: null,
  alpha: null,
  get_alpha: function() {
		return this.__alpha;
	},
  __alpha: null,
  __visible: null,
  parent: null,
  set_originX: function(value) {
		this.__transformDirty = true;
		if(this.parent != null) {
			var _this = this.parent;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
		return this.originX = value;
	},
  scaleX: null,
  set_originY: function(value) {
		this.__transformDirty = true;
		if(this.parent != null) {
			var _this = this.parent;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
		return this.originY = value;
	},
  __matrix: null,
  set_x: function(value) {
		this.__transformDirty = true;
		if(this.parent != null) {
			var _this = this.parent;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
		return this.__matrix.tx = value;
	},
  rect: null,
  colorTransform: null,
  __sourceDirty: null,
  get_y: function() {
		return this.__matrix.ty;
	},
  data: null,
  clone: function() {
		var tile = new Tile(this.__id);
		tile.set_matrix(this.__matrix.clone());
		tile.set_tileset(this.__tileset);
		return tile;
	},
  rotation: null,
  __colorTransformDirty: null,
  __shaderDirty: null,
  set_id: function(value) {
		this.__sourceDirty = true;
		if(this.parent != null) {
			var _this = this.parent;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
		return this.__id = value;
	},
  set_rect: function(value) {
		this.__sourceDirty = true;
		if(this.parent != null) {
			var _this = this.parent;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
		return this.__rect = value;
	},
 __class__: Tile
};
Tile.__name__ = "openfl.display.Tile";
Tile.__fromTileArray = function(position,tileArray) {
	var cachePosition = tileArray.position;
	tileArray.position = position;
	var tile = new Tile();
	tile.set_alpha(tileArray.__data.data.get(11 + tileArray.position * 21));
	tile.set_id(tileArray.__data.data.get(tileArray.position * 21) | 0);
	tileArray.set_matrix(tile.get_matrix());
	tileArray.position = cachePosition;
	return tile;
};
Tile.__tempMatrix = new openfl_geom_Matrix();
Object.defineProperties(Tile.prototype, {
	"tileset": { get: Tile.prototype.get_tileset, set: Tile.prototype.set_tileset },
	"id": { get: Tile.prototype.get_id, set: Tile.prototype.set_id },
	"originX": { set: Tile.prototype.set_originX },
	"scaleX": { get: Tile.prototype.get_scaleX, set: Tile.prototype.set_scaleX },
	"shader": { get: Tile.prototype.get_shader, set: Tile.prototype.set_shader },
	"scaleY": { get: Tile.prototype.get_scaleY, set: Tile.prototype.set_scaleY },
	"rect": { get: Tile.prototype.get_rect, set: Tile.prototype.set_rect },
	"visible": { get: Tile.prototype.get_visible, set: Tile.prototype.set_visible },
	"colorTransform": { get: Tile.prototype.get_colorTransform, set: Tile.prototype.set_colorTransform },
	"matrix": { get: Tile.prototype.get_matrix, set: Tile.prototype.set_matrix },
	"alpha": { get: Tile.prototype.get_alpha, set: Tile.prototype.set_alpha },
	"rotation": { get: Tile.prototype.get_rotation, set: Tile.prototype.set_rotation },
	"y": { get: Tile.prototype.get_y, set: Tile.prototype.set_y },
	"originY": { set: Tile.prototype.set_originY },
	"x": { get: Tile.prototype.get_x, set: Tile.prototype.set_x },
});



return Tile;
}());
exports.default = exports.Tile = Tile;
