// Package: openfl.display.TileArray
var openfl__Vector_Vector_Impl_ = require("../../openfl/_Vector/Vector_Impl_").Vector_Impl_;
var openfl_display_ITile = require("../../openfl/display/ITile").ITile;
var openfl_display__TileArray_TileArrayIterator = require("../../openfl/display/_TileArray/TileArrayIterator").TileArrayIterator;
var openfl_geom_ColorTransform = require("../../openfl/geom/ColorTransform").ColorTransform;
var openfl_geom_Rectangle = require("../../openfl/geom/Rectangle").Rectangle;
var lime_utils__DataPointer_DataPointer_Impl_ = require("../../lime/utils/_DataPointer/DataPointer_Impl_").DataPointer_Impl_;
var openfl_geom_Matrix = require("../../openfl/geom/Matrix").Matrix;


// Class: openfl.display.TileArray

var TileArray = (function () {
var TileArray = function(length) {
	if(length == null) {
		length = 0;
	}
	this.__cacheAlpha = -1;
	this.__data = openfl__Vector_Vector_Impl_.toFloatVector(null,length * 21);
	this.__dirty = openfl__Vector_Vector_Impl_.toBoolVector(null,length * 5);
	this.__shaders = openfl__Vector_Vector_Impl_.toObjectVector(null,length);
	this.__tilesets = openfl__Vector_Vector_Impl_.toObjectVector(null,length);
	this.__visible = openfl__Vector_Vector_Impl_.toBoolVector(null,length);
	this.__length = length;
};
TileArray.__interfaces__ = [openfl_display_ITile];
TileArray.prototype = {
    "__properties__": {"get_alpha":"get_alpha","set_alpha":"set_alpha","get_colorTransform":"get_colorTransform","set_colorTransform":"set_colorTransform","get_id":"get_id","set_id":"set_id","get_length":"get_length","set_length":"set_length","get_matrix":"get_matrix","set_matrix":"set_matrix","get_rect":"get_rect","set_rect":"set_rect","get_shader":"get_shader","set_shader":"set_shader","get_tileset":"get_tileset","set_tileset":"set_tileset","get_visible":"get_visible","set_visible":"set_visible"},
  set_tileset: function(value) {
		this.__tilesets.data.set(this.position,value);
		return value;
	},
  __bufferDirty: null,
  shader: null,
  iterator: function() {
		return new openfl_display__TileArray_TileArrayIterator(this);
	},
  __dirty: null,
  __rect: null,
  __init: function(position) {
		this.position = position;
		this.__dirty.data.set(2 + this.position * 5,true);
		this.__data.data.set(11 + this.position * 21,1);
		this.set_colorTransform(null);
		this.__dirty.data.set(this.position * 5,true);
		this.__data.data.set(this.position * 21,0);
		this.set_matrix(null);
		this.__tilesets.data.set(this.position,null);
		this.__visible.data.set(this.position,true);
		this.__dirty.data.set(4 + position * 5,true);
	},
  set_shader: function(value) {
		this.__shaders.data.set(this.position,value);
		return value;
	},
  visible: null,
  __tilesets: null,
  get_length: function() {
		return this.__length;
	},
  set_visible: function(value) {
		this.__visible.data.set(this.position,value);
		return value;
	},
  __bufferContext: null,
  get_colorTransform: function() {
		if(this.__colorTransform == null) {
			this.__colorTransform = new openfl_geom_ColorTransform();
		}
		var i = 12 + this.position * 21;
		var tmp = this.__data.data.get(i);
		this.__colorTransform.redMultiplier = tmp;
		var tmp1 = this.__data.data.get(i + 1);
		this.__colorTransform.greenMultiplier = tmp1;
		var tmp2 = this.__data.data.get(i + 2);
		this.__colorTransform.blueMultiplier = tmp2;
		var tmp3 = this.__data.data.get(i + 3);
		this.__colorTransform.alphaMultiplier = tmp3;
		var tmp4 = this.__data.data.get(i + 4);
		this.__colorTransform.redOffset = tmp4;
		var tmp5 = this.__data.data.get(i + 5);
		this.__colorTransform.greenOffset = tmp5;
		var tmp6 = this.__data.data.get(i + 6);
		this.__colorTransform.blueOffset = tmp6;
		var tmp7 = this.__data.data.get(i + 7);
		this.__colorTransform.alphaOffset = tmp7;
		return this.__colorTransform;
	},
  alpha: null,
  __updateGLBuffer: function(gl,defaultTileset,worldAlpha,defaultColorTransform) {
		var _gthis = this;
		var attributeLength = 25;
		var stride = attributeLength * 6;
		var bufferLength = this.__length * stride;
		if(this.__bufferData == null) {
			var this1;
			if(bufferLength != null) {
				this1 = new Float32Array(bufferLength);
			} else {
				this1 = null;
			}
			this.__bufferData = this1;
			this.__bufferSkipped = openfl__Vector_Vector_Impl_.toBoolVector(null,this.__length);
			this.__bufferDirty = true;
		} else if(this.__bufferData.length != bufferLength) {
			var this2;
			if(bufferLength != null) {
				this2 = new Float32Array(bufferLength);
			} else {
				this2 = null;
			}
			var data = this2;
			if(this.__bufferData.length <= data.length) {
				data.set(this.__bufferData);
				if(this.__bufferData.length == 0) {
					this.__bufferDirty = true;
				} else {
					var cacheLength = this.__bufferData.length;
					var _g1 = cacheLength;
					var _g = bufferLength;
					while(_g1 < _g) {
						var i = _g1++;
						this.__dirty.data.set(4 + this.position * 5,true);
					}
				}
			} else {
				data.set(this.__bufferData.subarray(0,data.length));
			}
			this.__bufferData = data;
			this.__bufferSkipped.data.set_length(this.__length);
			this.__bufferDirty = true;
		}
		if(this.__buffer == null || this.__bufferContext != gl) {
			this.__bufferContext = gl;
			this.__buffer = gl.__context.createBuffer();
		}
		gl.__context.bindBuffer(gl.ARRAY_BUFFER,this.__buffer);
		if(this.__bufferDirty || this.__cacheAlpha != worldAlpha || this.__cacheDefaultTileset != defaultTileset) {
			var tileMatrix;
			var tileColorTransform;
			var tileRect = null;
			var offset = 0;
			var alpha;
			var visible;
			var tileset;
			var tileData;
			var id;
			var bitmapWidth;
			var bitmapHeight;
			var tileWidth;
			var tileHeight;
			var uvX;
			var uvY;
			var uvWidth;
			var uvHeight;
			var x;
			var y;
			var x2;
			var y2;
			var x3;
			var y3;
			var x4;
			var y4;
			var redMultiplier;
			var greenMultiplier;
			var blueMultiplier;
			var alphaMultiplier;
			var redOffset;
			var greenOffset;
			var blueOffset;
			var alphaOffset;
			this.position = 0;
			var __skipTile = function(i1,offset1) {
				var _g2 = 0;
				while(_g2 < 6) {
					var i2 = _g2++;
					_gthis.__bufferData[offset1 + attributeLength * i2 + 4] = 0;
				}
				_gthis.__bufferSkipped.data.set(i1,true);
			};
			var _g11 = 0;
			var _g3 = this.__length;
			while(_g11 < _g3) {
				var i3 = _g11++;
				this.position = i3;
				offset = i3 * stride;
				alpha = this.__data.data.get(11 + this.position * 21);
				visible = this.__visible.data.get(this.position);
				if(!visible || alpha <= 0) {
					__skipTile(i3,offset);
					continue;
				}
				tileset = this.__tilesets.data.get(this.position);
				if(tileset == null) {
					tileset = defaultTileset;
				}
				if(tileset == null) {
					__skipTile(i3,offset);
					continue;
				}
				id = this.__data.data.get(this.position * 21) | 0;
				if(id > -1) {
					if(id >= tileset.__data.length) {
						__skipTile(i3,offset);
						continue;
					}
					tileData = tileset.__data[id];
					if(tileData == null) {
						__skipTile(i3,offset);
						continue;
					}
					tileWidth = tileData.width;
					tileHeight = tileData.height;
					uvX = tileData.__uvX;
					uvY = tileData.__uvY;
					uvWidth = tileData.__uvWidth;
					uvHeight = tileData.__uvHeight;
				} else {
					tileRect = this.get_rect();
					if(tileRect == null) {
						__skipTile(i3,offset);
						continue;
					}
					tileWidth = tileRect.width;
					tileHeight = tileRect.height;
					if(tileWidth <= 0 || tileHeight <= 0) {
						__skipTile(i3,offset);
						continue;
					}
					bitmapWidth = tileset.bitmapData.width;
					bitmapHeight = tileset.bitmapData.height;
					uvX = tileRect.x / bitmapWidth;
					uvY = tileRect.y / bitmapHeight;
					uvWidth = tileRect.get_right() / bitmapWidth;
					uvHeight = tileRect.get_bottom() / bitmapHeight;
				}
				tileMatrix = this.get_matrix();
				x = 0 * tileMatrix.a + 0 * tileMatrix.c + tileMatrix.tx;
				y = 0 * tileMatrix.b + 0 * tileMatrix.d + tileMatrix.ty;
				x2 = tileWidth * tileMatrix.a + 0 * tileMatrix.c + tileMatrix.tx;
				y2 = tileWidth * tileMatrix.b + 0 * tileMatrix.d + tileMatrix.ty;
				x3 = 0 * tileMatrix.a + tileHeight * tileMatrix.c + tileMatrix.tx;
				y3 = 0 * tileMatrix.b + tileHeight * tileMatrix.d + tileMatrix.ty;
				x4 = tileWidth * tileMatrix.a + tileHeight * tileMatrix.c + tileMatrix.tx;
				y4 = tileWidth * tileMatrix.b + tileHeight * tileMatrix.d + tileMatrix.ty;
				alpha *= worldAlpha;
				tileColorTransform = this.get_colorTransform();
				tileColorTransform.__combine(defaultColorTransform);
				redMultiplier = tileColorTransform.redMultiplier;
				greenMultiplier = tileColorTransform.greenMultiplier;
				blueMultiplier = tileColorTransform.blueMultiplier;
				alphaMultiplier = tileColorTransform.alphaMultiplier;
				redOffset = tileColorTransform.redOffset;
				greenOffset = tileColorTransform.greenOffset;
				blueOffset = tileColorTransform.blueOffset;
				alphaOffset = tileColorTransform.alphaOffset;
				this.__bufferData[offset] = x;
				this.__bufferData[offset + 1] = y;
				this.__bufferData[offset + 2] = uvX;
				this.__bufferData[offset + 3] = uvY;
				this.__bufferData[offset + attributeLength] = x2;
				this.__bufferData[offset + attributeLength + 1] = y2;
				this.__bufferData[offset + attributeLength + 2] = uvWidth;
				this.__bufferData[offset + attributeLength + 3] = uvY;
				this.__bufferData[offset + attributeLength * 2] = x3;
				this.__bufferData[offset + attributeLength * 2 + 1] = y3;
				this.__bufferData[offset + attributeLength * 2 + 2] = uvX;
				this.__bufferData[offset + attributeLength * 2 + 3] = uvHeight;
				this.__bufferData[offset + attributeLength * 3] = x3;
				this.__bufferData[offset + attributeLength * 3 + 1] = y3;
				this.__bufferData[offset + attributeLength * 3 + 2] = uvX;
				this.__bufferData[offset + attributeLength * 3 + 3] = uvHeight;
				this.__bufferData[offset + attributeLength * 4] = x2;
				this.__bufferData[offset + attributeLength * 4 + 1] = y2;
				this.__bufferData[offset + attributeLength * 4 + 2] = uvWidth;
				this.__bufferData[offset + attributeLength * 4 + 3] = uvY;
				this.__bufferData[offset + attributeLength * 5] = x4;
				this.__bufferData[offset + attributeLength * 5 + 1] = y4;
				this.__bufferData[offset + attributeLength * 5 + 2] = uvWidth;
				this.__bufferData[offset + attributeLength * 5 + 3] = uvHeight;
				var _g21 = 0;
				while(_g21 < 6) {
					var i4 = _g21++;
					this.__bufferData[offset + attributeLength * i4 + 4] = alpha;
					this.__bufferData[offset + attributeLength * i4 + 5] = redMultiplier;
					this.__bufferData[offset + attributeLength * i4 + 10] = greenMultiplier;
					this.__bufferData[offset + attributeLength * i4 + 15] = blueMultiplier;
					this.__bufferData[offset + attributeLength * i4 + 20] = alphaMultiplier;
					this.__bufferData[offset + attributeLength * i4 + 21] = redOffset / 255;
					this.__bufferData[offset + attributeLength * i4 + 22] = greenOffset / 255;
					this.__bufferData[offset + attributeLength * i4 + 23] = blueOffset / 255;
					this.__bufferData[offset + attributeLength * i4 + 24] = alphaOffset / 255;
				}
				this.__bufferSkipped.data.set(i3,false);
			}
			var target = gl.ARRAY_BUFFER;
			var size = this.__bufferData.byteLength;
			var data1 = lime_utils__DataPointer_DataPointer_Impl_.fromArrayBufferView(this.__bufferData);
			var usage = gl.DYNAMIC_DRAW;
			gl.__context.bufferData(target,lime_utils__DataPointer_DataPointer_Impl_.toBufferView(data1,size),usage);
			this.__cacheAlpha = worldAlpha;
			this.__cacheDefaultTileset = defaultTileset;
			this.__bufferDirty = false;
		}
		return this.__buffer;
	},
  get_alpha: function() {
		return this.__data.data.get(11 + this.position * 21);
	},
  get_rect: function() {
		if(this.__rect == null) {
			this.__rect = new openfl_geom_Rectangle();
		}
		var i = 1 + this.position * 21;
		var tmp = this.__data.data.get(i);
		this.__rect.x = tmp;
		var tmp1 = this.__data.data.get(i + 1);
		this.__rect.y = tmp1;
		var tmp2 = this.__data.data.get(i + 2);
		this.__rect.width = tmp2;
		var tmp3 = this.__data.data.get(i + 3);
		this.__rect.height = tmp3;
		return this.__rect;
	},
  __visible: null,
  set_colorTransform: function(value) {
		var i = 12 + this.position * 21;
		if(value != null) {
			this.__data.data.set(i,value.redMultiplier);
			this.__data.data.set(i + 1,value.greenMultiplier);
			this.__data.data.set(i + 2,value.blueMultiplier);
			this.__data.data.set(i + 3,value.alphaMultiplier);
			this.__data.data.set(i + 4,value.redOffset);
			this.__data.data.set(i + 5,value.greenOffset);
			this.__data.data.set(i + 6,value.blueOffset);
			this.__data.data.set(i + 7,value.alphaOffset);
		} else {
			this.__data.data.set(i,1);
			this.__data.data.set(i + 1,1);
			this.__data.data.set(i + 2,1);
			this.__data.data.set(i + 3,1);
			this.__data.data.set(i + 4,0);
			this.__data.data.set(i + 5,0);
			this.__data.data.set(i + 6,0);
			this.__data.data.set(i + 7,0);
		}
		this.__dirty.data.set(3 + this.position * 5,true);
		return value;
	},
  tileset: null,
  __length: null,
  set_alpha: function(value) {
		this.__dirty.data.set(2 + this.position * 5,true);
		return this.__data.data.set(11 + this.position * 21,value);
	},
  id: null,
  __cacheAlpha: null,
  __data: null,
  get_matrix: function() {
		if(this.__matrix == null) {
			this.__matrix = new openfl_geom_Matrix();
		}
		var i = 5 + this.position * 21;
		var tmp = this.__data.data.get(i);
		this.__matrix.a = tmp;
		var tmp1 = this.__data.data.get(i + 1);
		this.__matrix.b = tmp1;
		var tmp2 = this.__data.data.get(i + 2);
		this.__matrix.c = tmp2;
		var tmp3 = this.__data.data.get(i + 3);
		this.__matrix.d = tmp3;
		var tmp4 = this.__data.data.get(i + 4);
		this.__matrix.tx = tmp4;
		var tmp5 = this.__data.data.get(i + 5);
		this.__matrix.ty = tmp5;
		return this.__matrix;
	},
  get_tileset: function() {
		return this.__tilesets.data.get(this.position);
	},
  __matrix: null,
  rect: null,
  get_id: function() {
		return this.__data.data.get(this.position * 21) | 0;
	},
  get_shader: function() {
		return this.__shaders.data.get(this.position);
	},
  colorTransform: null,
  matrix: null,
  position: null,
  __bufferSkipped: null,
  set_matrix: function(value) {
		var i = 5 + this.position * 21;
		if(value != null) {
			this.__data.data.set(i,value.a);
			this.__data.data.set(i + 1,value.b);
			this.__data.data.set(i + 2,value.c);
			this.__data.data.set(i + 3,value.d);
			this.__data.data.set(i + 4,value.tx);
			this.__data.data.set(i + 5,value.ty);
		} else {
			this.__data.data.set(i,1);
			this.__data.data.set(i + 1,0);
			this.__data.data.set(i + 2,0);
			this.__data.data.set(i + 3,1);
			this.__data.data.set(i + 4,0);
			this.__data.data.set(i + 5,0);
		}
		this.__dirty.data.set(1 + this.position * 5,true);
		return value;
	},
  set_length: function(value) {
		this.__data.data.set_length(value * 21);
		this.__dirty.data.set_length(value * 5);
		this.__shaders.data.set_length(value);
		this.__tilesets.data.set_length(value);
		this.__visible.data.set_length(value);
		if(value > this.__length) {
			var cachePosition = this.position;
			var _g1 = this.__length;
			var _g = value;
			while(_g1 < _g) {
				var i = _g1++;
				this.position = i;
				this.__dirty.data.set(2 + this.position * 5,true);
				this.__data.data.set(11 + this.position * 21,1);
				this.set_colorTransform(null);
				this.__dirty.data.set(this.position * 5,true);
				this.__data.data.set(this.position * 21,0);
				this.set_matrix(null);
				this.__tilesets.data.set(this.position,null);
				this.__visible.data.set(this.position,true);
				this.__dirty.data.set(4 + i * 5,true);
			}
			this.position = cachePosition;
		}
		this.__length = value;
		return value;
	},
  length: null,
  __bufferData: null,
  __cacheDefaultTileset: null,
  __shaders: null,
  set_id: function(value) {
		this.__dirty.data.set(this.position * 5,true);
		this.__data.data.set(this.position * 21,value);
		return value;
	},
  get_visible: function() {
		return this.__visible.data.get(this.position);
	},
  __colorTransform: null,
  set_rect: function(value) {
		if(value != null) {
			this.__data.data.set(this.position * 21,-1);
			var i = 1 + this.position * 21;
			this.__data.data.set(i,value.x);
			this.__data.data.set(i + 1,value.y);
			this.__data.data.set(i + 2,value.width);
			this.__data.data.set(i + 3,value.height);
		} else {
			var i1 = 1 + this.position * 21;
			this.__data.data.set(i1,0);
			this.__data.data.set(i1 + 1,0);
			this.__data.data.set(i1 + 2,0);
			this.__data.data.set(i1 + 3,0);
		}
		this.__dirty.data.set(this.position * 5,true);
		return value;
	},
  __buffer: null,
 __class__: TileArray
};
TileArray.__name__ = "openfl.display.TileArray";
TileArray.MATRIX_DIRTY_INDEX = 1;
TileArray.ID_INDEX = 0;
TileArray.ALPHA_DIRTY_INDEX = 2;
TileArray.ALL_DIRTY_INDEX = 4;
TileArray.MATRIX_INDEX = 5;
TileArray.COLOR_TRANSFORM_DIRTY_INDEX = 3;
TileArray.SOURCE_DIRTY_INDEX = 0;
TileArray.DATA_LENGTH = 21;
TileArray.DIRTY_LENGTH = 5;
TileArray.ALPHA_INDEX = 11;
TileArray.COLOR_TRANSFORM_INDEX = 12;
TileArray.RECT_INDEX = 1;
Object.defineProperties(TileArray.prototype, {
	"tileset": { get: TileArray.prototype.get_tileset, set: TileArray.prototype.set_tileset },
	"id": { get: TileArray.prototype.get_id, set: TileArray.prototype.set_id },
	"shader": { get: TileArray.prototype.get_shader, set: TileArray.prototype.set_shader },
	"rect": { get: TileArray.prototype.get_rect, set: TileArray.prototype.set_rect },
	"visible": { get: TileArray.prototype.get_visible, set: TileArray.prototype.set_visible },
	"colorTransform": { get: TileArray.prototype.get_colorTransform, set: TileArray.prototype.set_colorTransform },
	"matrix": { get: TileArray.prototype.get_matrix, set: TileArray.prototype.set_matrix },
	"length": { get: TileArray.prototype.get_length, set: TileArray.prototype.set_length },
	"alpha": { get: TileArray.prototype.get_alpha, set: TileArray.prototype.set_alpha },
});



return TileArray;
}());
exports.default = exports.TileArray = TileArray;
