// Package: openfl.display.Tilemap
var openfl_display_IShaderDrawable = require("../../openfl/display/IShaderDrawable").IShaderDrawable;
var openfl__Vector_Vector_Impl_ = require("../../openfl/_Vector/Vector_Impl_").Vector_Impl_;
var openfl_display_Tile = require("../../openfl/display/Tile").Tile;
var lime_graphics_utils_ImageCanvasUtil = require("../../lime/graphics/utils/ImageCanvasUtil").ImageCanvasUtil;
var openfl__internal_renderer_opengl_GLTilemap = require("../../openfl/_internal/renderer/opengl/GLTilemap").GLTilemap;
var $extend = require("../../extend_stub").extend_stub;
var openfl_display_DisplayObject = require("../../openfl/display/DisplayObject").DisplayObject;
var openfl__Vector_AbstractVector = require("../../openfl/_Vector/AbstractVector").AbstractVector;
var openfl_display_TileArray = require("../../openfl/display/TileArray").TileArray;
var openfl__internal_renderer_canvas_CanvasGraphics = require("../../openfl/_internal/renderer/canvas/CanvasGraphics").CanvasGraphics;
var openfl_geom_Rectangle = require("../../openfl/geom/Rectangle").Rectangle;
var openfl__internal_renderer_opengl_GLBitmap = require("../../openfl/_internal/renderer/opengl/GLBitmap").GLBitmap;
var lime_utils__DataPointer_DataPointer_Impl_ = require("../../lime/utils/_DataPointer/DataPointer_Impl_").DataPointer_Impl_;
var openfl__internal_renderer_opengl_GLMaskManager = require("../../openfl/_internal/renderer/opengl/GLMaskManager").GLMaskManager;


// Class: openfl.display.Tilemap

var Tilemap = (function () {
var Tilemap = function(width,height,tileset,smoothing) {
	if(smoothing == null) {
		smoothing = true;
	}
	openfl_display_DisplayObject.call(this);
	this.set_tileset(tileset);
	this.smoothing = smoothing;
	this.__tiles = openfl__Vector_Vector_Impl_.toObjectVector(null);
	this.numTiles = 0;
	this.__width = width;
	this.__height = height;
};
Tilemap.__interfaces__ = [openfl_display_IShaderDrawable];
Tilemap.__super__ = openfl_display_DisplayObject;
Tilemap.prototype = $extend(openfl_display_DisplayObject.prototype, {
    "__properties__": {"get_height":"get_height","set_height":"set_height","set_tileset":"set_tileset","get_width":"get_width","set_width":"set_width"},
  set_height: function(value) {
		this.__height = value | 0;
		return this.__height * Math.abs(this.get_scaleY());
	},
  set_tileset: function(value) {
		this.__tileArrayDirty = true;
		return this.tileset = value;
	},
  smoothing: null,
  shader: null,
  __renderDOM: function(renderSession) {
	},
  __renderDOMClear: function(renderSession) {
	},
  addTile: function(tile) {
		if(tile == null) {
			return null;
		}
		if(tile.parent == this) {
			this.removeTile(tile);
		}
		this.__tiles.data.set(this.numTiles,tile);
		tile.parent = this;
		this.numTiles++;
		if(!this.__renderDirty) {
			this.__renderDirty = true;
			this.__setParentRenderDirty();
		}
		return tile;
	},
  __getBounds: function(rect,matrix) {
		var bounds = openfl_geom_Rectangle.__pool.get();
		bounds.setTo(0,0,this.__width,this.__height);
		bounds.__transform(bounds,matrix);
		rect.__expand(bounds.x,bounds.y,bounds.width,bounds.height);
		openfl_geom_Rectangle.__pool.release(bounds);
	},
  __updateCacheBitmap: function(renderSession,force) {
		if(this.get_filters() == null) {
			return;
		}
		openfl_display_DisplayObject.prototype.__updateCacheBitmap.call(this,renderSession,force);
	},
  removeTile: function(tile) {
		var cacheLength = this.__tiles.data.get_length();
		var _g1 = 0;
		var _g = this.__tiles.data.get_length();
		while(_g1 < _g) {
			var i = _g1++;
			if(this.__tiles.data.get(i) == tile) {
				tile.parent = null;
				new openfl__Vector_AbstractVector(this.__tiles.data.splice(i,1));
				break;
			}
		}
		this.__tileArrayDirty = true;
		if(cacheLength > this.__tiles.data.get_length()) {
			this.numTiles--;
		}
		if(this.numTiles <= 0 && this.__tileArray != null) {
			this.__tileArray.set_length(0);
		}
		if(!this.__renderDirty) {
			this.__renderDirty = true;
			this.__setParentRenderDirty();
		}
		return tile;
	},
  get_width: function() {
		return this.__width * Math.abs(this.__scaleX);
	},
  getTileIndex: function(tile) {
		var _g1 = 0;
		var _g = this.__tiles.data.get_length();
		while(_g1 < _g) {
			var i = _g1++;
			if(this.__tiles.data.get(i) == tile) {
				return i;
			}
		}
		return -1;
	},
  __updateTileArray: function() {
		if(this.__tiles.data.get_length() > 0) {
			if(this.__tileArray == null) {
				this.__tileArray = new openfl_display_TileArray();
			}
			this.__tileArray.set_length(this.numTiles);
			var tile;
			var _g1 = 0;
			var _g = this.__tiles.data.get_length();
			while(_g1 < _g) {
				var i = _g1++;
				tile = this.__tiles.data.get(i);
				if(tile != null) {
					tile.__updateTileArray(i,this.__tileArray,this.__tileArrayDirty);
				}
			}
		}
		this.__tileArrayDirty = false;
	},
  addTileAt: function(tile,index) {
		if(tile == null) {
			return null;
		}
		if(tile.parent == this) {
			var cacheLength = this.__tiles.data.get_length();
			this.removeTile(tile);
			if(cacheLength > this.__tiles.data.get_length()) {
				--index;
			}
		}
		this.__tiles.data.insertAt(index,tile);
		tile.parent = this;
		this.__tileArrayDirty = true;
		this.numTiles++;
		if(!this.__renderDirty) {
			this.__renderDirty = true;
			this.__setParentRenderDirty();
		}
		return tile;
	},
  addTiles: function(tiles) {
		var _g = 0;
		while(_g < tiles.length) {
			var tile = tiles[_g];
			++_g;
			this.addTile(tile);
		}
		return tiles;
	},
  tileset: null,
  __tileArray: null,
  setTiles: function(tileArray) {
		this.__tileArray = tileArray;
		this.numTiles = this.__tileArray.__length;
		this.__tileArray.__bufferDirty = true;
		this.__tileArrayDirty = false;
		this.__tiles.data.set_length(0);
		if(!this.__renderDirty) {
			this.__renderDirty = true;
			this.__setParentRenderDirty();
		}
	},
  __renderGL: function(renderSession) {
		this.__updateCacheBitmap(renderSession,false);
		if(this.__cacheBitmap != null && !this.__cacheBitmapRender) {
			openfl__internal_renderer_opengl_GLBitmap.render(this.__cacheBitmap,renderSession);
		} else {
			if(!(this.opaqueBackground == null && this.__graphics == null)) {
				if(!(!this.__renderable || this.__worldAlpha <= 0)) {
					if(this.opaqueBackground != null && !this.__cacheBitmapRender && this.get_width() > 0 && this.get_height() > 0) {
						renderSession.blendModeManager.setBlendMode(this.__worldBlendMode);
						renderSession.maskManager.pushObject(this);
						var gl = renderSession.gl;
						var rect = openfl_geom_Rectangle.__pool.get();
						rect.setTo(0,0,this.get_width(),this.get_height());
						renderSession.maskManager.pushRect(rect,this.__renderTransform);
						var color = this.opaqueBackground;
						gl.__context.clearColor((color >>> 16 & 255) / 255,(color >>> 8 & 255) / 255,(color & 255) / 255,1);
						gl.__context.clear(gl.COLOR_BUFFER_BIT);
						renderSession.maskManager.popRect();
						renderSession.maskManager.popObject(this);
						openfl_geom_Rectangle.__pool.release(rect);
					}
					if(this.__graphics != null) {
						if(!(!this.__renderable || this.__worldAlpha <= 0)) {
							var graphics = this.__graphics;
							if(graphics != null) {
								openfl__internal_renderer_canvas_CanvasGraphics.render(graphics,renderSession,this.__renderTransform);
								var bounds = graphics.__bounds;
								if(graphics.__bitmap != null && graphics.__visible) {
									var renderer = renderSession.renderer;
									var gl1 = renderSession.gl;
									renderSession.blendModeManager.setBlendMode(this.__worldBlendMode);
									renderSession.maskManager.pushObject(this);
									var shader = renderSession.filterManager.pushObject(this);
									renderSession.shaderManager.setShader(shader);
									shader.get_data().uImage0.input = graphics.__bitmap;
									shader.get_data().uImage0.smoothing = renderSession.allowSmoothing;
									shader.get_data().uMatrix.value = renderer.getMatrix(graphics.__worldTransform);
									var useColorTransform = !this.__worldColorTransform.__isDefault();
									if(shader.get_data().uColorTransform.value == null) {
										shader.get_data().uColorTransform.value = [];
									}
									shader.get_data().uColorTransform.value[0] = useColorTransform;
									renderSession.shaderManager.updateShader(shader);
									var target = gl1.ARRAY_BUFFER;
									var buffer = graphics.__bitmap.getBuffer(gl1,this.__worldAlpha,this.__worldColorTransform);
									gl1.__context.bindBuffer(target,buffer);
									var index = shader.get_data().aPosition.index;
									var type = gl1.FLOAT;
									var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(0);
									gl1.__context.vertexAttribPointer(index,3,type,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
									var index1 = shader.get_data().aTexCoord.index;
									var type1 = gl1.FLOAT;
									var offset1 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(12);
									gl1.__context.vertexAttribPointer(index1,2,type1,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset1));
									var index2 = shader.get_data().aAlpha.index;
									var type2 = gl1.FLOAT;
									var offset2 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(20);
									gl1.__context.vertexAttribPointer(index2,1,type2,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset2));
									var index3 = shader.get_data().aColorMultipliers.index;
									var type3 = gl1.FLOAT;
									var offset3 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(24);
									gl1.__context.vertexAttribPointer(index3,4,type3,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset3));
									var index4 = shader.get_data().aColorMultipliers.index + 1;
									var type4 = gl1.FLOAT;
									var offset4 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(40);
									gl1.__context.vertexAttribPointer(index4,4,type4,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset4));
									var index5 = shader.get_data().aColorMultipliers.index + 2;
									var type5 = gl1.FLOAT;
									var offset5 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(56);
									gl1.__context.vertexAttribPointer(index5,4,type5,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset5));
									var index6 = shader.get_data().aColorMultipliers.index + 3;
									var type6 = gl1.FLOAT;
									var offset6 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(72);
									gl1.__context.vertexAttribPointer(index6,4,type6,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset6));
									var index7 = shader.get_data().aColorOffsets.index;
									var type7 = gl1.FLOAT;
									var offset7 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(88);
									gl1.__context.vertexAttribPointer(index7,4,type7,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset7));
									gl1.__context.drawArrays(gl1.TRIANGLE_STRIP,0,4);
									renderSession.filterManager.popObject(this);
									renderSession.maskManager.popObject(this);
								}
							}
						}
					}
				}
			}
			openfl__internal_renderer_opengl_GLTilemap.render(this,renderSession);
		}
	},
  contains: function(tile) {
		return this.__tiles.data.indexOf(tile,0) > -1;
	},
  __hitTest: function(x,y,shapeFlag,stack,interactiveOnly,hitObject) {
		if(!hitObject.get_visible() || this.__isMask) {
			return false;
		}
		if(this.get_mask() != null && !this.get_mask().__hitTestMask(x,y)) {
			return false;
		}
		this.__getRenderTransform();
		var _this = this.__renderTransform;
		var norm = _this.a * _this.d - _this.b * _this.c;
		var px = norm == 0 ? -_this.tx : 1.0 / norm * (_this.c * (_this.ty - y) + _this.d * (x - _this.tx));
		var _this1 = this.__renderTransform;
		var norm1 = _this1.a * _this1.d - _this1.b * _this1.c;
		var py = norm1 == 0 ? -_this1.ty : 1.0 / norm1 * (_this1.a * (y - _this1.ty) + _this1.b * (_this1.tx - x));
		if(px > 0 && py > 0 && px <= this.__width && py <= this.__height) {
			if(stack != null && !interactiveOnly) {
				stack.push(hitObject);
			}
			return true;
		}
		return false;
	},
  set_width: function(value) {
		this.__width = value | 0;
		return this.__width * Math.abs(this.__scaleX);
	},
  __renderCairo: function(renderSession) {
	},
  numTiles: null,
  __tileArrayDirty: null,
  __height: null,
  removeTiles: function(beginIndex,endIndex) {
		if(endIndex == null) {
			endIndex = 2147483647;
		}
		if(beginIndex == null) {
			beginIndex = 0;
		}
		if(beginIndex < 0) {
			beginIndex = 0;
		}
		if(endIndex > this.__tiles.data.get_length() - 1) {
			endIndex = this.__tiles.data.get_length() - 1;
		}
		var removed = new openfl__Vector_AbstractVector(this.__tiles.data.splice(beginIndex,endIndex - beginIndex + 1));
		var _g = 0;
		while(_g < removed.data.get_length()) {
			var tile = removed.data.get(_g);
			++_g;
			tile.parent = null;
		}
		this.__tileArrayDirty = true;
		this.numTiles = this.__tiles.data.get_length();
		if(this.numTiles == 0 && this.__tileArray != null) {
			this.__tileArray.set_length(0);
		}
		if(!this.__renderDirty) {
			this.__renderDirty = true;
			this.__setParentRenderDirty();
		}
	},
  __renderCanvas: function(renderSession) {
		this.__updateCacheBitmap(renderSession,!this.__worldColorTransform.__isDefault());
		if(this.__cacheBitmap != null && !this.__cacheBitmapRender) {
			var bitmap = this.__cacheBitmap;
			if(!(!bitmap.__renderable || bitmap.__worldAlpha <= 0)) {
				var context = renderSession.context;
				if(bitmap.bitmapData != null && bitmap.bitmapData.__isValid && bitmap.bitmapData.readable) {
					renderSession.blendModeManager.setBlendMode(bitmap.__worldBlendMode);
					renderSession.maskManager.pushObject(bitmap,false);
					lime_graphics_utils_ImageCanvasUtil.convertToCanvas(bitmap.bitmapData.image);
					context.globalAlpha = bitmap.__worldAlpha;
					var transform = bitmap.__renderTransform;
					var scrollRect = bitmap.__scrollRect;
					if(renderSession.roundPixels) {
						context.setTransform(transform.a,transform.b,transform.c,transform.d,transform.tx | 0,transform.ty | 0);
					} else {
						context.setTransform(transform.a,transform.b,transform.c,transform.d,transform.tx,transform.ty);
					}
					if(!renderSession.allowSmoothing || !bitmap.smoothing) {
						context.mozImageSmoothingEnabled = false;
						context.msImageSmoothingEnabled = false;
						context.imageSmoothingEnabled = false;
					}
					if(scrollRect == null) {
						context.drawImage(bitmap.bitmapData.image.get_src(),0,0);
					} else {
						context.drawImage(bitmap.bitmapData.image.get_src(),scrollRect.x,scrollRect.y,scrollRect.width,scrollRect.height,scrollRect.x,scrollRect.y,scrollRect.width,scrollRect.height);
					}
					if(!renderSession.allowSmoothing || !bitmap.smoothing) {
						context.mozImageSmoothingEnabled = true;
						context.msImageSmoothingEnabled = true;
						context.imageSmoothingEnabled = true;
					}
					renderSession.maskManager.popObject(bitmap,false);
				}
			}
		} else {
			if(!(this.opaqueBackground == null && this.__graphics == null)) {
				if(!(!this.__renderable || this.__worldAlpha <= 0)) {
					if(this.opaqueBackground != null && !this.__cacheBitmapRender && this.get_width() > 0 && this.get_height() > 0) {
						renderSession.blendModeManager.setBlendMode(this.__worldBlendMode);
						renderSession.maskManager.pushObject(this);
						var context1 = renderSession.context;
						var transform1 = this.__renderTransform;
						if(renderSession.roundPixels) {
							context1.setTransform(transform1.a,transform1.b,transform1.c,transform1.d,transform1.tx | 0,transform1.ty | 0);
						} else {
							context1.setTransform(transform1.a,transform1.b,transform1.c,transform1.d,transform1.tx,transform1.ty);
						}
						var color = this.opaqueBackground;
						context1.fillStyle = "rgb(" + (color >>> 16 & 255) + "," + (color >>> 8 & 255) + "," + (color & 255) + ")";
						context1.fillRect(0,0,this.get_width(),this.get_height());
						renderSession.maskManager.popObject(this);
					}
					if(this.__graphics != null) {
						if(!(!this.__renderable || this.__worldAlpha <= 0)) {
							var graphics = this.__graphics;
							if(graphics != null) {
								openfl__internal_renderer_canvas_CanvasGraphics.render(graphics,renderSession,this.__renderTransform);
								var bounds = graphics.__bounds;
								var width = graphics.__width;
								var height = graphics.__height;
								if(graphics.__canvas != null) {
									var context2 = renderSession.context;
									var scrollRect1 = this.__scrollRect;
									if(width > 0 && height > 0 && (scrollRect1 == null || scrollRect1.width > 0 && scrollRect1.height > 0)) {
										renderSession.blendModeManager.setBlendMode(this.__worldBlendMode);
										renderSession.maskManager.pushObject(this);
										context2.globalAlpha = this.__worldAlpha;
										var transform2 = graphics.__worldTransform;
										if(renderSession.roundPixels) {
											context2.setTransform(transform2.a,transform2.b,transform2.c,transform2.d,transform2.tx | 0,transform2.ty | 0);
										} else {
											context2.setTransform(transform2.a,transform2.b,transform2.c,transform2.d,transform2.tx,transform2.ty);
										}
										context2.drawImage(graphics.__canvas,0,0);
										renderSession.maskManager.popObject(this);
									}
								}
							}
						}
					}
				}
			}
			if(!(!this.__renderable || this.__worldAlpha <= 0)) {
				this.__updateTileArray();
				if(!(this.__tileArray == null || this.__tileArray.__length == 0)) {
					var context3 = renderSession.context;
					renderSession.blendModeManager.setBlendMode(this.__worldBlendMode);
					renderSession.maskManager.pushObject(this);
					var rect = openfl_geom_Rectangle.__pool.get();
					rect.setTo(0,0,this.__width,this.__height);
					renderSession.maskManager.pushRect(rect,this.__renderTransform);
					var transform3 = this.__renderTransform;
					var roundPixels = renderSession.roundPixels;
					if(!renderSession.allowSmoothing || !this.smoothing) {
						context3.mozImageSmoothingEnabled = false;
						context3.msImageSmoothingEnabled = false;
						context3.imageSmoothingEnabled = false;
					}
					var defaultTileset = this.tileset;
					var cacheBitmapData = null;
					var source = null;
					var alpha;
					var visible;
					var tileset;
					var id;
					var tileData;
					var bitmapData;
					var tileArray = this.__tileArray;
					var tileTransform;
					var tileRect = openfl_geom_Rectangle.__pool.get();
					var tile = tileArray.iterator();
					while(tile.hasNext()) {
						var tile1 = tile.next();
						alpha = tile1.get_alpha();
						visible = tile1.get_visible();
						if(!visible || alpha <= 0) {
							continue;
						}
						tileset = tile1.get_tileset();
						if(tileset == null) {
							tileset = defaultTileset;
						}
						if(tileset == null) {
							continue;
						}
						id = tile1.get_id();
						if(id == -1) {
							tileRect.copyFrom(tile1.get_rect());
							if(tileRect.width <= 0 || tileRect.height <= 0) {
								continue;
							}
						} else {
							tileData = tileset.__data[id];
							if(tileData == null) {
								continue;
							}
							tileRect.setTo(tileData.x,tileData.y,tileData.width,tileData.height);
						}
						bitmapData = tileset.bitmapData;
						if(bitmapData == null || !bitmapData.readable) {
							continue;
						}
						if(bitmapData != cacheBitmapData) {
							if(bitmapData.image.buffer.__srcImage == null) {
								lime_graphics_utils_ImageCanvasUtil.convertToCanvas(bitmapData.image);
							}
							source = bitmapData.image.get_src();
							cacheBitmapData = bitmapData;
						}
						context3.globalAlpha = this.__worldAlpha * alpha;
						tileTransform = tile1.get_matrix();
						tileTransform.concat(transform3);
						if(roundPixels) {
							context3.setTransform(tileTransform.a,tileTransform.b,tileTransform.c,tileTransform.d,tileTransform.tx | 0,tileTransform.ty | 0);
						} else {
							context3.setTransform(tileTransform.a,tileTransform.b,tileTransform.c,tileTransform.d,tileTransform.tx,tileTransform.ty);
						}
						context3.drawImage(source,tileRect.x,tileRect.y,tileRect.width,tileRect.height,0,0,tileRect.width,tileRect.height);
					}
					if(!renderSession.allowSmoothing || !this.smoothing) {
						context3.mozImageSmoothingEnabled = true;
						context3.msImageSmoothingEnabled = true;
						context3.imageSmoothingEnabled = true;
					}
					renderSession.maskManager.popRect();
					renderSession.maskManager.popObject(this);
					openfl_geom_Rectangle.__pool.release(rect);
					openfl_geom_Rectangle.__pool.release(tileRect);
				}
			}
		}
	},
  __renderGLMask: function(renderSession) {
		this.__updateCacheBitmap(renderSession,false);
		if(this.__cacheBitmap != null && !this.__cacheBitmapRender) {
			openfl__internal_renderer_opengl_GLBitmap.renderMask(this.__cacheBitmap,renderSession);
		} else {
			if(!(this.opaqueBackground == null && this.__graphics == null)) {
				if(this.opaqueBackground != null && !this.__cacheBitmapRender && this.get_width() > 0 && this.get_height() > 0) {
					var gl = renderSession.gl;
				}
				if(this.__graphics != null) {
					var graphics = this.__graphics;
					if(graphics != null) {
						openfl__internal_renderer_canvas_CanvasGraphics.render(graphics,renderSession,this.__renderTransform);
						var bounds = graphics.__bounds;
						if(graphics.__bitmap != null) {
							var renderer = renderSession.renderer;
							var gl1 = renderSession.gl;
							var shader = openfl__internal_renderer_opengl_GLMaskManager.maskShader;
							renderSession.shaderManager.setShader(shader);
							shader.get_data().uImage0.input = graphics.__bitmap;
							shader.get_data().uImage0.smoothing = renderSession.allowSmoothing;
							shader.get_data().uMatrix.value = renderer.getMatrix(graphics.__worldTransform);
							renderSession.shaderManager.updateShader(shader);
							var target = gl1.ARRAY_BUFFER;
							var buffer = graphics.__bitmap.getBuffer(gl1,this.__worldAlpha,this.__worldColorTransform);
							gl1.__context.bindBuffer(target,buffer);
							var index = shader.get_data().aPosition.index;
							var type = gl1.FLOAT;
							var offset = lime_utils__DataPointer_DataPointer_Impl_.fromInt(0);
							gl1.__context.vertexAttribPointer(index,3,type,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset));
							var index1 = shader.get_data().aTexCoord.index;
							var type1 = gl1.FLOAT;
							var offset1 = lime_utils__DataPointer_DataPointer_Impl_.fromInt(12);
							gl1.__context.vertexAttribPointer(index1,2,type1,false,104,lime_utils__DataPointer_DataPointer_Impl_.toValue(offset1));
							gl1.__context.drawArrays(gl1.TRIANGLE_STRIP,0,4);
						}
					}
				}
			}
			openfl__internal_renderer_opengl_GLTilemap.renderMask(this,renderSession);
		}
	},
  get_height: function() {
		return this.__height * Math.abs(this.get_scaleY());
	},
  __tiles: null,
  __width: null,
  getTileAt: function(index) {
		if(index >= 0 && index < this.numTiles) {
			var tile = this.__tiles.data.get(index);
			if(tile == null && this.__tileArray != null && index < this.__tileArray.__length) {
				tile = openfl_display_Tile.__fromTileArray(index,this.__tileArray);
				this.__tiles.data.set(index,tile);
			}
			return this.__tiles.data.get(index);
		}
		return null;
	},
  __renderFlash: function() {
	},
  getTiles: function() {
		this.__updateTileArray();
		if(this.__tileArray == null) {
			this.__tileArray = new openfl_display_TileArray();
		}
		return this.__tileArray;
	},
  removeTileAt: function(index) {
		if(index >= 0 && index < this.numTiles) {
			return this.removeTile(this.__tiles.data.get(index));
		}
		return null;
	},
 __class__: Tilemap
});
Tilemap.__name__ = "openfl.display.Tilemap";
Object.defineProperties(Tilemap.prototype, {
	"tileset": { set: Tilemap.prototype.set_tileset },
	"height": { get: Tilemap.prototype.get_height, set: Tilemap.prototype.set_height },
	"width": { get: Tilemap.prototype.get_width, set: Tilemap.prototype.set_width },
});



return Tilemap;
}());
exports.default = exports.Tilemap = Tilemap;
