// Package: openfl.events.Event
var $bind = require("../../bind_stub").bind_stub;
var Reflect = require("../../Reflect").Reflect;
var Std = require("../../Std").Std;


// Class: openfl.events.Event

var Event = (function () {
var Event = function(type,bubbles,cancelable) {
	if(cancelable == null) {
		cancelable = false;
	}
	if(bubbles == null) {
		bubbles = false;
	}
	this.type = type;
	this.bubbles = bubbles;
	this.cancelable = cancelable;
	this.eventPhase = 2;
};
Event.prototype = {
  stopPropagation: function() {
		this.__isCanceled = true;
	},
  __formatToString: function(className,parameters) {
		var output = "[" + className;
		var arg = null;
		var _g = 0;
		while(_g < parameters.length) {
			var param = parameters[_g];
			++_g;
			arg = Reflect.field(this,param);
			if(typeof(arg) == "string") {
				output += " " + param + "=\"" + Std.string(arg) + "\"";
			} else {
				output += " " + param + "=" + Std.string(arg);
			}
		}
		output += "]";
		return output;
	},
  currentTarget: null,
  type: null,
  preventDefault: function() {
		if(this.cancelable) {
			this.__preventDefault = true;
		}
	},
  cancelable: null,
  eventPhase: null,
  __isCanceled: null,
  toString: function() {
		return this.__formatToString("Event",["type","bubbles","cancelable"]);
	},
  bubbles: null,
  target: null,
  __isCanceledNow: null,
  formatToString: function(className,p1,p2,p3,p4,p5) {
		var parameters = [];
		if(p1 != null) {
			parameters.push(p1);
		}
		if(p2 != null) {
			parameters.push(p2);
		}
		if(p3 != null) {
			parameters.push(p3);
		}
		if(p4 != null) {
			parameters.push(p4);
		}
		if(p5 != null) {
			parameters.push(p5);
		}
		return $bind(this,this.__formatToString).apply(this,[className,parameters]);
	},
  isDefaultPrevented: function() {
		return this.__preventDefault;
	},
  __preventDefault: null,
  clone: function() {
		var event = new Event(this.type,this.bubbles,this.cancelable);
		event.eventPhase = this.eventPhase;
		event.target = this.target;
		event.currentTarget = this.currentTarget;
		return event;
	},
  stopImmediatePropagation: function() {
		this.__isCanceled = true;
		this.__isCanceledNow = true;
	},
 __class__: Event
};
Event.__name__ = "openfl.events.Event";
Event.ID3 = "id3";
Event.PASTE = "paste";
Event.COMPLETE = "complete";
Event.EXIT_FRAME = "exitFrame";
Event.REMOVED_FROM_STAGE = "removedFromStage";
Event.SCROLL = "scroll";
Event.ACTIVATE = "activate";
Event.CONNECT = "connect";
Event.FULLSCREEN = "fullScreen";
Event.UNLOAD = "unload";
Event.MOUSE_LEAVE = "mouseLeave";
Event.CHANGE = "change";
Event.INIT = "init";
Event.FRAME_CONSTRUCTED = "frameConstructed";
Event.CONTEXT3D_CREATE = "context3DCreate";
Event.CLOSE = "close";
Event.OPEN = "open";
Event.REMOVED = "removed";
Event.RENDER = "render";
Event.TAB_CHILDREN_CHANGE = "tabChildrenChange";
Event.FRAME_LABEL = "frameLabel";
Event.SELECT = "select";
Event.ADDED_TO_STAGE = "addedToStage";
Event.TAB_ENABLED_CHANGE = "tabEnabledChange";
Event.TAB_INDEX_CHANGE = "tabIndexChange";
Event.TEXTURE_READY = "textureReady";
Event.COPY = "copy";
Event.ENTER_FRAME = "enterFrame";
Event.CLEAR = "clear";
Event.SELECT_ALL = "selectAll";
Event.RESIZE = "resize";
Event.ADDED = "added";
Event.DEACTIVATE = "deactivate";
Event.CANCEL = "cancel";
Event.SOUND_COMPLETE = "soundComplete";
Event.CUT = "cut";


return Event;
}());
exports.default = exports.Event = Event;
