// Package: openfl.filters.BlurFilter
var lime_graphics_utils_ImageDataUtil = require("../../lime/graphics/utils/ImageDataUtil").ImageDataUtil;
var $extend = require("../../extend_stub").extend_stub;
var openfl_filters_BitmapFilter = require("../../openfl/filters/BitmapFilter").BitmapFilter;


// Class: openfl.filters.BlurFilter

var BlurFilter = (function () {
var BlurFilter = function(blurX,blurY,quality) {
	if(quality == null) {
		quality = 1;
	}
	if(blurY == null) {
		blurY = 4;
	}
	if(blurX == null) {
		blurX = 4;
	}
	openfl_filters_BitmapFilter.call(this);
	this.set_blurX(blurX);
	this.set_blurY(blurY);
	this.set_quality(quality);
	this.__needSecondBitmapData = true;
	this.__preserveObject = false;
};
BlurFilter.__super__ = openfl_filters_BitmapFilter;
BlurFilter.prototype = $extend(openfl_filters_BitmapFilter.prototype, {
    "__properties__": {"set_blurX":"set_blurX","set_blurY":"set_blurY","set_quality":"set_quality"},
  verticalPasses: null,
  blurY: null,
  __initShader: function(renderSession,pass) {
		return null;
	},
  set_blurX: function(value) {
		if(value != this.blurX) {
			this.blurX = value;
			this.__renderDirty = true;
			this.__leftExtension = value > 0 ? Math.ceil(value) : 0;
			this.__rightExtension = this.__leftExtension;
		}
		return value;
	},
  set_blurY: function(value) {
		if(value != this.blurY) {
			this.blurY = value;
			this.__renderDirty = true;
			this.__topExtension = value > 0 ? Math.ceil(value) : 0;
			this.__bottomExtension = this.__topExtension;
		}
		return value;
	},
  __applyFilter: function(bitmapData,sourceBitmapData,sourceRect,destPoint) {
		var finalImage = lime_graphics_utils_ImageDataUtil.gaussianBlur(bitmapData.image,sourceBitmapData.image,sourceRect.__toLimeRectangle(),destPoint.__toLimeVector2(),this.blurX,this.blurY,this.quality);
		if(finalImage == bitmapData.image) {
			return bitmapData;
		}
		return sourceBitmapData;
	},
  blurX: null,
  quality: null,
  clone: function() {
		return new BlurFilter(this.blurX,this.blurY,this.quality);
	},
  set_quality: function(value) {
		this.horizontalPasses = this.blurX <= 0 ? 0 : Math.round(this.blurX * (value / 4)) + 1;
		this.verticalPasses = this.blurY <= 0 ? 0 : Math.round(this.blurY * (value / 4)) + 1;
		this.__numShaderPasses = this.horizontalPasses + this.verticalPasses;
		if(value != this.quality) {
			this.__renderDirty = true;
		}
		return this.quality = value;
	},
  horizontalPasses: null,
 __class__: BlurFilter
});
BlurFilter.__name__ = "openfl.filters.BlurFilter";
Object.defineProperties(BlurFilter.prototype, {
	"blurY": { set: BlurFilter.prototype.set_blurY },
	"blurX": { set: BlurFilter.prototype.set_blurX },
	"quality": { set: BlurFilter.prototype.set_quality },
});



return BlurFilter;
}());
exports.default = exports.BlurFilter = BlurFilter;
