// Package: openfl.filters.ColorMatrixFilter
var lime_graphics_utils_ImageCanvasUtil = require("../../lime/graphics/utils/ImageCanvasUtil").ImageCanvasUtil;
var $extend = require("../../extend_stub").extend_stub;
var lime_math_color__RGBA_RGBA_Impl_ = require("../../lime/math/color/_RGBA/RGBA_Impl_").RGBA_Impl_;
var openfl_filters_BitmapFilter = require("../../openfl/filters/BitmapFilter").BitmapFilter;


// Class: openfl.filters.ColorMatrixFilter

var ColorMatrixFilter = (function () {
var ColorMatrixFilter = function(matrix) {
	openfl_filters_BitmapFilter.call(this);
	this.set_matrix(matrix);
	this.__numShaderPasses = 0;
	this.__needSecondBitmapData = false;
};
ColorMatrixFilter.__super__ = openfl_filters_BitmapFilter;
ColorMatrixFilter.prototype = $extend(openfl_filters_BitmapFilter.prototype, {
    "__properties__": {"set_matrix":"set_matrix"},
  __initShader: function(renderSession,pass) {
		return null;
	},
  __applyFilter: function(destBitmapData,sourceBitmapData,sourceRect,destPoint) {
		var sourceImage = sourceBitmapData.image;
		var image = destBitmapData.image;
		lime_graphics_utils_ImageCanvasUtil.convertToData(sourceImage);
		lime_graphics_utils_ImageCanvasUtil.convertToData(image);
		var sourceData = sourceImage.get_data();
		var destData = image.get_data();
		var offsetX = destPoint.x - sourceRect.x | 0;
		var offsetY = destPoint.y - sourceRect.y | 0;
		var sourceStride = sourceBitmapData.width * 4;
		var destStride = destBitmapData.width * 4;
		var sourceFormat = sourceImage.buffer.format;
		var destFormat = image.buffer.format;
		var sourcePremultiplied = sourceImage.buffer.premultiplied;
		var destPremultiplied = image.buffer.premultiplied;
		var sourcePixel;
		var destPixel = 0;
		var sourceOffset;
		var destOffset;
		var _g1 = sourceRect.y | 0;
		var _g = sourceRect.height | 0;
		while(_g1 < _g) {
			var row = _g1++;
			var _g3 = sourceRect.x | 0;
			var _g2 = sourceRect.width | 0;
			while(_g3 < _g2) {
				var column = _g3++;
				sourceOffset = row * sourceStride + column * 4;
				destOffset = (row + offsetX) * destStride + (column + offsetY) * 4;
				switch(sourceFormat) {
				case 0:
					sourcePixel = (sourceData[sourceOffset] & 255) << 24 | (sourceData[sourceOffset + 1] & 255) << 16 | (sourceData[sourceOffset + 2] & 255) << 8 | sourceData[sourceOffset + 3] & 255;
					break;
				case 1:
					sourcePixel = (sourceData[sourceOffset + 1] & 255) << 24 | (sourceData[sourceOffset + 2] & 255) << 16 | (sourceData[sourceOffset + 3] & 255) << 8 | sourceData[sourceOffset] & 255;
					break;
				case 2:
					sourcePixel = (sourceData[sourceOffset + 2] & 255) << 24 | (sourceData[sourceOffset + 1] & 255) << 16 | (sourceData[sourceOffset] & 255) << 8 | sourceData[sourceOffset + 3] & 255;
					break;
				}
				if(sourcePremultiplied) {
					if((sourcePixel & 255) != 0 && (sourcePixel & 255) != 255) {
						lime_math_color__RGBA_RGBA_Impl_.unmult = 255.0 / (sourcePixel & 255);
						sourcePixel = (lime_math_color__RGBA_RGBA_Impl_.__clamp[Math.round((sourcePixel >>> 24 & 255) * lime_math_color__RGBA_RGBA_Impl_.unmult)] & 255) << 24 | (lime_math_color__RGBA_RGBA_Impl_.__clamp[Math.round((sourcePixel >>> 16 & 255) * lime_math_color__RGBA_RGBA_Impl_.unmult)] & 255) << 16 | (lime_math_color__RGBA_RGBA_Impl_.__clamp[Math.round((sourcePixel >>> 8 & 255) * lime_math_color__RGBA_RGBA_Impl_.unmult)] & 255) << 8 | sourcePixel & 255 & 255;
					}
				}
				if((sourcePixel & 255) == 0) {
					destPixel = 0;
				} else {
					var value = Math.min(this.matrix[0] * (sourcePixel >>> 24 & 255) + this.matrix[1] * (sourcePixel >>> 16 & 255) + this.matrix[2] * (sourcePixel >>> 8 & 255) + this.matrix[3] * (sourcePixel & 255) + this.matrix[4],255) | 0;
					destPixel = (value & 255) << 24 | (destPixel >>> 16 & 255 & 255) << 16 | (destPixel >>> 8 & 255 & 255) << 8 | destPixel & 255 & 255;
					var value1 = Math.min(this.matrix[5] * (sourcePixel >>> 24 & 255) + this.matrix[6] * (sourcePixel >>> 16 & 255) + this.matrix[7] * (sourcePixel >>> 8 & 255) + this.matrix[8] * (sourcePixel & 255) + this.matrix[9],255) | 0;
					destPixel = (destPixel >>> 24 & 255 & 255) << 24 | (value1 & 255) << 16 | (destPixel >>> 8 & 255 & 255) << 8 | destPixel & 255 & 255;
					var value2 = Math.min(this.matrix[10] * (sourcePixel >>> 24 & 255) + this.matrix[11] * (sourcePixel >>> 16 & 255) + this.matrix[12] * (sourcePixel >>> 8 & 255) + this.matrix[13] * (sourcePixel & 255) + this.matrix[14],255) | 0;
					destPixel = (destPixel >>> 24 & 255 & 255) << 24 | (destPixel >>> 16 & 255 & 255) << 16 | (value2 & 255) << 8 | destPixel & 255 & 255;
					var value3 = Math.min(this.matrix[15] * (sourcePixel >>> 24 & 255) + this.matrix[16] * (sourcePixel >>> 16 & 255) + this.matrix[17] * (sourcePixel >>> 8 & 255) + this.matrix[18] * (sourcePixel & 255) + this.matrix[19],255) | 0;
					destPixel = (destPixel >>> 24 & 255 & 255) << 24 | (destPixel >>> 16 & 255 & 255) << 16 | (destPixel >>> 8 & 255 & 255) << 8 | value3 & 255;
				}
				if(destPremultiplied) {
					if((destPixel & 255) == 0) {
						if(destPixel != 0) {
							destPixel = 0;
						}
					} else if((destPixel & 255) != 255) {
						lime_math_color__RGBA_RGBA_Impl_.a16 = lime_math_color__RGBA_RGBA_Impl_.__alpha16[destPixel & 255];
						destPixel = ((destPixel >>> 24 & 255) * lime_math_color__RGBA_RGBA_Impl_.a16 >> 16 & 255) << 24 | ((destPixel >>> 16 & 255) * lime_math_color__RGBA_RGBA_Impl_.a16 >> 16 & 255) << 16 | ((destPixel >>> 8 & 255) * lime_math_color__RGBA_RGBA_Impl_.a16 >> 16 & 255) << 8 | destPixel & 255 & 255;
					}
				}
				switch(destFormat) {
				case 0:
					destData[destOffset] = destPixel >>> 24 & 255;
					destData[destOffset + 1] = destPixel >>> 16 & 255;
					destData[destOffset + 2] = destPixel >>> 8 & 255;
					destData[destOffset + 3] = destPixel & 255;
					break;
				case 1:
					destData[destOffset] = destPixel & 255;
					destData[destOffset + 1] = destPixel >>> 24 & 255;
					destData[destOffset + 2] = destPixel >>> 16 & 255;
					destData[destOffset + 3] = destPixel >>> 8 & 255;
					break;
				case 2:
					destData[destOffset] = destPixel >>> 8 & 255;
					destData[destOffset + 1] = destPixel >>> 16 & 255;
					destData[destOffset + 2] = destPixel >>> 24 & 255;
					destData[destOffset + 3] = destPixel & 255;
					break;
				}
			}
		}
		destBitmapData.image.dirty = true;
		return destBitmapData;
	},
  matrix: null,
  set_matrix: function(value) {
		if(value == null) {
			value = [1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1,0];
		}
		return this.matrix = value;
	},
  clone: function() {
		return new ColorMatrixFilter(this.matrix);
	},
 __class__: ColorMatrixFilter
});
ColorMatrixFilter.__name__ = "openfl.filters.ColorMatrixFilter";
Object.defineProperties(ColorMatrixFilter.prototype, {
	"matrix": { set: ColorMatrixFilter.prototype.set_matrix },
});



return ColorMatrixFilter;
}());
exports.default = exports.ColorMatrixFilter = ColorMatrixFilter;
