// Package: openfl.filters.DropShadowFilter
var lime_graphics_utils_ImageDataUtil = require("../../lime/graphics/utils/ImageDataUtil").ImageDataUtil;
var $extend = require("../../extend_stub").extend_stub;
var openfl_geom_ColorTransform = require("../../openfl/geom/ColorTransform").ColorTransform;
var openfl_filters_BitmapFilter = require("../../openfl/filters/BitmapFilter").BitmapFilter;


// Class: openfl.filters.DropShadowFilter

var DropShadowFilter = (function () {
var DropShadowFilter = function(distance,angle,color,alpha,blurX,blurY,strength,quality,inner,knockout,hideObject) {
	if(hideObject == null) {
		hideObject = false;
	}
	if(knockout == null) {
		knockout = false;
	}
	if(inner == null) {
		inner = false;
	}
	if(quality == null) {
		quality = 1;
	}
	if(strength == null) {
		strength = 1;
	}
	if(blurY == null) {
		blurY = 4;
	}
	if(blurX == null) {
		blurX = 4;
	}
	if(alpha == null) {
		alpha = 1;
	}
	if(color == null) {
		color = 0;
	}
	if(angle == null) {
		angle = 45;
	}
	if(distance == null) {
		distance = 4;
	}
	this.distance = 4;
	this.blurY = 0;
	this.blurX = 0;
	this.angle = 45;
	openfl_filters_BitmapFilter.call(this);
	this.__offsetX = 0;
	this.__offsetY = 0;
	this.__updateSize();
	this.set_distance(distance);
	this.set_angle(angle);
	this.set_color(color);
	this.set_alpha(alpha);
	this.set_blurX(blurX);
	this.set_blurY(blurY);
	this.set_strength(strength);
	this.set_quality(quality);
	this.set_inner(inner);
	this.set_knockout(knockout);
	this.set_hideObject(hideObject);
	this.__needSecondBitmapData = true;
	this.__preserveObject = !hideObject;
};
DropShadowFilter.__super__ = openfl_filters_BitmapFilter;
DropShadowFilter.prototype = $extend(openfl_filters_BitmapFilter.prototype, {
    "__properties__": {"set_alpha":"set_alpha","set_angle":"set_angle","set_blurX":"set_blurX","set_blurY":"set_blurY","set_color":"set_color","set_distance":"set_distance","set_hideObject":"set_hideObject","set_inner":"set_inner","set_knockout":"set_knockout","set_quality":"set_quality","set_strength":"set_strength"},
  knockout: null,
  set_alpha: function(value) {
		if(value != this.alpha) {
			this.__renderDirty = true;
		}
		return this.alpha = value;
	},
  set_inner: function(value) {
		if(value != this.inner) {
			this.__renderDirty = true;
		}
		return this.inner = value;
	},
  blurY: null,
  strength: null,
  inner: null,
  set_angle: function(value) {
		if(value != this.angle) {
			this.angle = value;
			this.__renderDirty = true;
			this.__updateSize();
		}
		return value;
	},
  set_blurX: function(value) {
		if(value != this.blurX) {
			this.blurX = value;
			this.__renderDirty = true;
			this.__updateSize();
		}
		return value;
	},
  set_blurY: function(value) {
		if(value != this.blurY) {
			this.blurY = value;
			this.__renderDirty = true;
			this.__updateSize();
		}
		return value;
	},
  set_strength: function(value) {
		if(value != this.strength) {
			this.__renderDirty = true;
		}
		return this.strength = value;
	},
  __applyFilter: function(bitmapData,sourceBitmapData,sourceRect,destPoint) {
		var a = this.color >> 24 & 255;
		var r = this.color >> 16 & 255;
		var g = this.color >> 8 & 255;
		var b = this.color & 255;
		sourceBitmapData.colorTransform(sourceBitmapData.rect,new openfl_geom_ColorTransform(0,0,0,1,r,g,b,a));
		destPoint.x += this.__offsetX;
		destPoint.y += this.__offsetY;
		var finalImage = lime_graphics_utils_ImageDataUtil.gaussianBlur(bitmapData.image,sourceBitmapData.image,sourceRect.__toLimeRectangle(),destPoint.__toLimeVector2(),this.blurX,this.blurY,this.quality,this.strength);
		if(finalImage == bitmapData.image) {
			return bitmapData;
		}
		return sourceBitmapData;
	},
  set_distance: function(value) {
		if(value != this.distance) {
			this.distance = value;
			this.__renderDirty = true;
			this.__updateSize();
		}
		return value;
	},
  set_hideObject: function(value) {
		if(value != this.hideObject) {
			this.__renderDirty = true;
			this.__preserveObject = !value;
		}
		return this.hideObject = value;
	},
  __offsetX: null,
  blurX: null,
  quality: null,
  set_knockout: function(value) {
		if(value != this.knockout) {
			this.__renderDirty = true;
		}
		return this.knockout = value;
	},
  angle: null,
  color: null,
  clone: function() {
		return new DropShadowFilter(this.distance,this.angle,this.color,this.alpha,this.blurX,this.blurY,this.strength,this.quality,this.inner,this.knockout,this.hideObject);
	},
  set_quality: function(value) {
		if(value != this.quality) {
			this.__renderDirty = true;
		}
		return this.quality = value;
	},
  alpha: null,
  __offsetY: null,
  __updateSize: function() {
		this.__offsetX = this.distance * Math.cos(this.angle * Math.PI / 180) | 0;
		this.__offsetY = this.distance * Math.sin(this.angle * Math.PI / 180) | 0;
		this.__topExtension = Math.ceil((this.__offsetY < 0 ? -this.__offsetY : 0) + this.blurY);
		this.__bottomExtension = Math.ceil((this.__offsetY > 0 ? this.__offsetY : 0) + this.blurY);
		this.__leftExtension = Math.ceil((this.__offsetX < 0 ? -this.__offsetX : 0) + this.blurX);
		this.__rightExtension = Math.ceil((this.__offsetX > 0 ? this.__offsetX : 0) + this.blurX);
	},
  set_color: function(value) {
		if(value != this.color) {
			this.__renderDirty = true;
		}
		return this.color = value;
	},
  distance: null,
  hideObject: null,
 __class__: DropShadowFilter
});
DropShadowFilter.__name__ = "openfl.filters.DropShadowFilter";
Object.defineProperties(DropShadowFilter.prototype, {
	"knockout": { set: DropShadowFilter.prototype.set_knockout },
	"blurY": { set: DropShadowFilter.prototype.set_blurY },
	"strength": { set: DropShadowFilter.prototype.set_strength },
	"inner": { set: DropShadowFilter.prototype.set_inner },
	"blurX": { set: DropShadowFilter.prototype.set_blurX },
	"quality": { set: DropShadowFilter.prototype.set_quality },
	"angle": { set: DropShadowFilter.prototype.set_angle },
	"color": { set: DropShadowFilter.prototype.set_color },
	"alpha": { set: DropShadowFilter.prototype.set_alpha },
	"distance": { set: DropShadowFilter.prototype.set_distance },
	"hideObject": { set: DropShadowFilter.prototype.set_hideObject },
});



return DropShadowFilter;
}());
exports.default = exports.DropShadowFilter = DropShadowFilter;
