// Package: openfl.filters.GlowFilter
var lime_graphics_utils_ImageDataUtil = require("../../lime/graphics/utils/ImageDataUtil").ImageDataUtil;
var $extend = require("../../extend_stub").extend_stub;
var openfl_geom_ColorTransform = require("../../openfl/geom/ColorTransform").ColorTransform;
var openfl_filters_BitmapFilter = require("../../openfl/filters/BitmapFilter").BitmapFilter;


// Class: openfl.filters.GlowFilter

var GlowFilter = (function () {
var GlowFilter = function(color,alpha,blurX,blurY,strength,quality,inner,knockout) {
	if(knockout == null) {
		knockout = false;
	}
	if(inner == null) {
		inner = false;
	}
	if(quality == null) {
		quality = 1;
	}
	if(strength == null) {
		strength = 2;
	}
	if(blurY == null) {
		blurY = 6;
	}
	if(blurX == null) {
		blurX = 6;
	}
	if(alpha == null) {
		alpha = 1;
	}
	if(color == null) {
		color = 16711680;
	}
	openfl_filters_BitmapFilter.call(this);
	this.set_color(color);
	this.set_alpha(alpha);
	this.set_blurX(blurX);
	this.set_blurY(blurY);
	this.set_strength(strength);
	this.set_quality(quality);
	this.set_inner(inner);
	this.set_knockout(knockout);
	this.__needSecondBitmapData = true;
	this.__preserveObject = true;
};
GlowFilter.__super__ = openfl_filters_BitmapFilter;
GlowFilter.prototype = $extend(openfl_filters_BitmapFilter.prototype, {
    "__properties__": {"set_alpha":"set_alpha","set_blurX":"set_blurX","set_blurY":"set_blurY","set_color":"set_color","set_inner":"set_inner","set_knockout":"set_knockout","set_quality":"set_quality","set_strength":"set_strength"},
  knockout: null,
  set_alpha: function(value) {
		if(value != this.alpha) {
			this.__renderDirty = true;
		}
		return this.alpha = value;
	},
  set_inner: function(value) {
		if(value != this.inner) {
			this.__renderDirty = true;
		}
		return this.inner = value;
	},
  verticalPasses: null,
  blurY: null,
  strength: null,
  inner: null,
  __initShader: function(renderSession,pass) {
		return null;
	},
  set_blurX: function(value) {
		if(value != this.blurX) {
			this.blurX = value;
			this.__renderDirty = true;
			this.__leftExtension = value > 0 ? Math.ceil(value) : 0;
			this.__rightExtension = this.__leftExtension;
		}
		return value;
	},
  set_blurY: function(value) {
		if(value != this.blurY) {
			this.blurY = value;
			this.__renderDirty = true;
			this.__topExtension = value > 0 ? Math.ceil(value) : 0;
			this.__bottomExtension = this.__topExtension;
		}
		return value;
	},
  set_strength: function(value) {
		if(value != this.strength) {
			this.__renderDirty = true;
		}
		return this.strength = value;
	},
  __applyFilter: function(bitmapData,sourceBitmapData,sourceRect,destPoint) {
		var r = this.color >> 16 & 255;
		var g = this.color >> 8 & 255;
		var b = this.color & 255;
		sourceBitmapData.colorTransform(sourceBitmapData.rect,new openfl_geom_ColorTransform(0,0,0,1,r,g,b,this.alpha * 255));
		var finalImage = lime_graphics_utils_ImageDataUtil.gaussianBlur(bitmapData.image,sourceBitmapData.image,sourceRect.__toLimeRectangle(),destPoint.__toLimeVector2(),this.blurX,this.blurY,this.quality,this.strength);
		if(finalImage == bitmapData.image) {
			return bitmapData;
		}
		return sourceBitmapData;
	},
  blurX: null,
  quality: null,
  set_knockout: function(value) {
		if(value != this.knockout) {
			this.__renderDirty = true;
		}
		return this.knockout = value;
	},
  color: null,
  clone: function() {
		return new GlowFilter(this.color,this.alpha,this.blurX,this.blurY,this.strength,this.quality,this.inner,this.knockout);
	},
  set_quality: function(value) {
		this.horizontalPasses = this.blurX <= 0 ? 0 : Math.round(this.blurX * (value / 4)) + 1;
		this.verticalPasses = this.blurY <= 0 ? 0 : Math.round(this.blurY * (value / 4)) + 1;
		this.__numShaderPasses = this.horizontalPasses + this.verticalPasses;
		if(value != this.quality) {
			this.__renderDirty = true;
		}
		return this.quality = value;
	},
  alpha: null,
  horizontalPasses: null,
  set_color: function(value) {
		if(value != this.color) {
			this.__renderDirty = true;
		}
		return this.color = value;
	},
 __class__: GlowFilter
});
GlowFilter.__name__ = "openfl.filters.GlowFilter";
Object.defineProperties(GlowFilter.prototype, {
	"knockout": { set: GlowFilter.prototype.set_knockout },
	"blurY": { set: GlowFilter.prototype.set_blurY },
	"strength": { set: GlowFilter.prototype.set_strength },
	"inner": { set: GlowFilter.prototype.set_inner },
	"blurX": { set: GlowFilter.prototype.set_blurX },
	"quality": { set: GlowFilter.prototype.set_quality },
	"color": { set: GlowFilter.prototype.set_color },
	"alpha": { set: GlowFilter.prototype.set_alpha },
});



return GlowFilter;
}());
exports.default = exports.GlowFilter = GlowFilter;
