// Package: openfl.geom.PerspectiveProjection
var openfl_Lib = require("../../openfl/Lib").Lib;
var openfl_geom_Point = require("../../openfl/geom/Point").Point;
var openfl_geom_Matrix3D = require("../../openfl/geom/Matrix3D").Matrix3D;


// Class: openfl.geom.PerspectiveProjection

var PerspectiveProjection = (function () {
var PerspectiveProjection = function() {
	this.set_fieldOfView(0);
	this.focalLength = 0;
	this.matrix3D = new openfl_geom_Matrix3D();
	this.projectionCenter = new openfl_geom_Point(openfl_Lib.current.stage.stageWidth / 2,openfl_Lib.current.stage.stageHeight / 2);
};
PerspectiveProjection.prototype = {
    "__properties__": {"set_fieldOfView":"set_fieldOfView"},
  focalLength: null,
  fieldOfView: null,
  projectionCenter: null,
  toMatrix3D: function() {
		if(this.projectionCenter == null) {
			return null;
		}
		var _mp = this.matrix3D.rawData;
		_mp.data.set(0,this.focalLength);
		_mp.data.set(5,this.focalLength);
		_mp.data.set(11,1.0);
		_mp.data.set(15,0);
		return this.matrix3D;
	},
  set_fieldOfView: function(fieldOfView) {
		var p_nFovY = fieldOfView * 0.01745329251994329577;
		this.fieldOfView = p_nFovY;
		var cotan = 1 / Math.tan(p_nFovY / 2);
		this.focalLength = openfl_Lib.current.stage.stageWidth * (openfl_Lib.current.stage.stageWidth / openfl_Lib.current.stage.stageHeight) / 2 * cotan;
		return fieldOfView;
	},
  matrix3D: null,
 __class__: PerspectiveProjection
};
PerspectiveProjection.__name__ = "openfl.geom.PerspectiveProjection";
PerspectiveProjection.TO_RADIAN = 0.01745329251994329577;
Object.defineProperties(PerspectiveProjection.prototype, {
	"fieldOfView": { set: PerspectiveProjection.prototype.set_fieldOfView },
});



return PerspectiveProjection;
}());
exports.default = exports.PerspectiveProjection = PerspectiveProjection;
