// Package: openfl.geom.Point
var lime_utils_ObjectPool_openfl_geom_Point = require("../../lime/utils/ObjectPool_openfl_geom_Point").ObjectPool_openfl_geom_Point;
var lime_math_Vector2 = require("../../lime/math/Vector2").Vector2;


// Class: openfl.geom.Point

var Point = (function () {
var Point = function(x,y) {
	if(y == null) {
		y = 0;
	}
	if(x == null) {
		x = 0;
	}
	this.x = x;
	this.y = y;
};
Point.prototype = {
    "__properties__": {"get_length":"get_length"},
  copyFrom: function(sourcePoint) {
		this.x = sourcePoint.x;
		this.y = sourcePoint.y;
	},
  normalize: function(thickness) {
		if(this.x == 0 && this.y == 0) {
			return;
		} else {
			var norm = thickness / Math.sqrt(this.x * this.x + this.y * this.y);
			this.x *= norm;
			this.y *= norm;
		}
	},
  subtract: function(v) {
		return new Point(this.x - v.x,this.y - v.y);
	},
  setTo: function(xa,ya) {
		this.x = xa;
		this.y = ya;
	},
  add: function(v) {
		return new Point(v.x + this.x,v.y + this.y);
	},
  get_length: function() {
		return Math.sqrt(this.x * this.x + this.y * this.y);
	},
  offset: function(dx,dy) {
		this.x += dx;
		this.y += dy;
	},
  length: null,
  clone: function() {
		return new Point(this.x,this.y);
	},
  toString: function() {
		return "(x=" + this.x + ", y=" + this.y + ")";
	},
  y: null,
  equals: function(toCompare) {
		if(toCompare != null && toCompare.x == this.x) {
			return toCompare.y == this.y;
		} else {
			return false;
		}
	},
  __toLimeVector2: function() {
		if(Point.__limeVector2 == null) {
			Point.__limeVector2 = new lime_math_Vector2();
		}
		var _this = Point.__limeVector2;
		_this.x = this.x;
		_this.y = this.y;
		return Point.__limeVector2;
	},
  x: null,
 __class__: Point
};
Point.__name__ = "openfl.geom.Point";
Point.polar = function(len,angle) {
	return new Point(len * Math.cos(angle),len * Math.sin(angle));
};
Point.interpolate = function(pt1,pt2,f) {
	return new Point(pt2.x + f * (pt1.x - pt2.x),pt2.y + f * (pt1.y - pt2.y));
};
Point.__limeVector2 = null;
Point.distance = function(pt1,pt2) {
	var dx = pt1.x - pt2.x;
	var dy = pt1.y - pt2.y;
	return Math.sqrt(dx * dx + dy * dy);
};
Point.__pool = new lime_utils_ObjectPool_openfl_geom_Point(function() {
	return new Point();
},function(p) {
	p.setTo(0,0);
});
Object.defineProperties(Point.prototype, {
	"length": { get: Point.prototype.get_length },
});



return Point;
}());
exports.default = exports.Point = Point;
