// Package: openfl.geom.Rectangle
var lime_math_Rectangle = require("../../lime/math/Rectangle").Rectangle;
var openfl_geom_Point = require("../../openfl/geom/Point").Point;
var lime_utils_ObjectPool_openfl_geom_Rectangle = require("../../lime/utils/ObjectPool_openfl_geom_Rectangle").ObjectPool_openfl_geom_Rectangle;


// Class: openfl.geom.Rectangle

var Rectangle = (function () {
var Rectangle = function(x,y,width,height) {
	if(height == null) {
		height = 0;
	}
	if(width == null) {
		width = 0;
	}
	if(y == null) {
		y = 0;
	}
	if(x == null) {
		x = 0;
	}
	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
};
Rectangle.prototype = {
    "__properties__": {"get_bottom":"get_bottom","set_bottom":"set_bottom","get_bottomRight":"get_bottomRight","set_bottomRight":"set_bottomRight","get_left":"get_left","set_left":"set_left","get_right":"get_right","set_right":"set_right","get_size":"get_size","set_size":"set_size","get_top":"get_top","set_top":"set_top","get_topLeft":"get_topLeft","set_topLeft":"set_topLeft"},
  __expand: function(x,y,width,height) {
		if(this.width == 0 && this.height == 0) {
			this.x = x;
			this.y = y;
			this.width = width;
			this.height = height;
			return;
		}
		var cacheRight = this.get_right();
		var cacheBottom = this.get_bottom();
		if(this.x > x) {
			this.x = x;
			this.width = cacheRight - x;
		}
		if(this.y > y) {
			this.y = y;
			this.height = cacheBottom - y;
		}
		if(cacheRight < x + width) {
			this.width = x + width - this.x;
		}
		if(cacheBottom < y + height) {
			this.height = y + height - this.y;
		}
	},
  bottom: null,
  copyFrom: function(sourceRect) {
		this.x = sourceRect.x;
		this.y = sourceRect.y;
		this.width = sourceRect.width;
		this.height = sourceRect.height;
	},
  setEmpty: function() {
		this.x = this.y = this.width = this.height = 0;
	},
  set_left: function(l) {
		this.width -= l - this.x;
		this.x = l;
		return l;
	},
  bottomRight: null,
  setTo: function(xa,ya,widtha,heighta) {
		this.x = xa;
		this.y = ya;
		this.width = widtha;
		this.height = heighta;
	},
  set_right: function(r) {
		this.width = r - this.x;
		return r;
	},
  get_right: function() {
		return this.x + this.width;
	},
  containsRect: function(rect) {
		if(rect.width <= 0 || rect.height <= 0) {
			if(rect.x > this.x && rect.y > this.y && rect.get_right() < this.get_right()) {
				return rect.get_bottom() < this.get_bottom();
			} else {
				return false;
			}
		} else if(rect.x >= this.x && rect.y >= this.y && rect.get_right() <= this.get_right()) {
			return rect.get_bottom() <= this.get_bottom();
		} else {
			return false;
		}
	},
  offset: function(dx,dy) {
		this.x += dx;
		this.y += dy;
	},
  toString: function() {
		return "(x=" + this.x + ", y=" + this.y + ", width=" + this.width + ", height=" + this.height + ")";
	},
  set_bottomRight: function(p) {
		this.width = p.x - this.x;
		this.height = p.y - this.y;
		return p.clone();
	},
  set_size: function(p) {
		this.width = p.x;
		this.height = p.y;
		return p.clone();
	},
  y: null,
  isEmpty: function() {
		if(!(this.width <= 0)) {
			return this.height <= 0;
		} else {
			return true;
		}
	},
  get_bottomRight: function() {
		return new openfl_geom_Point(this.x + this.width,this.y + this.height);
	},
  set_top: function(t) {
		this.height -= t - this.y;
		this.y = t;
		return t;
	},
  height: null,
  __transform: function(rect,m) {
		var tx0 = m.a * this.x + m.c * this.y;
		var tx1 = tx0;
		var ty0 = m.b * this.x + m.d * this.y;
		var ty1 = ty0;
		var tx = m.a * (this.x + this.width) + m.c * this.y;
		var ty = m.b * (this.x + this.width) + m.d * this.y;
		if(tx < tx0) {
			tx0 = tx;
		}
		if(ty < ty0) {
			ty0 = ty;
		}
		if(tx > tx1) {
			tx1 = tx;
		}
		if(ty > ty1) {
			ty1 = ty;
		}
		tx = m.a * (this.x + this.width) + m.c * (this.y + this.height);
		ty = m.b * (this.x + this.width) + m.d * (this.y + this.height);
		if(tx < tx0) {
			tx0 = tx;
		}
		if(ty < ty0) {
			ty0 = ty;
		}
		if(tx > tx1) {
			tx1 = tx;
		}
		if(ty > ty1) {
			ty1 = ty;
		}
		tx = m.a * this.x + m.c * (this.y + this.height);
		ty = m.b * this.x + m.d * (this.y + this.height);
		if(tx < tx0) {
			tx0 = tx;
		}
		if(ty < ty0) {
			ty0 = ty;
		}
		if(tx > tx1) {
			tx1 = tx;
		}
		if(ty > ty1) {
			ty1 = ty;
		}
		rect.setTo(tx0 + m.tx,ty0 + m.ty,tx1 - tx0,ty1 - ty0);
	},
  get_top: function() {
		return this.y;
	},
  right: null,
  x: null,
  set_topLeft: function(p) {
		this.x = p.x;
		this.y = p.y;
		return p.clone();
	},
  top: null,
  inflatePoint: function(point) {
		this.inflate(point.x,point.y);
	},
  get_bottom: function() {
		return this.y + this.height;
	},
  union: function(toUnion) {
		if(this.width == 0 || this.height == 0) {
			return toUnion.clone();
		} else if(toUnion.width == 0 || toUnion.height == 0) {
			return this.clone();
		}
		var x0 = this.x > toUnion.x ? toUnion.x : this.x;
		var x1 = this.get_right() < toUnion.get_right() ? toUnion.get_right() : this.get_right();
		var y0 = this.y > toUnion.y ? toUnion.y : this.y;
		var y1 = this.get_bottom() < toUnion.get_bottom() ? toUnion.get_bottom() : this.get_bottom();
		return new Rectangle(x0,y0,x1 - x0,y1 - y0);
	},
  __toLimeRectangle: function() {
		if(Rectangle.__limeRectangle == null) {
			Rectangle.__limeRectangle = new lime_math_Rectangle();
		}
		Rectangle.__limeRectangle.setTo(this.x,this.y,this.width,this.height);
		return Rectangle.__limeRectangle;
	},
  set_bottom: function(b) {
		this.height = b - this.y;
		return b;
	},
  intersects: function(toIntersect) {
		var x0 = this.x < toIntersect.x ? toIntersect.x : this.x;
		var x1 = this.get_right() > toIntersect.get_right() ? toIntersect.get_right() : this.get_right();
		if(x1 <= x0) {
			return false;
		}
		var y0 = this.y < toIntersect.y ? toIntersect.y : this.y;
		var y1 = this.get_bottom() > toIntersect.get_bottom() ? toIntersect.get_bottom() : this.get_bottom();
		return y1 > y0;
	},
  offsetPoint: function(point) {
		this.x += point.x;
		this.y += point.y;
	},
  left: null,
  get_topLeft: function() {
		return new openfl_geom_Point(this.x,this.y);
	},
  contains: function(x,y) {
		if(x >= this.x && y >= this.y && x < this.get_right()) {
			return y < this.get_bottom();
		} else {
			return false;
		}
	},
  inflate: function(dx,dy) {
		this.x -= dx;
		this.width += dx * 2;
		this.y -= dy;
		this.height += dy * 2;
	},
  size: null,
  clone: function() {
		return new Rectangle(this.x,this.y,this.width,this.height);
	},
  get_size: function() {
		return new openfl_geom_Point(this.width,this.height);
	},
  topLeft: null,
  equals: function(toCompare) {
		if(toCompare == this) {
			return true;
		} else if(toCompare != null && this.x == toCompare.x && this.y == toCompare.y && this.width == toCompare.width) {
			return this.height == toCompare.height;
		} else {
			return false;
		}
	},
  intersection: function(toIntersect) {
		var x0 = this.x < toIntersect.x ? toIntersect.x : this.x;
		var x1 = this.get_right() > toIntersect.get_right() ? toIntersect.get_right() : this.get_right();
		if(x1 <= x0) {
			return new Rectangle();
		}
		var y0 = this.y < toIntersect.y ? toIntersect.y : this.y;
		var y1 = this.get_bottom() > toIntersect.get_bottom() ? toIntersect.get_bottom() : this.get_bottom();
		if(y1 <= y0) {
			return new Rectangle();
		}
		return new Rectangle(x0,y0,x1 - x0,y1 - y0);
	},
  __contract: function(x,y,width,height) {
		if(this.width == 0 && this.height == 0) {
			return;
		}
		var offsetX = 0.0;
		var offsetY = 0.0;
		var offsetRight = 0.0;
		var offsetBottom = 0.0;
		if(this.x < x) {
			offsetX = x - this.x;
		}
		if(this.y < y) {
			offsetY = y - this.y;
		}
		if(this.get_right() > x + width) {
			offsetRight = x + width - this.get_right();
		}
		if(this.get_bottom() > y + height) {
			offsetBottom = y + height - this.get_bottom();
		}
		this.x += offsetX;
		this.y += offsetY;
		this.width += offsetRight - offsetX;
		this.height += offsetBottom - offsetY;
	},
  width: null,
  containsPoint: function(point) {
		return this.contains(point.x,point.y);
	},
  get_left: function() {
		return this.x;
	},
 __class__: Rectangle
};
Rectangle.__name__ = "openfl.geom.Rectangle";
Rectangle.__limeRectangle = null;
Rectangle.__pool = new lime_utils_ObjectPool_openfl_geom_Rectangle(function() {
	return new Rectangle();
},function(r) {
	r.setTo(0,0,0,0);
});
Object.defineProperties(Rectangle.prototype, {
	"top": { get: Rectangle.prototype.get_top, set: Rectangle.prototype.set_top },
	"bottom": { get: Rectangle.prototype.get_bottom, set: Rectangle.prototype.set_bottom },
	"bottomRight": { get: Rectangle.prototype.get_bottomRight, set: Rectangle.prototype.set_bottomRight },
	"left": { get: Rectangle.prototype.get_left, set: Rectangle.prototype.set_left },
	"size": { get: Rectangle.prototype.get_size, set: Rectangle.prototype.set_size },
	"topLeft": { get: Rectangle.prototype.get_topLeft, set: Rectangle.prototype.set_topLeft },
	"right": { get: Rectangle.prototype.get_right, set: Rectangle.prototype.set_right },
});



return Rectangle;
}());
exports.default = exports.Rectangle = Rectangle;
