// Package: openfl.geom.Transform
var openfl__Vector_Vector_Impl_ = require("../../openfl/_Vector/Vector_Impl_").Vector_Impl_;
var openfl_geom_ColorTransform = require("../../openfl/geom/ColorTransform").ColorTransform;
var openfl_geom_Rectangle = require("../../openfl/geom/Rectangle").Rectangle;
var openfl_geom_Matrix3D = require("../../openfl/geom/Matrix3D").Matrix3D;


// Class: openfl.geom.Transform

var Transform = (function () {
var Transform = function(displayObject) {
	this.__colorTransform = new openfl_geom_ColorTransform();
	this.concatenatedColorTransform = new openfl_geom_ColorTransform();
	this.pixelBounds = new openfl_geom_Rectangle();
	this.__displayObject = displayObject;
	this.__hasMatrix = true;
};
Transform.prototype = {
    "__properties__": {"get_colorTransform":"get_colorTransform","set_colorTransform":"set_colorTransform","get_concatenatedMatrix":"get_concatenatedMatrix","get_matrix":"get_matrix","set_matrix":"set_matrix","get_matrix3D":"get_matrix3D","set_matrix3D":"set_matrix3D"},
  get_concatenatedMatrix: function() {
		if(this.__hasMatrix) {
			return this.__displayObject.__getWorldTransform().clone();
		}
		return null;
	},
  get_matrix: function() {
		if(this.__hasMatrix) {
			return this.__displayObject.__transform.clone();
		}
		return null;
	},
  __hasMatrix3D: null,
  __setTransform: function(a,b,c,d,tx,ty) {
		if(this.__displayObject != null) {
			var scaleX = 0.0;
			var scaleY = 0.0;
			if(b == 0) {
				scaleX = a;
			} else {
				scaleX = Math.sqrt(a * a + b * b);
			}
			if(c == 0) {
				scaleY = a;
			} else {
				scaleY = Math.sqrt(c * c + d * d);
			}
			this.__displayObject.__scaleX = scaleX;
			this.__displayObject.__scaleY = scaleY;
			var rotation = 180 / Math.PI * Math.atan2(d,c) - 90;
			if(rotation != this.__displayObject.__rotation) {
				this.__displayObject.__rotation = rotation;
				var radians = rotation * (Math.PI / 180);
				this.__displayObject.__rotationSine = Math.sin(radians);
				this.__displayObject.__rotationCosine = Math.cos(radians);
			}
			this.__displayObject.__transform.a = a;
			this.__displayObject.__transform.b = b;
			this.__displayObject.__transform.c = c;
			this.__displayObject.__transform.d = d;
			this.__displayObject.__transform.tx = tx;
			this.__displayObject.__transform.ty = ty;
			this.__displayObject.__setTransformDirty();
		}
	},
  concatenatedMatrix: null,
  colorTransform: null,
  matrix: null,
  pixelBounds: null,
  set_matrix: function(value) {
		if(value == null) {
			this.__hasMatrix = false;
			return null;
		}
		this.__hasMatrix = true;
		this.__hasMatrix3D = false;
		if(this.__displayObject != null) {
			this.__setTransform(value.a,value.b,value.c,value.d,value.tx,value.ty);
		}
		return value;
	},
  get_colorTransform: function() {
		return this.__colorTransform;
	},
  __displayObject: null,
  set_matrix3D: function(value) {
		if(value == null) {
			this.__hasMatrix3D = false;
			return null;
		}
		this.__hasMatrix = false;
		this.__hasMatrix3D = true;
		this.__setTransform(value.rawData.data.get(0),value.rawData.data.get(1),value.rawData.data.get(5),value.rawData.data.get(6),value.rawData.data.get(12),value.rawData.data.get(13));
		return value;
	},
  get_matrix3D: function() {
		if(this.__hasMatrix3D) {
			var matrix = this.__displayObject.__transform;
			var a = [matrix.a,matrix.b,0.0,0.0,matrix.c,matrix.d,0.0,0.0,0.0,0.0,1.0,0.0,matrix.tx,matrix.ty,0.0,1.0];
			var vector = openfl__Vector_Vector_Impl_.toFloatVector(null);
			var _g1 = 0;
			var _g = a.length;
			while(_g1 < _g) {
				var i = _g1++;
				vector.data.set(i,a[i]);
			}
			return new openfl_geom_Matrix3D(vector);
		}
		return null;
	},
  matrix3D: null,
  concatenatedColorTransform: null,
  __colorTransform: null,
  set_colorTransform: function(value) {
		if(!this.__colorTransform.__equals(value)) {
			this.__colorTransform = value;
			if(value != null) {
				this.__displayObject.set_alpha(value.alphaMultiplier);
			}
			var _this = this.__displayObject;
			if(!_this.__renderDirty) {
				_this.__renderDirty = true;
				_this.__setParentRenderDirty();
			}
		}
		return this.__colorTransform;
	},
  __hasMatrix: null,
 __class__: Transform
};
Transform.__name__ = "openfl.geom.Transform";
Object.defineProperties(Transform.prototype, {
	"concatenatedMatrix": { get: Transform.prototype.get_concatenatedMatrix },
	"colorTransform": { get: Transform.prototype.get_colorTransform, set: Transform.prototype.set_colorTransform },
	"matrix": { get: Transform.prototype.get_matrix, set: Transform.prototype.set_matrix },
	"matrix3D": { get: Transform.prototype.get_matrix3D, set: Transform.prototype.set_matrix3D },
});



return Transform;
}());
exports.default = exports.Transform = Transform;
