// Package: openfl.media.Sound
var lime_utils_Assets = require("../../lime/utils/Assets").Assets;
var openfl_media_SoundTransform = require("../../openfl/media/SoundTransform").SoundTransform;
var lime_media_AudioSource = require("../../lime/media/AudioSource").AudioSource;
var openfl_events_IOErrorEvent = require("../../openfl/events/IOErrorEvent").IOErrorEvent;
var openfl_utils__ByteArray_ByteArray_Impl_ = require("../../openfl/utils/_ByteArray/ByteArray_Impl_").ByteArray_Impl_;
var openfl_media_ID3Info = require("../../openfl/media/ID3Info").ID3Info;
var openfl_utils_ByteArrayData = require("../../openfl/utils/ByteArrayData").ByteArrayData;
var openfl_events_EventDispatcher = require("../../openfl/events/EventDispatcher").EventDispatcher;
var openfl_media_SoundChannel = require("../../openfl/media/SoundChannel").SoundChannel;
var $bind = require("../../bind_stub").bind_stub;
var $extend = require("../../extend_stub").extend_stub;
var openfl_media_SoundMixer = require("../../openfl/media/SoundMixer").SoundMixer;
var lime_media_AudioBuffer = require("../../lime/media/AudioBuffer").AudioBuffer;
var openfl_events_Event = require("../../openfl/events/Event").Event;
var lime_app_Future = require("../../lime/app/Future").Future;


// Class: openfl.media.Sound

var Sound = (function () {
var Sound = function(stream,context) {
	openfl_events_EventDispatcher.call(this,this);
	this.bytesLoaded = 0;
	this.bytesTotal = 0;
	this.isBuffering = false;
	this.url = null;
	if(stream != null) {
		this.load(stream,context);
	}
};
Sound.__super__ = openfl_events_EventDispatcher;
Sound.prototype = $extend(openfl_events_EventDispatcher.prototype, {
    "__properties__": {"get_id3":"get_id3","get_length":"get_length"},
  url: null,
  play: function(startTime,loops,sndTransform) {
		if(loops == null) {
			loops = 0;
		}
		if(startTime == null) {
			startTime = 0.0;
		}
		if(openfl_media_SoundMixer.__soundChannels.length >= 32) {
			return null;
		}
		if(sndTransform == null) {
			sndTransform = new openfl_media_SoundTransform();
		} else {
			sndTransform = sndTransform.clone();
		}
		var pan = openfl_media_SoundMixer.__soundTransform.pan + sndTransform.pan;
		if(pan > 1) {
			pan = 1;
		}
		if(pan < -1) {
			pan = -1;
		}
		var volume = openfl_media_SoundMixer.__soundTransform.volume * sndTransform.volume;
		var source = new lime_media_AudioSource(this.__buffer);
		source.offset = startTime | 0;
		if(loops > 1) {
			source.set_loops(loops - 1);
		}
		source.set_gain(volume);
		var position = source.get_position();
		position.x = pan;
		position.z = -1 * Math.sqrt(1 - Math.pow(pan,2));
		source.set_position(position);
		return new openfl_media_SoundChannel(source,sndTransform);
	},
  isBuffering: null,
  loadCompressedDataFromByteArray: function(bytes,bytesLength) {
		if(bytes == null || bytesLength <= 0) {
			this.dispatchEvent(new openfl_events_IOErrorEvent("ioError"));
			return;
		}
		if(openfl_utils__ByteArray_ByteArray_Impl_.get_length(bytes) > bytesLength) {
			var this1 = new openfl_utils_ByteArrayData(bytesLength);
			var copy = this1;
			copy.writeBytes(bytes,0,bytesLength);
			bytes = copy;
		}
		this.__buffer = lime_media_AudioBuffer.fromBytes(openfl_utils__ByteArray_ByteArray_Impl_.toBytes(bytes));
		if(this.__buffer == null) {
			this.dispatchEvent(new openfl_events_IOErrorEvent("ioError"));
		} else {
			this.dispatchEvent(new openfl_events_Event("complete"));
		}
	},
  id3: null,
  loadPCMFromByteArray: function(bytes,samples,format,stereo,sampleRate) {
		if(sampleRate == null) {
			sampleRate = 44100;
		}
		if(stereo == null) {
			stereo = true;
		}
		if(format == null) {
			format = "float";
		}
		if(bytes == null) {
			this.dispatchEvent(new openfl_events_IOErrorEvent("ioError"));
			return;
		}
		var audioBuffer = new lime_media_AudioBuffer();
		audioBuffer.bitsPerSample = format == "float" ? 32 : 16;
		audioBuffer.channels = stereo ? 2 : 1;
		var buffer = openfl_utils__ByteArray_ByteArray_Impl_.toArrayBuffer(bytes);
		var this1;
		if(buffer != null) {
			this1 = new Uint8Array(buffer,0);
		} else {
			this1 = null;
		}
		audioBuffer.data = this1;
		audioBuffer.sampleRate = sampleRate | 0;
		this.__buffer = audioBuffer;
		this.dispatchEvent(new openfl_events_Event("complete"));
	},
  AudioBuffer_onURLLoad: function(buffer) {
		if(buffer == null) {
			this.dispatchEvent(new openfl_events_IOErrorEvent("ioError"));
		} else {
			this.__buffer = buffer;
			this.dispatchEvent(new openfl_events_Event("complete"));
		}
	},
  get_length: function() {
		if(this.__buffer != null) {
			var samples = this.__buffer.data.length * 8 / (this.__buffer.channels * this.__buffer.bitsPerSample);
			return samples / this.__buffer.sampleRate * 1000 | 0;
		}
		return 0;
	},
  bytesTotal: null,
  close: function() {
		if(this.__buffer != null) {
			this.__buffer.dispose();
		}
	},
  length: null,
  load: function(stream,context) {
		var _gthis = this;
		this.url = stream.url;
		var defaultLibrary = lime_utils_Assets.getLibrary("default");
		var tmp;
		if(defaultLibrary != null) {
			var key = this.url;
			var _this = defaultLibrary.cachedAudioBuffers;
			if(__map_reserved[key] != null) {
				tmp = _this.existsReserved(key);
			} else {
				tmp = _this.h.hasOwnProperty(key);
			}
		} else {
			tmp = false;
		}
		if(tmp) {
			var key1 = this.url;
			var _this1 = defaultLibrary.cachedAudioBuffers;
			this.AudioBuffer_onURLLoad(__map_reserved[key1] != null ? _this1.getReserved(key1) : _this1.h[key1]);
		} else {
			lime_media_AudioBuffer.loadFromFile(this.url).onComplete($bind(this,this.AudioBuffer_onURLLoad)).onError(function(_) {
				_gthis.AudioBuffer_onURLLoad(null);
			});
		}
	},
  get_id3: function() {
		return new openfl_media_ID3Info();
	},
  bytesLoaded: null,
  __buffer: null,
 __class__: Sound
});
Sound.__name__ = "openfl.media.Sound";
Sound.loadFromFiles = function(paths) {
	return lime_media_AudioBuffer.loadFromFiles(paths).then(function(audioBuffer) {
		return lime_app_Future.withValue(Sound.fromAudioBuffer(audioBuffer));
	});
};
Sound.fromAudioBuffer = function(buffer) {
	var sound = new Sound();
	sound.__buffer = buffer;
	return sound;
};
Sound.loadFromFile = function(path) {
	return lime_media_AudioBuffer.loadFromFile(path).then(function(audioBuffer) {
		return lime_app_Future.withValue(Sound.fromAudioBuffer(audioBuffer));
	});
};
Sound.fromFile = function(path) {
	return Sound.fromAudioBuffer(lime_media_AudioBuffer.fromFile(path));
};
Object.defineProperties(Sound.prototype, {
	"id3": { get: Sound.prototype.get_id3 },
	"length": { get: Sound.prototype.get_length },
});



return Sound;
}());
exports.default = exports.Sound = Sound;
