// Package: openfl.media.SoundChannel
var openfl_media_SoundTransform = require("../../openfl/media/SoundTransform").SoundTransform;
var openfl_events_EventDispatcher = require("../../openfl/events/EventDispatcher").EventDispatcher;
var $bind = require("../../bind_stub").bind_stub;
var $extend = require("../../extend_stub").extend_stub;
var openfl_media_SoundMixer = require("../../openfl/media/SoundMixer").SoundMixer;
var openfl_events_Event = require("../../openfl/events/Event").Event;


// Class: openfl.media.SoundChannel

var SoundChannel = (function () {
var SoundChannel = function(source,soundTransform) {
	openfl_events_EventDispatcher.call(this,this);
	this.leftPeak = 1;
	this.rightPeak = 1;
	if(soundTransform != null) {
		this.__soundTransform = soundTransform;
	} else {
		this.__soundTransform = new openfl_media_SoundTransform();
	}
	if(source != null) {
		this.__source = source;
		this.__source.onComplete.add($bind(this,this.source_onComplete));
		this.__isValid = true;
		this.__source.play();
	}
	openfl_media_SoundMixer.__registerSoundChannel(this);
};
SoundChannel.__super__ = openfl_events_EventDispatcher;
SoundChannel.prototype = $extend(openfl_events_EventDispatcher.prototype, {
    "__properties__": {"get_position":"get_position","set_position":"set_position","get_soundTransform":"get_soundTransform","set_soundTransform":"set_soundTransform"},
  soundTransform: null,
  get_soundTransform: function() {
		return this.__soundTransform.clone();
	},
  get_position: function() {
		if(!this.__isValid) {
			return 0;
		}
		return this.__source.get_currentTime() + this.__source.offset;
	},
  leftPeak: null,
  __updateTransform: function() {
		this.set_soundTransform(this.get_soundTransform());
	},
  position: null,
  __isValid: null,
  __source: null,
  set_position: function(value) {
		if(!this.__isValid) {
			return 0;
		}
		this.__source.set_currentTime((value | 0) - this.__source.offset);
		return value;
	},
  stop: function() {
		openfl_media_SoundMixer.__unregisterSoundChannel(this);
		if(!this.__isValid) {
			return;
		}
		this.__source.stop();
		this.__dispose();
	},
  rightPeak: null,
  source_onComplete: function() {
		openfl_media_SoundMixer.__unregisterSoundChannel(this);
		this.__dispose();
		this.dispatchEvent(new openfl_events_Event("soundComplete"));
	},
  __soundTransform: null,
  __dispose: function() {
		if(!this.__isValid) {
			return;
		}
		this.__source.onComplete.remove($bind(this,this.source_onComplete));
		this.__source.dispose();
		this.__isValid = false;
	},
  set_soundTransform: function(value) {
		if(value != null) {
			this.__soundTransform.pan = value.pan;
			this.__soundTransform.volume = value.volume;
			var pan = openfl_media_SoundMixer.__soundTransform.pan + this.__soundTransform.pan;
			if(pan < -1) {
				pan = -1;
			}
			if(pan > 1) {
				pan = 1;
			}
			var volume = openfl_media_SoundMixer.__soundTransform.volume * this.__soundTransform.volume;
			if(this.__isValid) {
				this.__source.set_gain(volume);
				var position = this.__source.get_position();
				position.x = pan;
				position.z = -1 * Math.sqrt(1 - Math.pow(pan,2));
				this.__source.set_position(position);
				return value;
			}
		}
		return value;
	},
 __class__: SoundChannel
});
SoundChannel.__name__ = "openfl.media.SoundChannel";
Object.defineProperties(SoundChannel.prototype, {
	"soundTransform": { get: SoundChannel.prototype.get_soundTransform, set: SoundChannel.prototype.set_soundTransform },
	"position": { get: SoundChannel.prototype.get_position, set: SoundChannel.prototype.set_position },
});



return SoundChannel;
}());
exports.default = exports.SoundChannel = SoundChannel;
