// Package: openfl.net.NetStream
var openfl_events_EventDispatcher = require("../../openfl/events/EventDispatcher").EventDispatcher;
var haxe_Timer = require("../../haxe/Timer").Timer;
var $bind = require("../../bind_stub").bind_stub;
var openfl_events_NetStatusEvent = require("../../openfl/events/NetStatusEvent").NetStatusEvent;
var $extend = require("../../extend_stub").extend_stub;


// Class: openfl.net.NetStream

var NetStream = (function () {
var NetStream = function(connection,peerID) {
	openfl_events_EventDispatcher.call(this);
	this.__connection = connection;
	this.__video = window.document.createElement("video");
	this.__video.setAttribute("playsinline","");
	this.__video.setAttribute("webkit-playsinline","");
	this.__video.addEventListener("error",$bind(this,this.video_onError),false);
	this.__video.addEventListener("waiting",$bind(this,this.video_onWaiting),false);
	this.__video.addEventListener("ended",$bind(this,this.video_onEnd),false);
	this.__video.addEventListener("pause",$bind(this,this.video_onPause),false);
	this.__video.addEventListener("seeking",$bind(this,this.video_onSeeking),false);
	this.__video.addEventListener("playing",$bind(this,this.video_onPlaying),false);
	this.__video.addEventListener("timeupdate",$bind(this,this.video_onTimeUpdate),false);
	this.__video.addEventListener("loadstart",$bind(this,this.video_onLoadStart),false);
	this.__video.addEventListener("stalled",$bind(this,this.video_onStalled),false);
	this.__video.addEventListener("durationchanged",$bind(this,this.video_onDurationChanged),false);
	this.__video.addEventListener("canplay",$bind(this,this.video_onCanPlay),false);
	this.__video.addEventListener("canplaythrough",$bind(this,this.video_onCanPlayThrough),false);
	this.__video.addEventListener("loadedmetadata",$bind(this,this.video_onLoadMetaData),false);
};
NetStream.__super__ = openfl_events_EventDispatcher;
NetStream.prototype = $extend(openfl_events_EventDispatcher.prototype, {
    "__properties__": {"get_speed":"get_speed","set_speed":"set_speed"},
  objectEncoding: null,
  requestVideoStatus: function() {
		var _gthis = this;
		if(this.__timer == null) {
			this.__timer = new haxe_Timer(1);
		}
		this.__timer.run = function() {
			if(_gthis.__video.paused) {
				_gthis.__playStatus("NetStream.Play.pause");
			} else {
				_gthis.__playStatus("NetStream.Play.playing");
			}
			_gthis.__timer.stop();
		};
	},
  video_onEnd: function(event) {
		this.__connection.dispatchEvent(new openfl_events_NetStatusEvent("netStatus",false,false,{ code : "NetStream.Play.Stop"}));
		this.__playStatus("NetStream.Play.Complete");
	},
  play: function(url,_,_1,_2,_3,_4) {
		this.__video.src = url;
		this.__video.play();
	},
  video_onLoadStart: function(event) {
		this.__playStatus("NetStream.Play.loadstart");
	},
  audioCodec: null,
  video_onPause: function(event) {
		this.__playStatus("NetStream.Play.pause");
	},
  checkPolicyFile: null,
  __connection: null,
  videoCode: null,
  liveDelay: null,
  client: null,
  video_onTimeUpdate: function(event) {
		this.time = this.__video.currentTime;
		this.__playStatus("NetStream.Play.timeupdate");
	},
  bufferLength: null,
  resume: function() {
		this.__video.play();
	},
  set_speed: function(value) {
		return this.__video.playbackRate = value;
	},
  speed: null,
  video_onCanPlayThrough: function(event) {
		this.__playStatus("NetStream.Play.canplaythrough");
	},
  video_onCanPlay: function(event) {
		this.__playStatus("NetStream.Play.canplay");
	},
  bufferTime: null,
  bytesLoaded: null,
  video_onDurationChanged: function(event) {
		this.__playStatus("NetStream.Play.durationchanged");
	},
  __video: null,
  video_onLoadMetaData: function(event) {
		if(this.client != null) {
			try {
				var handler = this.client.onMetaData;
				handler({ width : this.__video.videoWidth, height : this.__video.videoHeight, duration : this.__video.duration});
			} catch( e ) {
			}
		}
	},
  decodedFrames: null,
  soundTransform: null,
  video_onSeeking: function(event) {
		this.__playStatus("NetStream.Play.seeking");
	},
  togglePause: function() {
		if(this.__video.paused) {
			this.__video.play();
		} else {
			this.__video.pause();
		}
	},
  __playStatus: function(code) {
		if(this.client != null) {
			try {
				var handler = this.client.onPlayStatus;
				handler({ code : code, duration : this.__video.duration, position : this.__video.currentTime, speed : this.__video.playbackRate, start : this.__video.startTime});
			} catch( e ) {
			}
		}
	},
  video_onPlaying: function(event) {
		this.__connection.dispatchEvent(new openfl_events_NetStatusEvent("netStatus",false,false,{ code : "NetStream.Play.Start"}));
		this.__playStatus("NetStream.Play.playing");
	},
  seek: function(time) {
		if(time < 0) {
			time = 0;
		} else if(time > this.__video.duration) {
			time = this.__video.duration;
		}
		this.__video.currentTime = time;
	},
  video_onError: function(event) {
		this.__connection.dispatchEvent(new openfl_events_NetStatusEvent("netStatus",false,false,{ code : "NetStream.Play.Stop"}));
		this.__playStatus("NetStream.Play.error");
	},
  video_onStalled: function(event) {
		this.__playStatus("NetStream.Play.stalled");
	},
  bytesTotal: null,
  close: function() {
		this.__video.pause();
		this.__video.src = "";
		this.time = 0;
	},
  get_speed: function() {
		return this.__video.playbackRate;
	},
  video_onWaiting: function(event) {
		this.__playStatus("NetStream.Play.waiting");
	},
  time: null,
  __timer: null,
  pause: function() {
		this.__video.pause();
	},
  currentFPS: null,
 __class__: NetStream
});
NetStream.__name__ = "openfl.net.NetStream";
Object.defineProperties(NetStream.prototype, {
	"speed": { get: NetStream.prototype.get_speed, set: NetStream.prototype.set_speed },
});



return NetStream;
}());
exports.default = exports.NetStream = NetStream;
