// Package: openfl.net.SharedObject
var openfl_Lib = require("../../openfl/Lib").Lib;
var haxe_ds_StringMap = require("../../haxe/ds/StringMap").StringMap;
var HxOverrides = require("../../HxOverrides").HxOverrides;
var Type = require("../../Type").Type;
var haxe_io_Bytes = require("../../haxe/io/Bytes").Bytes;
var js__Boot_HaxeError = require("../../js/_Boot/HaxeError").HaxeError;
var openfl_events_EventDispatcher = require("../../openfl/events/EventDispatcher").EventDispatcher;
var StringTools = require("../../StringTools").StringTools;
var lime_system_System = require("../../lime/system/System").System;
var $extend = require("../../extend_stub").extend_stub;
var Reflect = require("../../Reflect").Reflect;
var openfl_errors_Error = require("../../openfl/errors/Error").Error;
var haxe_Serializer = require("../../haxe/Serializer").Serializer;
var js_Browser = require("../../js/Browser").Browser;
var haxe_ds__StringMap_StringMapIterator = require("../../haxe/ds/_StringMap/StringMapIterator").StringMapIterator;
var haxe_Unserializer = require("../../haxe/Unserializer").Unserializer;


// Class: openfl.net.SharedObject

var SharedObject = (function () {
var SharedObject = function() {
	openfl_events_EventDispatcher.call(this);
	this.client = this;
	this.objectEncoding = 3;
};
SharedObject.__super__ = openfl_events_EventDispatcher;
SharedObject.prototype = $extend(openfl_events_EventDispatcher.prototype, {
    "__properties__": {"get_size":"get_size"},
  __name: null,
  objectEncoding: null,
  send: function(args) {
		openfl_Lib.notImplemented({ fileName : "SharedObject.hx", lineNumber : 269, className : "openfl.net.SharedObject", methodName : "send"});
	},
  setProperty: function(propertyName,value) {
		if(this.data != null) {
			this.data[propertyName] = value;
		}
	},
  connect: function(myConnection,params) {
		openfl_Lib.notImplemented({ fileName : "SharedObject.hx", lineNumber : 96, className : "openfl.net.SharedObject", methodName : "connect"});
	},
  fps: null,
  clear: function() {
		this.data = { };
		try {
			var storage = js_Browser.getLocalStorage();
			if(storage != null) {
				storage.removeItem(this.__localPath + ":" + this.__name);
			}
		} catch( e ) {
		}
	},
  size: null,
  close: function() {
	},
  setDirty: function(propertyName) {
	},
  client: null,
  data: null,
  flush: function(minDiskSpace) {
		if(minDiskSpace == null) {
			minDiskSpace = 0;
		}
		if(Reflect.fields(this.data).length == 0) {
			return 0;
		}
		var encodedData = haxe_Serializer.run(this.data);
		try {
			var storage = js_Browser.getLocalStorage();
			if(storage != null) {
				storage.removeItem(this.__localPath + ":" + this.__name);
				storage.setItem(this.__localPath + ":" + this.__name,encodedData);
			}
		} catch( e ) {
			return 1;
		}
		return 0;
	},
  get_size: function() {
		try {
			var d = haxe_Serializer.run(this.data);
			return haxe_io_Bytes.ofString(d).length;
		} catch( e ) {
			return 0;
		}
	},
  __localPath: null,
 __class__: SharedObject
});
SharedObject.__name__ = "openfl.net.SharedObject";
SharedObject.__sharedObjects = null;
SharedObject.__resolveClass = function(name) {
	if(name != null) {
		if(StringTools.startsWith(name,"neash.")) {
			name = StringTools.replace(name,"neash.","openfl.");
		}
		if(StringTools.startsWith(name,"native.")) {
			name = StringTools.replace(name,"native.","openfl.");
		}
		if(StringTools.startsWith(name,"flash.")) {
			name = StringTools.replace(name,"flash.","openfl.");
		}
		if(StringTools.startsWith(name,"openfl._v2.")) {
			name = StringTools.replace(name,"openfl._v2.","openfl.");
		}
		if(StringTools.startsWith(name,"openfl._legacy.")) {
			name = StringTools.replace(name,"openfl._legacy.","openfl.");
		}
		return Type.resolveClass(name);
	}
	return null;
};
SharedObject.getLocal = function(name,localPath,secure) {
	if(secure == null) {
		secure = false;
	}
	var illegalValues = [" ","~","%","&","\\",";",":","\"","'",",","<",">","?","#"];
	var allowed = true;
	if(name == null || name == "") {
		allowed = false;
	} else {
		var _g = 0;
		while(_g < illegalValues.length) {
			var value = illegalValues[_g];
			++_g;
			if(name.indexOf(value) > -1) {
				allowed = false;
				break;
			}
		}
	}
	if(!allowed) {
		throw new js__Boot_HaxeError(new openfl_errors_Error("Error #2134: Cannot create SharedObject."));
	}
	if(localPath == null) {
		localPath = window.location.href;
	}
	if(SharedObject.__sharedObjects == null) {
		SharedObject.__sharedObjects = new haxe_ds_StringMap();
		openfl_Lib.application.onExit.add(SharedObject.application_onExit);
	}
	var id = localPath + "/" + name;
	var _this = SharedObject.__sharedObjects;
	if(!(__map_reserved[id] != null ? _this.existsReserved(id) : _this.h.hasOwnProperty(id))) {
		var sharedObject = new SharedObject();
		sharedObject.data = { };
		sharedObject.__localPath = localPath;
		sharedObject.__name = name;
		var encodedData = null;
		try {
			var storage = js_Browser.getLocalStorage();
			if(storage != null) {
				encodedData = storage.getItem(localPath + ":" + name);
			}
		} catch( e ) {
		}
		if(encodedData != null && encodedData != "") {
			try {
				var unserializer = new haxe_Unserializer(encodedData);
				unserializer.setResolver({ resolveEnum : Type.resolveEnum, resolveClass : SharedObject.__resolveClass});
				sharedObject.data = unserializer.unserialize();
			} catch( e1 ) {
			}
		}
		var _this1 = SharedObject.__sharedObjects;
		if(__map_reserved[id] != null) {
			_this1.setReserved(id,sharedObject);
		} else {
			_this1.h[id] = sharedObject;
		}
	}
	var _this2 = SharedObject.__sharedObjects;
	if(__map_reserved[id] != null) {
		return _this2.getReserved(id);
	} else {
		return _this2.h[id];
	}
};
SharedObject.__getPath = function(localPath,name) {
	var path = lime_system_System.get_applicationStorageDirectory() + "/" + localPath + "/";
	name = StringTools.replace(name,"//","/");
	name = StringTools.replace(name,"//","/");
	if(StringTools.startsWith(name,"/")) {
		name = HxOverrides.substr(name,1,null);
	}
	if(StringTools.endsWith(name,"/")) {
		name = name.substring(0,name.length - 1);
	}
	if(name.indexOf("/") > -1) {
		var split = name.split("/");
		name = "";
		var _g1 = 0;
		var _g = split.length - 1;
		while(_g1 < _g) {
			var i = _g1++;
			name += "#" + split[i] + "/";
		}
		name += split[split.length - 1];
	}
	return path + name + ".sol";
};
SharedObject.application_onExit = function(_) {
	var _this = SharedObject.__sharedObjects;
	var sharedObject = new haxe_ds__StringMap_StringMapIterator(_this,_this.arrayKeys());
	while(sharedObject.hasNext()) {
		var sharedObject1 = sharedObject.next();
		sharedObject1.flush();
	}
};
SharedObject.getRemote = function(name,remotePath,persistence,secure) {
	if(secure == null) {
		secure = false;
	}
	if(persistence == null) {
		persistence = false;
	}
	openfl_Lib.notImplemented({ fileName : "SharedObject.hx", lineNumber : 260, className : "openfl.net.SharedObject", methodName : "getRemote"});
	return null;
};
SharedObject.defaultObjectEncoding = 3;
SharedObject.__mkdir = function(directory) {
};
Object.defineProperties(SharedObject.prototype, {
	"size": { get: SharedObject.prototype.get_size },
});



return SharedObject;
}());
exports.default = exports.SharedObject = SharedObject;
