// Package: openfl.net.Socket
var openfl_Lib = require("../../openfl/Lib").Lib;
var haxe_io_Bytes = require("../../haxe/io/Bytes").Bytes;
var openfl_utils_IDataOutput = require("../../openfl/utils/IDataOutput").IDataOutput;
var openfl_errors_IOError = require("../../openfl/errors/IOError").IOError;
var openfl_events_ProgressEvent = require("../../openfl/events/ProgressEvent").ProgressEvent;
var js__Boot_HaxeError = require("../../js/_Boot/HaxeError").HaxeError;
var openfl_utils__ByteArray_ByteArray_Impl_ = require("../../openfl/utils/_ByteArray/ByteArray_Impl_").ByteArray_Impl_;
var openfl_utils_ByteArrayData = require("../../openfl/utils/ByteArrayData").ByteArrayData;
var openfl_events_EventDispatcher = require("../../openfl/events/EventDispatcher").EventDispatcher;
var $bind = require("../../bind_stub").bind_stub;
var openfl_errors_SecurityError = require("../../openfl/errors/SecurityError").SecurityError;
var $extend = require("../../extend_stub").extend_stub;
var _UInt_UInt_Impl_ = require("../../_UInt/UInt_Impl_").UInt_Impl_;
var openfl_utils_IDataInput = require("../../openfl/utils/IDataInput").IDataInput;
var openfl_events_Event = require("../../openfl/events/Event").Event;
var EReg = require("../../EReg").EReg;


// Class: openfl.net.Socket

var Socket = (function () {
var Socket = function(host,port) {
	if(port == null) {
		port = 0;
	}
	openfl_events_EventDispatcher.call(this);
	this.set_endian(0);
	this.timeout = 20000;
	this.__buffer = new haxe_io_Bytes(new ArrayBuffer(4096));
	if(port > 0 && port < 65535) {
		this.connect(host,port);
	}
};
Socket.__interfaces__ = [openfl_utils_IDataOutput,openfl_utils_IDataInput];
Socket.__super__ = openfl_events_EventDispatcher;
Socket.prototype = $extend(openfl_events_EventDispatcher.prototype, {
    "__properties__": {"get_bytesAvailable":"get_bytesAvailable","get_bytesPending":"get_bytesPending","get_connected":"get_connected","get_endian":"get_endian","set_endian":"set_endian"},
  __input: null,
  get_endian: function() {
		return this.__endian;
	},
  __output: null,
  this_onEnterFrame: function(event) {
		if(this.__socket != null) {
			this.flush();
		}
	},
  objectEncoding: null,
  socket_onError: function(e) {
		this.dispatchEvent(new openfl_events_Event("ioError"));
	},
  socket_onOpen: function(_) {
		this.__connected = true;
		this.dispatchEvent(new openfl_events_Event("connect"));
	},
  writeBoolean: function(value) {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		this.__output.writeBoolean(value);
	},
  writeFloat: function(value) {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		this.__output.writeFloat(value);
	},
  bytesPending: null,
  secure: null,
  connect: function(host,port) {
		if(port == null) {
			port = 0;
		}
		if(this.__socket != null) {
			this.close();
		}
		if(port < 0 || port > 65535) {
			throw new js__Boot_HaxeError(new openfl_errors_SecurityError("Invalid socket port number specified."));
		}
		this.__timestamp = window.performance.now() / 1000;
		this.__host = host;
		this.__port = port;
		var this1 = new openfl_utils_ByteArrayData(0);
		this.__output = this1;
		this.__output.__endian = this.__endian;
		var this2 = new openfl_utils_ByteArrayData(0);
		this.__input = this2;
		this.__input.__endian = this.__endian;
		var this3 = new openfl_utils_ByteArrayData(0);
		this.__inputBuffer = this3;
		this.__inputBuffer.__endian = this.__endian;
		if(window.location.protocol == "https:") {
			this.secure = true;
		}
		var schema = this.secure ? "wss" : "ws";
		var urlReg = new EReg("^(.*://)?([A-Za-z0-9\\-\\.]+)/?(.*)","g");
		urlReg.match(host);
		var __webHost = urlReg.matched(2);
		var __webPath = urlReg.matched(3);
		this.__socket = new WebSocket(schema + "://" + __webHost + ":" + port + "/" + __webPath);
		this.__socket.binaryType = "arraybuffer";
		this.__socket.onopen = $bind(this,this.socket_onOpen);
		this.__socket.onmessage = $bind(this,this.socket_onMessage);
		this.__socket.onclose = $bind(this,this.socket_onClose);
		this.__socket.onerror = $bind(this,this.socket_onError);
		openfl_Lib.current.addEventListener("enterFrame",$bind(this,this.this_onEnterFrame));
	},
  writeShort: function(value) {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		this.__output.writeShort(value);
	},
  get_connected: function() {
		return this.__connected;
	},
  __connected: null,
  flush: function() {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		if(openfl_utils__ByteArray_ByteArray_Impl_.get_length(this.__output) > 0) {
			try {
				var buffer = openfl_utils__ByteArray_ByteArray_Impl_.toArrayBuffer(this.__output);
				if(buffer.byteLength > openfl_utils__ByteArray_ByteArray_Impl_.get_length(this.__output)) {
					buffer = buffer.slice(0,openfl_utils__ByteArray_ByteArray_Impl_.get_length(this.__output));
				}
				this.__socket.send(buffer);
				var this1 = new openfl_utils_ByteArrayData(0);
				this.__output = this1;
				this.__output.__endian = this.__endian;
			} catch( e ) {
				throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
			}
		}
	},
  get_bytesAvailable: function() {
		var _this = this.__input;
		return _this.length - _this.position;
	},
  writeUTFBytes: function(value) {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		this.__output.writeUTFBytes(value);
	},
  __endian: null,
  __inputBuffer: null,
  __timestamp: null,
  readUnsignedShort: function() {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		return this.__input.readUnsignedShort();
	},
  writeInt: function(value) {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		this.__output.writeInt(value);
	},
  readByte: function() {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		return this.__input.readByte();
	},
  writeByte: function(value) {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		this.__output.writeByte(value);
	},
  socket_onClose: function(_) {
		this.dispatchEvent(new openfl_events_Event("close"));
	},
  __port: null,
  readBoolean: function() {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		return this.__input.readBoolean();
	},
  readBytes: function(bytes,offset,length) {
		if(length == null) {
			length = 0;
		}
		if(offset == null) {
			offset = 0;
		}
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		this.__input.readBytes(bytes,offset,length);
	},
  readMultiByte: function(length,charSet) {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		return this.__input.readMultiByte(length,charSet);
	},
  writeDouble: function(value) {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		this.__output.writeDouble(value);
	},
  readShort: function() {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		return this.__input.readShort();
	},
  readDouble: function() {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		return this.__input.readDouble();
	},
  readUTF: function() {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		return this.__input.readUTF();
	},
  bytesAvailable: null,
  timeout: null,
  __host: null,
  readInt: function() {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		return this.__input.readInt();
	},
  socket_onMessage: function(msg) {
		if(typeof(msg.data) == "string") {
			this.__inputBuffer.position = openfl_utils__ByteArray_ByteArray_Impl_.get_length(this.__inputBuffer);
			var cachePosition = this.__inputBuffer.position;
			this.__inputBuffer.writeUTFBytes(msg.data);
			this.__inputBuffer.position = cachePosition;
		} else {
			var newData = openfl_utils__ByteArray_ByteArray_Impl_.fromArrayBuffer(msg.data);
			newData.readBytes(this.__inputBuffer,openfl_utils__ByteArray_ByteArray_Impl_.get_length(this.__inputBuffer));
		}
		var _this = this.__inputBuffer;
		if(_UInt_UInt_Impl_.gt(_this.length - _this.position,0)) {
			var this1 = new openfl_utils_ByteArrayData(0);
			var newInput = this1;
			var _this1 = this.__inputBuffer;
			var newDataLength = _this1.length - _this1.position;
			var _this2 = this.__input;
			this.__input.readBytes(newInput,0,_this2.length - _this2.position);
			this.__inputBuffer.position = 0;
			this.__inputBuffer.readBytes(newInput,newInput.position,openfl_utils__ByteArray_ByteArray_Impl_.get_length(this.__inputBuffer));
			newInput.position = 0;
			this.__input = newInput;
			this.__input.__endian = this.__endian;
			this.__inputBuffer.clear();
			this.dispatchEvent(new openfl_events_ProgressEvent("socketData",false,false,_UInt_UInt_Impl_.toFloat(newDataLength),0));
		}
	},
  writeBytes: function(bytes,offset,length) {
		if(length == null) {
			length = 0;
		}
		if(offset == null) {
			offset = 0;
		}
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		this.__output.writeBytes(bytes,offset,length);
	},
  writeUnsignedInt: function(value) {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		this.__output.writeUnsignedInt(value);
	},
  __cleanSocket: function() {
		try {
			this.__socket.close();
		} catch( e ) {
		}
		this.__socket = null;
		this.__connected = false;
		openfl_Lib.current.removeEventListener("enterFrame",$bind(this,this.this_onEnterFrame));
	},
  get_bytesPending: function() {
		return openfl_utils__ByteArray_ByteArray_Impl_.get_length(this.__output);
	},
  close: function() {
		if(this.__socket != null) {
			this.__cleanSocket();
		} else {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
	},
  readUTFBytes: function(length) {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		return this.__input.readUTFBytes(length);
	},
  set_endian: function(value) {
		this.__endian = value;
		if(this.__input != null) {
			this.__input.__endian = value;
		}
		if(this.__inputBuffer != null) {
			this.__inputBuffer.__endian = value;
		}
		if(this.__output != null) {
			this.__output.__endian = value;
		}
		return this.__endian;
	},
  connected: null,
  readUnsignedInt: function() {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		return this.__input.readUnsignedInt();
	},
  endian: null,
  readFloat: function() {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		return this.__input.readFloat();
	},
  writeUTF: function(value) {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		this.__output.writeUTF(value);
	},
  __socket: null,
  readUnsignedByte: function() {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		return this.__input.readUnsignedByte();
	},
  writeMultiByte: function(value,charSet) {
		if(this.__socket == null) {
			throw new js__Boot_HaxeError(new openfl_errors_IOError("Operation attempted on invalid socket."));
		}
		this.__output.writeUTFBytes(value);
	},
  __buffer: null,
 __class__: Socket
});
Socket.__name__ = "openfl.net.Socket";
Object.defineProperties(Socket.prototype, {
	"bytesAvailable": { get: Socket.prototype.get_bytesAvailable },
	"bytesPending": { get: Socket.prototype.get_bytesPending },
	"connected": { get: Socket.prototype.get_connected },
	"endian": { get: Socket.prototype.get_endian, set: Socket.prototype.set_endian },
});



return Socket;
}());
exports.default = exports.Socket = Socket;
