// Package: openfl.net.URLLoader
var openfl_net_URLRequestHeader = require("../../openfl/net/URLRequestHeader").URLRequestHeader;
var lime_net__HTTPRequest_String = require("../../lime/net/_HTTPRequest_String")._HTTPRequest_String;
var haxe_io_Bytes = require("../../haxe/io/Bytes").Bytes;
var openfl_events_ProgressEvent = require("../../openfl/events/ProgressEvent").ProgressEvent;
var openfl_events_IOErrorEvent = require("../../openfl/events/IOErrorEvent").IOErrorEvent;
var openfl_events_EventDispatcher = require("../../openfl/events/EventDispatcher").EventDispatcher;
var lime_net_HTTPRequestHeader = require("../../lime/net/HTTPRequestHeader").HTTPRequestHeader;
var $bind = require("../../bind_stub").bind_stub;
var js_Boot = require("../../js/Boot").Boot;
var $extend = require("../../extend_stub").extend_stub;
var Reflect = require("../../Reflect").Reflect;
var openfl_events_Event = require("../../openfl/events/Event").Event;
var openfl_net_URLVariables = require("../../openfl/net/URLVariables").URLVariables;
var openfl_events_SecurityErrorEvent = require("../../openfl/events/SecurityErrorEvent").SecurityErrorEvent;
var openfl_events_HTTPStatusEvent = require("../../openfl/events/HTTPStatusEvent").HTTPStatusEvent;
var Std = require("../../Std").Std;
var lime_net__HTTPRequest_openfl_utils_ByteArray = require("../../lime/net/_HTTPRequest_openfl_utils_ByteArray")._HTTPRequest_openfl_utils_ByteArray;


// Class: openfl.net.URLLoader

var URLLoader = (function () {
var URLLoader = function(request) {
	openfl_events_EventDispatcher.call(this);
	this.bytesLoaded = 0;
	this.bytesTotal = 0;
	this.dataFormat = 1;
	if(request != null) {
		this.load(request);
	}
};
URLLoader.__super__ = openfl_events_EventDispatcher;
URLLoader.prototype = $extend(openfl_events_EventDispatcher.prototype, {
  dataFormat: null,
  httpRequest_onProgress: function(bytesLoaded,bytesTotal) {
		var event = new openfl_events_ProgressEvent("progress");
		event.bytesLoaded = bytesLoaded;
		event.bytesTotal = bytesTotal;
		this.dispatchEvent(event);
	},
  bytesTotal: null,
  close: function() {
		if(this.__httpRequest != null) {
			this.__httpRequest.cancel();
		}
	},
  data: null,
  __prepareRequest: function(httpRequest,request) {
		this.__httpRequest = httpRequest;
		this.__httpRequest.uri = request.url;
		var _g = request.method;
		var tmp;
		switch(_g) {
		case "DELETE":
			tmp = "DELETE";
			break;
		case "HEAD":
			tmp = "HEAD";
			break;
		case "OPTIONS":
			tmp = "OPTIONS";
			break;
		case "POST":
			tmp = "POST";
			break;
		case "PUT":
			tmp = "PUT";
			break;
		default:
			tmp = "GET";
		}
		this.__httpRequest.method = tmp;
		if(request.data != null) {
			if(js_Boot.__instanceof(request.data,openfl_net_URLVariables)) {
				var fields = Reflect.fields(request.data);
				var _g1 = 0;
				while(_g1 < fields.length) {
					var field = fields[_g1];
					++_g1;
					var _this = this.__httpRequest.formData;
					var value = Reflect.field(request.data,field);
					if(__map_reserved[field] != null) {
						_this.setReserved(field,value);
					} else {
						_this.h[field] = value;
					}
				}
			} else if(js_Boot.__instanceof(request.data,haxe_io_Bytes)) {
				this.__httpRequest.data = request.data;
			} else {
				this.__httpRequest.data = haxe_io_Bytes.ofString(Std.string(request.data));
			}
		}
		this.__httpRequest.contentType = request.contentType;
		if(request.requestHeaders != null) {
			var _g11 = 0;
			var _g2 = request.requestHeaders;
			while(_g11 < _g2.length) {
				var header = _g2[_g11];
				++_g11;
				this.__httpRequest.headers.push(new lime_net_HTTPRequestHeader(header.name,header.value));
			}
		}
		this.__httpRequest.followRedirects = request.followRedirects;
		this.__httpRequest.timeout = request.idleTimeout | 0;
		this.__httpRequest.withCredentials = request.manageCookies;
		var userAgent = request.userAgent;
		if(userAgent == null) {
			userAgent = "Mozilla/5.0 (Windows; U; en) AppleWebKit/420+ (KHTML, like Gecko) OpenFL/1.0";
		}
		this.__httpRequest.userAgent = request.userAgent;
		this.__httpRequest.enableResponseHeaders = true;
	},
  __httpRequest: null,
  load: function(request) {
		var _gthis = this;
		if(this.dataFormat == 0) {
			var httpRequest = new lime_net__HTTPRequest_openfl_utils_ByteArray();
			this.__prepareRequest(httpRequest,request);
			httpRequest.load().onProgress($bind(this,this.httpRequest_onProgress)).onError($bind(this,this.httpRequest_onError)).onComplete(function(data) {
				_gthis.__dispatchStatus();
				_gthis.data = data;
				var event = new openfl_events_Event("complete");
				_gthis.dispatchEvent(event);
			});
		} else {
			var httpRequest1 = new lime_net__HTTPRequest_String();
			this.__prepareRequest(httpRequest1,request);
			httpRequest1.load().onProgress($bind(this,this.httpRequest_onProgress)).onError($bind(this,this.httpRequest_onError)).onComplete(function(data1) {
				_gthis.__dispatchStatus();
				_gthis.data = data1;
				var event1 = new openfl_events_Event("complete");
				_gthis.dispatchEvent(event1);
			});
		}
	},
  __dispatchStatus: function() {
		var event = new openfl_events_HTTPStatusEvent("httpStatus",false,false,this.__httpRequest.responseStatus);
		event.responseURL = this.__httpRequest.uri;
		var headers = [];
		if(this.__httpRequest.enableResponseHeaders && this.__httpRequest.responseHeaders != null) {
			var _g = 0;
			var _g1 = this.__httpRequest.responseHeaders;
			while(_g < _g1.length) {
				var header = _g1[_g];
				++_g;
				headers.push(new openfl_net_URLRequestHeader(header.name,header.value));
			}
		}
		event.responseHeaders = headers;
		this.dispatchEvent(event);
	},
  bytesLoaded: null,
  httpRequest_onError: function(error) {
		this.__dispatchStatus();
		if(error == 403) {
			var event = new openfl_events_SecurityErrorEvent("securityError");
			event.text = Std.string(error);
			this.dispatchEvent(event);
		} else {
			var event1 = new openfl_events_IOErrorEvent("ioError");
			event1.text = Std.string(error);
			this.dispatchEvent(event1);
		}
	},
 __class__: URLLoader
});
URLLoader.__name__ = "openfl.net.URLLoader";


return URLLoader;
}());
exports.default = exports.URLLoader = URLLoader;
