// Package: openfl.net.URLStream
var openfl_events_ProgressEvent = require("../../openfl/events/ProgressEvent").ProgressEvent;
var openfl_utils__ByteArray_ByteArray_Impl_ = require("../../openfl/utils/_ByteArray/ByteArray_Impl_").ByteArray_Impl_;
var openfl_events_EventDispatcher = require("../../openfl/events/EventDispatcher").EventDispatcher;
var openfl_net_URLLoader = require("../../openfl/net/URLLoader").URLLoader;
var $bind = require("../../bind_stub").bind_stub;
var $extend = require("../../extend_stub").extend_stub;
var openfl_utils_IDataInput = require("../../openfl/utils/IDataInput").IDataInput;
var openfl_events_Event = require("../../openfl/events/Event").Event;


// Class: openfl.net.URLStream

var URLStream = (function () {
var URLStream = function() {
	openfl_events_EventDispatcher.call(this);
	this.__loader = new openfl_net_URLLoader();
	this.__loader.dataFormat = 0;
};
URLStream.__interfaces__ = [openfl_utils_IDataInput];
URLStream.__super__ = openfl_events_EventDispatcher;
URLStream.prototype = $extend(openfl_events_EventDispatcher.prototype, {
    "__properties__": {"get_bytesAvailable":"get_bytesAvailable","get_connected":"get_connected","get_endian":"get_endian","set_endian":"set_endian"},
  readByte: function() {
		return this.__data.readByte();
	},
  loader_onComplete: function(event) {
		this.__removeEventListeners();
		this.__data = this.__loader.data;
		this.dispatchEvent(new openfl_events_ProgressEvent("progress",false,false,this.__loader.bytesLoaded,this.__loader.bytesTotal));
		this.dispatchEvent(new openfl_events_Event("complete"));
	},
  get_endian: function() {
		return this.__data.__endian;
	},
  __data: null,
  readBoolean: function() {
		return this.__data.readBoolean();
	},
  readBytes: function(bytes,offset,length) {
		if(length == null) {
			length = 0;
		}
		if(offset == null) {
			offset = 0;
		}
		this.__data.readBytes(bytes,offset,length);
	},
  readMultiByte: function(length,charSet) {
		return this.__data.readMultiByte(length,charSet);
	},
  loader_onProgressEvent: function(event) {
		this.__data = this.__loader.data;
		this.dispatchEvent(event);
	},
  objectEncoding: null,
  readShort: function() {
		return this.__data.readShort();
	},
  loader_onSecurityError: function(event) {
		this.__removeEventListeners();
		this.dispatchEvent(event);
	},
  readDouble: function() {
		return this.__data.readDouble();
	},
  readUTF: function() {
		return this.__data.readUTF();
	},
  bytesAvailable: null,
  readObject: function() {
		return null;
	},
  __loader: null,
  readInt: function() {
		return this.__data.readInt();
	},
  loader_onIOError: function(event) {
		this.__removeEventListeners();
		this.dispatchEvent(event);
	},
  get_connected: function() {
		return false;
	},
  close: function() {
		this.__removeEventListeners();
		this.__data = null;
	},
  readUTFBytes: function(length) {
		return this.__data.readUTFBytes(length);
	},
  __removeEventListeners: function() {
		this.__loader.removeEventListener("complete",$bind(this,this.loader_onComplete));
		this.__loader.removeEventListener("ioError",$bind(this,this.loader_onIOError));
		this.__loader.removeEventListener("securityError",$bind(this,this.loader_onSecurityError));
		this.__loader.removeEventListener("progress",$bind(this,this.loader_onProgressEvent));
	},
  get_bytesAvailable: function() {
		if(this.__data != null) {
			return openfl_utils__ByteArray_ByteArray_Impl_.get_length(this.__data) - this.__data.position;
		}
		return 0;
	},
  set_endian: function(value) {
		return this.__data.__endian = value;
	},
  connected: null,
  load: function(request) {
		this.__removeEventListeners();
		this.__addEventListeners();
		this.__loader.load(request);
	},
  readUnsignedInt: function() {
		return this.__data.readUnsignedInt();
	},
  endian: null,
  readFloat: function() {
		return this.__data.readFloat();
	},
  readUnsignedByte: function() {
		return this.__data.readUnsignedByte();
	},
  readUnsignedShort: function() {
		return this.__data.readUnsignedShort();
	},
  __addEventListeners: function() {
		this.__loader.addEventListener("complete",$bind(this,this.loader_onComplete));
		this.__loader.addEventListener("ioError",$bind(this,this.loader_onIOError));
		this.__loader.addEventListener("securityError",$bind(this,this.loader_onSecurityError));
		this.__loader.addEventListener("progress",$bind(this,this.loader_onProgressEvent));
	},
 __class__: URLStream
});
URLStream.__name__ = "openfl.net.URLStream";
Object.defineProperties(URLStream.prototype, {
	"bytesAvailable": { get: URLStream.prototype.get_bytesAvailable },
	"connected": { get: URLStream.prototype.get_connected },
	"endian": { get: URLStream.prototype.get_endian, set: URLStream.prototype.set_endian },
});



return URLStream;
}());
exports.default = exports.URLStream = URLStream;
