// Package: openfl.net.XMLSocket
var openfl_events_DataEvent = require("../../openfl/events/DataEvent").DataEvent;
var openfl_net_Socket = require("../../openfl/net/Socket").Socket;
var openfl_events_EventDispatcher = require("../../openfl/events/EventDispatcher").EventDispatcher;
var $bind = require("../../bind_stub").bind_stub;
var $extend = require("../../extend_stub").extend_stub;
var openfl_events_Event = require("../../openfl/events/Event").Event;
var Std = require("../../Std").Std;


// Class: openfl.net.XMLSocket

var XMLSocket = (function () {
var XMLSocket = function(host,port) {
	if(port == null) {
		port = 80;
	}
	openfl_events_EventDispatcher.call(this);
	if(host != null) {
		this.connect(host,port);
	}
};
XMLSocket.__super__ = openfl_events_EventDispatcher;
XMLSocket.prototype = $extend(openfl_events_EventDispatcher.prototype, {
  send: function(object) {
		this.__socket.writeUTFBytes(Std.string(object));
		this.__socket.writeByte(0);
		this.__socket.flush();
	},
  __onConnect: function(_) {
		this.connected = true;
		this.dispatchEvent(new openfl_events_Event("connect"));
	},
  __onError: function(_) {
		this.dispatchEvent(new openfl_events_Event("ioError"));
	},
  timeout: null,
  connect: function(host,port) {
		this.connected = false;
		this.__socket = new openfl_net_Socket();
		this.__socket.addEventListener("close",$bind(this,this.__onClose));
		this.__socket.addEventListener("connect",$bind(this,this.__onConnect));
		this.__socket.addEventListener("ioError",$bind(this,this.__onError));
		this.__socket.addEventListener("socketData",$bind(this,this.__onSocketData));
		this.__socket.connect(host,port);
	},
  close: function() {
		this.__socket.removeEventListener("close",$bind(this,this.__onClose));
		this.__socket.removeEventListener("connect",$bind(this,this.__onConnect));
		this.__socket.removeEventListener("ioError",$bind(this,this.__onError));
		this.__socket.removeEventListener("socketData",$bind(this,this.__onSocketData));
		this.__socket.close();
	},
  __onClose: function(_) {
		this.connected = false;
		this.dispatchEvent(new openfl_events_Event("close"));
	},
  connected: null,
  __socket: null,
  __onSocketData: function(_) {
		this.dispatchEvent(new openfl_events_DataEvent("data",false,false,this.__socket.readUTFBytes(this.__socket.get_bytesAvailable())));
	},
 __class__: XMLSocket
});
XMLSocket.__name__ = "openfl.net.XMLSocket";


return XMLSocket;
}());
exports.default = exports.XMLSocket = XMLSocket;
