// Package: openfl.sensors.Accelerometer
var js__Boot_HaxeError = require("../../js/_Boot/HaxeError").HaxeError;
var openfl_errors_ArgumentError = require("../../openfl/errors/ArgumentError").ArgumentError;
var openfl_events_EventDispatcher = require("../../openfl/events/EventDispatcher").EventDispatcher;
var haxe_Timer = require("../../haxe/Timer").Timer;
var $bind = require("../../bind_stub").bind_stub;
var lime_system_Sensor = require("../../lime/system/Sensor").Sensor;
var $extend = require("../../extend_stub").extend_stub;
var lime_system_SensorType = require("../../lime/system/SensorType").SensorType;
var openfl_events_AccelerometerEvent = require("../../openfl/events/AccelerometerEvent").AccelerometerEvent;


// Class: openfl.sensors.Accelerometer

var Accelerometer = (function () {
var Accelerometer = function() {
	openfl_events_EventDispatcher.call(this);
	Accelerometer.initialize();
	this._interval = 0;
	this.set_muted(false);
	this.setRequestedUpdateInterval(Accelerometer.defaultInterval);
};
Accelerometer.__super__ = openfl_events_EventDispatcher;
Accelerometer.prototype = $extend(openfl_events_EventDispatcher.prototype, {
    "__properties__": {"set_muted":"set_muted"},
  muted: null,
  setRequestedUpdateInterval: function(interval) {
		this._interval = interval;
		if(this._interval < 0) {
			throw new js__Boot_HaxeError(new openfl_errors_ArgumentError());
		} else if(this._interval == 0) {
			this._interval = Accelerometer.defaultInterval;
		}
		if(this.timer != null) {
			this.timer.stop();
			this.timer = null;
		}
		if(Accelerometer.supported && !this.muted) {
			this.timer = new haxe_Timer(this._interval);
			this.timer.run = $bind(this,this.update);
		}
	},
  addEventListener: function(type,listener,useCapture,priority,useWeakReference) {
		if(useWeakReference == null) {
			useWeakReference = false;
		}
		if(priority == null) {
			priority = 0;
		}
		if(useCapture == null) {
			useCapture = false;
		}
		openfl_events_EventDispatcher.prototype.addEventListener.call(this,type,listener,useCapture,priority,useWeakReference);
		this.update();
	},
  update: function() {
		var event = new openfl_events_AccelerometerEvent("update");
		event.timestamp = window.performance.now() / 1000;
		event.accelerationX = Accelerometer.currentX;
		event.accelerationY = Accelerometer.currentY;
		event.accelerationZ = Accelerometer.currentZ;
		this.dispatchEvent(event);
	},
  _interval: null,
  set_muted: function(value) {
		this.muted = value;
		this.setRequestedUpdateInterval(this._interval);
		return value;
	},
  timer: null,
 __class__: Accelerometer
});
Accelerometer.__name__ = "openfl.sensors.Accelerometer";
Accelerometer.initialize = function() {
	if(!Accelerometer.initialized) {
		var sensors = lime_system_Sensor.getSensors(lime_system_SensorType.ACCELEROMETER);
		if(sensors.length > 0) {
			sensors[0].onUpdate.add(Accelerometer.accelerometer_onUpdate);
			Accelerometer.supported = true;
		}
		Accelerometer.initialized = true;
	}
};
Accelerometer.currentZ = 0.0;
Accelerometer.isSupported = null;
Accelerometer.get_isSupported = function() {
	Accelerometer.initialize();
	return Accelerometer.supported;
};
Accelerometer.defaultInterval = 34;
Accelerometer.initialized = false;
Accelerometer.accelerometer_onUpdate = function(x,y,z) {
	Accelerometer.currentX = x;
	Accelerometer.currentY = y;
	Accelerometer.currentZ = z;
};
Accelerometer.supported = false;
Accelerometer.currentY = 1.0;
Accelerometer.currentX = 0.0;
Object.defineProperties(Accelerometer.prototype, {
	"muted": { set: Accelerometer.prototype.set_muted },
});



return Accelerometer;
}());
exports.default = exports.Accelerometer = Accelerometer;
