// Package: openfl.system.Capabilities
var openfl_Lib = require("../../openfl/Lib").Lib;
var StringTools = require("../../StringTools").StringTools;
var lime_system__Locale_Locale_Impl_ = require("../../lime/system/_Locale/Locale_Impl_").Locale_Impl_;


// Class: openfl.system.Capabilities

var Capabilities = (function () {
var Capabilities = function() {};
Capabilities.prototype = {
 __class__: Capabilities
};
Capabilities.__name__ = "openfl.system.Capabilities";
Capabilities.hasMP3 = false;
Capabilities.screenColor = "color";
Capabilities.supports32BitProcesses = false;
Capabilities.touchscreenType = 0;
Capabilities.hasStreamingVideo = false;
Capabilities.screenDPI = null;
Capabilities.hasAccessibility = false;
Capabilities.hasScreenPlayback = false;
Capabilities.hasAudioEncoder = false;
Capabilities.get_screenDPI = function() {
	var $window = openfl_Lib.application != null ? openfl_Lib.application.__windows[0] : null;
	var screenDPI = Capabilities.__standardDensities[0];
	if($window != null) {
		var display = $window.get_display();
		if(display != null) {
			var actual = display.dpi;
			var closestValue = screenDPI;
			var closestDifference = Math.abs(actual - screenDPI);
			var difference;
			var _g = 0;
			var _g1 = Capabilities.__standardDensities;
			while(_g < _g1.length) {
				var density = _g1[_g];
				++_g;
				difference = Math.abs(actual - density);
				if(difference < closestDifference) {
					closestDifference = difference;
					closestValue = density;
				}
			}
			screenDPI = closestValue;
		}
	}
	return screenDPI;
};
Capabilities.get_screenResolutionX = function() {
	var stage = openfl_Lib.current.stage;
	var resolutionX = 0;
	if(stage.window != null) {
		var display = stage.window.get_display();
		if(display != null) {
			resolutionX = display.currentMode.width;
		}
	}
	if(resolutionX > 0) {
		return resolutionX;
	}
	return stage.stageWidth;
};
Capabilities.manufacturer = null;
Capabilities.language = null;
Capabilities.isDebugger = false;
Capabilities.get_os = function() {
	return "HTML5";
};
Capabilities.cpuArchitecture = null;
Capabilities.hasPrinting = true;
Capabilities.hasEmbeddedVideo = false;
Capabilities.hasScreenBroadcast = false;
Capabilities.maxLevelIDC = 0;
Capabilities.version = null;
Capabilities.hasMultiChannelAudio = function(type) {
	return false;
};
Capabilities.get_pixelAspectRatio = function() {
	return 1;
};
Capabilities.avHardwareDisable = true;
Capabilities.screenResolutionY = null;
Capabilities.get_screenResolutionY = function() {
	var stage = openfl_Lib.current.stage;
	var resolutionY = 0;
	if(stage.window != null) {
		var display = stage.window.get_display();
		if(display != null) {
			resolutionY = display.currentMode.height;
		}
	}
	if(resolutionY > 0) {
		return resolutionY;
	}
	return stage.stageHeight;
};
Capabilities.hasIME = false;
Capabilities.os = null;
Capabilities.get_cpuArchitecture = function() {
	return "x86";
};
Capabilities.screenResolutionX = null;
Capabilities.get_language = function() {
	var language = lime_system__Locale_Locale_Impl_.get_language(lime_system__Locale_Locale_Impl_.get_currentLocale());
	if(language != null) {
		language = language.toLowerCase();
		switch(language) {
		case "cs":case "da":case "de":case "en":case "es":case "fi":case "fr":case "hu":case "it":case "ja":case "ko":case "nb":case "nl":case "pl":case "pt":case "ru":case "sv":case "tr":
			return language;
		case "zh":
			var region = lime_system__Locale_Locale_Impl_.get_region(lime_system__Locale_Locale_Impl_.get_currentLocale());
			if(region != null) {
				var _g = region.toUpperCase();
				switch(_g) {
				case "HANT":case "TW":
					return "zh-TW";
				default:
				}
			}
			return "zh-CN";
		default:
			return "xu";
		}
	}
	return "en";
};
Capabilities.serverString = "";
Capabilities.pixelAspectRatio = null;
Capabilities.playerType = "StandAlone";
Capabilities.hasVideoEncoder = true;
Capabilities.get_version = function() {
	var value = "WEB";
	value += " " + StringTools.replace("6.5.1",".",",") + ",0";
	return value;
};
Capabilities.hasTLS = true;
Capabilities.supports64BitProcesses = false;
Capabilities.__standardDensities = [120,160,240,320,480,640,800,960];
Capabilities.get_manufacturer = function() {
	return "OpenFL HTML5";
};
Capabilities.localFileReadDisable = false;
Capabilities.hasAudio = true;
Capabilities.hasStreamingAudio = false;
Capabilities.isEmbeddedInAcrobat = false;


return Capabilities;
}());
exports.default = exports.Capabilities = Capabilities;
