// Package: openfl.utils.Assets
var lime_utils_Assets = require("../../lime/utils/Assets").Assets;
var openfl_utils_AssetCache = require("../../openfl/utils/AssetCache").AssetCache;
var Type = require("../../Type").Type;
var openfl_utils__ByteArray_ByteArray_Impl_ = require("../../openfl/utils/_ByteArray/ByteArray_Impl_").ByteArray_Impl_;
var openfl_events_EventDispatcher = require("../../openfl/events/EventDispatcher").EventDispatcher;
var $bind = require("../../bind_stub").bind_stub;
var openfl_media_Sound = require("../../openfl/media/Sound").Sound;
var openfl_events_Event = require("../../openfl/events/Event").Event;
var lime_app_Promise = require("../../lime/app/Promise").Promise;
var lime_app_Future = require("../../lime/app/Future").Future;
var openfl_text_Font = require("../../openfl/text/Font").Font;


// Class: openfl.utils.Assets

var Assets = (function () {
var Assets = function() {};
Assets.prototype = {
 __class__: Assets
};
Assets.__name__ = "openfl.utils.Assets";
Assets.list = function(type) {
	return lime_utils_Assets.list(type);
};
Assets.getFont = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	return new openfl_text_Font();
};
Assets.removeEventListener = function(type,listener,capture) {
	if(capture == null) {
		capture = false;
	}
	Assets.dispatcher.removeEventListener(type,listener,capture);
};
Assets.loadMovieClip = function(id) {
	var promise = new lime_app_Promise();
	return promise.future;
};
Assets.resolveEnum = function(name) {
	var value = Type.resolveEnum(name);
	return value;
};
Assets.unloadLibrary = function(name) {
	lime_utils_Assets.unloadLibrary(name);
};
Assets.loadFont = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	if(useCache == null) {
		useCache = true;
	}
	var promise = new lime_app_Promise();
	return promise.future;
};
Assets.dispatcher = new openfl_events_EventDispatcher();
Assets.getPath = function(id) {
	return lime_utils_Assets.getPath(id);
};
Assets.hasEventListener = function(type) {
	return Assets.dispatcher.hasEventListener(type);
};
Assets.hasLibrary = function(name) {
	return lime_utils_Assets.hasLibrary(name);
};
Assets.getSound = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	return null;
};
Assets.getMovieClip = function(id) {
	return null;
};
Assets.LimeAssets_onChange = function() {
	Assets.dispatchEvent(new openfl_events_Event("change"));
};
Assets.isLocal = function(id,type,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	return false;
};
Assets.loadText = function(id) {
	var future = lime_utils_Assets.loadText(id);
	return future;
};
Assets.dispatchEvent = function(event) {
	return Assets.dispatcher.dispatchEvent(event);
};
Assets.getText = function(id) {
	return lime_utils_Assets.getText(id);
};
Assets.isValidSound = function(sound) {
	return true;
};
Assets.loadBytes = function(id) {
	var promise = new lime_app_Promise();
	var future = lime_utils_Assets.loadBytes(id);
	future.onComplete(function(bytes) {
		promise.complete(openfl_utils__ByteArray_ByteArray_Impl_.fromBytes(bytes));
	});
	future.onProgress(function(progress,total) {
		promise.progress(progress,total);
	});
	future.onError(function(msg) {
		promise.error(msg);
	});
	return promise.future;
};
Assets.registerLibrary = function(name,library) {
	lime_utils_Assets.registerLibrary(name,library);
};
Assets.resolveClass = function(name) {
	return Type.resolveClass(name);
};
Assets.cache = new openfl_utils_AssetCache();
Assets.getLibrary = function(name) {
	return lime_utils_Assets.getLibrary(name);
};
Assets.loadSound = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	if(useCache == null) {
		useCache = true;
	}
	var promise = new lime_app_Promise();
	lime_utils_Assets.loadAudioBuffer(id,useCache).onComplete(function(buffer) {
		if(buffer != null) {
			var sound = openfl_media_Sound.fromAudioBuffer(buffer);
			if(useCache && Assets.cache.get_enabled()) {
				Assets.cache.setSound(id,sound);
			}
			promise.complete(sound);
		} else {
			promise.error("[Assets] Could not load Sound \"" + id + "\"");
		}
	}).onError($bind(promise,promise.error)).onProgress($bind(promise,promise.progress));
	return promise.future;
};
Assets.addEventListener = function(type,listener,useCapture,priority,useWeakReference) {
	if(useWeakReference == null) {
		useWeakReference = false;
	}
	if(priority == null) {
		priority = 0;
	}
	if(useCapture == null) {
		useCapture = false;
	}
	if(!lime_utils_Assets.onChange.has(Assets.LimeAssets_onChange)) {
		lime_utils_Assets.onChange.add(Assets.LimeAssets_onChange);
	}
	Assets.dispatcher.addEventListener(type,listener,useCapture,priority,useWeakReference);
};
Assets.loadLibrary = function(name) {
	var future = lime_utils_Assets.loadLibrary(name);
	return future;
};
Assets.getBytes = function(id) {
	return openfl_utils__ByteArray_ByteArray_Impl_.fromBytes(lime_utils_Assets.getBytes(id));
};
Assets.exists = function(id,type) {
	return lime_utils_Assets.exists(id,type);
};
Assets.getBitmapData = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	return null;
};
Assets.getMusic = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	return Assets.getSound(id,useCache);
};
Assets.loadBitmapData = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	if(useCache == null) {
		useCache = true;
	}
	var promise = new lime_app_Promise();
	return promise.future;
};
Assets.isValidBitmapData = function(bitmapData) {
	return true;
};
Assets.loadMusic = function(id,useCache) {
	if(useCache == null) {
		useCache = true;
	}
	if(useCache == null) {
		useCache = true;
	}
	var future = new lime_app_Future(function() {
		return Assets.getMusic(id,useCache);
	});
	return future;
};


return Assets;
}());
exports.default = exports.Assets = Assets;
