// Package: openfl.utils.ByteArrayData
var haxe_io_Bytes = require("../../haxe/io/Bytes").Bytes;
var openfl_utils_IDataOutput = require("../../openfl/utils/IDataOutput").IDataOutput;
var lime_utils_compress_Deflate = require("../../lime/utils/compress/Deflate").Deflate;
var js__Boot_HaxeError = require("../../js/_Boot/HaxeError").HaxeError;
var openfl_utils__ByteArray_ByteArray_Impl_ = require("../../openfl/utils/_ByteArray/ByteArray_Impl_").ByteArray_Impl_;
var lime_system_Endian = require("../../lime/system/Endian").Endian;
var haxe_io_FPHelper = require("../../haxe/io/FPHelper").FPHelper;
var lime_system_System = require("../../lime/system/System").System;
var $extend = require("../../extend_stub").extend_stub;
var openfl_utils_IDataInput = require("../../openfl/utils/IDataInput").IDataInput;
var lime_utils_compress_LZMA = require("../../lime/utils/compress/LZMA").LZMA;
var openfl_errors_EOFError = require("../../openfl/errors/EOFError").EOFError;
var lime_utils_compress_Zlib = require("../../lime/utils/compress/Zlib").Zlib;


// Class: openfl.utils.ByteArrayData

var ByteArrayData = (function () {
var ByteArrayData = function(length) {
	if(length == null) {
		length = 0;
	}
	var bytes = new haxe_io_Bytes(new ArrayBuffer(length));
	haxe_io_Bytes.call(this,bytes.b.buffer);
	this.__length = length;
	if(ByteArrayData.__defaultEndian == null) {
		if(lime_system_System.get_endianness() == lime_system_Endian.LITTLE_ENDIAN) {
			ByteArrayData.__defaultEndian = 1;
		} else {
			ByteArrayData.__defaultEndian = 0;
		}
	}
	this.__endian = ByteArrayData.__defaultEndian;
	this.position = 0;
};
ByteArrayData.__interfaces__ = [openfl_utils_IDataOutput,openfl_utils_IDataInput];
ByteArrayData.__super__ = haxe_io_Bytes;
ByteArrayData.prototype = $extend(haxe_io_Bytes.prototype, {
    "__properties__": {"get_bytesAvailable":"get_bytesAvailable","get_endian":"get_endian","set_endian":"set_endian"},
  get_endian: function() {
		return this.__endian;
	},
  objectEncoding: null,
  writeBoolean: function(value) {
		this.writeByte(value ? 1 : 0);
	},
  writeFloat: function(value) {
		if(this.__endian == 1) {
			this.__resize(this.position + 4);
			this.setFloat(this.position,value);
			this.position += 4;
		} else {
			var $int = haxe_io_FPHelper.floatToI32(value);
			this.writeInt($int);
		}
	},
  writeShort: function(value) {
		this.__resize(this.position + 2);
		if(this.__endian == 1) {
			this.b[this.position++] = value & 255;
			this.b[this.position++] = value >> 8 & 255;
		} else {
			this.b[this.position++] = value >> 8 & 255;
			this.b[this.position++] = value & 255;
		}
	},
  __fromBytes: function(bytes) {
		this.b = bytes.b;
		this.__length = bytes.length;
		this.data = bytes.data;
		this.length = bytes.length;
	},
  get_bytesAvailable: function() {
		return this.length - this.position;
	},
  writeUTFBytes: function(value) {
		var bytes = haxe_io_Bytes.ofString(value);
		this.writeBytes(openfl_utils__ByteArray_ByteArray_Impl_.fromBytes(haxe_io_Bytes.ofString(value)));
	},
  __endian: null,
  readUnsignedShort: function() {
		var ch1 = this.readUnsignedByte();
		var ch2 = this.readUnsignedByte();
		if(this.__endian == 1) {
			return (ch2 << 8) + ch1;
		} else {
			return ch1 << 8 | ch2;
		}
	},
  writeInt: function(value) {
		this.__resize(this.position + 4);
		if(this.__endian == 1) {
			this.b[this.position++] = value & 255 & 255;
			this.b[this.position++] = value >> 8 & 255 & 255;
			this.b[this.position++] = value >> 16 & 255 & 255;
			this.b[this.position++] = value >> 24 & 255 & 255;
		} else {
			this.b[this.position++] = value >> 24 & 255 & 255;
			this.b[this.position++] = value >> 16 & 255 & 255;
			this.b[this.position++] = value >> 8 & 255 & 255;
			this.b[this.position++] = value & 255 & 255;
		}
	},
  __resize: function(size) {
		if(size > this.__length) {
			var bytes = new haxe_io_Bytes(new ArrayBuffer((size + 1) * 3 >> 1));
			var cacheLength = this.length;
			this.length = this.__length;
			bytes.blit(0,this,0,this.__length);
			this.length = cacheLength;
			this.b = bytes.b;
			this.__length = bytes.length;
			this.data = bytes.data;
		}
		if(this.length < size) {
			this.length = size;
		}
	},
  __length: null,
  readByte: function() {
		var value = this.readUnsignedByte();
		if((value & 128) != 0) {
			return value - 256;
		} else {
			return value;
		}
	},
  writeByte: function(value) {
		this.__resize(this.position + 1);
		this.b[this.position++] = value & 255 & 255;
	},
  readBoolean: function() {
		if(this.position < this.length) {
			return this.b[this.position++] != 0;
		} else {
			throw new js__Boot_HaxeError(new openfl_errors_EOFError());
		}
	},
  readBytes: function(bytes,offset,length) {
		if(length == null) {
			length = 0;
		}
		if(offset == null) {
			offset = 0;
		}
		if(length == 0) {
			length = this.length - this.position;
		}
		if(this.position + length > this.length) {
			throw new js__Boot_HaxeError(new openfl_errors_EOFError());
		}
		if(bytes.length < offset + length) {
			bytes.__resize(offset + length);
		}
		bytes.blit(offset,this,this.position,length);
		this.position += length;
	},
  readMultiByte: function(length,charSet) {
		return this.readUTFBytes(length);
	},
  writeDouble: function(value) {
		var int64 = haxe_io_FPHelper.doubleToI64(value);
		if(this.__endian == 1) {
			this.writeInt(int64.low);
			this.writeInt(int64.high);
		} else {
			this.writeInt(int64.high);
			this.writeInt(int64.low);
		}
	},
  readShort: function() {
		var ch1 = this.readUnsignedByte();
		var ch2 = this.readUnsignedByte();
		var value;
		if(this.__endian == 1) {
			value = ch2 << 8 | ch1;
		} else {
			value = ch1 << 8 | ch2;
		}
		if((value & 32768) != 0) {
			return value - 65536;
		} else {
			return value;
		}
	},
  readDouble: function() {
		var ch1 = this.readInt();
		var ch2 = this.readInt();
		if(this.__endian == 1) {
			return haxe_io_FPHelper.i64ToDouble(ch1,ch2);
		} else {
			return haxe_io_FPHelper.i64ToDouble(ch2,ch1);
		}
	},
  readUTF: function() {
		var bytesCount = this.readUnsignedShort();
		return this.readUTFBytes(bytesCount);
	},
  compress: function(algorithm) {
		if(algorithm == null) {
			algorithm = 2;
		}
		if(this.__length > this.length) {
			var cacheLength = this.length;
			this.length = this.__length;
			var data = new haxe_io_Bytes(new ArrayBuffer(cacheLength));
			data.blit(0,this,0,cacheLength);
			this.b = data.b;
			this.__length = data.length;
			this.data = data.data;
			this.length = cacheLength;
		}
		var bytes;
		switch(algorithm) {
		case 0:
			bytes = lime_utils_compress_Deflate.compress(this);
			break;
		case 1:
			bytes = lime_utils_compress_LZMA.compress(this);
			break;
		default:
			bytes = lime_utils_compress_Zlib.compress(this);
		}
		if(bytes != null) {
			this.b = bytes.b;
			this.__length = bytes.length;
			this.data = bytes.data;
			this.length = this.__length;
			this.position = this.length;
		}
	},
  deflate: function() {
		this.compress(0);
	},
  bytesAvailable: null,
  inflate: function() {
		this.uncompress(0);
	},
  readInt: function() {
		var ch1 = this.readUnsignedByte();
		var ch2 = this.readUnsignedByte();
		var ch3 = this.readUnsignedByte();
		var ch4 = this.readUnsignedByte();
		if(this.__endian == 1) {
			return ch4 << 24 | ch3 << 16 | ch2 << 8 | ch1;
		} else {
			return ch1 << 24 | ch2 << 16 | ch3 << 8 | ch4;
		}
	},
  position: null,
  clear: function() {
		this.length = 0;
		this.position = 0;
	},
  writeBytes: function(bytes,offset,length) {
		if(length == null) {
			length = 0;
		}
		if(offset == null) {
			offset = 0;
		}
		if(openfl_utils__ByteArray_ByteArray_Impl_.get_length(bytes) == 0) {
			return;
		}
		if(length == 0) {
			length = openfl_utils__ByteArray_ByteArray_Impl_.get_length(bytes) - offset;
		}
		this.__resize(this.position + length);
		this.blit(this.position,bytes,offset,length);
		this.position = this.position + length;
	},
  writeUnsignedInt: function(value) {
		this.writeInt(value);
	},
  __setData: function(bytes) {
		this.b = bytes.b;
		this.__length = bytes.length;
		this.data = bytes.data;
	},
  readUTFBytes: function(length) {
		if(this.position + length > this.length) {
			throw new js__Boot_HaxeError(new openfl_errors_EOFError());
		}
		this.position += length;
		return this.getString(this.position - length,length);
	},
  set_endian: function(value) {
		return this.__endian = value;
	},
  readUnsignedInt: function() {
		var ch1 = this.readUnsignedByte();
		var ch2 = this.readUnsignedByte();
		var ch3 = this.readUnsignedByte();
		var ch4 = this.readUnsignedByte();
		if(this.__endian == 1) {
			return ch4 << 24 | ch3 << 16 | ch2 << 8 | ch1;
		} else {
			return ch1 << 24 | ch2 << 16 | ch3 << 8 | ch4;
		}
	},
  uncompress: function(algorithm) {
		if(algorithm == null) {
			algorithm = 2;
		}
		if(this.__length > this.length) {
			var cacheLength = this.length;
			this.length = this.__length;
			var data = new haxe_io_Bytes(new ArrayBuffer(cacheLength));
			data.blit(0,this,0,cacheLength);
			this.b = data.b;
			this.__length = data.length;
			this.data = data.data;
			this.length = cacheLength;
		}
		var bytes;
		switch(algorithm) {
		case 0:
			bytes = lime_utils_compress_Deflate.decompress(this);
			break;
		case 1:
			bytes = lime_utils_compress_LZMA.decompress(this);
			break;
		default:
			bytes = lime_utils_compress_Zlib.decompress(this);
		}
		if(bytes != null) {
			this.b = bytes.b;
			this.__length = bytes.length;
			this.data = bytes.data;
			this.length = this.__length;
		}
		this.position = 0;
	},
  endian: null,
  readFloat: function() {
		return haxe_io_FPHelper.i32ToFloat(this.readInt());
	},
  writeUTF: function(value) {
		var bytes = haxe_io_Bytes.ofString(value);
		this.writeShort(bytes.length);
		this.writeBytes(openfl_utils__ByteArray_ByteArray_Impl_.fromBytes(bytes));
	},
  readUnsignedByte: function() {
		if(this.position < this.length) {
			return this.b[this.position++];
		} else {
			throw new js__Boot_HaxeError(new openfl_errors_EOFError());
		}
	},
  writeMultiByte: function(value,charSet) {
		this.writeUTFBytes(value);
	},
 __class__: ByteArrayData
});
ByteArrayData.__name__ = "openfl.utils.ByteArrayData";
ByteArrayData.fromBytes = function(bytes) {
	var result = new ByteArrayData();
	result.__fromBytes(bytes);
	return result;
};
ByteArrayData.__defaultEndian = null;
Object.defineProperties(ByteArrayData.prototype, {
	"bytesAvailable": { get: ByteArrayData.prototype.get_bytesAvailable },
	"endian": { get: ByteArrayData.prototype.get_endian, set: ByteArrayData.prototype.set_endian },
});



return ByteArrayData;
}());
exports.default = exports.ByteArrayData = ByteArrayData;
