// Package: openfl.utils.Timer
var openfl_events_TimerEvent = require("../../openfl/events/TimerEvent").TimerEvent;
var js__Boot_HaxeError = require("../../js/_Boot/HaxeError").HaxeError;
var openfl_events_EventDispatcher = require("../../openfl/events/EventDispatcher").EventDispatcher;
var $bind = require("../../bind_stub").bind_stub;
var $extend = require("../../extend_stub").extend_stub;
var openfl_errors_Error = require("../../openfl/errors/Error").Error;


// Class: openfl.utils.Timer

var Timer = (function () {
var Timer = function(delay,repeatCount) {
	if(repeatCount == null) {
		repeatCount = 0;
	}
	if(isNaN(delay) || delay < 0) {
		throw new js__Boot_HaxeError(new openfl_errors_Error("The delay specified is negative or not a finite number"));
	}
	openfl_events_EventDispatcher.call(this);
	this.__delay = delay;
	this.set_repeatCount(repeatCount);
	this.running = false;
	this.currentCount = 0;
};
Timer.__super__ = openfl_events_EventDispatcher;
Timer.prototype = $extend(openfl_events_EventDispatcher.prototype, {
    "__properties__": {"get_delay":"get_delay","set_delay":"set_delay","set_repeatCount":"set_repeatCount"},
  reset: function() {
		if(this.running) {
			this.stop();
		}
		this.currentCount = 0;
	},
  currentCount: null,
  repeatCount: null,
  __delay: null,
  delay: null,
  set_delay: function(value) {
		this.__delay = value;
		if(this.running) {
			this.stop();
			this.start();
		}
		return this.__delay;
	},
  __timerID: null,
  get_delay: function() {
		return this.__delay;
	},
  stop: function() {
		this.running = false;
		if(this.__timerID != null) {
			window.clearInterval(this.__timerID);
			this.__timerID = null;
		}
	},
  timer_onTimer: function() {
		this.currentCount++;
		if(this.repeatCount > 0 && this.currentCount >= this.repeatCount) {
			this.stop();
			this.dispatchEvent(new openfl_events_TimerEvent("timer"));
			this.dispatchEvent(new openfl_events_TimerEvent("timerComplete"));
		} else {
			this.dispatchEvent(new openfl_events_TimerEvent("timer"));
		}
	},
  running: null,
  __timer: null,
  set_repeatCount: function(v) {
		if(this.running && v != 0 && v <= this.currentCount) {
			this.stop();
		}
		this.repeatCount = v;
		return v;
	},
  start: function() {
		if(!this.running) {
			this.running = true;
			this.__timerID = window.setInterval($bind(this,this.timer_onTimer),this.__delay | 0);
		}
	},
 __class__: Timer
});
Timer.__name__ = "openfl.utils.Timer";
Object.defineProperties(Timer.prototype, {
	"repeatCount": { set: Timer.prototype.set_repeatCount },
	"delay": { get: Timer.prototype.get_delay, set: Timer.prototype.set_delay },
});



return Timer;
}());
exports.default = exports.Timer = Timer;
