// Package: openfl.utils._Dictionary.ClassMap
var haxe_ds_StringMap = require("../../../haxe/ds/StringMap").StringMap;
var haxe_IMap = require("../../../haxe/IMap").IMap;
var Type = require("../../../Type").Type;
var haxe_ds__StringMap_StringMapIterator = require("../../../haxe/ds/_StringMap/StringMapIterator").StringMapIterator;


// Class: openfl.utils._Dictionary.ClassMap

var ClassMap = (function () {
var ClassMap = function() {
	this.types = new haxe_ds_StringMap();
	this.values = new haxe_ds_StringMap();
};
ClassMap.__interfaces__ = [haxe_IMap];
ClassMap.prototype = {
  types: null,
  values: null,
  set: function(key,value) {
		var name = Type.getClassName(key);
		var _this = this.types;
		if(__map_reserved[name] != null) {
			_this.setReserved(name,key);
		} else {
			_this.h[name] = key;
		}
		var _this1 = this.values;
		if(__map_reserved[name] != null) {
			_this1.setReserved(name,value);
		} else {
			_this1.h[name] = value;
		}
	},
  keys: function() {
		var _this = this.types;
		return new haxe_ds__StringMap_StringMapIterator(_this,_this.arrayKeys());
	},
  iterator: function() {
		var _this = this.values;
		return new haxe_ds__StringMap_StringMapIterator(_this,_this.arrayKeys());
	},
  exists: function(key) {
		var this1 = this.types;
		var key1 = Type.getClassName(key);
		var _this = this1;
		if(__map_reserved[key1] != null) {
			return _this.existsReserved(key1);
		} else {
			return _this.h.hasOwnProperty(key1);
		}
	},
  toString: function() {
		return this.values.toString();
	},
  get: function(key) {
		var this1 = this.values;
		var key1 = Type.getClassName(key);
		var _this = this1;
		if(__map_reserved[key1] != null) {
			return _this.getReserved(key1);
		} else {
			return _this.h[key1];
		}
	},
  remove: function(key) {
		var name = Type.getClassName(key);
		if(!this.types.remove(name)) {
			return this.values.remove(name);
		} else {
			return true;
		}
	},
 __class__: ClassMap
};
ClassMap.__name__ = "openfl.utils._Dictionary.ClassMap";


return ClassMap;
}());
exports.default = exports.ClassMap = ClassMap;
