// Package: openfl.utils._Dictionary.FloatMap
var HxOverrides = require("../../../HxOverrides").HxOverrides;
var haxe_IMap = require("../../../haxe/IMap").IMap;


// Class: openfl.utils._Dictionary.FloatMap

var FloatMap = (function () {
var FloatMap = function() {
	this.floatKeys = [];
	this.values = [];
};
FloatMap.__interfaces__ = [haxe_IMap];
FloatMap.prototype = {
  values: null,
  set: function(key,value) {
		this.insertSorted(key,value);
	},
  floatKeys: null,
  keys: function() {
		return HxOverrides.iter(this.floatKeys.slice());
	},
  iterator: function() {
		return HxOverrides.iter(this.values.slice());
	},
  exists: function(key) {
		return this.indexOf(key) > -1;
	},
  insertSorted: function(key,value) {
		var len = this.floatKeys.length;
		var startIndex = 0;
		var endIndex = len - 1;
		if(len == 0) {
			this.floatKeys.push(key);
			this.values.push(value);
			return;
		}
		var midIndex = 0;
		while(startIndex < endIndex) {
			midIndex = Math.floor((startIndex + endIndex) / 2);
			if(this.floatKeys[midIndex] == key) {
				this.values[midIndex] = value;
				return;
			} else if(this.floatKeys[midIndex] > key) {
				endIndex = midIndex - 1;
			} else {
				startIndex = midIndex + 1;
			}
		}
		if(this.floatKeys[startIndex] > key) {
			this.floatKeys.splice(startIndex,0,key);
			this.values.splice(startIndex,0,value);
		} else if(this.floatKeys[startIndex] < key) {
			this.floatKeys.splice(startIndex + 1,0,key);
			this.values.splice(startIndex + 1,0,value);
		} else {
			this.values[startIndex] = value;
		}
	},
  indexOf: function(key) {
		var len = this.floatKeys.length;
		var startIndex = 0;
		var endIndex = len - 1;
		if(len == 0) {
			return -1;
		}
		var midIndex = 0;
		while(startIndex < endIndex) {
			midIndex = Math.floor((startIndex + endIndex) / 2);
			if(this.floatKeys[midIndex] == key) {
				return midIndex;
			} else if(this.floatKeys[midIndex] > key) {
				endIndex = midIndex - 1;
			} else {
				startIndex = midIndex + 1;
			}
		}
		if(this.floatKeys[startIndex] == key) {
			return startIndex;
		} else {
			return -1;
		}
	},
  toString: function() {
		return this.values.toString();
	},
  get: function(key) {
		var ind = this.indexOf(key);
		if(ind > -1) {
			return this.values[ind];
		} else {
			return null;
		}
	},
  remove: function(key) {
		var ind = this.indexOf(key);
		if(ind > -1) {
			this.floatKeys.splice(ind,1);
			this.values.splice(ind,1);
			return true;
		}
		return false;
	},
 __class__: FloatMap
};
FloatMap.__name__ = "openfl.utils._Dictionary.FloatMap";


return FloatMap;
}());
exports.default = exports.FloatMap = FloatMap;
